/* game-window.c generated by valac 0.56.3, the Vala compiler
 * generated from game-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2015, 2016, 2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define IAGNO_PROGRAM_NAME _ ("Reversi")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	GAME_WINDOW_FLAGS_HAS_SOUND = 1 << 0,
	GAME_WINDOW_FLAGS_SHORTCUTS = 1 << 1,
	GAME_WINDOW_FLAGS_SHOW_HELP = 1 << 2,
	GAME_WINDOW_FLAGS_SHOW_START_BUTTON = 1 << 3
} GameWindowFlags;

#define TYPE_GAME_WINDOW_FLAGS (game_window_flags_get_type ())

#define TYPE_ADAPTATIVE_WINDOW (adaptative_window_get_type ())
#define ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindow))
#define ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))
#define IS_ADAPTATIVE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WINDOW))
#define IS_ADAPTATIVE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADAPTATIVE_WINDOW))
#define ADAPTATIVE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADAPTATIVE_WINDOW, AdaptativeWindowClass))

typedef struct _AdaptativeWindow AdaptativeWindow;
typedef struct _AdaptativeWindowClass AdaptativeWindowClass;
typedef struct _AdaptativeWindowPrivate AdaptativeWindowPrivate;

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_BASE_WINDOW (base_window_get_type ())
#define BASE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_WINDOW, BaseWindow))
#define BASE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_WINDOW, BaseWindowClass))
#define IS_BASE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_WINDOW))
#define IS_BASE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_WINDOW))
#define BASE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_WINDOW, BaseWindowClass))

typedef struct _BaseWindow BaseWindow;
typedef struct _BaseWindowClass BaseWindowClass;
typedef struct _BaseWindowPrivate BaseWindowPrivate;

#define TYPE_GAME_WINDOW (game_window_get_type ())
#define GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_WINDOW, GameWindow))
#define GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_WINDOW, GameWindowClass))
#define IS_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_WINDOW))
#define IS_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_WINDOW))
#define GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_WINDOW, GameWindowClass))

typedef struct _GameWindow GameWindow;
typedef struct _GameWindowClass GameWindowClass;
typedef struct _GameWindowPrivate GameWindowPrivate;

#define TYPE_NIGHT_TIME_AWARE_HEADER_BAR (night_time_aware_header_bar_get_type ())
#define NIGHT_TIME_AWARE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBar))
#define NIGHT_TIME_AWARE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBarClass))
#define IS_NIGHT_TIME_AWARE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIGHT_TIME_AWARE_HEADER_BAR))
#define IS_NIGHT_TIME_AWARE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIGHT_TIME_AWARE_HEADER_BAR))
#define NIGHT_TIME_AWARE_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBarClass))

typedef struct _NightTimeAwareHeaderBar NightTimeAwareHeaderBar;
typedef struct _NightTimeAwareHeaderBarClass NightTimeAwareHeaderBarClass;

#define TYPE_BASE_HEADER_BAR (base_header_bar_get_type ())
#define BASE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_HEADER_BAR, BaseHeaderBar))
#define BASE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_HEADER_BAR, BaseHeaderBarClass))
#define IS_BASE_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_HEADER_BAR))
#define IS_BASE_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_HEADER_BAR))
#define BASE_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_HEADER_BAR, BaseHeaderBarClass))

typedef struct _BaseHeaderBar BaseHeaderBar;
typedef struct _BaseHeaderBarClass BaseHeaderBarClass;

#define TYPE_GAME_HEADER_BAR (game_header_bar_get_type ())
#define GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBar))
#define GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))
#define IS_GAME_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_HEADER_BAR))
#define IS_GAME_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_HEADER_BAR))
#define GAME_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_HEADER_BAR, GameHeaderBarClass))

typedef struct _GameHeaderBar GameHeaderBar;
typedef struct _GameHeaderBarClass GameHeaderBarClass;

#define TYPE_BASE_VIEW (base_view_get_type ())
#define BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BASE_VIEW, BaseView))
#define BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BASE_VIEW, BaseViewClass))
#define IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BASE_VIEW))
#define IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BASE_VIEW))
#define BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BASE_VIEW, BaseViewClass))

typedef struct _BaseView BaseView;
typedef struct _BaseViewClass BaseViewClass;

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;

#define TYPE_GAME_ACTION_BAR (game_action_bar_get_type ())
#define GAME_ACTION_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_ACTION_BAR, GameActionBar))
#define GAME_ACTION_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_ACTION_BAR, GameActionBarClass))
#define IS_GAME_ACTION_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_ACTION_BAR))
#define IS_GAME_ACTION_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_ACTION_BAR))
#define GAME_ACTION_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_ACTION_BAR, GameActionBarClass))

typedef struct _GameActionBar GameActionBar;
typedef struct _GameActionBarClass GameActionBarClass;
enum  {
	GAME_WINDOW_0_PROPERTY,
	GAME_WINDOW_NUM_PROPERTIES
};
static GParamSpec* game_window_properties[GAME_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NIGHT_LIGHT_MONITOR (night_light_monitor_get_type ())
#define NIGHT_LIGHT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor))
#define NIGHT_LIGHT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitorClass))
#define IS_NIGHT_LIGHT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIGHT_LIGHT_MONITOR))
#define IS_NIGHT_LIGHT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIGHT_LIGHT_MONITOR))
#define NIGHT_LIGHT_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitorClass))

typedef struct _NightLightMonitor NightLightMonitor;
typedef struct _NightLightMonitorClass NightLightMonitorClass;

#define TYPE_GAME_ACTION_BAR_PLACE_HOLDER (game_action_bar_place_holder_get_type ())
#define GAME_ACTION_BAR_PLACE_HOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_ACTION_BAR_PLACE_HOLDER, GameActionBarPlaceHolder))
#define GAME_ACTION_BAR_PLACE_HOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_ACTION_BAR_PLACE_HOLDER, GameActionBarPlaceHolderClass))
#define IS_GAME_ACTION_BAR_PLACE_HOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_ACTION_BAR_PLACE_HOLDER))
#define IS_GAME_ACTION_BAR_PLACE_HOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_ACTION_BAR_PLACE_HOLDER))
#define GAME_ACTION_BAR_PLACE_HOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_ACTION_BAR_PLACE_HOLDER, GameActionBarPlaceHolderClass))

typedef struct _GameActionBarPlaceHolder GameActionBarPlaceHolder;
typedef struct _GameActionBarPlaceHolderClass GameActionBarPlaceHolderClass;
enum  {
	GAME_WINDOW_PLAY_SIGNAL,
	GAME_WINDOW_WAIT_SIGNAL,
	GAME_WINDOW_BACK_SIGNAL,
	GAME_WINDOW_RESTART_SIGNAL,
	GAME_WINDOW_UNDO_SIGNAL,
	GAME_WINDOW_REDO_SIGNAL,
	GAME_WINDOW_HINT_SIGNAL,
	GAME_WINDOW_NUM_SIGNALS
};
static guint game_window_signals[GAME_WINDOW_NUM_SIGNALS] = {0};

struct _AdaptativeWindow {
	GtkApplicationWindow parent_instance;
	AdaptativeWindowPrivate * priv;
};

struct _AdaptativeWindowClass {
	GtkApplicationWindowClass parent_class;
	void (*on_fullscreen) (AdaptativeWindow* self);
	void (*on_unfullscreen) (AdaptativeWindow* self);
	void (*before_destroy) (AdaptativeWindow* self);
};

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _BaseWindow {
	AdaptativeWindow parent_instance;
	BaseWindowPrivate * priv;
	GSimpleAction* escape_action;
};

struct _BaseWindowClass {
	AdaptativeWindowClass parent_class;
	gboolean (*handle_copy_text) (BaseWindow* self, gchar** copy_text);
	gboolean (*get_alt_copy_text) (BaseWindow* self, gchar** copy_text);
	void (*paste_text) (BaseWindow* self, const gchar* text);
	void (*menu_pressed) (BaseWindow* self);
	void (*set_window_size) (BaseWindow* self, AdaptativeWidgetWindowSize new_size);
	void (*close_in_window_panels) (BaseWindow* self);
	gboolean (*escape_pressed) (BaseWindow* self);
	void (*show_default_view) (BaseWindow* self);
};

struct _GameWindow {
	BaseWindow parent_instance;
	GameWindowPrivate * priv;
};

struct _GameWindowClass {
	BaseWindowClass parent_class;
};

struct _GameWindowPrivate {
	gboolean game_finished;
	GameHeaderBar* headerbar;
	GameView* game_view;
	GameActionBar* actionbar;
	gboolean is_quite_thin;
	GSimpleAction* undo_action;
	GSimpleAction* redo_action;
	gboolean back_action_disabled;
};

static gint GameWindow_private_offset;
static gpointer game_window_parent_class = NULL;
static AdaptativeWidgetIface * game_window_adaptative_widget_parent_iface = NULL;

VALA_EXTERN GType game_window_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWindow, g_object_unref)
VALA_EXTERN GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWidget, g_object_unref)
VALA_EXTERN GType base_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseWindow, g_object_unref)
VALA_EXTERN GType game_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameWindow, g_object_unref)
VALA_EXTERN GType night_time_aware_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NightTimeAwareHeaderBar, g_object_unref)
VALA_EXTERN GType base_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseHeaderBar, g_object_unref)
VALA_EXTERN GType game_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHeaderBar, g_object_unref)
VALA_EXTERN GType base_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BaseView, g_object_unref)
VALA_EXTERN GType game_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
VALA_EXTERN GType game_action_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameActionBar, g_object_unref)
VALA_EXTERN void base_window_set_window_size (BaseWindow* self,
                                  AdaptativeWidgetWindowSize new_size);
VALA_EXTERN gboolean base_window_escape_pressed (BaseWindow* self);
static void game_window_new_game_cb (GameWindow* self);
static void _game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void game_window_start_game_cb (GameWindow* self);
static void _game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void game_window_undo_cb (GameWindow* self);
static void _game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_redo_cb (GameWindow* self);
static void _game_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void game_window_hint_cb (GameWindow* self);
static void _game_window_hint_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
VALA_EXTERN GType night_light_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NightLightMonitor, g_object_unref)
VALA_EXTERN GameWindow* game_window_new (const gchar* css_resource,
                             const gchar* name,
                             const gchar* about_action_label,
                             gboolean start_now,
                             GameWindowFlags flags,
                             GtkBox* new_game_screen,
                             GtkWidget* view_content,
                             GMenu* appearance_menu,
                             GtkWidget* game_widget_1,
                             GtkWidget* game_widget_2,
                             NightLightMonitor* night_light_monitor);
VALA_EXTERN GameWindow* game_window_construct (GType object_type,
                                   const gchar* css_resource,
                                   const gchar* name,
                                   const gchar* about_action_label,
                                   gboolean start_now,
                                   GameWindowFlags flags,
                                   GtkBox* new_game_screen,
                                   GtkWidget* view_content,
                                   GMenu* appearance_menu,
                                   GtkWidget* game_widget_1,
                                   GtkWidget* game_widget_2,
                                   NightLightMonitor* night_light_monitor);
VALA_EXTERN GameActionBar* game_action_bar_new (const gchar* _game_name,
                                    GtkWidget* _game_widget,
                                    gboolean _show_actionbar);
VALA_EXTERN GameActionBar* game_action_bar_construct (GType object_type,
                                          const gchar* _game_name,
                                          GtkWidget* _game_widget,
                                          gboolean _show_actionbar);
VALA_EXTERN GType game_action_bar_place_holder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameActionBarPlaceHolder, g_object_unref)
VALA_EXTERN GameActionBarPlaceHolder* game_action_bar_place_holder_new (GameActionBar* _actionbar);
VALA_EXTERN GameActionBarPlaceHolder* game_action_bar_place_holder_construct (GType object_type,
                                                                  GameActionBar* _actionbar);
VALA_EXTERN GameHeaderBar* game_header_bar_new (const gchar* _window_name,
                                    const gchar* _about_action_label,
                                    GameWindowFlags flags,
                                    GMenu* _appearance_menu,
                                    GtkWidget* _game_widget,
                                    NightLightMonitor* _night_light_monitor);
VALA_EXTERN GameHeaderBar* game_header_bar_construct (GType object_type,
                                          const gchar* _window_name,
                                          const gchar* _about_action_label,
                                          GameWindowFlags flags,
                                          GMenu* _appearance_menu,
                                          GtkWidget* _game_widget,
                                          NightLightMonitor* _night_light_monitor);
VALA_EXTERN GameView* game_view_new (GameWindowFlags flags,
                         GtkBox* new_game_screen,
                         GtkWidget* content,
                         GameActionBarPlaceHolder* actionbar_placeholder);
VALA_EXTERN GameView* game_view_construct (GType object_type,
                               GameWindowFlags flags,
                               GtkBox* new_game_screen,
                               GtkWidget* content,
                               GameActionBarPlaceHolder* actionbar_placeholder);
VALA_EXTERN void base_window_add_to_main_overlay (BaseWindow* self,
                                      GtkWidget* widget);
VALA_EXTERN void adaptative_window_add_adaptative_child (AdaptativeWindow* self,
                                             AdaptativeWidget* child);
static void game_window_install_ui_action_entries (GameWindow* self);
static void game_window_show_view (GameWindow* self);
static void game_window_show_new_game_screen (GameWindow* self);
static void game_window_real_set_window_size (AdaptativeWidget* base,
                                       AdaptativeWidgetWindowSize new_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_quite_thin (AdaptativeWidgetWindowSize window_size);
VALA_EXTERN void game_window_finish_game (GameWindow* self);
VALA_EXTERN void game_header_bar_finish_game (GameHeaderBar* self);
static gboolean game_window_real_escape_pressed (BaseWindow* base);
static void game_window_back_cb (GameWindow* self);
VALA_EXTERN gboolean game_view_game_content_visible_if_true (GameView* self);
VALA_EXTERN void game_view_configure_transition (GameView* self,
                                     GtkStackTransitionType transition_type,
                                     guint transition_duration);
VALA_EXTERN void base_window_hide_notification (BaseWindow* self);
VALA_EXTERN void game_header_bar_update_title (GameHeaderBar* self,
                                   const gchar* new_title);
VALA_EXTERN void game_action_bar_set_visibility (GameActionBar* self,
                                     gboolean new_visibility);
VALA_EXTERN gboolean game_header_bar_show_new_game_screen (GameHeaderBar* self,
                                               gboolean game_finished);
VALA_EXTERN void game_view_show_new_game_box (GameView* self,
                                  gboolean grab_focus);
VALA_EXTERN gboolean game_header_bar_show_view (GameHeaderBar* self,
                                    gboolean game_finished);
VALA_EXTERN void game_view_show_game_content (GameView* self,
                                  gboolean grab_focus);
VALA_EXTERN gboolean base_view_is_in_in_window_mode (BaseView* self);
static void game_window_new_game (GameWindow* self);
VALA_EXTERN void game_window_cannot_undo_more (GameWindow* self);
VALA_EXTERN void game_window_new_turn_start (GameWindow* self,
                                 gboolean can_undo);
VALA_EXTERN void game_window_clear_subtitle (GameWindow* self);
VALA_EXTERN void game_window_update_title (GameWindow* self,
                               const gchar* game_name);
VALA_EXTERN void game_action_bar_update_title (GameActionBar* self,
                                   const gchar* new_title);
VALA_EXTERN void game_header_bar_new_game (GameHeaderBar* self);
VALA_EXTERN void adaptative_widget_set_window_size (AdaptativeWidget* self,
                                        AdaptativeWidgetWindowSize new_size);
static void game_window_finalize (GObject * obj);
static GType game_window_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry GAME_WINDOW_ui_action_entries[5] = {{"new-game", _game_window_new_game_cb_gsimple_action_activate_callback}, {"start-game", _game_window_start_game_cb_gsimple_action_activate_callback}, {"undo", _game_window_undo_cb_gsimple_action_activate_callback}, {"redo", _game_window_redo_cb_gsimple_action_activate_callback}, {"hint", _game_window_hint_cb_gsimple_action_activate_callback}};

static GType
game_window_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{GAME_WINDOW_FLAGS_HAS_SOUND, "GAME_WINDOW_FLAGS_HAS_SOUND", "has-sound"}, {GAME_WINDOW_FLAGS_SHORTCUTS, "GAME_WINDOW_FLAGS_SHORTCUTS", "shortcuts"}, {GAME_WINDOW_FLAGS_SHOW_HELP, "GAME_WINDOW_FLAGS_SHOW_HELP", "show-help"}, {GAME_WINDOW_FLAGS_SHOW_START_BUTTON, "GAME_WINDOW_FLAGS_SHOW_START_BUTTON", "show-start-button"}, {0, NULL, NULL}};
	GType game_window_flags_type_id;
	game_window_flags_type_id = g_flags_register_static ("GameWindowFlags", values);
	return game_window_flags_type_id;
}

GType
game_window_flags_get_type (void)
{
	static volatile gsize game_window_flags_type_id__once = 0;
	if (g_once_init_enter (&game_window_flags_type_id__once)) {
		GType game_window_flags_type_id;
		game_window_flags_type_id = game_window_flags_get_type_once ();
		g_once_init_leave (&game_window_flags_type_id__once, game_window_flags_type_id);
	}
	return game_window_flags_type_id__once;
}

static inline gpointer
game_window_get_instance_private (GameWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GameWindow_private_offset);
}

static void
_game_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 189 "../src/game-window.vala"
	game_window_new_game_cb ((GameWindow*) self);
#line 452 "game-window.c"
}

static void
_game_window_start_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 189 "../src/game-window.vala"
	game_window_start_game_cb ((GameWindow*) self);
#line 462 "game-window.c"
}

static void
_game_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 189 "../src/game-window.vala"
	game_window_undo_cb ((GameWindow*) self);
#line 472 "game-window.c"
}

static void
_game_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 189 "../src/game-window.vala"
	game_window_redo_cb ((GameWindow*) self);
#line 482 "game-window.c"
}

static void
_game_window_hint_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 189 "../src/game-window.vala"
	game_window_hint_cb ((GameWindow*) self);
#line 492 "game-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/game-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 500 "game-window.c"
}

GameWindow*
game_window_construct (GType object_type,
                       const gchar* css_resource,
                       const gchar* name,
                       const gchar* about_action_label,
                       gboolean start_now,
                       GameWindowFlags flags,
                       GtkBox* new_game_screen,
                       GtkWidget* view_content,
                       GMenu* appearance_menu,
                       GtkWidget* game_widget_1,
                       GtkWidget* game_widget_2,
                       NightLightMonitor* night_light_monitor)
{
	GameWindow * self = NULL;
	GameActionBar* _actionbar = NULL;
	GameActionBar* _tmp0_;
	GameActionBarPlaceHolder* actionbar_placeholder = NULL;
	GameActionBar* _tmp1_;
	GameActionBarPlaceHolder* _tmp2_;
	GameHeaderBar* _headerbar = NULL;
	GameHeaderBar* _tmp3_;
	GameView* _game_view = NULL;
	GameActionBarPlaceHolder* _tmp4_;
	GameView* _tmp5_;
	GameHeaderBar* _tmp6_;
	GameView* _tmp7_;
	GameHeaderBar* _tmp8_;
	GameHeaderBar* _tmp9_;
	GameView* _tmp10_;
	GameView* _tmp11_;
	GameActionBar* _tmp12_;
	GameActionBar* _tmp13_;
	GameActionBar* _tmp14_;
	GameActionBar* _tmp15_;
	GameView* _tmp16_;
	GameActionBar* _tmp17_;
	GameActionBarPlaceHolder* _tmp18_;
#line 40 "../src/game-window.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 40 "../src/game-window.vala"
	g_return_val_if_fail (about_action_label != NULL, NULL);
#line 40 "../src/game-window.vala"
	g_return_val_if_fail (new_game_screen != NULL, NULL);
#line 40 "../src/game-window.vala"
	g_return_val_if_fail (view_content != NULL, NULL);
#line 40 "../src/game-window.vala"
	g_return_val_if_fail (night_light_monitor != NULL, NULL);
#line 42 "../src/game-window.vala"
	_tmp0_ = game_action_bar_new (name, game_widget_2, start_now);
#line 42 "../src/game-window.vala"
	g_object_ref_sink (_tmp0_);
#line 42 "../src/game-window.vala"
	_actionbar = _tmp0_;
#line 43 "../src/game-window.vala"
	_tmp1_ = _actionbar;
#line 43 "../src/game-window.vala"
	_tmp2_ = game_action_bar_place_holder_new (_tmp1_);
#line 43 "../src/game-window.vala"
	g_object_ref_sink (_tmp2_);
#line 43 "../src/game-window.vala"
	actionbar_placeholder = _tmp2_;
#line 45 "../src/game-window.vala"
	_tmp3_ = game_header_bar_new (name, about_action_label, flags, appearance_menu, game_widget_1, night_light_monitor);
#line 45 "../src/game-window.vala"
	g_object_ref_sink (_tmp3_);
#line 45 "../src/game-window.vala"
	_headerbar = _tmp3_;
#line 46 "../src/game-window.vala"
	_tmp4_ = actionbar_placeholder;
#line 46 "../src/game-window.vala"
	_tmp5_ = game_view_new (flags, new_game_screen, view_content, _tmp4_);
#line 46 "../src/game-window.vala"
	g_object_ref_sink (_tmp5_);
#line 46 "../src/game-window.vala"
	_game_view = _tmp5_;
#line 48 "../src/game-window.vala"
	_tmp6_ = _headerbar;
#line 48 "../src/game-window.vala"
	_tmp7_ = _game_view;
#line 48 "../src/game-window.vala"
	self = (GameWindow*) g_object_new (object_type, "nta-headerbar", G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_NIGHT_TIME_AWARE_HEADER_BAR, NightTimeAwareHeaderBar), "base-view", G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_BASE_VIEW, BaseView), "window-title", IAGNO_PROGRAM_NAME, "specific-css-class-or-empty", "", "help-string-or-empty", "help:iagno", "schema-path", "/org/gnome/iagno/", NULL);
#line 55 "../src/game-window.vala"
	_tmp8_ = _headerbar;
#line 55 "../src/game-window.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 55 "../src/game-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 55 "../src/game-window.vala"
	self->priv->headerbar = _tmp9_;
#line 56 "../src/game-window.vala"
	_tmp10_ = _game_view;
#line 56 "../src/game-window.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 56 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_view);
#line 56 "../src/game-window.vala"
	self->priv->game_view = _tmp11_;
#line 57 "../src/game-window.vala"
	_tmp12_ = _actionbar;
#line 57 "../src/game-window.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 57 "../src/game-window.vala"
	_g_object_unref0 (self->priv->actionbar);
#line 57 "../src/game-window.vala"
	self->priv->actionbar = _tmp13_;
#line 59 "../src/game-window.vala"
	_tmp14_ = self->priv->actionbar;
#line 59 "../src/game-window.vala"
	base_window_add_to_main_overlay ((BaseWindow*) self, (GtkWidget*) _tmp14_);
#line 60 "../src/game-window.vala"
	_tmp15_ = self->priv->actionbar;
#line 60 "../src/game-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_END);
#line 62 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (new_game_screen, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 63 "../src/game-window.vala"
	_tmp16_ = self->priv->game_view;
#line 63 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 64 "../src/game-window.vala"
	_tmp17_ = self->priv->actionbar;
#line 64 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 65 "../src/game-window.vala"
	_tmp18_ = actionbar_placeholder;
#line 65 "../src/game-window.vala"
	adaptative_window_add_adaptative_child ((AdaptativeWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget));
#line 68 "../src/game-window.vala"
	if (css_resource != NULL) {
#line 633 "game-window.c"
		GtkCssProvider* css_provider = NULL;
		GtkCssProvider* _tmp19_;
		GtkCssProvider* _tmp20_;
		GdkScreen* gdk_screen = NULL;
		GdkScreen* _tmp21_;
		GdkScreen* _tmp22_;
		GdkScreen* _tmp23_;
#line 70 "../src/game-window.vala"
		_tmp19_ = gtk_css_provider_new ();
#line 70 "../src/game-window.vala"
		css_provider = _tmp19_;
#line 71 "../src/game-window.vala"
		_tmp20_ = css_provider;
#line 71 "../src/game-window.vala"
		gtk_css_provider_load_from_resource (_tmp20_, (const gchar*) css_resource);
#line 72 "../src/game-window.vala"
		_tmp21_ = gdk_screen_get_default ();
#line 72 "../src/game-window.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 72 "../src/game-window.vala"
		gdk_screen = _tmp22_;
#line 73 "../src/game-window.vala"
		_tmp23_ = gdk_screen;
#line 73 "../src/game-window.vala"
		if (_tmp23_ != NULL) {
#line 659 "game-window.c"
			GdkScreen* _tmp24_;
			GtkCssProvider* _tmp25_;
#line 74 "../src/game-window.vala"
			_tmp24_ = gdk_screen;
#line 74 "../src/game-window.vala"
			_tmp25_ = css_provider;
#line 74 "../src/game-window.vala"
			gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp25_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 668 "game-window.c"
		}
#line 68 "../src/game-window.vala"
		_g_object_unref0 (gdk_screen);
#line 68 "../src/game-window.vala"
		_g_object_unref0 (css_provider);
#line 674 "game-window.c"
	}
#line 78 "../src/game-window.vala"
	game_window_install_ui_action_entries (self);
#line 81 "../src/game-window.vala"
	gtk_window_set_title ((GtkWindow*) self, name);
#line 84 "../src/game-window.vala"
	if (start_now) {
#line 85 "../src/game-window.vala"
		game_window_show_view (self);
#line 684 "game-window.c"
	} else {
#line 87 "../src/game-window.vala"
		game_window_show_new_game_screen (self);
#line 688 "game-window.c"
	}
#line 40 "../src/game-window.vala"
	_g_object_unref0 (_game_view);
#line 40 "../src/game-window.vala"
	_g_object_unref0 (_headerbar);
#line 40 "../src/game-window.vala"
	_g_object_unref0 (actionbar_placeholder);
#line 40 "../src/game-window.vala"
	_g_object_unref0 (_actionbar);
#line 40 "../src/game-window.vala"
	return self;
#line 700 "game-window.c"
}

GameWindow*
game_window_new (const gchar* css_resource,
                 const gchar* name,
                 const gchar* about_action_label,
                 gboolean start_now,
                 GameWindowFlags flags,
                 GtkBox* new_game_screen,
                 GtkWidget* view_content,
                 GMenu* appearance_menu,
                 GtkWidget* game_widget_1,
                 GtkWidget* game_widget_2,
                 NightLightMonitor* night_light_monitor)
{
#line 40 "../src/game-window.vala"
	return game_window_construct (TYPE_GAME_WINDOW, css_resource, name, about_action_label, start_now, flags, new_game_screen, view_content, appearance_menu, game_widget_1, game_widget_2, night_light_monitor);
#line 718 "game-window.c"
}

static void
game_window_real_set_window_size (AdaptativeWidget* base,
                                  AdaptativeWidgetWindowSize new_size)
{
	GameWindow * self;
#line 95 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 97 "../src/game-window.vala"
	BASE_WINDOW_CLASS (game_window_parent_class)->set_window_size (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BASE_WINDOW, BaseWindow), new_size);
#line 99 "../src/game-window.vala"
	self->priv->is_quite_thin = adaptative_widget_window_size_is_quite_thin (new_size);
#line 732 "game-window.c"
}

void
game_window_finish_game (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
#line 106 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/game-window.vala"
	self->priv->game_finished = TRUE;
#line 109 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 109 "../src/game-window.vala"
	game_header_bar_finish_game (_tmp0_);
#line 747 "game-window.c"
}

static gboolean
game_window_real_escape_pressed (BaseWindow* base)
{
	GameWindow * self;
	gboolean result;
#line 112 "../src/game-window.vala"
	self = (GameWindow*) base;
#line 114 "../src/game-window.vala"
	if (BASE_WINDOW_CLASS (game_window_parent_class)->escape_pressed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BASE_WINDOW, BaseWindow))) {
#line 115 "../src/game-window.vala"
		result = TRUE;
#line 115 "../src/game-window.vala"
		return result;
#line 763 "game-window.c"
	}
#line 116 "../src/game-window.vala"
	if (self->priv->back_action_disabled) {
#line 117 "../src/game-window.vala"
		result = TRUE;
#line 117 "../src/game-window.vala"
		return result;
#line 771 "game-window.c"
	}
#line 118 "../src/game-window.vala"
	game_window_back_cb (self);
#line 119 "../src/game-window.vala"
	result = TRUE;
#line 119 "../src/game-window.vala"
	return result;
#line 779 "game-window.c"
}

static void
game_window_back_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
#line 121 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 123 "../src/game-window.vala"
	if (game_view_game_content_visible_if_true (_tmp0_)) {
#line 124 "../src/game-window.vala"
		return;
#line 795 "game-window.c"
	}
#line 127 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 127 "../src/game-window.vala"
	game_view_configure_transition (_tmp1_, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT, (guint) 800);
#line 128 "../src/game-window.vala"
	game_window_show_view (self);
#line 130 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_BACK_SIGNAL], 0);
#line 805 "game-window.c"
}

static void
game_window_show_new_game_screen (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
	GameActionBar* _tmp1_;
	gboolean grabs_focus = FALSE;
	GameHeaderBar* _tmp2_;
	GameView* _tmp3_;
#line 137 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/game-window.vala"
	base_window_hide_notification ((BaseWindow*) self);
#line 140 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 140 "../src/game-window.vala"
	game_header_bar_update_title (_tmp0_, IAGNO_PROGRAM_NAME);
#line 141 "../src/game-window.vala"
	_tmp1_ = self->priv->actionbar;
#line 141 "../src/game-window.vala"
	game_action_bar_set_visibility (_tmp1_, FALSE);
#line 142 "../src/game-window.vala"
	_tmp2_ = self->priv->headerbar;
#line 142 "../src/game-window.vala"
	grabs_focus = game_header_bar_show_new_game_screen (_tmp2_, self->priv->game_finished);
#line 143 "../src/game-window.vala"
	_tmp3_ = self->priv->game_view;
#line 143 "../src/game-window.vala"
	game_view_show_new_game_box (_tmp3_, !grabs_focus);
#line 836 "game-window.c"
}

static void
game_window_show_view (GameWindow* self)
{
	gboolean grabs_focus = FALSE;
	GameHeaderBar* _tmp0_;
	GameView* _tmp1_;
	GSimpleAction* _tmp2_;
#line 146 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 148 "../src/game-window.vala"
	grabs_focus = game_header_bar_show_view (_tmp0_, self->priv->game_finished);
#line 149 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 149 "../src/game-window.vala"
	game_view_show_game_content (_tmp1_, !grabs_focus);
#line 150 "../src/game-window.vala"
	_tmp2_ = ((BaseWindow*) self)->escape_action;
#line 150 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp2_, FALSE);
#line 860 "game-window.c"
}

static void
game_window_install_ui_action_entries (GameWindow* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
#line 173 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/game-window.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 175 "../src/game-window.vala"
	action_group = _tmp0_;
#line 176 "../src/game-window.vala"
	g_action_map_add_action_entries ((GActionMap*) action_group, GAME_WINDOW_ui_action_entries, (gint) G_N_ELEMENTS (GAME_WINDOW_ui_action_entries), self);
#line 177 "../src/game-window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "ui", (GActionGroup*) action_group);
#line 180 "../src/game-window.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) action_group, "undo");
#line 180 "../src/game-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_simple_action_get_type (), GSimpleAction));
#line 180 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 180 "../src/game-window.vala"
	self->priv->undo_action = _tmp2_;
#line 181 "../src/game-window.vala"
	_tmp3_ = g_action_map_lookup_action ((GActionMap*) action_group, "redo");
#line 181 "../src/game-window.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_simple_action_get_type (), GSimpleAction));
#line 181 "../src/game-window.vala"
	_g_object_unref0 (self->priv->redo_action);
#line 181 "../src/game-window.vala"
	self->priv->redo_action = _tmp4_;
#line 185 "../src/game-window.vala"
	_tmp5_ = self->priv->undo_action;
#line 185 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp5_, FALSE);
#line 186 "../src/game-window.vala"
	_tmp6_ = self->priv->redo_action;
#line 186 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 173 "../src/game-window.vala"
	_g_object_unref0 (action_group);
#line 910 "game-window.c"
}

static void
game_window_new_game_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
#line 200 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 202 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 203 "../src/game-window.vala"
		return;
#line 926 "game-window.c"
	}
#line 204 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 204 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 205 "../src/game-window.vala"
		return;
#line 934 "game-window.c"
	}
#line 207 "../src/game-window.vala"
	game_window_new_game (self);
#line 938 "game-window.c"
}

static void
game_window_undo_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
	GameView* _tmp2_;
#line 210 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 212 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 213 "../src/game-window.vala"
		return;
#line 955 "game-window.c"
	}
#line 214 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 214 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 216 "../src/game-window.vala"
		if (!self->priv->back_action_disabled) {
#line 217 "../src/game-window.vala"
			game_window_back_cb (self);
#line 965 "game-window.c"
		}
#line 218 "../src/game-window.vala"
		return;
#line 969 "game-window.c"
	}
#line 221 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 223 "../src/game-window.vala"
	_tmp2_ = self->priv->game_view;
#line 223 "../src/game-window.vala"
	game_view_show_game_content (_tmp2_, TRUE);
#line 226 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_UNDO_SIGNAL], 0);
#line 979 "game-window.c"
}

static void
game_window_redo_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
	GameView* _tmp2_;
	GSimpleAction* _tmp3_;
#line 229 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 231 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 232 "../src/game-window.vala"
		return;
#line 997 "game-window.c"
	}
#line 233 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 233 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 234 "../src/game-window.vala"
		return;
#line 1005 "game-window.c"
	}
#line 236 "../src/game-window.vala"
	_tmp2_ = self->priv->game_view;
#line 236 "../src/game-window.vala"
	game_view_show_game_content (_tmp2_, TRUE);
#line 238 "../src/game-window.vala"
	_tmp3_ = self->priv->undo_action;
#line 238 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp3_, TRUE);
#line 240 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_REDO_SIGNAL], 0);
#line 1017 "game-window.c"
}

static void
game_window_hint_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
#line 243 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 245 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 246 "../src/game-window.vala"
		return;
#line 1033 "game-window.c"
	}
#line 247 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 247 "../src/game-window.vala"
	if (!game_view_game_content_visible_if_true (_tmp1_)) {
#line 248 "../src/game-window.vala"
		return;
#line 1041 "game-window.c"
	}
#line 250 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_HINT_SIGNAL], 0);
#line 1045 "game-window.c"
}

void
game_window_cannot_undo_more (GameWindow* self)
{
	GSimpleAction* _tmp0_;
	GameView* _tmp1_;
#line 257 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 259 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 260 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 260 "../src/game-window.vala"
	game_view_show_game_content (_tmp1_, TRUE);
#line 1063 "game-window.c"
}

void
game_window_new_turn_start (GameWindow* self,
                            gboolean can_undo)
{
	GSimpleAction* _tmp0_;
#line 263 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/game-window.vala"
	_tmp0_ = self->priv->undo_action;
#line 265 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp0_, can_undo);
#line 266 "../src/game-window.vala"
	base_window_hide_notification ((BaseWindow*) self);
#line 1079 "game-window.c"
}

void
game_window_clear_subtitle (GameWindow* self)
{
	GameHeaderBar* _tmp0_;
#line 269 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 271 "../src/game-window.vala"
	gtk_header_bar_set_subtitle ((GtkHeaderBar*) _tmp0_, NULL);
#line 1092 "game-window.c"
}

void
game_window_update_title (GameWindow* self,
                          const gchar* game_name)
{
	GameHeaderBar* _tmp0_;
	GameActionBar* _tmp1_;
	GameActionBar* _tmp2_;
#line 274 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/game-window.vala"
	g_return_if_fail (game_name != NULL);
#line 276 "../src/game-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 276 "../src/game-window.vala"
	game_header_bar_update_title (_tmp0_, game_name);
#line 277 "../src/game-window.vala"
	_tmp1_ = self->priv->actionbar;
#line 277 "../src/game-window.vala"
	game_action_bar_update_title (_tmp1_, game_name);
#line 278 "../src/game-window.vala"
	_tmp2_ = self->priv->actionbar;
#line 278 "../src/game-window.vala"
	game_action_bar_set_visibility (_tmp2_, TRUE);
#line 1118 "game-window.c"
}

static void
game_window_new_game (GameWindow* self)
{
	GameView* _tmp0_;
	GameHeaderBar* _tmp1_;
	GSimpleAction* _tmp2_;
#line 285 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_WAIT_SIGNAL], 0);
#line 289 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 289 "../src/game-window.vala"
	game_view_configure_transition (_tmp0_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT, (guint) 800);
#line 291 "../src/game-window.vala"
	_tmp1_ = self->priv->headerbar;
#line 291 "../src/game-window.vala"
	game_header_bar_new_game (_tmp1_);
#line 292 "../src/game-window.vala"
	self->priv->back_action_disabled = FALSE;
#line 293 "../src/game-window.vala"
	_tmp2_ = ((BaseWindow*) self)->escape_action;
#line 293 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp2_, TRUE);
#line 294 "../src/game-window.vala"
	game_window_show_new_game_screen (self);
#line 1147 "game-window.c"
}

static void
game_window_start_game_cb (GameWindow* self)
{
	GameView* _tmp0_;
	GameView* _tmp1_;
	GSimpleAction* _tmp2_;
#line 297 "../src/game-window.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/game-window.vala"
	_tmp0_ = self->priv->game_view;
#line 299 "../src/game-window.vala"
	if (base_view_is_in_in_window_mode ((BaseView*) _tmp0_)) {
#line 300 "../src/game-window.vala"
		return;
#line 1164 "game-window.c"
	}
#line 302 "../src/game-window.vala"
	_tmp1_ = self->priv->game_view;
#line 302 "../src/game-window.vala"
	if (game_view_game_content_visible_if_true (_tmp1_)) {
#line 303 "../src/game-window.vala"
		return;
#line 1172 "game-window.c"
	}
#line 305 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 307 "../src/game-window.vala"
	_tmp2_ = self->priv->undo_action;
#line 307 "../src/game-window.vala"
	g_simple_action_set_enabled (_tmp2_, FALSE);
#line 310 "../src/game-window.vala"
	g_signal_emit (self, game_window_signals[GAME_WINDOW_PLAY_SIGNAL], 0);
#line 312 "../src/game-window.vala"
	if (self->priv->is_quite_thin) {
#line 1184 "game-window.c"
		GameView* _tmp3_;
#line 313 "../src/game-window.vala"
		_tmp3_ = self->priv->game_view;
#line 313 "../src/game-window.vala"
		game_view_configure_transition (_tmp3_, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN, (guint) 1000);
#line 1190 "game-window.c"
	} else {
		GameView* _tmp4_;
#line 315 "../src/game-window.vala"
		_tmp4_ = self->priv->game_view;
#line 315 "../src/game-window.vala"
		game_view_configure_transition (_tmp4_, GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP, (guint) 1000);
#line 1197 "game-window.c"
	}
#line 316 "../src/game-window.vala"
	game_window_show_view (self);
#line 1201 "game-window.c"
}

static void
game_window_class_init (GameWindowClass * klass,
                        gpointer klass_data)
{
#line 31 "../src/game-window.vala"
	game_window_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/game-window.vala"
	g_type_class_adjust_private_offset (klass, &GameWindow_private_offset);
#line 31 "../src/game-window.vala"
	((BaseWindowClass *) klass)->set_window_size = (void (*) (BaseWindow*, AdaptativeWidgetWindowSize)) game_window_real_set_window_size;
#line 31 "../src/game-window.vala"
	((BaseWindowClass *) klass)->escape_pressed = (gboolean (*) (BaseWindow*)) game_window_real_escape_pressed;
#line 31 "../src/game-window.vala"
	G_OBJECT_CLASS (klass)->finalize = game_window_finalize;
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_PLAY_SIGNAL] = g_signal_new ("play", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_WAIT_SIGNAL] = g_signal_new ("wait", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_BACK_SIGNAL] = g_signal_new ("back", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_RESTART_SIGNAL] = g_signal_new ("restart", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_UNDO_SIGNAL] = g_signal_new ("undo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_REDO_SIGNAL] = g_signal_new ("redo", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../src/game-window.vala"
	game_window_signals[GAME_WINDOW_HINT_SIGNAL] = g_signal_new ("hint", TYPE_GAME_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1232 "game-window.c"
}

static void
game_window_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                              gpointer iface_data)
{
#line 31 "../src/game-window.vala"
	game_window_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 31 "../src/game-window.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) game_window_real_set_window_size;
#line 1243 "game-window.c"
}

static void
game_window_instance_init (GameWindow * self,
                           gpointer klass)
{
#line 31 "../src/game-window.vala"
	self->priv = game_window_get_instance_private (self);
#line 33 "../src/game-window.vala"
	self->priv->game_finished = FALSE;
#line 94 "../src/game-window.vala"
	self->priv->is_quite_thin = FALSE;
#line 171 "../src/game-window.vala"
	self->priv->back_action_disabled = TRUE;
#line 1258 "game-window.c"
}

static void
game_window_finalize (GObject * obj)
{
	GameWindow * self;
#line 31 "../src/game-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_WINDOW, GameWindow);
#line 36 "../src/game-window.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 37 "../src/game-window.vala"
	_g_object_unref0 (self->priv->game_view);
#line 38 "../src/game-window.vala"
	_g_object_unref0 (self->priv->actionbar);
#line 167 "../src/game-window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 168 "../src/game-window.vala"
	_g_object_unref0 (self->priv->redo_action);
#line 31 "../src/game-window.vala"
	G_OBJECT_CLASS (game_window_parent_class)->finalize (obj);
#line 1279 "game-window.c"
}

static GType
game_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameWindow), 0, (GInstanceInitFunc) game_window_instance_init, NULL };
	static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) game_window_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType game_window_type_id;
	game_window_type_id = g_type_register_static (TYPE_BASE_WINDOW, "GameWindow", &g_define_type_info, 0);
	g_type_add_interface_static (game_window_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
	GameWindow_private_offset = g_type_add_instance_private (game_window_type_id, sizeof (GameWindowPrivate));
	return game_window_type_id;
}

GType
game_window_get_type (void)
{
	static volatile gsize game_window_type_id__once = 0;
	if (g_once_init_enter (&game_window_type_id__once)) {
		GType game_window_type_id;
		game_window_type_id = game_window_get_type_once ();
		g_once_init_leave (&game_window_type_id__once, game_window_type_id);
	}
	return game_window_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

