/* new-game-screen.c generated by valac 0.56.3, the Vala compiler
 * generated from new-game-screen.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of a GNOME game

   Copyright (C) 2015-2016 – Arnaud Bonatti <arnaud.bonatti@gmail.com>

   This application is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This application is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this application.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_NEW_GAME_SCREEN (new_game_screen_get_type ())
#define NEW_GAME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_GAME_SCREEN, NewGameScreen))
#define NEW_GAME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_GAME_SCREEN, NewGameScreenClass))
#define IS_NEW_GAME_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_GAME_SCREEN))
#define IS_NEW_GAME_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_GAME_SCREEN))
#define NEW_GAME_SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_GAME_SCREEN, NewGameScreenClass))

typedef struct _NewGameScreen NewGameScreen;
typedef struct _NewGameScreenClass NewGameScreenClass;
typedef struct _NewGameScreenPrivate NewGameScreenPrivate;
enum  {
	NEW_GAME_SCREEN_0_PROPERTY,
	NEW_GAME_SCREEN_NUM_PROPERTIES
};
static GParamSpec* new_game_screen_properties[NEW_GAME_SCREEN_NUM_PROPERTIES];
typedef enum  {
	NEW_GAME_SCREEN_MENU_BUTTON_ONE,
	NEW_GAME_SCREEN_MENU_BUTTON_TWO
} NewGameScreenMenuButton;

#define NEW_GAME_SCREEN_TYPE_MENU_BUTTON (new_game_screen_menu_button_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _NewGameScreen {
	GtkBox parent_instance;
	NewGameScreenPrivate * priv;
};

struct _NewGameScreenClass {
	GtkBoxClass parent_class;
};

struct _NewGameScreenPrivate {
	GtkModelButton* modelbutton_one;
	GtkModelButton* modelbutton_two;
	GtkMenuButton* menubutton_one;
	GtkMenuButton* menubutton_two;
	GtkBox* games_box;
	GtkBox* options_box;
	GtkLabel* games_label;
	GtkLabel* options_label;
	GtkSeparator* options_separator;
	gboolean phone_size;
	gboolean extra_thin;
	gboolean extra_flat;
};

static gint NewGameScreen_private_offset;
static gpointer new_game_screen_parent_class = NULL;
static AdaptativeWidgetIface * new_game_screen_adaptative_widget_parent_iface = NULL;

VALA_EXTERN GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWidget, g_object_unref)
VALA_EXTERN GType new_game_screen_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewGameScreen, g_object_unref)
VALA_EXTERN GType new_game_screen_menu_button_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NewGameScreen* new_game_screen_new (const gchar* modelbutton_one_label,
                                    const gchar* modelbutton_one_action,
                                    const gchar* modelbutton_two_label,
                                    const gchar* modelbutton_two_action);
VALA_EXTERN NewGameScreen* new_game_screen_construct (GType object_type,
                                          const gchar* modelbutton_one_label,
                                          const gchar* modelbutton_one_action,
                                          const gchar* modelbutton_two_label,
                                          const gchar* modelbutton_two_action);
VALA_EXTERN void new_game_screen_update_menubutton_label (NewGameScreen* self,
                                              NewGameScreenMenuButton button,
                                              const gchar* label);
VALA_EXTERN void new_game_screen_update_menubutton_menu (NewGameScreen* self,
                                             NewGameScreenMenuButton button,
                                             GMenu* menu);
VALA_EXTERN void new_game_screen_update_menubutton_sensitivity (NewGameScreen* self,
                                                    NewGameScreenMenuButton button,
                                                    gboolean new_sensitivity);
VALA_EXTERN gchar* new_game_screen_get_size_button_label (gint size);
static void new_game_screen_fix_race (NewGameScreen* self);
static void __lambda21_ (NewGameScreen* self);
static void ___lambda21__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void __lambda22_ (NewGameScreen* self);
static void ___lambda22__gtk_widget_map (GtkWidget* _sender,
                                  gpointer self);
static void new_game_screen_real_set_window_size (AdaptativeWidget* base,
                                           AdaptativeWidgetWindowSize new_size);
VALA_EXTERN gboolean adaptative_widget_window_size_is_extra_flat (AdaptativeWidgetWindowSize window_size);
static GObject * new_game_screen_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
VALA_EXTERN void adaptative_widget_set_window_size (AdaptativeWidget* self,
                                        AdaptativeWidgetWindowSize new_size);
static void new_game_screen_finalize (GObject * obj);
static GType new_game_screen_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
new_game_screen_get_instance_private (NewGameScreen* self)
{
	return G_STRUCT_MEMBER_P (self, NewGameScreen_private_offset);
}

static GType
new_game_screen_menu_button_get_type_once (void)
{
	static const GEnumValue values[] = {{NEW_GAME_SCREEN_MENU_BUTTON_ONE, "NEW_GAME_SCREEN_MENU_BUTTON_ONE", "one"}, {NEW_GAME_SCREEN_MENU_BUTTON_TWO, "NEW_GAME_SCREEN_MENU_BUTTON_TWO", "two"}, {0, NULL, NULL}};
	GType new_game_screen_menu_button_type_id;
	new_game_screen_menu_button_type_id = g_enum_register_static ("NewGameScreenMenuButton", values);
	return new_game_screen_menu_button_type_id;
}

GType
new_game_screen_menu_button_get_type (void)
{
	static volatile gsize new_game_screen_menu_button_type_id__once = 0;
	if (g_once_init_enter (&new_game_screen_menu_button_type_id__once)) {
		GType new_game_screen_menu_button_type_id;
		new_game_screen_menu_button_type_id = new_game_screen_menu_button_get_type_once ();
		g_once_init_leave (&new_game_screen_menu_button_type_id__once, new_game_screen_menu_button_type_id);
	}
	return new_game_screen_menu_button_type_id__once;
}

NewGameScreen*
new_game_screen_construct (GType object_type,
                           const gchar* modelbutton_one_label,
                           const gchar* modelbutton_one_action,
                           const gchar* modelbutton_two_label,
                           const gchar* modelbutton_two_action)
{
	NewGameScreen * self = NULL;
	GtkModelButton* _tmp0_;
	GtkModelButton* _tmp1_;
	GtkModelButton* _tmp2_;
	GtkModelButton* _tmp3_;
#line 43 "../src/new-game-screen.vala"
	g_return_val_if_fail (modelbutton_one_label != NULL, NULL);
#line 43 "../src/new-game-screen.vala"
	g_return_val_if_fail (modelbutton_one_action != NULL, NULL);
#line 43 "../src/new-game-screen.vala"
	g_return_val_if_fail (modelbutton_two_label != NULL, NULL);
#line 43 "../src/new-game-screen.vala"
	g_return_val_if_fail (modelbutton_two_action != NULL, NULL);
#line 43 "../src/new-game-screen.vala"
	self = (NewGameScreen*) g_object_new (object_type, NULL);
#line 48 "../src/new-game-screen.vala"
	_tmp0_ = self->priv->modelbutton_one;
#line 48 "../src/new-game-screen.vala"
	g_object_set (_tmp0_, "text", modelbutton_one_label, NULL);
#line 49 "../src/new-game-screen.vala"
	_tmp1_ = self->priv->modelbutton_two;
#line 49 "../src/new-game-screen.vala"
	g_object_set (_tmp1_, "text", modelbutton_two_label, NULL);
#line 51 "../src/new-game-screen.vala"
	_tmp2_ = self->priv->modelbutton_one;
#line 51 "../src/new-game-screen.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp2_, modelbutton_one_action);
#line 52 "../src/new-game-screen.vala"
	_tmp3_ = self->priv->modelbutton_two;
#line 52 "../src/new-game-screen.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp3_, modelbutton_two_action);
#line 43 "../src/new-game-screen.vala"
	return self;
#line 233 "new-game-screen.c"
}

NewGameScreen*
new_game_screen_new (const gchar* modelbutton_one_label,
                     const gchar* modelbutton_one_action,
                     const gchar* modelbutton_two_label,
                     const gchar* modelbutton_two_action)
{
#line 43 "../src/new-game-screen.vala"
	return new_game_screen_construct (TYPE_NEW_GAME_SCREEN, modelbutton_one_label, modelbutton_one_action, modelbutton_two_label, modelbutton_two_action);
#line 244 "new-game-screen.c"
}

inline void
new_game_screen_update_menubutton_label (NewGameScreen* self,
                                         NewGameScreenMenuButton button,
                                         const gchar* label)
{
#line 64 "../src/new-game-screen.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/new-game-screen.vala"
	g_return_if_fail (label != NULL);
#line 66 "../src/new-game-screen.vala"
	switch (button) {
#line 66 "../src/new-game-screen.vala"
		case NEW_GAME_SCREEN_MENU_BUTTON_ONE:
#line 260 "new-game-screen.c"
		{
			GtkMenuButton* _tmp0_;
#line 68 "../src/new-game-screen.vala"
			_tmp0_ = self->priv->menubutton_one;
#line 68 "../src/new-game-screen.vala"
			gtk_button_set_label ((GtkButton*) _tmp0_, label);
#line 68 "../src/new-game-screen.vala"
			return;
#line 269 "new-game-screen.c"
		}
#line 66 "../src/new-game-screen.vala"
		case NEW_GAME_SCREEN_MENU_BUTTON_TWO:
#line 273 "new-game-screen.c"
		{
			GtkMenuButton* _tmp1_;
#line 69 "../src/new-game-screen.vala"
			_tmp1_ = self->priv->menubutton_two;
#line 69 "../src/new-game-screen.vala"
			gtk_button_set_label ((GtkButton*) _tmp1_, label);
#line 69 "../src/new-game-screen.vala"
			return;
#line 282 "new-game-screen.c"
		}
		default:
#line 66 "../src/new-game-screen.vala"
		break;
#line 287 "new-game-screen.c"
	}
}

inline void
new_game_screen_update_menubutton_menu (NewGameScreen* self,
                                        NewGameScreenMenuButton button,
                                        GMenu* menu)
{
#line 73 "../src/new-game-screen.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/new-game-screen.vala"
	g_return_if_fail (menu != NULL);
#line 75 "../src/new-game-screen.vala"
	switch (button) {
#line 75 "../src/new-game-screen.vala"
		case NEW_GAME_SCREEN_MENU_BUTTON_ONE:
#line 304 "new-game-screen.c"
		{
			GtkMenuButton* _tmp0_;
#line 77 "../src/new-game-screen.vala"
			_tmp0_ = self->priv->menubutton_one;
#line 77 "../src/new-game-screen.vala"
			gtk_menu_button_set_menu_model (_tmp0_, (GMenuModel*) menu);
#line 77 "../src/new-game-screen.vala"
			return;
#line 313 "new-game-screen.c"
		}
#line 75 "../src/new-game-screen.vala"
		case NEW_GAME_SCREEN_MENU_BUTTON_TWO:
#line 317 "new-game-screen.c"
		{
			GtkMenuButton* _tmp1_;
#line 78 "../src/new-game-screen.vala"
			_tmp1_ = self->priv->menubutton_two;
#line 78 "../src/new-game-screen.vala"
			gtk_menu_button_set_menu_model (_tmp1_, (GMenuModel*) menu);
#line 78 "../src/new-game-screen.vala"
			return;
#line 326 "new-game-screen.c"
		}
		default:
#line 75 "../src/new-game-screen.vala"
		break;
#line 331 "new-game-screen.c"
	}
}

inline void
new_game_screen_update_menubutton_sensitivity (NewGameScreen* self,
                                               NewGameScreenMenuButton button,
                                               gboolean new_sensitivity)
{
#line 82 "../src/new-game-screen.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/new-game-screen.vala"
	switch (button) {
#line 84 "../src/new-game-screen.vala"
		case NEW_GAME_SCREEN_MENU_BUTTON_ONE:
#line 346 "new-game-screen.c"
		{
			GtkMenuButton* _tmp0_;
#line 86 "../src/new-game-screen.vala"
			_tmp0_ = self->priv->menubutton_one;
#line 86 "../src/new-game-screen.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, new_sensitivity);
#line 86 "../src/new-game-screen.vala"
			return;
#line 355 "new-game-screen.c"
		}
#line 84 "../src/new-game-screen.vala"
		case NEW_GAME_SCREEN_MENU_BUTTON_TWO:
#line 359 "new-game-screen.c"
		{
			GtkMenuButton* _tmp1_;
#line 87 "../src/new-game-screen.vala"
			_tmp1_ = self->priv->menubutton_two;
#line 87 "../src/new-game-screen.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, new_sensitivity);
#line 87 "../src/new-game-screen.vala"
			return;
#line 368 "new-game-screen.c"
		}
		default:
#line 84 "../src/new-game-screen.vala"
		break;
#line 373 "new-game-screen.c"
	}
}

inline gchar*
new_game_screen_get_size_button_label (gint size)
{
	gchar* _tmp0_;
	gchar* result;
#line 95 "../src/new-game-screen.vala"
	_tmp0_ = g_strdup_printf (_ ("Size: %d × %d ▾"), size, size);
#line 95 "../src/new-game-screen.vala"
	result = _tmp0_;
#line 95 "../src/new-game-screen.vala"
	return result;
#line 388 "new-game-screen.c"
}

static void
__lambda21_ (NewGameScreen* self)
{
	GtkBox* _tmp0_;
#line 105 "../src/new-game-screen.vala"
	_tmp0_ = self->priv->games_box;
#line 105 "../src/new-game-screen.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 399 "new-game-screen.c"
}

static void
___lambda21__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 105 "../src/new-game-screen.vala"
	__lambda21_ ((NewGameScreen*) self);
#line 409 "new-game-screen.c"
}

static void
__lambda22_ (NewGameScreen* self)
{
	GtkBox* _tmp0_;
#line 106 "../src/new-game-screen.vala"
	_tmp0_ = self->priv->games_box;
#line 106 "../src/new-game-screen.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 420 "new-game-screen.c"
}

static void
___lambda22__gtk_widget_map (GtkWidget* _sender,
                             gpointer self)
{
#line 106 "../src/new-game-screen.vala"
	__lambda22_ ((NewGameScreen*) self);
#line 429 "new-game-screen.c"
}

static void
new_game_screen_fix_race (NewGameScreen* self)
{
#line 103 "../src/new-game-screen.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/new-game-screen.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda21__gtk_widget_size_allocate, self, G_CONNECT_AFTER);
#line 106 "../src/new-game-screen.vala"
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) ___lambda22__gtk_widget_map, self, 0);
#line 441 "new-game-screen.c"
}

static void
new_game_screen_real_set_window_size (AdaptativeWidget* base,
                                      AdaptativeWidgetWindowSize new_size)
{
	NewGameScreen * self;
	gboolean _extra_flat = FALSE;
	gboolean _extra_thin = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _phone_size = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 119 "../src/new-game-screen.vala"
	self = (NewGameScreen*) base;
#line 121 "../src/new-game-screen.vala"
	_extra_flat = adaptative_widget_window_size_is_extra_flat (new_size);
#line 122 "../src/new-game-screen.vala"
	_extra_thin = new_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN;
#line 123 "../src/new-game-screen.vala"
	if (new_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH) {
#line 123 "../src/new-game-screen.vala"
		_tmp0_ = TRUE;
#line 466 "new-game-screen.c"
	} else {
#line 124 "../src/new-game-screen.vala"
		_tmp0_ = new_size == ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT;
#line 470 "new-game-screen.c"
	}
#line 123 "../src/new-game-screen.vala"
	_phone_size = _tmp0_;
#line 126 "../src/new-game-screen.vala"
	if (_extra_thin == self->priv->extra_thin) {
#line 127 "../src/new-game-screen.vala"
		_tmp2_ = _phone_size == self->priv->phone_size;
#line 478 "new-game-screen.c"
	} else {
#line 126 "../src/new-game-screen.vala"
		_tmp2_ = FALSE;
#line 482 "new-game-screen.c"
	}
#line 126 "../src/new-game-screen.vala"
	if (_tmp2_) {
#line 128 "../src/new-game-screen.vala"
		_tmp1_ = _extra_flat == self->priv->extra_flat;
#line 488 "new-game-screen.c"
	} else {
#line 126 "../src/new-game-screen.vala"
		_tmp1_ = FALSE;
#line 492 "new-game-screen.c"
	}
#line 126 "../src/new-game-screen.vala"
	if (_tmp1_) {
#line 129 "../src/new-game-screen.vala"
		return;
#line 498 "new-game-screen.c"
	}
#line 130 "../src/new-game-screen.vala"
	self->priv->extra_thin = _extra_thin;
#line 131 "../src/new-game-screen.vala"
	self->priv->phone_size = _phone_size;
#line 132 "../src/new-game-screen.vala"
	self->priv->extra_flat = _extra_flat;
#line 134 "../src/new-game-screen.vala"
	if (!_extra_thin) {
#line 134 "../src/new-game-screen.vala"
		_tmp3_ = !_phone_size;
#line 510 "new-game-screen.c"
	} else {
#line 134 "../src/new-game-screen.vala"
		_tmp3_ = FALSE;
#line 514 "new-game-screen.c"
	}
#line 134 "../src/new-game-screen.vala"
	if (_tmp3_) {
#line 136 "../src/new-game-screen.vala"
		if (self->priv->extra_flat) {
#line 520 "new-game-screen.c"
			GtkLabel* _tmp4_;
			GtkLabel* _tmp5_;
			GtkBox* _tmp6_;
			GtkBox* _tmp7_;
			GtkSeparator* _tmp8_;
			GtkSeparator* _tmp9_;
#line 138 "../src/new-game-screen.vala"
			_tmp4_ = self->priv->games_label;
#line 138 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 139 "../src/new-game-screen.vala"
			_tmp5_ = self->priv->options_label;
#line 139 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 140 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 141 "../src/new-game-screen.vala"
			_tmp6_ = self->priv->games_box;
#line 141 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp6_, GTK_ORIENTATION_VERTICAL);
#line 142 "../src/new-game-screen.vala"
			_tmp7_ = self->priv->options_box;
#line 142 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp7_, GTK_ORIENTATION_VERTICAL);
#line 143 "../src/new-game-screen.vala"
			_tmp8_ = self->priv->options_separator;
#line 143 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp8_, GTK_ORIENTATION_VERTICAL);
#line 144 "../src/new-game-screen.vala"
			_tmp9_ = self->priv->options_separator;
#line 144 "../src/new-game-screen.vala"
			gtk_widget_show ((GtkWidget*) _tmp9_);
#line 553 "new-game-screen.c"
		} else {
			GtkLabel* _tmp10_;
			GtkLabel* _tmp11_;
			GtkSeparator* _tmp12_;
			GtkBox* _tmp13_;
			GtkBox* _tmp14_;
			GtkBox* _tmp15_;
#line 148 "../src/new-game-screen.vala"
			_tmp10_ = self->priv->games_label;
#line 148 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 149 "../src/new-game-screen.vala"
			_tmp11_ = self->priv->options_label;
#line 149 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp11_);
#line 150 "../src/new-game-screen.vala"
			_tmp12_ = self->priv->options_separator;
#line 150 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp12_);
#line 151 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 152 "../src/new-game-screen.vala"
			_tmp13_ = self->priv->games_box;
#line 152 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp13_, GTK_ORIENTATION_HORIZONTAL);
#line 153 "../src/new-game-screen.vala"
			_tmp14_ = self->priv->options_box;
#line 153 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp14_, GTK_ORIENTATION_HORIZONTAL);
#line 154 "../src/new-game-screen.vala"
			_tmp15_ = self->priv->games_box;
#line 154 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 587 "new-game-screen.c"
		}
	} else {
#line 157 "../src/new-game-screen.vala"
		if (_phone_size) {
#line 592 "new-game-screen.c"
			GtkLabel* _tmp16_;
			GtkLabel* _tmp17_;
			GtkBox* _tmp18_;
			GtkBox* _tmp19_;
			GtkSeparator* _tmp20_;
			GtkSeparator* _tmp21_;
#line 159 "../src/new-game-screen.vala"
			_tmp16_ = self->priv->games_label;
#line 159 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp16_);
#line 160 "../src/new-game-screen.vala"
			_tmp17_ = self->priv->options_label;
#line 160 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp17_);
#line 161 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 162 "../src/new-game-screen.vala"
			_tmp18_ = self->priv->games_box;
#line 162 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp18_, GTK_ORIENTATION_VERTICAL);
#line 163 "../src/new-game-screen.vala"
			_tmp19_ = self->priv->options_box;
#line 163 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp19_, GTK_ORIENTATION_VERTICAL);
#line 164 "../src/new-game-screen.vala"
			_tmp20_ = self->priv->options_separator;
#line 164 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp20_, GTK_ORIENTATION_HORIZONTAL);
#line 165 "../src/new-game-screen.vala"
			_tmp21_ = self->priv->options_separator;
#line 165 "../src/new-game-screen.vala"
			gtk_widget_show ((GtkWidget*) _tmp21_);
#line 625 "new-game-screen.c"
		} else {
			GtkSeparator* _tmp22_;
			GtkBox* _tmp23_;
			GtkBox* _tmp24_;
			GtkLabel* _tmp25_;
			GtkLabel* _tmp26_;
#line 169 "../src/new-game-screen.vala"
			_tmp22_ = self->priv->options_separator;
#line 169 "../src/new-game-screen.vala"
			gtk_widget_hide ((GtkWidget*) _tmp22_);
#line 170 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 171 "../src/new-game-screen.vala"
			_tmp23_ = self->priv->games_box;
#line 171 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_VERTICAL);
#line 172 "../src/new-game-screen.vala"
			_tmp24_ = self->priv->options_box;
#line 172 "../src/new-game-screen.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp24_, GTK_ORIENTATION_VERTICAL);
#line 173 "../src/new-game-screen.vala"
			_tmp25_ = self->priv->games_label;
#line 173 "../src/new-game-screen.vala"
			gtk_widget_show ((GtkWidget*) _tmp25_);
#line 174 "../src/new-game-screen.vala"
			_tmp26_ = self->priv->options_label;
#line 174 "../src/new-game-screen.vala"
			gtk_widget_show ((GtkWidget*) _tmp26_);
#line 654 "new-game-screen.c"
		}
	}
#line 176 "../src/new-game-screen.vala"
	gtk_widget_queue_allocate ((GtkWidget*) self);
#line 659 "new-game-screen.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/new-game-screen.vala"
	return self ? g_object_ref (self) : NULL;
#line 667 "new-game-screen.c"
}

static GObject *
new_game_screen_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NewGameScreen * self;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GdkScreen* gdk_screen = NULL;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GdkScreen* _tmp4_;
#line 32 "../src/new-game-screen.vala"
	parent_class = G_OBJECT_CLASS (new_game_screen_parent_class);
#line 32 "../src/new-game-screen.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/new-game-screen.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_GAME_SCREEN, NewGameScreen);
#line 34 "../src/new-game-screen.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 34 "../src/new-game-screen.vala"
	css_provider = _tmp0_;
#line 35 "../src/new-game-screen.vala"
	_tmp1_ = css_provider;
#line 35 "../src/new-game-screen.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/org/gnome/Reversi/ui/new-game-screen.css");
#line 36 "../src/new-game-screen.vala"
	_tmp2_ = gdk_screen_get_default ();
#line 36 "../src/new-game-screen.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 36 "../src/new-game-screen.vala"
	gdk_screen = _tmp3_;
#line 37 "../src/new-game-screen.vala"
	_tmp4_ = gdk_screen;
#line 37 "../src/new-game-screen.vala"
	if (_tmp4_ != NULL) {
#line 709 "new-game-screen.c"
		GdkScreen* _tmp5_;
		GtkCssProvider* _tmp6_;
#line 38 "../src/new-game-screen.vala"
		_tmp5_ = gdk_screen;
#line 38 "../src/new-game-screen.vala"
		_tmp6_ = css_provider;
#line 38 "../src/new-game-screen.vala"
		gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp6_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 718 "new-game-screen.c"
	}
#line 40 "../src/new-game-screen.vala"
	new_game_screen_fix_race (self);
#line 32 "../src/new-game-screen.vala"
	_g_object_unref0 (gdk_screen);
#line 32 "../src/new-game-screen.vala"
	_g_object_unref0 (css_provider);
#line 32 "../src/new-game-screen.vala"
	return obj;
#line 728 "new-game-screen.c"
}

static void
new_game_screen_class_init (NewGameScreenClass * klass,
                            gpointer klass_data)
{
#line 24 "../src/new-game-screen.vala"
	new_game_screen_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/new-game-screen.vala"
	g_type_class_adjust_private_offset (klass, &NewGameScreen_private_offset);
#line 24 "../src/new-game-screen.vala"
	G_OBJECT_CLASS (klass)->constructor = new_game_screen_constructor;
#line 24 "../src/new-game-screen.vala"
	G_OBJECT_CLASS (klass)->finalize = new_game_screen_finalize;
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Reversi/ui/new-game-screen.ui");
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "modelbutton_one", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, modelbutton_one));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "modelbutton_two", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, modelbutton_two));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menubutton_one", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, menubutton_one));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menubutton_two", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, menubutton_two));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "games_box", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, games_box));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_box", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, options_box));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "games_label", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, games_label));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_label", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, options_label));
#line 24 "../src/new-game-screen.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "options_separator", FALSE, NewGameScreen_private_offset + G_STRUCT_OFFSET (NewGameScreenPrivate, options_separator));
#line 763 "new-game-screen.c"
}

static void
new_game_screen_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                                  gpointer iface_data)
{
#line 24 "../src/new-game-screen.vala"
	new_game_screen_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/new-game-screen.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) new_game_screen_real_set_window_size;
#line 774 "new-game-screen.c"
}

static void
new_game_screen_instance_init (NewGameScreen * self,
                               gpointer klass)
{
#line 24 "../src/new-game-screen.vala"
	self->priv = new_game_screen_get_instance_private (self);
#line 116 "../src/new-game-screen.vala"
	self->priv->phone_size = FALSE;
#line 117 "../src/new-game-screen.vala"
	self->priv->extra_thin = FALSE;
#line 118 "../src/new-game-screen.vala"
	self->priv->extra_flat = FALSE;
#line 24 "../src/new-game-screen.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 791 "new-game-screen.c"
}

static void
new_game_screen_finalize (GObject * obj)
{
	NewGameScreen * self;
#line 24 "../src/new-game-screen.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_GAME_SCREEN, NewGameScreen);
#line 24 "../src/new-game-screen.vala"
	G_OBJECT_CLASS (new_game_screen_parent_class)->finalize (obj);
#line 802 "new-game-screen.c"
}

static GType
new_game_screen_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NewGameScreenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_game_screen_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewGameScreen), 0, (GInstanceInitFunc) new_game_screen_instance_init, NULL };
	static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) new_game_screen_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType new_game_screen_type_id;
	new_game_screen_type_id = g_type_register_static (gtk_box_get_type (), "NewGameScreen", &g_define_type_info, 0);
	g_type_add_interface_static (new_game_screen_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
	NewGameScreen_private_offset = g_type_add_instance_private (new_game_screen_type_id, sizeof (NewGameScreenPrivate));
	return new_game_screen_type_id;
}

GType
new_game_screen_get_type (void)
{
	static volatile gsize new_game_screen_type_id__once = 0;
	if (g_once_init_enter (&new_game_screen_type_id__once)) {
		GType new_game_screen_type_id;
		new_game_screen_type_id = new_game_screen_get_type_once ();
		g_once_init_leave (&new_game_screen_type_id__once, new_game_screen_type_id);
	}
	return new_game_screen_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

