/* night-light-monitor.c generated by valac 0.56.3, the Vala compiler
 * generated from night-light-monitor.vala, do not modify */

/*
  This file is part of GNOME Reversi

  GNOME Reversi is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  GNOME Reversi is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/
/*
  This code has been inspired by the one for a similar function in Calendar
  https://gitlab.gnome.org/GNOME/gnome-calendar commit 474ce8b9da4a3322f2fe
  Copyright 2018 Georges Basile Stavracas Neto <georges.stavracas@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

#define NIGHT_LIGHT_MONITOR_warning_init_connection "Impossible to get connection for session bus, night-light mode disable" \
"d."
#define NIGHT_LIGHT_MONITOR_warning_init_dbus_proxy "Impossible to get dbus proxy for session bus, night-light mode disable" \
"d."
#define NIGHT_LIGHT_MONITOR_warning_cached_property "Impossible to get cached property from proxy, night-light mode disable" \
"d."
#define NIGHT_LIGHT_MONITOR_warning_check_your_logs "Something went wrong during the night mode support init, doing nothing" \
"."
#define NIGHT_LIGHT_MONITOR_warning_get_gtksettings "Something went wrong getting GtkSettings default object, doing nothing" \
"."
#define NIGHT_LIGHT_MONITOR_schema_name "org.gnome.Reversi.Lib"
#define NIGHT_LIGHT_MONITOR_automatic_night_mode_key "automatic-night-mode"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NIGHT_LIGHT_MONITOR (night_light_monitor_get_type ())
#define NIGHT_LIGHT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor))
#define NIGHT_LIGHT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitorClass))
#define IS_NIGHT_LIGHT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIGHT_LIGHT_MONITOR))
#define IS_NIGHT_LIGHT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIGHT_LIGHT_MONITOR))
#define NIGHT_LIGHT_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitorClass))

typedef struct _NightLightMonitor NightLightMonitor;
typedef struct _NightLightMonitorClass NightLightMonitorClass;
typedef struct _NightLightMonitorPrivate NightLightMonitorPrivate;
typedef enum  {
	NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN,
	NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT,
	NIGHT_LIGHT_MONITOR_NIGHT_TIME_DAY
} NightLightMonitorNightTime;

#define NIGHT_LIGHT_MONITOR_TYPE_NIGHT_TIME (night_light_monitor_night_time_get_type ())
enum  {
	NIGHT_LIGHT_MONITOR_0_PROPERTY,
	NIGHT_LIGHT_MONITOR_SCHEMA_PATH_PROPERTY,
	NIGHT_LIGHT_MONITOR_NIGHT_TIME_PROPERTY,
	NIGHT_LIGHT_MONITOR_DARK_THEME_PROPERTY,
	NIGHT_LIGHT_MONITOR_AUTOMATIC_NIGHT_MODE_PROPERTY,
	NIGHT_LIGHT_MONITOR_NUM_PROPERTIES
};
static GParamSpec* night_light_monitor_properties[NIGHT_LIGHT_MONITOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _NightLightMonitor {
	GObject parent_instance;
	NightLightMonitorPrivate * priv;
};

struct _NightLightMonitorClass {
	GObjectClass parent_class;
};

struct _NightLightMonitorPrivate {
	gchar* _schema_path;
	NightLightMonitorNightTime _night_time;
	gboolean _dark_theme;
	gboolean _automatic_night_mode;
	GSettings* settings;
	GDBusProxy* proxy;
	gboolean paused;
};

static gint NightLightMonitor_private_offset;
static gpointer night_light_monitor_parent_class = NULL;

VALA_EXTERN GType night_light_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NightLightMonitor, g_object_unref)
VALA_EXTERN GType night_light_monitor_night_time_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean night_light_monitor_night_time_should_use_dark_theme (NightLightMonitorNightTime state);
VALA_EXTERN NightLightMonitor* night_light_monitor_new (const gchar* _schema_path);
VALA_EXTERN NightLightMonitor* night_light_monitor_construct (GType object_type,
                                                  const gchar* _schema_path);
VALA_EXTERN NightLightMonitorNightTime night_light_monitor_get_night_time (NightLightMonitor* self);
static void night_light_monitor_connect_properties (NightLightMonitor* self);
VALA_EXTERN void night_light_monitor_set_use_night_mode (NightLightMonitor* self,
                                             gboolean night_mode_state);
static void night_light_monitor_update (NightLightMonitor* self);
static void night_light_monitor_init_connection (GDBusConnection** connection);
static void night_light_monitor_init_proxy (GDBusConnection* connection,
                                     GDBusProxy** proxy);
static NightLightMonitorNightTime night_light_monitor_get_updated_night_time (GDBusProxy** proxy,
                                                                       gboolean automatic_night_mode);
static void __lambda5_ (NightLightMonitor* self);
VALA_EXTERN gboolean night_light_monitor_get_automatic_night_mode (NightLightMonitor* self);
static void night_light_monitor_set_night_time (NightLightMonitor* self,
                                         NightLightMonitorNightTime value);
static void ___lambda5__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                    GVariant* changed_properties,
                                                    gchar** invalidated_properties,
                                                    gpointer self);
static void __lambda6_ (NightLightMonitor* self,
                 GSettings* _settings,
                 const gchar* _key_name);
static void night_light_monitor_set_automatic_night_mode (NightLightMonitor* self,
                                                   gboolean value);
static void ___lambda6__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void night_light_monitor_set_dark_theme_real (NightLightMonitor* self,
                                              gboolean night_mode);
static gboolean _night_light_monitor_set_dark_theme_real (gboolean night_mode);
static void night_light_monitor_set_dark_theme (NightLightMonitor* self,
                                         gboolean value);
static const gchar* night_light_monitor_get_schema_path (NightLightMonitor* self);
static void night_light_monitor_set_schema_path (NightLightMonitor* self,
                                          const gchar* value);
VALA_EXTERN gboolean night_light_monitor_get_dark_theme (NightLightMonitor* self);
static GObject * night_light_monitor_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void night_light_monitor_finalize (GObject * obj);
static GType night_light_monitor_get_type_once (void);
static void _vala_night_light_monitor_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_night_light_monitor_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
night_light_monitor_get_instance_private (NightLightMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, NightLightMonitor_private_offset);
}

gboolean
night_light_monitor_night_time_should_use_dark_theme (NightLightMonitorNightTime state)
{
	gboolean result;
#line 56 "../src/night-light-monitor.vala"
	result = state == NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT;
#line 56 "../src/night-light-monitor.vala"
	return result;
#line 176 "night-light-monitor.c"
}

static GType
night_light_monitor_night_time_get_type_once (void)
{
	static const GEnumValue values[] = {{NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN, "NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN", "unknown"}, {NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT, "NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT", "night"}, {NIGHT_LIGHT_MONITOR_NIGHT_TIME_DAY, "NIGHT_LIGHT_MONITOR_NIGHT_TIME_DAY", "day"}, {0, NULL, NULL}};
	GType night_light_monitor_night_time_type_id;
	night_light_monitor_night_time_type_id = g_enum_register_static ("NightLightMonitorNightTime", values);
	return night_light_monitor_night_time_type_id;
}

GType
night_light_monitor_night_time_get_type (void)
{
	static volatile gsize night_light_monitor_night_time_type_id__once = 0;
	if (g_once_init_enter (&night_light_monitor_night_time_type_id__once)) {
		GType night_light_monitor_night_time_type_id;
		night_light_monitor_night_time_type_id = night_light_monitor_night_time_get_type_once ();
		g_once_init_leave (&night_light_monitor_night_time_type_id__once, night_light_monitor_night_time_type_id);
	}
	return night_light_monitor_night_time_type_id__once;
}

NightLightMonitor*
night_light_monitor_construct (GType object_type,
                               const gchar* _schema_path)
{
	NightLightMonitor * self = NULL;
	NightLightMonitorNightTime _tmp0_;
#line 63 "../src/night-light-monitor.vala"
	g_return_val_if_fail (_schema_path != NULL, NULL);
#line 65 "../src/night-light-monitor.vala"
	self = (NightLightMonitor*) g_object_new (object_type, "schema-path", _schema_path, NULL);
#line 66 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_night_time;
#line 66 "../src/night-light-monitor.vala"
	if (_tmp0_ == NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN) {
#line 67 "../src/night-light-monitor.vala"
		return self;
#line 216 "night-light-monitor.c"
	}
#line 68 "../src/night-light-monitor.vala"
	night_light_monitor_connect_properties (self);
#line 63 "../src/night-light-monitor.vala"
	return self;
#line 222 "night-light-monitor.c"
}

NightLightMonitor*
night_light_monitor_new (const gchar* _schema_path)
{
#line 63 "../src/night-light-monitor.vala"
	return night_light_monitor_construct (TYPE_NIGHT_LIGHT_MONITOR, _schema_path);
#line 230 "night-light-monitor.c"
}

void
night_light_monitor_set_use_night_mode (NightLightMonitor* self,
                                        gboolean night_mode_state)
{
	NightLightMonitorNightTime _tmp0_;
#line 71 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_night_time;
#line 73 "../src/night-light-monitor.vala"
	if (_tmp0_ == NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN) {
#line 74 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:74: %s", NIGHT_LIGHT_MONITOR_warning_check_your_logs);
#line 246 "night-light-monitor.c"
	} else {
#line 77 "../src/night-light-monitor.vala"
		self->priv->paused = !night_mode_state;
#line 78 "../src/night-light-monitor.vala"
		night_light_monitor_update (self);
#line 252 "night-light-monitor.c"
	}
}

static void
night_light_monitor_init_connection (GDBusConnection** connection)
{
	GDBusConnection* _vala_connection = NULL;
	GError* _inner_error0_ = NULL;
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_;
		GDBusConnection* _tmp2_;
#line 113 "../src/night-light-monitor.vala"
		_tmp1_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
#line 113 "../src/night-light-monitor.vala"
		_tmp0_ = _tmp1_;
#line 113 "../src/night-light-monitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "night-light-monitor.c"
			goto __catch0_g_error;
		}
#line 113 "../src/night-light-monitor.vala"
		_tmp2_ = _tmp0_;
#line 113 "../src/night-light-monitor.vala"
		_tmp0_ = NULL;
#line 113 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_connection);
#line 113 "../src/night-light-monitor.vala"
		_vala_connection = _tmp2_;
#line 111 "../src/night-light-monitor.vala"
		_g_object_unref0 (_tmp0_);
#line 284 "night-light-monitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 111 "../src/night-light-monitor.vala"
		e = _inner_error0_;
#line 111 "../src/night-light-monitor.vala"
		_inner_error0_ = NULL;
#line 117 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:117: %s", NIGHT_LIGHT_MONITOR_warning_init_connection);
#line 118 "../src/night-light-monitor.vala"
		_tmp3_ = e;
#line 118 "../src/night-light-monitor.vala"
		_tmp4_ = _tmp3_->message;
#line 118 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:118: %s", _tmp4_);
#line 119 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_connection);
#line 119 "../src/night-light-monitor.vala"
		_vala_connection = NULL;
#line 111 "../src/night-light-monitor.vala"
		_g_error_free0 (e);
#line 310 "night-light-monitor.c"
	}
	__finally0:
#line 111 "../src/night-light-monitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_connection);
#line 111 "../src/night-light-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/night-light-monitor.vala"
		g_clear_error (&_inner_error0_);
#line 111 "../src/night-light-monitor.vala"
		return;
#line 323 "night-light-monitor.c"
	}
#line 109 "../src/night-light-monitor.vala"
	if (connection) {
#line 109 "../src/night-light-monitor.vala"
		*connection = _vala_connection;
#line 329 "night-light-monitor.c"
	} else {
#line 109 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_connection);
#line 333 "night-light-monitor.c"
	}
}

static void
night_light_monitor_init_proxy (GDBusConnection* connection,
                                GDBusProxy** proxy)
{
	GDBusProxy* _vala_proxy = NULL;
	GError* _inner_error0_ = NULL;
#line 123 "../src/night-light-monitor.vala"
	g_return_if_fail (connection != NULL);
#line 345 "night-light-monitor.c"
	{
		GDBusProxy* _tmp0_ = NULL;
		GDBusProxy* _tmp1_;
		GDBusProxy* _tmp2_;
#line 127 "../src/night-light-monitor.vala"
		_tmp1_ = g_dbus_proxy_new_sync (connection, G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, NULL, "org.gnome.SettingsDaemon.Color", "/org/gnome/SettingsDaemon/Color", "org.gnome.SettingsDaemon.Color", NULL, &_inner_error0_);
#line 127 "../src/night-light-monitor.vala"
		_tmp0_ = _tmp1_;
#line 127 "../src/night-light-monitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "night-light-monitor.c"
			goto __catch0_g_error;
		}
#line 127 "../src/night-light-monitor.vala"
		_tmp2_ = _tmp0_;
#line 127 "../src/night-light-monitor.vala"
		_tmp0_ = NULL;
#line 127 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_proxy);
#line 127 "../src/night-light-monitor.vala"
		_vala_proxy = _tmp2_;
#line 125 "../src/night-light-monitor.vala"
		_g_object_unref0 (_tmp0_);
#line 369 "night-light-monitor.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 125 "../src/night-light-monitor.vala"
		e = _inner_error0_;
#line 125 "../src/night-light-monitor.vala"
		_inner_error0_ = NULL;
#line 137 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:137: %s", NIGHT_LIGHT_MONITOR_warning_init_dbus_proxy);
#line 138 "../src/night-light-monitor.vala"
		_tmp3_ = e;
#line 138 "../src/night-light-monitor.vala"
		_tmp4_ = _tmp3_->message;
#line 138 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:138: %s", _tmp4_);
#line 139 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_proxy);
#line 139 "../src/night-light-monitor.vala"
		_vala_proxy = NULL;
#line 125 "../src/night-light-monitor.vala"
		_g_error_free0 (e);
#line 395 "night-light-monitor.c"
	}
	__finally0:
#line 125 "../src/night-light-monitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_proxy);
#line 125 "../src/night-light-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/night-light-monitor.vala"
		g_clear_error (&_inner_error0_);
#line 125 "../src/night-light-monitor.vala"
		return;
#line 408 "night-light-monitor.c"
	}
#line 123 "../src/night-light-monitor.vala"
	if (proxy) {
#line 123 "../src/night-light-monitor.vala"
		*proxy = _vala_proxy;
#line 414 "night-light-monitor.c"
	} else {
#line 123 "../src/night-light-monitor.vala"
		_g_object_unref0 (_vala_proxy);
#line 418 "night-light-monitor.c"
	}
}

static NightLightMonitorNightTime
night_light_monitor_get_updated_night_time (GDBusProxy** proxy,
                                            gboolean automatic_night_mode)
{
	GVariant* variant_active = NULL;
	GVariant* _tmp0_;
	GVariant* variant_paused = NULL;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gboolean night_time_is_night = FALSE;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	NightLightMonitorNightTime result;
#line 143 "../src/night-light-monitor.vala"
	g_return_val_if_fail (*proxy != NULL, 0);
#line 145 "../src/night-light-monitor.vala"
	_tmp0_ = g_dbus_proxy_get_cached_property (*proxy, "NightLightActive");
#line 145 "../src/night-light-monitor.vala"
	variant_active = _tmp0_;
#line 146 "../src/night-light-monitor.vala"
	_tmp1_ = g_dbus_proxy_get_cached_property (*proxy, "DisabledUntilTomorrow");
#line 146 "../src/night-light-monitor.vala"
	variant_paused = _tmp1_;
#line 147 "../src/night-light-monitor.vala"
	_tmp2_ = variant_active;
#line 147 "../src/night-light-monitor.vala"
	if (_tmp2_ == NULL) {
#line 149 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:149: %s", NIGHT_LIGHT_MONITOR_warning_cached_property);
#line 150 "../src/night-light-monitor.vala"
		result = NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN;
#line 150 "../src/night-light-monitor.vala"
		_g_variant_unref0 (variant_paused);
#line 150 "../src/night-light-monitor.vala"
		_g_variant_unref0 (variant_active);
#line 150 "../src/night-light-monitor.vala"
		return result;
#line 459 "night-light-monitor.c"
	}
#line 153 "../src/night-light-monitor.vala"
	_tmp3_ = variant_active;
#line 153 "../src/night-light-monitor.vala"
	night_time_is_night = g_variant_get_boolean ((GVariant*) _tmp3_);
#line 154 "../src/night-light-monitor.vala"
	_tmp4_ = variant_paused;
#line 154 "../src/night-light-monitor.vala"
	if (_tmp4_ != NULL) {
#line 469 "night-light-monitor.c"
		gboolean _tmp5_ = FALSE;
#line 155 "../src/night-light-monitor.vala"
		if (night_time_is_night) {
#line 473 "night-light-monitor.c"
			gboolean _tmp6_ = FALSE;
			GVariant* _tmp7_;
#line 155 "../src/night-light-monitor.vala"
			_tmp7_ = variant_paused;
#line 155 "../src/night-light-monitor.vala"
			if (g_variant_get_boolean ((GVariant*) _tmp7_)) {
#line 155 "../src/night-light-monitor.vala"
				_tmp6_ = automatic_night_mode;
#line 482 "night-light-monitor.c"
			} else {
#line 155 "../src/night-light-monitor.vala"
				_tmp6_ = FALSE;
#line 486 "night-light-monitor.c"
			}
#line 155 "../src/night-light-monitor.vala"
			_tmp5_ = !_tmp6_;
#line 490 "night-light-monitor.c"
		} else {
#line 155 "../src/night-light-monitor.vala"
			_tmp5_ = FALSE;
#line 494 "night-light-monitor.c"
		}
#line 155 "../src/night-light-monitor.vala"
		night_time_is_night = _tmp5_;
#line 498 "night-light-monitor.c"
	}
#line 157 "../src/night-light-monitor.vala"
	if (night_time_is_night) {
#line 158 "../src/night-light-monitor.vala"
		result = NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT;
#line 158 "../src/night-light-monitor.vala"
		_g_variant_unref0 (variant_paused);
#line 158 "../src/night-light-monitor.vala"
		_g_variant_unref0 (variant_active);
#line 158 "../src/night-light-monitor.vala"
		return result;
#line 510 "night-light-monitor.c"
	} else {
#line 160 "../src/night-light-monitor.vala"
		result = NIGHT_LIGHT_MONITOR_NIGHT_TIME_DAY;
#line 160 "../src/night-light-monitor.vala"
		_g_variant_unref0 (variant_paused);
#line 160 "../src/night-light-monitor.vala"
		_g_variant_unref0 (variant_active);
#line 160 "../src/night-light-monitor.vala"
		return result;
#line 520 "night-light-monitor.c"
	}
}

static void
__lambda5_ (NightLightMonitor* self)
{
	gboolean _tmp0_;
	NightLightMonitorNightTime _tmp1_;
	NightLightMonitorNightTime _tmp2_;
#line 172 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_automatic_night_mode;
#line 172 "../src/night-light-monitor.vala"
	_tmp1_ = night_light_monitor_get_updated_night_time (&self->priv->proxy, _tmp0_);
#line 172 "../src/night-light-monitor.vala"
	night_light_monitor_set_night_time (self, _tmp1_);
#line 173 "../src/night-light-monitor.vala"
	_tmp2_ = self->priv->_night_time;
#line 173 "../src/night-light-monitor.vala"
	if (_tmp2_ != NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT) {
#line 540 "night-light-monitor.c"
		gboolean _tmp3_;
#line 174 "../src/night-light-monitor.vala"
		_tmp3_ = self->priv->_automatic_night_mode;
#line 174 "../src/night-light-monitor.vala"
		self->priv->paused = !_tmp3_;
#line 546 "night-light-monitor.c"
	}
#line 175 "../src/night-light-monitor.vala"
	night_light_monitor_update (self);
#line 550 "night-light-monitor.c"
}

static void
___lambda5__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                               GVariant* changed_properties,
                                               gchar** invalidated_properties,
                                               gpointer self)
{
#line 171 "../src/night-light-monitor.vala"
	__lambda5_ ((NightLightMonitor*) self);
#line 561 "night-light-monitor.c"
}

static void
__lambda6_ (NightLightMonitor* self,
            GSettings* _settings,
            const gchar* _key_name)
{
	gboolean _tmp0_;
#line 177 "../src/night-light-monitor.vala"
	g_return_if_fail (_settings != NULL);
#line 177 "../src/night-light-monitor.vala"
	g_return_if_fail (_key_name != NULL);
#line 178 "../src/night-light-monitor.vala"
	night_light_monitor_set_automatic_night_mode (self, g_settings_get_boolean (_settings, _key_name));
#line 179 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_automatic_night_mode;
#line 179 "../src/night-light-monitor.vala"
	self->priv->paused = !_tmp0_;
#line 180 "../src/night-light-monitor.vala"
	night_light_monitor_update (self);
#line 582 "night-light-monitor.c"
}

static void
___lambda6__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
#line 177 "../src/night-light-monitor.vala"
	__lambda6_ ((NightLightMonitor*) self, _sender, key);
#line 592 "night-light-monitor.c"
}

static void
night_light_monitor_connect_properties (NightLightMonitor* self)
{
	GDBusProxy* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
#line 169 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->proxy;
#line 171 "../src/night-light-monitor.vala"
	g_signal_connect_object (_tmp0_, "g-properties-changed", (GCallback) ___lambda5__g_dbus_proxy_g_properties_changed, self, 0);
#line 177 "../src/night-light-monitor.vala"
	_tmp1_ = self->priv->settings;
#line 177 "../src/night-light-monitor.vala"
	_tmp2_ = g_strconcat ("changed::", NIGHT_LIGHT_MONITOR_automatic_night_mode_key, NULL);
#line 177 "../src/night-light-monitor.vala"
	g_signal_connect_object (_tmp1_, _tmp2_, (GCallback) ___lambda6__g_settings_changed, self, 0);
#line 177 "../src/night-light-monitor.vala"
	_g_free0 (_tmp2_);
#line 182 "../src/night-light-monitor.vala"
	night_light_monitor_update (self);
#line 617 "night-light-monitor.c"
}

static void
night_light_monitor_update (NightLightMonitor* self)
{
	gboolean _tmp0_;
#line 185 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_automatic_night_mode;
#line 187 "../src/night-light-monitor.vala"
	if (_tmp0_) {
#line 189 "../src/night-light-monitor.vala"
		if (self->priv->paused) {
#line 190 "../src/night-light-monitor.vala"
			night_light_monitor_set_dark_theme_real (self, FALSE);
#line 634 "night-light-monitor.c"
		} else {
			NightLightMonitorNightTime _tmp1_;
#line 192 "../src/night-light-monitor.vala"
			_tmp1_ = self->priv->_night_time;
#line 192 "../src/night-light-monitor.vala"
			night_light_monitor_set_dark_theme_real (self, night_light_monitor_night_time_should_use_dark_theme (_tmp1_));
#line 641 "night-light-monitor.c"
		}
	} else {
		NightLightMonitorNightTime _tmp2_;
#line 194 "../src/night-light-monitor.vala"
		_tmp2_ = self->priv->_night_time;
#line 194 "../src/night-light-monitor.vala"
		if (_tmp2_ == NIGHT_LIGHT_MONITOR_NIGHT_TIME_NIGHT) {
#line 196 "../src/night-light-monitor.vala"
			if (self->priv->paused) {
#line 197 "../src/night-light-monitor.vala"
				night_light_monitor_set_dark_theme_real (self, FALSE);
#line 653 "night-light-monitor.c"
			} else {
#line 199 "../src/night-light-monitor.vala"
				night_light_monitor_set_dark_theme_real (self, TRUE);
#line 657 "night-light-monitor.c"
			}
		} else {
#line 202 "../src/night-light-monitor.vala"
			night_light_monitor_set_dark_theme_real (self, FALSE);
#line 662 "night-light-monitor.c"
		}
	}
}

static void
night_light_monitor_set_dark_theme_real (NightLightMonitor* self,
                                         gboolean night_mode)
{
#line 204 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/night-light-monitor.vala"
	if (_night_light_monitor_set_dark_theme_real (night_mode)) {
#line 207 "../src/night-light-monitor.vala"
		night_light_monitor_set_dark_theme (self, night_mode);
#line 677 "night-light-monitor.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 211 "../src/night-light-monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 686 "night-light-monitor.c"
}

static gboolean
_night_light_monitor_set_dark_theme_real (gboolean night_mode)
{
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GtkSettings* _tmp2_;
	GtkSettings* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 211 "../src/night-light-monitor.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 211 "../src/night-light-monitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 211 "../src/night-light-monitor.vala"
	gtk_settings = _tmp1_;
#line 212 "../src/night-light-monitor.vala"
	_tmp2_ = gtk_settings;
#line 212 "../src/night-light-monitor.vala"
	if (_tmp2_ == NULL) {
#line 214 "../src/night-light-monitor.vala"
		g_warning ("night-light-monitor.vala:214: %s", NIGHT_LIGHT_MONITOR_warning_get_gtksettings);
#line 215 "../src/night-light-monitor.vala"
		result = FALSE;
#line 215 "../src/night-light-monitor.vala"
		_g_object_unref0 (gtk_settings);
#line 215 "../src/night-light-monitor.vala"
		return result;
#line 718 "night-light-monitor.c"
	}
#line 218 "../src/night-light-monitor.vala"
	_tmp3_ = gtk_settings;
#line 218 "../src/night-light-monitor.vala"
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp4_, NULL);
#line 218 "../src/night-light-monitor.vala"
	_tmp5_ = _tmp4_;
#line 218 "../src/night-light-monitor.vala"
	if (night_mode != _tmp5_) {
#line 728 "night-light-monitor.c"
		GtkSettings* _tmp6_;
#line 219 "../src/night-light-monitor.vala"
		_tmp6_ = gtk_settings;
#line 219 "../src/night-light-monitor.vala"
		g_object_set ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", night_mode, NULL);
#line 734 "night-light-monitor.c"
	}
#line 220 "../src/night-light-monitor.vala"
	result = TRUE;
#line 220 "../src/night-light-monitor.vala"
	_g_object_unref0 (gtk_settings);
#line 220 "../src/night-light-monitor.vala"
	return result;
#line 742 "night-light-monitor.c"
}

static const gchar*
night_light_monitor_get_schema_path (NightLightMonitor* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "../src/night-light-monitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_schema_path;
#line 47 "../src/night-light-monitor.vala"
	result = _tmp0_;
#line 47 "../src/night-light-monitor.vala"
	return result;
#line 758 "night-light-monitor.c"
}

static void
night_light_monitor_set_schema_path (NightLightMonitor* self,
                                     const gchar* value)
{
	gchar* _tmp0_;
#line 47 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/night-light-monitor.vala"
	_tmp0_ = g_strdup (value);
#line 47 "../src/night-light-monitor.vala"
	_g_free0 (self->priv->_schema_path);
#line 47 "../src/night-light-monitor.vala"
	self->priv->_schema_path = _tmp0_;
#line 774 "night-light-monitor.c"
}

NightLightMonitorNightTime
night_light_monitor_get_night_time (NightLightMonitor* self)
{
	NightLightMonitorNightTime result;
#line 59 "../src/night-light-monitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../src/night-light-monitor.vala"
	result = self->priv->_night_time;
#line 59 "../src/night-light-monitor.vala"
	return result;
#line 787 "night-light-monitor.c"
}

static void
night_light_monitor_set_night_time (NightLightMonitor* self,
                                    NightLightMonitorNightTime value)
{
	NightLightMonitorNightTime old_value;
#line 59 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/night-light-monitor.vala"
	old_value = night_light_monitor_get_night_time (self);
#line 59 "../src/night-light-monitor.vala"
	if (old_value != value) {
#line 59 "../src/night-light-monitor.vala"
		self->priv->_night_time = value;
#line 59 "../src/night-light-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_NIGHT_TIME_PROPERTY]);
#line 805 "night-light-monitor.c"
	}
}

gboolean
night_light_monitor_get_dark_theme (NightLightMonitor* self)
{
	gboolean result;
#line 60 "../src/night-light-monitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/night-light-monitor.vala"
	result = self->priv->_dark_theme;
#line 60 "../src/night-light-monitor.vala"
	return result;
#line 819 "night-light-monitor.c"
}

static void
night_light_monitor_set_dark_theme (NightLightMonitor* self,
                                    gboolean value)
{
	gboolean old_value;
#line 60 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/night-light-monitor.vala"
	old_value = night_light_monitor_get_dark_theme (self);
#line 60 "../src/night-light-monitor.vala"
	if (old_value != value) {
#line 60 "../src/night-light-monitor.vala"
		self->priv->_dark_theme = value;
#line 60 "../src/night-light-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_DARK_THEME_PROPERTY]);
#line 837 "night-light-monitor.c"
	}
}

gboolean
night_light_monitor_get_automatic_night_mode (NightLightMonitor* self)
{
	gboolean result;
#line 61 "../src/night-light-monitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/night-light-monitor.vala"
	result = self->priv->_automatic_night_mode;
#line 61 "../src/night-light-monitor.vala"
	return result;
#line 851 "night-light-monitor.c"
}

static void
night_light_monitor_set_automatic_night_mode (NightLightMonitor* self,
                                              gboolean value)
{
	gboolean old_value;
#line 61 "../src/night-light-monitor.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/night-light-monitor.vala"
	old_value = night_light_monitor_get_automatic_night_mode (self);
#line 61 "../src/night-light-monitor.vala"
	if (old_value != value) {
#line 61 "../src/night-light-monitor.vala"
		self->priv->_automatic_night_mode = value;
#line 61 "../src/night-light-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_AUTOMATIC_NIGHT_MODE_PROPERTY]);
#line 869 "night-light-monitor.c"
	}
}

static GObject *
night_light_monitor_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NightLightMonitor * self;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gboolean _tmp3_;
	GDBusConnection* connection = NULL;
	GDBusConnection* _tmp4_ = NULL;
	GDBusConnection* _tmp5_;
	GDBusProxy* nullable_proxy = NULL;
	GDBusConnection* _tmp6_;
	GDBusProxy* _tmp7_ = NULL;
	GDBusProxy* _tmp8_;
	GDBusProxy* _tmp9_;
	GDBusProxy* _tmp10_;
	gboolean _tmp11_;
	NightLightMonitorNightTime _tmp12_;
#line 89 "../src/night-light-monitor.vala"
	parent_class = G_OBJECT_CLASS (night_light_monitor_parent_class);
#line 89 "../src/night-light-monitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 89 "../src/night-light-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor);
#line 91 "../src/night-light-monitor.vala"
	_tmp0_ = self->priv->_schema_path;
#line 91 "../src/night-light-monitor.vala"
	_tmp1_ = g_settings_new_with_path (NIGHT_LIGHT_MONITOR_schema_name, _tmp0_);
#line 91 "../src/night-light-monitor.vala"
	_g_object_unref0 (self->priv->settings);
#line 91 "../src/night-light-monitor.vala"
	self->priv->settings = _tmp1_;
#line 92 "../src/night-light-monitor.vala"
	_tmp2_ = self->priv->settings;
#line 92 "../src/night-light-monitor.vala"
	night_light_monitor_set_automatic_night_mode (self, g_settings_get_boolean (_tmp2_, NIGHT_LIGHT_MONITOR_automatic_night_mode_key));
#line 93 "../src/night-light-monitor.vala"
	_tmp3_ = self->priv->_automatic_night_mode;
#line 93 "../src/night-light-monitor.vala"
	self->priv->paused = !_tmp3_;
#line 96 "../src/night-light-monitor.vala"
	night_light_monitor_init_connection (&_tmp4_);
#line 96 "../src/night-light-monitor.vala"
	_g_object_unref0 (connection);
#line 96 "../src/night-light-monitor.vala"
	connection = _tmp4_;
#line 97 "../src/night-light-monitor.vala"
	_tmp5_ = connection;
#line 97 "../src/night-light-monitor.vala"
	if (_tmp5_ == NULL) {
#line 98 "../src/night-light-monitor.vala"
		_g_object_unref0 (connection);
#line 98 "../src/night-light-monitor.vala"
		return obj;
#line 932 "night-light-monitor.c"
	}
#line 101 "../src/night-light-monitor.vala"
	_tmp6_ = connection;
#line 101 "../src/night-light-monitor.vala"
	night_light_monitor_init_proxy (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_dbus_connection_get_type (), GDBusConnection), &_tmp7_);
#line 101 "../src/night-light-monitor.vala"
	_g_object_unref0 (nullable_proxy);
#line 101 "../src/night-light-monitor.vala"
	nullable_proxy = _tmp7_;
#line 102 "../src/night-light-monitor.vala"
	_tmp8_ = nullable_proxy;
#line 102 "../src/night-light-monitor.vala"
	if (_tmp8_ == NULL) {
#line 103 "../src/night-light-monitor.vala"
		_g_object_unref0 (nullable_proxy);
#line 103 "../src/night-light-monitor.vala"
		_g_object_unref0 (connection);
#line 103 "../src/night-light-monitor.vala"
		return obj;
#line 952 "night-light-monitor.c"
	}
#line 105 "../src/night-light-monitor.vala"
	_tmp9_ = nullable_proxy;
#line 105 "../src/night-light-monitor.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_dbus_proxy_get_type (), GDBusProxy));
#line 105 "../src/night-light-monitor.vala"
	_g_object_unref0 (self->priv->proxy);
#line 105 "../src/night-light-monitor.vala"
	self->priv->proxy = _tmp10_;
#line 106 "../src/night-light-monitor.vala"
	_tmp11_ = self->priv->_automatic_night_mode;
#line 106 "../src/night-light-monitor.vala"
	_tmp12_ = night_light_monitor_get_updated_night_time (&self->priv->proxy, _tmp11_);
#line 106 "../src/night-light-monitor.vala"
	night_light_monitor_set_night_time (self, _tmp12_);
#line 89 "../src/night-light-monitor.vala"
	_g_object_unref0 (nullable_proxy);
#line 89 "../src/night-light-monitor.vala"
	_g_object_unref0 (connection);
#line 89 "../src/night-light-monitor.vala"
	return obj;
#line 974 "night-light-monitor.c"
}

static void
night_light_monitor_class_init (NightLightMonitorClass * klass,
                                gpointer klass_data)
{
#line 23 "../src/night-light-monitor.vala"
	night_light_monitor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/night-light-monitor.vala"
	g_type_class_adjust_private_offset (klass, &NightLightMonitor_private_offset);
#line 23 "../src/night-light-monitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_night_light_monitor_get_property;
#line 23 "../src/night-light-monitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_night_light_monitor_set_property;
#line 23 "../src/night-light-monitor.vala"
	G_OBJECT_CLASS (klass)->constructor = night_light_monitor_constructor;
#line 23 "../src/night-light-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = night_light_monitor_finalize;
#line 23 "../src/night-light-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIGHT_LIGHT_MONITOR_SCHEMA_PATH_PROPERTY, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_SCHEMA_PATH_PROPERTY] = g_param_spec_string ("schema-path", "schema-path", "schema-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/night-light-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIGHT_LIGHT_MONITOR_NIGHT_TIME_PROPERTY, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_NIGHT_TIME_PROPERTY] = g_param_spec_enum ("night-time", "night-time", "night-time", NIGHT_LIGHT_MONITOR_TYPE_NIGHT_TIME, NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/night-light-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIGHT_LIGHT_MONITOR_DARK_THEME_PROPERTY, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_DARK_THEME_PROPERTY] = g_param_spec_boolean ("dark-theme", "dark-theme", "dark-theme", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/night-light-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIGHT_LIGHT_MONITOR_AUTOMATIC_NIGHT_MODE_PROPERTY, night_light_monitor_properties[NIGHT_LIGHT_MONITOR_AUTOMATIC_NIGHT_MODE_PROPERTY] = g_param_spec_boolean ("automatic-night-mode", "automatic-night-mode", "automatic-night-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1001 "night-light-monitor.c"
}

static void
night_light_monitor_instance_init (NightLightMonitor * self,
                                   gpointer klass)
{
#line 23 "../src/night-light-monitor.vala"
	self->priv = night_light_monitor_get_instance_private (self);
#line 59 "../src/night-light-monitor.vala"
	self->priv->_night_time = NIGHT_LIGHT_MONITOR_NIGHT_TIME_UNKNOWN;
#line 60 "../src/night-light-monitor.vala"
	self->priv->_dark_theme = FALSE;
#line 61 "../src/night-light-monitor.vala"
	self->priv->_automatic_night_mode = FALSE;
#line 167 "../src/night-light-monitor.vala"
	self->priv->paused = FALSE;
#line 1018 "night-light-monitor.c"
}

static void
night_light_monitor_finalize (GObject * obj)
{
	NightLightMonitor * self;
#line 23 "../src/night-light-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor);
#line 47 "../src/night-light-monitor.vala"
	_g_free0 (self->priv->_schema_path);
#line 86 "../src/night-light-monitor.vala"
	_g_object_unref0 (self->priv->settings);
#line 87 "../src/night-light-monitor.vala"
	_g_object_unref0 (self->priv->proxy);
#line 23 "../src/night-light-monitor.vala"
	G_OBJECT_CLASS (night_light_monitor_parent_class)->finalize (obj);
#line 1035 "night-light-monitor.c"
}

static GType
night_light_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NightLightMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) night_light_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NightLightMonitor), 0, (GInstanceInitFunc) night_light_monitor_instance_init, NULL };
	GType night_light_monitor_type_id;
	night_light_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "NightLightMonitor", &g_define_type_info, 0);
	NightLightMonitor_private_offset = g_type_add_instance_private (night_light_monitor_type_id, sizeof (NightLightMonitorPrivate));
	return night_light_monitor_type_id;
}

GType
night_light_monitor_get_type (void)
{
	static volatile gsize night_light_monitor_type_id__once = 0;
	if (g_once_init_enter (&night_light_monitor_type_id__once)) {
		GType night_light_monitor_type_id;
		night_light_monitor_type_id = night_light_monitor_get_type_once ();
		g_once_init_leave (&night_light_monitor_type_id__once, night_light_monitor_type_id);
	}
	return night_light_monitor_type_id__once;
}

static void
_vala_night_light_monitor_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	NightLightMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor);
#line 23 "../src/night-light-monitor.vala"
	switch (property_id) {
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_SCHEMA_PATH_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		g_value_set_string (value, night_light_monitor_get_schema_path (self));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_NIGHT_TIME_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		g_value_set_enum (value, night_light_monitor_get_night_time (self));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_DARK_THEME_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		g_value_set_boolean (value, night_light_monitor_get_dark_theme (self));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_AUTOMATIC_NIGHT_MODE_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		g_value_set_boolean (value, night_light_monitor_get_automatic_night_mode (self));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 1094 "night-light-monitor.c"
		default:
#line 23 "../src/night-light-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/night-light-monitor.vala"
		break;
#line 1100 "night-light-monitor.c"
	}
}

static void
_vala_night_light_monitor_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	NightLightMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIGHT_LIGHT_MONITOR, NightLightMonitor);
#line 23 "../src/night-light-monitor.vala"
	switch (property_id) {
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_SCHEMA_PATH_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		night_light_monitor_set_schema_path (self, g_value_get_string (value));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_NIGHT_TIME_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		night_light_monitor_set_night_time (self, g_value_get_enum (value));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_DARK_THEME_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		night_light_monitor_set_dark_theme (self, g_value_get_boolean (value));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 23 "../src/night-light-monitor.vala"
		case NIGHT_LIGHT_MONITOR_AUTOMATIC_NIGHT_MODE_PROPERTY:
#line 23 "../src/night-light-monitor.vala"
		night_light_monitor_set_automatic_night_mode (self, g_value_get_boolean (value));
#line 23 "../src/night-light-monitor.vala"
		break;
#line 1138 "night-light-monitor.c"
		default:
#line 23 "../src/night-light-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/night-light-monitor.vala"
		break;
#line 1144 "night-light-monitor.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

