/* reversi-view.c generated by valac 0.56.3, the Vala compiler
 * generated from reversi-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>

#define REVERSI_VIEW_HIGHLIGHT_MAX ((guint8) 5)
#define REVERSI_VIEW_PIXMAP_FLIP_DELAY 20
#define REVERSI_VIEW_HUMANS_OPENING_INTENSITY_MAX ((guint8) 15)
#define REVERSI_VIEW_OVERTURE_STEPS_MAX ((guint8) 10)
#define REVERSI_VIEW_HALF_PI G_PI_2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_REVERSI_VIEW (reversi_view_get_type ())
#define REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REVERSI_VIEW, ReversiView))
#define REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REVERSI_VIEW, ReversiViewClass))
#define IS_REVERSI_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REVERSI_VIEW))
#define IS_REVERSI_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REVERSI_VIEW))
#define REVERSI_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REVERSI_VIEW, ReversiViewClass))

typedef struct _ReversiView ReversiView;
typedef struct _ReversiViewClass ReversiViewClass;
typedef struct _ReversiViewPrivate ReversiViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_IAGNO (iagno_get_type ())
#define IAGNO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IAGNO, Iagno))
#define IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IAGNO, IagnoClass))
#define IS_IAGNO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IAGNO))
#define IS_IAGNO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IAGNO))
#define IAGNO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IAGNO, IagnoClass))

typedef struct _Iagno Iagno;
typedef struct _IagnoClass IagnoClass;

#define TYPE_THEME_MANAGER (theme_manager_get_type ())
#define THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_MANAGER, ThemeManager))
#define THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_MANAGER, ThemeManagerClass))
#define IS_THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_MANAGER))
#define IS_THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_MANAGER))
#define THEME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_MANAGER, ThemeManagerClass))

typedef struct _ThemeManager ThemeManager;
typedef struct _ThemeManagerClass ThemeManagerClass;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	REVERSI_VIEW_0_PROPERTY,
	REVERSI_VIEW_SHOW_PLAYABLE_TILES_PROPERTY,
	REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY,
	REVERSI_VIEW_GAME_PROPERTY,
	REVERSI_VIEW_IAGNO_INSTANCE_PROPERTY,
	REVERSI_VIEW_THEME_MANAGER_PROPERTY,
	REVERSI_VIEW_NUM_PROPERTIES
};
static GParamSpec* reversi_view_properties[REVERSI_VIEW_NUM_PROPERTIES];
typedef enum  {
	REVERSI_VIEW_DIRECTION_TOP,
	REVERSI_VIEW_DIRECTION_LEFT,
	REVERSI_VIEW_DIRECTION_RIGHT,
	REVERSI_VIEW_DIRECTION_BOTTOM
} ReversiViewDirection;

#define REVERSI_VIEW_TYPE_DIRECTION (reversi_view_direction_get_type ())
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	OPENING_HUMANS,
	OPENING_REVERSI,
	OPENING_INVERTED,
	OPENING_ALTER_TOP,
	OPENING_ALTER_LEFT,
	OPENING_ALTER_RIGHT,
	OPENING_ALTER_BOTTOM
} Opening;

#define TYPE_OPENING (opening_get_type ())

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	REVERSI_VIEW_MOVE_SIGNAL,
	REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL,
	REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL,
	REVERSI_VIEW_NUM_SIGNALS
};
static guint reversi_view_signals[REVERSI_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ReversiView {
	GtkDrawingArea parent_instance;
	ReversiViewPrivate * priv;
};

struct _ReversiViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _ReversiViewPrivate {
	gboolean _show_playable_tiles;
	gboolean _show_turnable_tiles;
	gint board_x;
	gint board_y;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 old_highlight_x;
	guint8 old_highlight_y;
	guint8 highlight_state;
	gboolean show_mouse_highlight;
	gboolean mouse_position_set;
	guint8 mouse_highlight_x;
	guint8 mouse_highlight_y;
	guint8 mouse_position_x;
	guint8 mouse_position_y;
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	cairo_pattern_t* board_pattern;
	gboolean noise_pixbuf_loaded;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	guint8 humans_opening_intensity;
	gboolean game_is_set;
	guint8 game_size;
	Game* _game;
	Iagno* _iagno_instance;
	ThemeManager* _theme_manager;
	gboolean configuration_done;
	gint paving_size;
	gint tile_size;
	gint board_size;
	gint* tile_xs;
	gint tile_xs_length1;
	gint tile_xs_length2;
	gint* tile_ys;
	gint tile_ys_length1;
	gint tile_ys_length2;
	gint* overture_origin_xs;
	gint overture_origin_xs_length1;
	gint _overture_origin_xs_size_;
	gint overture_origin_y;
	guint8* overture_steps;
	gint overture_steps_length1;
	gint _overture_steps_size_;
	guint8* overture_target;
	gint overture_target_length1;
	gint _overture_target_size_;
	guint8 current_overture_playable;
	gboolean last_state_set;
	GameStateObject* last_state;
	gboolean flip_final_result_now;
	Player winning_color;
	gint n_winning_tiles;
	Player losing_color;
	gint n_losing_tiles;
	GtkEventControllerMotion* motion_controller;
	GtkGestureMultiPress* click_controller;
	gboolean mouse_is_in;
	guint timeout_id;
	GtkEventControllerKey* key_controller;
	guint8 playable_tiles_highlight_state;
	gboolean* possible_moves;
	gint possible_moves_length1;
	gint possible_moves_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _Block7Data {
	int _ref_count_;
	ReversiView* self;
	gboolean is_final_animation;
};

struct _Block8Data {
	int _ref_count_;
	ReversiView* self;
	guint8 x;
	guint8 y;
};

static gint ReversiView_private_offset;
static gpointer reversi_view_parent_class = NULL;

VALA_EXTERN GType reversi_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ReversiView, g_object_unref)
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN GType iagno_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Iagno, g_object_unref)
VALA_EXTERN GType theme_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeManager, g_object_unref)
VALA_EXTERN GType game_state_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
static GType reversi_view_direction_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN ReversiView* reversi_view_new (Iagno* iagno_instance,
                               ThemeManager* theme_manager);
VALA_EXTERN ReversiView* reversi_view_construct (GType object_type,
                                     Iagno* iagno_instance,
                                     ThemeManager* theme_manager);
static gboolean reversi_view_real_configure_event (GtkWidget* base,
                                            GdkEventConfigure* e);
static void reversi_view_configure_theme (ReversiView* self);
static ThemeManager* reversi_view_get_theme_manager (ReversiView* self);
VALA_EXTERN gint theme_manager_get_border_width (ThemeManager* self);
VALA_EXTERN gint theme_manager_get_spacing_width (ThemeManager* self);
static inline void reversi_view_configure_overture_origin (ReversiView* self);
static gboolean reversi_view_real_draw (GtkWidget* base,
                                 cairo_t* cr);
static inline void reversi_view_init_patterns (ReversiView* self,
                                 cairo_t* cr);
static inline void reversi_view_draw_overture (ReversiView* self,
                                 cairo_t* cr);
static inline void reversi_view_draw_highlight (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_add_highlights (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_draw_playables (ReversiView* self,
                                  cairo_t* cr);
static inline void reversi_view_draw_overture_playables (ReversiView* self,
                                           cairo_t* cr);
VALA_EXTERN RsvgHandle* theme_manager_get_tileset_handle (ThemeManager* self);
VALA_EXTERN gboolean theme_manager_get_apply_texture (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_texture_alpha (ThemeManager* self);
static inline void reversi_view_draw_board_background (ReversiView* self,
                                         cairo_t* cr);
static inline void reversi_view_draw_tiles_background (ReversiView* self,
                                         cairo_t* cr,
                                         cairo_pattern_t** noise_pattern);
VALA_EXTERN gdouble theme_manager_get_spacing_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_spacing_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_spacing_blue (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_half_border_width (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_border_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_border_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_border_blue (ThemeManager* self);
static inline void reversi_view_draw_tile_background (ReversiView* self,
                                        cairo_t* cr,
                                        cairo_pattern_t** noise_pattern,
                                        gint tile_x,
                                        gint tile_y);
VALA_EXTERN gdouble theme_manager_get_background_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_background_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_background_blue (ThemeManager* self);
static void reversi_view_rounded_square (ReversiView* self,
                                  cairo_t* cr,
                                  gdouble x,
                                  gdouble y,
                                  gint size,
                                  gdouble width,
                                  gdouble radius_percent);
VALA_EXTERN gint theme_manager_get_background_radius (ThemeManager* self);
static void reversi_view_darken_tile (ReversiView* self,
                               cairo_t* cr,
                               guint8 x,
                               guint8 y);
VALA_EXTERN Game* reversi_view_get_game (ReversiView* self);
VALA_EXTERN GType opening_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Opening game_get_opening (Game* self);
VALA_EXTERN gboolean game_get_is_complete (Game* self);
static Iagno* reversi_view_get_iagno_instance (ReversiView* self);
VALA_EXTERN Player iagno_get_player_one (Iagno* self);
VALA_EXTERN Player game_get_current_color (Game* self);
VALA_EXTERN GType computer_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
VALA_EXTERN ComputerPlayer* iagno_get_computer (Iagno* self);
static inline void reversi_view_draw_tile_highlight (ReversiView* self,
                                       cairo_t* cr,
                                       guint8 x,
                                       guint8 y);
VALA_EXTERN GType possible_move_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PossibleMove* possible_move_dup (const PossibleMove* self);
VALA_EXTERN void possible_move_free (PossibleMove* self);
VALA_EXTERN gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
static void reversi_view_queue_draw_tile (ReversiView* self,
                                   guint8 x,
                                   guint8 y);
static void reversi_view_highlight_tile (ReversiView* self,
                                  cairo_t* cr,
                                  guint8 x,
                                  guint8 y,
                                  guint8 intensity,
                                  gboolean soft_highlight);
static gboolean reversi_view_get_show_turnable_tiles (ReversiView* self);
static inline void reversi_view_highlight_turnable_tiles (ReversiView* self,
                                            cairo_t* cr,
                                            guint8 x,
                                            guint8 y,
                                            gint8 x_step,
                                            gint8 y_step,
                                            guint8 count);
static gboolean reversi_view_get_show_playable_tiles (ReversiView* self);
static void reversi_view_init_possible_moves (ReversiView* self);
static inline void reversi_view_add_highlight (ReversiView* self,
                                 cairo_t* cr,
                                 guint8 x,
                                 guint8 y,
                                 guint8 intensity);
static inline void reversi_view_draw_playable (ReversiView* self,
                                 cairo_t* cr,
                                 gint pixmap,
                                 gint tile_x,
                                 gint tile_y);
static inline void reversi_view_draw_overture_indicator (ReversiView* self,
                                           cairo_t* cr);
static inline void reversi_view_draw_overture_playable (ReversiView* self,
                                          cairo_t* cr,
                                          guint8 playable_id);
static void reversi_view_get_x_and_y (ReversiView* self,
                               guint8 playable_id,
                               guint8* x,
                               guint8* y);
static void _reversi_view_draw_overture_playable (ReversiView* self,
                                           cairo_t* cr,
                                           gint tile_x,
                                           gint tile_y,
                                           gint pixmap);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_blue (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_alpha (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_blue (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_alpha (ThemeManager* self);
static inline void reversi_view_update_highlight_after_undo (ReversiView* self);
static void reversi_view_get_missing_tile (ReversiView* self,
                                    guint8* x,
                                    guint8* y);
static void reversi_view_set_square (ReversiView* self,
                              guint8 x,
                              guint8 y,
                              gint pixmap,
                              gboolean is_final_animation,
                              gboolean force_redraw);
static gint reversi_view_get_pixmap (Player color);
VALA_EXTERN Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
static inline void reversi_view_highlight_playable_tiles (ReversiView* self,
                                            gboolean force_reload);
VALA_EXTERN Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
static void reversi_view_turn_ended_cb (ReversiView* self,
                                 gboolean undoing,
                                 gboolean no_draw);
VALA_EXTERN GameStateObject* game_get_current_state (Game* self);
static inline void reversi_view_update_squares (ReversiView* self);
static inline void reversi_view_update_square (ReversiView* self,
                                 guint8 x,
                                 guint8 y);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean ____lambda17_ (Block7Data* _data7_);
static void reversi_view_flip_final_result_tile (ReversiView* self,
                                          guint8 x,
                                          guint8 y);
static void _reversi_view_on_motion (ReversiView* self,
                              guint8 x,
                              guint8 y,
                              gboolean force_redraw);
static gboolean _____lambda17__gsource_func (gpointer self);
static void reversi_view_game_is_complete_cb (ReversiView* self);
VALA_EXTERN guint8 game_get_n_light_tiles (Game* self);
VALA_EXTERN guint8 game_get_n_dark_tiles (Game* self);
static gboolean ___lambda16_ (ReversiView* self);
static void reversi_view_set_winner_and_loser_variables (ReversiView* self);
static gboolean ____lambda16__gsource_func (gpointer self);
VALA_EXTERN gboolean reversi_view_undo_final_animation (ReversiView* self);
static void reversi_view_init_mouse (ReversiView* self);
static void reversi_view_on_motion (ReversiView* self,
                             GtkEventControllerMotion* _motion_controller,
                             gdouble event_x,
                             gdouble event_y);
static void _reversi_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static inline void reversi_view_on_click (ReversiView* self,
                            GtkGestureMultiPress* _click_controller,
                            gint n_press,
                            gdouble event_x,
                            gdouble event_y);
static void _reversi_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self);
static gboolean reversi_view_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static gboolean reversi_view_pointer_is_in_board (ReversiView* self,
                                           gdouble pos_x,
                                           gdouble pos_y,
                                           guint8* x,
                                           guint8* y);
static void reversi_view_on_cursor_moving_in (ReversiView* self,
                                       guint8 x,
                                       guint8 y);
static gboolean reversi_view_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean ______lambda19_ (Block8Data* _data8_);
static gboolean _______lambda19__gsource_func (gpointer self);
static inline void reversi_view_move_if_possible (ReversiView* self,
                                    guint8 x,
                                    guint8 y);
static void reversi_view_init_keyboard (ReversiView* self);
static inline gboolean reversi_view_on_key_pressed (ReversiView* self,
                                      GtkEventControllerKey* _key_controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType state);
static gboolean _reversi_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self);
static void reversi_view_set_highlight_position_if_needed (ReversiView* self,
                                                    ReversiViewDirection direction);
static void reversi_view_init_highlight_on_light_tile_if_needed (ReversiView* self);
static void reversi_view_init_highlight_on_light_tile (ReversiView* self);
VALA_EXTERN void game_get_possible_moves (Game* self,
                              GSList** moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static void __lambda18_ (ReversiView* self,
                  PossibleMove* move);
static void ___lambda18__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN void reversi_view_set_show_playable_tiles (ReversiView* self,
                                           gboolean value);
VALA_EXTERN void reversi_view_set_show_turnable_tiles (ReversiView* self,
                                           gboolean value);
VALA_EXTERN void reversi_view_set_game (ReversiView* self,
                            Game* value);
VALA_EXTERN guint8 game_get_size (Game* self);
static void _reversi_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                                  gboolean completeness,
                                                                  gpointer self);
static void _reversi_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                                  gboolean undoing,
                                                  gboolean no_draw,
                                                  gpointer self);
static void reversi_view_set_iagno_instance (ReversiView* self,
                                      Iagno* value);
static void reversi_view_set_theme_manager (ReversiView* self,
                                     ThemeManager* value);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * reversi_view_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _reversi_view___lambda20_ (ReversiView* self);
static void __reversi_view___lambda20__theme_manager_theme_changed (ThemeManager* _sender,
                                                             gpointer self);
static void reversi_view_finalize (GObject * obj);
static GType reversi_view_get_type_once (void);
static void _vala_reversi_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_reversi_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
reversi_view_get_instance_private (ReversiView* self)
{
	return G_STRUCT_MEMBER_P (self, ReversiView_private_offset);
}

static GType
reversi_view_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{REVERSI_VIEW_DIRECTION_TOP, "REVERSI_VIEW_DIRECTION_TOP", "top"}, {REVERSI_VIEW_DIRECTION_LEFT, "REVERSI_VIEW_DIRECTION_LEFT", "left"}, {REVERSI_VIEW_DIRECTION_RIGHT, "REVERSI_VIEW_DIRECTION_RIGHT", "right"}, {REVERSI_VIEW_DIRECTION_BOTTOM, "REVERSI_VIEW_DIRECTION_BOTTOM", "bottom"}, {0, NULL, NULL}};
	GType reversi_view_direction_type_id;
	reversi_view_direction_type_id = g_enum_register_static ("ReversiViewDirection", values);
	return reversi_view_direction_type_id;
}

static GType
reversi_view_direction_get_type (void)
{
	static volatile gsize reversi_view_direction_type_id__once = 0;
	if (g_once_init_enter (&reversi_view_direction_type_id__once)) {
		GType reversi_view_direction_type_id;
		reversi_view_direction_type_id = reversi_view_direction_get_type_once ();
		g_once_init_leave (&reversi_view_direction_type_id__once, reversi_view_direction_type_id);
	}
	return reversi_view_direction_type_id__once;
}

ReversiView*
reversi_view_construct (GType object_type,
                        Iagno* iagno_instance,
                        ThemeManager* theme_manager)
{
	ReversiView * self = NULL;
#line 191 "../src/reversi-view.vala"
	g_return_val_if_fail (iagno_instance != NULL, NULL);
#line 191 "../src/reversi-view.vala"
	g_return_val_if_fail (theme_manager != NULL, NULL);
#line 193 "../src/reversi-view.vala"
	self = (ReversiView*) g_object_new (object_type, "iagno-instance", iagno_instance, "theme-manager", theme_manager, NULL);
#line 191 "../src/reversi-view.vala"
	return self;
#line 618 "reversi-view.c"
}

ReversiView*
reversi_view_new (Iagno* iagno_instance,
                  ThemeManager* theme_manager)
{
#line 191 "../src/reversi-view.vala"
	return reversi_view_construct (TYPE_REVERSI_VIEW, iagno_instance, theme_manager);
#line 627 "reversi-view.c"
}

static gboolean
reversi_view_real_configure_event (GtkWidget* base,
                                   GdkEventConfigure* e)
{
	ReversiView * self;
	gboolean result;
#line 207 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 207 "../src/reversi-view.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 207 "../src/reversi-view.vala"
	_vala_return_val_if_fail (self->priv->game_is_set, "game_is_set", FALSE);
#line 210 "../src/reversi-view.vala"
	reversi_view_configure_theme (self);
#line 211 "../src/reversi-view.vala"
	self->priv->configuration_done = TRUE;
#line 212 "../src/reversi-view.vala"
	result = TRUE;
#line 212 "../src/reversi-view.vala"
	return result;
#line 650 "reversi-view.c"
}

static void
reversi_view_configure_theme (ReversiView* self)
{
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
	ThemeManager* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	ThemeManager* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	ThemeManager* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	ThemeManager* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	ThemeManager* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	ThemeManager* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	ThemeManager* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
#line 214 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/reversi-view.vala"
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 217 "../src/reversi-view.vala"
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 218 "../src/reversi-view.vala"
	size = MIN (allocated_width, allocated_height);
#line 219 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 219 "../src/reversi-view.vala"
	_tmp1_ = theme_manager_get_border_width (_tmp0_);
#line 219 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 219 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_theme_manager;
#line 219 "../src/reversi-view.vala"
	_tmp4_ = theme_manager_get_spacing_width (_tmp3_);
#line 219 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 219 "../src/reversi-view.vala"
	self->priv->paving_size = ((size - (2 * _tmp2_)) + _tmp5_) / self->priv->game_size;
#line 220 "../src/reversi-view.vala"
	_tmp6_ = self->priv->_theme_manager;
#line 220 "../src/reversi-view.vala"
	_tmp7_ = theme_manager_get_spacing_width (_tmp6_);
#line 220 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 220 "../src/reversi-view.vala"
	self->priv->tile_size = self->priv->paving_size - _tmp8_;
#line 221 "../src/reversi-view.vala"
	_tmp9_ = self->priv->_theme_manager;
#line 221 "../src/reversi-view.vala"
	_tmp10_ = theme_manager_get_spacing_width (_tmp9_);
#line 221 "../src/reversi-view.vala"
	_tmp11_ = _tmp10_;
#line 221 "../src/reversi-view.vala"
	_tmp12_ = self->priv->_theme_manager;
#line 221 "../src/reversi-view.vala"
	_tmp13_ = theme_manager_get_border_width (_tmp12_);
#line 221 "../src/reversi-view.vala"
	_tmp14_ = _tmp13_;
#line 221 "../src/reversi-view.vala"
	self->priv->board_size = ((self->priv->paving_size * self->priv->game_size) - _tmp11_) + (2 * _tmp14_);
#line 222 "../src/reversi-view.vala"
	_tmp15_ = self->priv->_theme_manager;
#line 222 "../src/reversi-view.vala"
	_tmp16_ = theme_manager_get_border_width (_tmp15_);
#line 222 "../src/reversi-view.vala"
	_tmp17_ = _tmp16_;
#line 222 "../src/reversi-view.vala"
	self->priv->board_x = ((allocated_width - self->priv->board_size) / 2) + _tmp17_;
#line 223 "../src/reversi-view.vala"
	_tmp18_ = self->priv->_theme_manager;
#line 223 "../src/reversi-view.vala"
	_tmp19_ = theme_manager_get_border_width (_tmp18_);
#line 223 "../src/reversi-view.vala"
	_tmp20_ = _tmp19_;
#line 223 "../src/reversi-view.vala"
	self->priv->board_y = ((allocated_height - self->priv->board_size) / 2) + _tmp20_;
#line 225 "../src/reversi-view.vala"
	if (((gint) self->priv->humans_opening_intensity) != 0) {
#line 226 "../src/reversi-view.vala"
		reversi_view_configure_overture_origin (self);
#line 744 "reversi-view.c"
	}
	{
		guint8 x = 0U;
#line 228 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 750 "reversi-view.c"
		{
			gboolean _tmp21_ = FALSE;
#line 228 "../src/reversi-view.vala"
			_tmp21_ = TRUE;
#line 228 "../src/reversi-view.vala"
			while (TRUE) {
#line 228 "../src/reversi-view.vala"
				if (!_tmp21_) {
#line 759 "reversi-view.c"
					guint8 _tmp22_;
#line 228 "../src/reversi-view.vala"
					_tmp22_ = x;
#line 228 "../src/reversi-view.vala"
					x = _tmp22_ + 1;
#line 765 "reversi-view.c"
				}
#line 228 "../src/reversi-view.vala"
				_tmp21_ = FALSE;
#line 228 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 228 "../src/reversi-view.vala"
					break;
#line 773 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 230 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 779 "reversi-view.c"
					{
						gboolean _tmp23_ = FALSE;
#line 230 "../src/reversi-view.vala"
						_tmp23_ = TRUE;
#line 230 "../src/reversi-view.vala"
						while (TRUE) {
#line 786 "reversi-view.c"
							gint* _tmp25_;
							gint _tmp25__length1;
							gint _tmp25__length2;
							gint* _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
#line 230 "../src/reversi-view.vala"
							if (!_tmp23_) {
#line 795 "reversi-view.c"
								guint8 _tmp24_;
#line 230 "../src/reversi-view.vala"
								_tmp24_ = y;
#line 230 "../src/reversi-view.vala"
								y = _tmp24_ + 1;
#line 801 "reversi-view.c"
							}
#line 230 "../src/reversi-view.vala"
							_tmp23_ = FALSE;
#line 230 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 230 "../src/reversi-view.vala"
								break;
#line 809 "reversi-view.c"
							}
#line 232 "../src/reversi-view.vala"
							_tmp25_ = self->priv->tile_xs;
#line 232 "../src/reversi-view.vala"
							_tmp25__length1 = self->priv->tile_xs_length1;
#line 232 "../src/reversi-view.vala"
							_tmp25__length2 = self->priv->tile_xs_length2;
#line 232 "../src/reversi-view.vala"
							_tmp25_[(x * _tmp25__length2) + y] = self->priv->paving_size * ((gint) x);
#line 233 "../src/reversi-view.vala"
							_tmp26_ = self->priv->tile_ys;
#line 233 "../src/reversi-view.vala"
							_tmp26__length1 = self->priv->tile_ys_length1;
#line 233 "../src/reversi-view.vala"
							_tmp26__length2 = self->priv->tile_ys_length2;
#line 233 "../src/reversi-view.vala"
							_tmp26_[(x * _tmp26__length2) + y] = self->priv->paving_size * ((gint) y);
#line 827 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_configure_overture_origin (ReversiView* self)
{
#line 237 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/reversi-view.vala"
	if ((self->priv->game_size % 2) == 0) {
#line 843 "reversi-view.c"
		gint* _tmp0_;
		gint _tmp0__length1;
		ThemeManager* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint* _tmp4_;
		gint _tmp4__length1;
		ThemeManager* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint* _tmp8_;
		gint _tmp8__length1;
		ThemeManager* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint* _tmp12_;
		gint _tmp12__length1;
		ThemeManager* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 241 "../src/reversi-view.vala"
		_tmp0_ = self->priv->overture_origin_xs;
#line 241 "../src/reversi-view.vala"
		_tmp0__length1 = self->priv->overture_origin_xs_length1;
#line 241 "../src/reversi-view.vala"
		_tmp1_ = self->priv->_theme_manager;
#line 241 "../src/reversi-view.vala"
		_tmp2_ = theme_manager_get_border_width (_tmp1_);
#line 241 "../src/reversi-view.vala"
		_tmp3_ = _tmp2_;
#line 241 "../src/reversi-view.vala"
		_tmp0_[0] = ((((self->priv->game_size - 3) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp3_) - (self->priv->tile_size / 2);
#line 242 "../src/reversi-view.vala"
		_tmp4_ = self->priv->overture_origin_xs;
#line 242 "../src/reversi-view.vala"
		_tmp4__length1 = self->priv->overture_origin_xs_length1;
#line 242 "../src/reversi-view.vala"
		_tmp5_ = self->priv->_theme_manager;
#line 242 "../src/reversi-view.vala"
		_tmp6_ = theme_manager_get_border_width (_tmp5_);
#line 242 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_;
#line 242 "../src/reversi-view.vala"
		_tmp4_[1] = ((((self->priv->game_size - 1) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp7_) - (self->priv->tile_size / 2);
#line 243 "../src/reversi-view.vala"
		_tmp8_ = self->priv->overture_origin_xs;
#line 243 "../src/reversi-view.vala"
		_tmp8__length1 = self->priv->overture_origin_xs_length1;
#line 243 "../src/reversi-view.vala"
		_tmp9_ = self->priv->_theme_manager;
#line 243 "../src/reversi-view.vala"
		_tmp10_ = theme_manager_get_border_width (_tmp9_);
#line 243 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 243 "../src/reversi-view.vala"
		_tmp8_[2] = ((((self->priv->game_size + 1) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp11_) - (self->priv->tile_size / 2);
#line 244 "../src/reversi-view.vala"
		_tmp12_ = self->priv->overture_origin_xs;
#line 244 "../src/reversi-view.vala"
		_tmp12__length1 = self->priv->overture_origin_xs_length1;
#line 244 "../src/reversi-view.vala"
		_tmp13_ = self->priv->_theme_manager;
#line 244 "../src/reversi-view.vala"
		_tmp14_ = theme_manager_get_border_width (_tmp13_);
#line 244 "../src/reversi-view.vala"
		_tmp15_ = _tmp14_;
#line 244 "../src/reversi-view.vala"
		_tmp12_[3] = ((((self->priv->game_size + 3) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp15_) - (self->priv->tile_size / 2);
#line 246 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) == 4) {
#line 914 "reversi-view.c"
			ThemeManager* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 248 "../src/reversi-view.vala"
			_tmp16_ = self->priv->_theme_manager;
#line 248 "../src/reversi-view.vala"
			_tmp17_ = theme_manager_get_border_width (_tmp16_);
#line 248 "../src/reversi-view.vala"
			_tmp18_ = _tmp17_;
#line 248 "../src/reversi-view.vala"
			self->priv->overture_origin_y = (gint) (((((self->priv->game_size + 2.6) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp18_) - (self->priv->tile_size / 2));
#line 926 "reversi-view.c"
		} else {
			ThemeManager* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
#line 251 "../src/reversi-view.vala"
			_tmp19_ = self->priv->_theme_manager;
#line 251 "../src/reversi-view.vala"
			_tmp20_ = theme_manager_get_border_width (_tmp19_);
#line 251 "../src/reversi-view.vala"
			_tmp21_ = _tmp20_;
#line 251 "../src/reversi-view.vala"
			self->priv->overture_origin_y = ((((self->priv->game_size + 4) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp21_) - (self->priv->tile_size / 2);
#line 939 "reversi-view.c"
		}
	} else {
		gint* _tmp22_;
		gint _tmp22__length1;
		ThemeManager* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint* _tmp26_;
		gint _tmp26__length1;
		ThemeManager* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		gint* _tmp30_;
		gint _tmp30__length1;
		ThemeManager* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint* _tmp34_;
		gint _tmp34__length1;
		gint* _tmp35_;
		gint _tmp35__length1;
		gint _tmp36_;
		gint* _tmp37_;
		gint _tmp37__length1;
		gint* _tmp38_;
		gint _tmp38__length1;
		gint _tmp39_;
		gint* _tmp40_;
		gint _tmp40__length1;
		gint* _tmp41_;
		gint _tmp41__length1;
		gint _tmp42_;
#line 255 "../src/reversi-view.vala"
		_tmp22_ = self->priv->overture_origin_xs;
#line 255 "../src/reversi-view.vala"
		_tmp22__length1 = self->priv->overture_origin_xs_length1;
#line 255 "../src/reversi-view.vala"
		_tmp23_ = self->priv->_theme_manager;
#line 255 "../src/reversi-view.vala"
		_tmp24_ = theme_manager_get_border_width (_tmp23_);
#line 255 "../src/reversi-view.vala"
		_tmp25_ = _tmp24_;
#line 255 "../src/reversi-view.vala"
		_tmp22_[0] = ((((self->priv->game_size - 2) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp25_) - (self->priv->tile_size / 2);
#line 256 "../src/reversi-view.vala"
		_tmp26_ = self->priv->overture_origin_xs;
#line 256 "../src/reversi-view.vala"
		_tmp26__length1 = self->priv->overture_origin_xs_length1;
#line 256 "../src/reversi-view.vala"
		_tmp27_ = self->priv->_theme_manager;
#line 256 "../src/reversi-view.vala"
		_tmp28_ = theme_manager_get_border_width (_tmp27_);
#line 256 "../src/reversi-view.vala"
		_tmp29_ = _tmp28_;
#line 256 "../src/reversi-view.vala"
		_tmp26_[2] = (((self->priv->game_size * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp29_) - (self->priv->tile_size / 2);
#line 257 "../src/reversi-view.vala"
		_tmp30_ = self->priv->overture_origin_xs;
#line 257 "../src/reversi-view.vala"
		_tmp30__length1 = self->priv->overture_origin_xs_length1;
#line 257 "../src/reversi-view.vala"
		_tmp31_ = self->priv->_theme_manager;
#line 257 "../src/reversi-view.vala"
		_tmp32_ = theme_manager_get_border_width (_tmp31_);
#line 257 "../src/reversi-view.vala"
		_tmp33_ = _tmp32_;
#line 257 "../src/reversi-view.vala"
		_tmp30_[4] = ((((self->priv->game_size + 2) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp33_) - (self->priv->tile_size / 2);
#line 258 "../src/reversi-view.vala"
		_tmp34_ = self->priv->overture_origin_xs;
#line 258 "../src/reversi-view.vala"
		_tmp34__length1 = self->priv->overture_origin_xs_length1;
#line 258 "../src/reversi-view.vala"
		_tmp35_ = self->priv->overture_origin_xs;
#line 258 "../src/reversi-view.vala"
		_tmp35__length1 = self->priv->overture_origin_xs_length1;
#line 258 "../src/reversi-view.vala"
		_tmp36_ = _tmp35_[0];
#line 258 "../src/reversi-view.vala"
		_tmp34_[1] = _tmp36_;
#line 259 "../src/reversi-view.vala"
		_tmp37_ = self->priv->overture_origin_xs;
#line 259 "../src/reversi-view.vala"
		_tmp37__length1 = self->priv->overture_origin_xs_length1;
#line 259 "../src/reversi-view.vala"
		_tmp38_ = self->priv->overture_origin_xs;
#line 259 "../src/reversi-view.vala"
		_tmp38__length1 = self->priv->overture_origin_xs_length1;
#line 259 "../src/reversi-view.vala"
		_tmp39_ = _tmp38_[2];
#line 259 "../src/reversi-view.vala"
		_tmp37_[3] = _tmp39_;
#line 260 "../src/reversi-view.vala"
		_tmp40_ = self->priv->overture_origin_xs;
#line 260 "../src/reversi-view.vala"
		_tmp40__length1 = self->priv->overture_origin_xs_length1;
#line 260 "../src/reversi-view.vala"
		_tmp41_ = self->priv->overture_origin_xs;
#line 260 "../src/reversi-view.vala"
		_tmp41__length1 = self->priv->overture_origin_xs_length1;
#line 260 "../src/reversi-view.vala"
		_tmp42_ = _tmp41_[4];
#line 260 "../src/reversi-view.vala"
		_tmp40_[5] = _tmp42_;
#line 262 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) == 5) {
#line 1046 "reversi-view.c"
			ThemeManager* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
#line 264 "../src/reversi-view.vala"
			_tmp43_ = self->priv->_theme_manager;
#line 264 "../src/reversi-view.vala"
			_tmp44_ = theme_manager_get_border_width (_tmp43_);
#line 264 "../src/reversi-view.vala"
			_tmp45_ = _tmp44_;
#line 264 "../src/reversi-view.vala"
			self->priv->overture_origin_y = (gint) (((((self->priv->game_size + 3.6) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp45_) - (self->priv->tile_size / 2));
#line 1058 "reversi-view.c"
		} else {
			ThemeManager* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
#line 267 "../src/reversi-view.vala"
			_tmp46_ = self->priv->_theme_manager;
#line 267 "../src/reversi-view.vala"
			_tmp47_ = theme_manager_get_border_width (_tmp46_);
#line 267 "../src/reversi-view.vala"
			_tmp48_ = _tmp47_;
#line 267 "../src/reversi-view.vala"
			self->priv->overture_origin_y = ((((self->priv->game_size + 5) * self->priv->board_size) / (2 * self->priv->game_size)) - _tmp48_) - (self->priv->tile_size / 2);
#line 1071 "reversi-view.c"
		}
	}
}

static gboolean
reversi_view_real_draw (GtkWidget* base,
                        cairo_t* cr)
{
	ReversiView * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	cairo_pattern_t* _tmp2_;
	ThemeManager* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	ThemeManager* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	cairo_pattern_t* _tmp10_;
	ThemeManager* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	ThemeManager* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean result;
#line 271 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 271 "../src/reversi-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 273 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 274 "../src/reversi-view.vala"
		result = FALSE;
#line 274 "../src/reversi-view.vala"
		return result;
#line 1108 "reversi-view.c"
	}
#line 276 "../src/reversi-view.vala"
	_tmp2_ = self->priv->board_pattern;
#line 276 "../src/reversi-view.vala"
	if (_tmp2_ == NULL) {
#line 276 "../src/reversi-view.vala"
		_tmp1_ = TRUE;
#line 1116 "reversi-view.c"
	} else {
		cairo_pattern_t* _tmp3_;
#line 276 "../src/reversi-view.vala"
		_tmp3_ = self->priv->tiles_pattern;
#line 276 "../src/reversi-view.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 1123 "reversi-view.c"
	}
#line 276 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 276 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 1129 "reversi-view.c"
	} else {
#line 276 "../src/reversi-view.vala"
		_tmp0_ = self->priv->render_size != ((guint) self->priv->tile_size);
#line 1133 "reversi-view.c"
	}
#line 276 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 277 "../src/reversi-view.vala"
		reversi_view_init_patterns (self, cr);
#line 1139 "reversi-view.c"
	}
#line 280 "../src/reversi-view.vala"
	_tmp4_ = self->priv->_theme_manager;
#line 280 "../src/reversi-view.vala"
	_tmp5_ = theme_manager_get_border_width (_tmp4_);
#line 280 "../src/reversi-view.vala"
	_tmp6_ = _tmp5_;
#line 280 "../src/reversi-view.vala"
	_tmp7_ = self->priv->_theme_manager;
#line 280 "../src/reversi-view.vala"
	_tmp8_ = theme_manager_get_border_width (_tmp7_);
#line 280 "../src/reversi-view.vala"
	_tmp9_ = _tmp8_;
#line 280 "../src/reversi-view.vala"
	cairo_translate (cr, (gdouble) (self->priv->board_x - _tmp6_), (gdouble) (self->priv->board_y - _tmp9_));
#line 282 "../src/reversi-view.vala"
	_tmp10_ = self->priv->board_pattern;
#line 282 "../src/reversi-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp10_);
#line 283 "../src/reversi-view.vala"
	cairo_rectangle (cr, 0.0, 0.0, (gdouble) self->priv->board_size, (gdouble) self->priv->board_size);
#line 287 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 290 "../src/reversi-view.vala"
	_tmp11_ = self->priv->_theme_manager;
#line 290 "../src/reversi-view.vala"
	_tmp12_ = theme_manager_get_border_width (_tmp11_);
#line 290 "../src/reversi-view.vala"
	_tmp13_ = _tmp12_;
#line 290 "../src/reversi-view.vala"
	_tmp14_ = self->priv->_theme_manager;
#line 290 "../src/reversi-view.vala"
	_tmp15_ = theme_manager_get_border_width (_tmp14_);
#line 290 "../src/reversi-view.vala"
	_tmp16_ = _tmp15_;
#line 290 "../src/reversi-view.vala"
	cairo_translate (cr, (gdouble) _tmp13_, (gdouble) _tmp16_);
#line 292 "../src/reversi-view.vala"
	if (((gint) self->priv->humans_opening_intensity) != 0) {
#line 293 "../src/reversi-view.vala"
		reversi_view_draw_overture (self, cr);
#line 1181 "reversi-view.c"
	}
#line 295 "../src/reversi-view.vala"
	reversi_view_draw_highlight (self, cr);
#line 296 "../src/reversi-view.vala"
	reversi_view_add_highlights (self, cr);
#line 297 "../src/reversi-view.vala"
	if (((gint) self->priv->humans_opening_intensity) == 0) {
#line 298 "../src/reversi-view.vala"
		reversi_view_draw_playables (self, cr);
#line 1191 "reversi-view.c"
	} else {
#line 300 "../src/reversi-view.vala"
		reversi_view_draw_overture_playables (self, cr);
#line 1195 "reversi-view.c"
	}
#line 302 "../src/reversi-view.vala"
	result = FALSE;
#line 302 "../src/reversi-view.vala"
	return result;
#line 1201 "reversi-view.c"
}

static inline void
reversi_view_init_patterns (ReversiView* self,
                            cairo_t* cr)
{
	cairo_surface_t* surface = NULL;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* _tmp3_;
	RsvgDimensionData size = {0};
	ThemeManager* _tmp4_;
	RsvgHandle* _tmp5_;
	RsvgHandle* _tmp6_;
	RsvgDimensionData _tmp7_ = {0};
	cairo_t* _tmp8_;
	RsvgDimensionData _tmp9_;
	RsvgDimensionData _tmp10_;
	ThemeManager* _tmp11_;
	RsvgHandle* _tmp12_;
	RsvgHandle* _tmp13_;
	cairo_t* _tmp14_;
	cairo_surface_t* _tmp15_;
	cairo_pattern_t* _tmp16_;
	cairo_pattern_t* noise_pattern = NULL;
	ThemeManager* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	cairo_surface_t* _tmp38_;
	cairo_surface_t* _tmp39_;
	cairo_surface_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	cairo_surface_t* _tmp44_;
	cairo_pattern_t* _tmp45_;
	GError* _inner_error0_ = NULL;
#line 305 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 307 "../src/reversi-view.vala"
	self->priv->render_size = (guint) self->priv->tile_size;
#line 313 "../src/reversi-view.vala"
	_tmp0_ = cairo_get_target (cr);
#line 313 "../src/reversi-view.vala"
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 313 "../src/reversi-view.vala"
	_cairo_surface_destroy0 (surface);
#line 313 "../src/reversi-view.vala"
	surface = _tmp1_;
#line 315 "../src/reversi-view.vala"
	_tmp2_ = surface;
#line 315 "../src/reversi-view.vala"
	_tmp3_ = cairo_create (_tmp2_);
#line 315 "../src/reversi-view.vala"
	_cairo_destroy0 (context);
#line 315 "../src/reversi-view.vala"
	context = _tmp3_;
#line 316 "../src/reversi-view.vala"
	_tmp4_ = self->priv->_theme_manager;
#line 316 "../src/reversi-view.vala"
	_tmp5_ = theme_manager_get_tileset_handle (_tmp4_);
#line 316 "../src/reversi-view.vala"
	_tmp6_ = _tmp5_;
#line 316 "../src/reversi-view.vala"
	rsvg_handle_get_dimensions (_tmp6_, &_tmp7_);
#line 316 "../src/reversi-view.vala"
	size = _tmp7_;
#line 317 "../src/reversi-view.vala"
	_tmp8_ = context;
#line 317 "../src/reversi-view.vala"
	_tmp9_ = size;
#line 317 "../src/reversi-view.vala"
	_tmp10_ = size;
#line 317 "../src/reversi-view.vala"
	cairo_scale (_tmp8_, (((gdouble) self->priv->tile_size) * 8.0) / ((gdouble) _tmp9_.width), (((gdouble) self->priv->tile_size) * 4.0) / ((gdouble) _tmp10_.height));
#line 319 "../src/reversi-view.vala"
	_tmp11_ = self->priv->_theme_manager;
#line 319 "../src/reversi-view.vala"
	_tmp12_ = theme_manager_get_tileset_handle (_tmp11_);
#line 319 "../src/reversi-view.vala"
	_tmp13_ = _tmp12_;
#line 319 "../src/reversi-view.vala"
	_tmp14_ = context;
#line 319 "../src/reversi-view.vala"
	rsvg_handle_render_cairo (_tmp13_, _tmp14_);
#line 320 "../src/reversi-view.vala"
	_tmp15_ = surface;
#line 320 "../src/reversi-view.vala"
	_tmp16_ = cairo_pattern_create_for_surface (_tmp15_);
#line 320 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 320 "../src/reversi-view.vala"
	self->priv->tiles_pattern = _tmp16_;
#line 323 "../src/reversi-view.vala"
	noise_pattern = NULL;
#line 325 "../src/reversi-view.vala"
	_tmp17_ = self->priv->_theme_manager;
#line 325 "../src/reversi-view.vala"
	_tmp18_ = theme_manager_get_apply_texture (_tmp17_);
#line 325 "../src/reversi-view.vala"
	_tmp19_ = _tmp18_;
#line 325 "../src/reversi-view.vala"
	if (_tmp19_) {
#line 1309 "reversi-view.c"
		GdkPixbuf* noise_pixbuf = NULL;
		GdkPixbuf* _tmp25_;
#line 327 "../src/reversi-view.vala"
		noise_pixbuf = NULL;
#line 1314 "reversi-view.c"
		{
			GdkPixbuf* _tmp20_ = NULL;
			GdkPixbuf* _tmp21_;
			GdkPixbuf* _tmp22_;
#line 331 "../src/reversi-view.vala"
			_tmp21_ = gdk_pixbuf_new_from_resource_at_scale ("/org/gnome/Reversi/ui/noise.png", self->priv->tile_size, self->priv->tile_size, FALSE, &_inner_error0_);
#line 331 "../src/reversi-view.vala"
			_tmp20_ = _tmp21_;
#line 331 "../src/reversi-view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1325 "reversi-view.c"
				goto __catch0_g_error;
			}
#line 331 "../src/reversi-view.vala"
			_tmp22_ = _tmp20_;
#line 331 "../src/reversi-view.vala"
			_tmp20_ = NULL;
#line 331 "../src/reversi-view.vala"
			_g_object_unref0 (noise_pixbuf);
#line 331 "../src/reversi-view.vala"
			noise_pixbuf = _tmp22_;
#line 329 "../src/reversi-view.vala"
			_g_object_unref0 (_tmp20_);
#line 1338 "reversi-view.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 329 "../src/reversi-view.vala"
			e = _inner_error0_;
#line 329 "../src/reversi-view.vala"
			_inner_error0_ = NULL;
#line 335 "../src/reversi-view.vala"
			_tmp23_ = e;
#line 335 "../src/reversi-view.vala"
			_tmp24_ = _tmp23_->message;
#line 335 "../src/reversi-view.vala"
			g_warning ("reversi-view.vala:335: %s", _tmp24_);
#line 329 "../src/reversi-view.vala"
			_g_error_free0 (e);
#line 1358 "reversi-view.c"
		}
		__finally0:
#line 329 "../src/reversi-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../src/reversi-view.vala"
			_g_object_unref0 (noise_pixbuf);
#line 329 "../src/reversi-view.vala"
			_cairo_pattern_destroy0 (noise_pattern);
#line 329 "../src/reversi-view.vala"
			_cairo_destroy0 (context);
#line 329 "../src/reversi-view.vala"
			_cairo_surface_destroy0 (surface);
#line 329 "../src/reversi-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../src/reversi-view.vala"
			g_clear_error (&_inner_error0_);
#line 329 "../src/reversi-view.vala"
			return;
#line 1377 "reversi-view.c"
		}
#line 336 "../src/reversi-view.vala"
		_tmp25_ = noise_pixbuf;
#line 336 "../src/reversi-view.vala"
		self->priv->noise_pixbuf_loaded = _tmp25_ != NULL;
#line 337 "../src/reversi-view.vala"
		if (self->priv->noise_pixbuf_loaded) {
#line 1385 "reversi-view.c"
			cairo_surface_t* _tmp26_;
			cairo_surface_t* _tmp27_;
			cairo_surface_t* _tmp28_;
			cairo_t* _tmp29_;
			cairo_t* _tmp30_;
			GdkPixbuf* _tmp31_;
			cairo_t* _tmp32_;
			ThemeManager* _tmp33_;
			gdouble _tmp34_;
			gdouble _tmp35_;
			cairo_surface_t* _tmp36_;
			cairo_pattern_t* _tmp37_;
#line 339 "../src/reversi-view.vala"
			_tmp26_ = cairo_get_target (cr);
#line 339 "../src/reversi-view.vala"
			_tmp27_ = cairo_surface_create_similar (_tmp26_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size, self->priv->tile_size);
#line 339 "../src/reversi-view.vala"
			_cairo_surface_destroy0 (surface);
#line 339 "../src/reversi-view.vala"
			surface = _tmp27_;
#line 341 "../src/reversi-view.vala"
			_tmp28_ = surface;
#line 341 "../src/reversi-view.vala"
			_tmp29_ = cairo_create (_tmp28_);
#line 341 "../src/reversi-view.vala"
			_cairo_destroy0 (context);
#line 341 "../src/reversi-view.vala"
			context = _tmp29_;
#line 342 "../src/reversi-view.vala"
			_tmp30_ = context;
#line 342 "../src/reversi-view.vala"
			_tmp31_ = noise_pixbuf;
#line 342 "../src/reversi-view.vala"
			gdk_cairo_set_source_pixbuf (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gdk_pixbuf_get_type (), GdkPixbuf), 0.0, 0.0);
#line 343 "../src/reversi-view.vala"
			_tmp32_ = context;
#line 343 "../src/reversi-view.vala"
			_tmp33_ = self->priv->_theme_manager;
#line 343 "../src/reversi-view.vala"
			_tmp34_ = theme_manager_get_texture_alpha (_tmp33_);
#line 343 "../src/reversi-view.vala"
			_tmp35_ = _tmp34_;
#line 343 "../src/reversi-view.vala"
			cairo_paint_with_alpha (_tmp32_, _tmp35_);
#line 346 "../src/reversi-view.vala"
			_tmp36_ = surface;
#line 346 "../src/reversi-view.vala"
			_tmp37_ = cairo_pattern_create_for_surface (_tmp36_);
#line 346 "../src/reversi-view.vala"
			_cairo_pattern_destroy0 (noise_pattern);
#line 346 "../src/reversi-view.vala"
			noise_pattern = _tmp37_;
#line 1438 "reversi-view.c"
		}
#line 325 "../src/reversi-view.vala"
		_g_object_unref0 (noise_pixbuf);
#line 1442 "reversi-view.c"
	}
#line 352 "../src/reversi-view.vala"
	_tmp38_ = cairo_get_target (cr);
#line 352 "../src/reversi-view.vala"
	_tmp39_ = cairo_surface_create_similar (_tmp38_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->board_size, self->priv->board_size);
#line 352 "../src/reversi-view.vala"
	_cairo_surface_destroy0 (surface);
#line 352 "../src/reversi-view.vala"
	surface = _tmp39_;
#line 354 "../src/reversi-view.vala"
	_tmp40_ = surface;
#line 354 "../src/reversi-view.vala"
	_tmp41_ = cairo_create (_tmp40_);
#line 354 "../src/reversi-view.vala"
	_cairo_destroy0 (context);
#line 354 "../src/reversi-view.vala"
	context = _tmp41_;
#line 356 "../src/reversi-view.vala"
	_tmp42_ = context;
#line 356 "../src/reversi-view.vala"
	reversi_view_draw_board_background (self, _tmp42_);
#line 357 "../src/reversi-view.vala"
	_tmp43_ = context;
#line 357 "../src/reversi-view.vala"
	reversi_view_draw_tiles_background (self, _tmp43_, &noise_pattern);
#line 359 "../src/reversi-view.vala"
	_tmp44_ = surface;
#line 359 "../src/reversi-view.vala"
	_tmp45_ = cairo_pattern_create_for_surface (_tmp44_);
#line 359 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->board_pattern);
#line 359 "../src/reversi-view.vala"
	self->priv->board_pattern = _tmp45_;
#line 305 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (noise_pattern);
#line 305 "../src/reversi-view.vala"
	_cairo_destroy0 (context);
#line 305 "../src/reversi-view.vala"
	_cairo_surface_destroy0 (surface);
#line 1482 "reversi-view.c"
}

static inline void
reversi_view_draw_board_background (ReversiView* self,
                                    cairo_t* cr)
{
	ThemeManager* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	ThemeManager* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	ThemeManager* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	ThemeManager* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	ThemeManager* _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	ThemeManager* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	ThemeManager* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	ThemeManager* _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	ThemeManager* _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	ThemeManager* _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	ThemeManager* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
#line 362 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 362 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 364 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 364 "../src/reversi-view.vala"
	_tmp1_ = theme_manager_get_spacing_red (_tmp0_);
#line 364 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 364 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_theme_manager;
#line 364 "../src/reversi-view.vala"
	_tmp4_ = theme_manager_get_spacing_green (_tmp3_);
#line 364 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 364 "../src/reversi-view.vala"
	_tmp6_ = self->priv->_theme_manager;
#line 364 "../src/reversi-view.vala"
	_tmp7_ = theme_manager_get_spacing_blue (_tmp6_);
#line 364 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 364 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, _tmp2_, _tmp5_, _tmp8_, 1.0);
#line 365 "../src/reversi-view.vala"
	_tmp9_ = self->priv->_theme_manager;
#line 365 "../src/reversi-view.vala"
	_tmp10_ = theme_manager_get_half_border_width (_tmp9_);
#line 365 "../src/reversi-view.vala"
	_tmp11_ = _tmp10_;
#line 365 "../src/reversi-view.vala"
	_tmp12_ = self->priv->_theme_manager;
#line 365 "../src/reversi-view.vala"
	_tmp13_ = theme_manager_get_half_border_width (_tmp12_);
#line 365 "../src/reversi-view.vala"
	_tmp14_ = _tmp13_;
#line 365 "../src/reversi-view.vala"
	_tmp15_ = self->priv->_theme_manager;
#line 365 "../src/reversi-view.vala"
	_tmp16_ = theme_manager_get_border_width (_tmp15_);
#line 365 "../src/reversi-view.vala"
	_tmp17_ = _tmp16_;
#line 365 "../src/reversi-view.vala"
	_tmp18_ = self->priv->_theme_manager;
#line 365 "../src/reversi-view.vala"
	_tmp19_ = theme_manager_get_border_width (_tmp18_);
#line 365 "../src/reversi-view.vala"
	_tmp20_ = _tmp19_;
#line 365 "../src/reversi-view.vala"
	cairo_rectangle (cr, _tmp11_, _tmp14_, (gdouble) (self->priv->board_size - _tmp17_), (gdouble) (self->priv->board_size - _tmp20_));
#line 369 "../src/reversi-view.vala"
	cairo_fill_preserve (cr);
#line 370 "../src/reversi-view.vala"
	_tmp21_ = self->priv->_theme_manager;
#line 370 "../src/reversi-view.vala"
	_tmp22_ = theme_manager_get_border_red (_tmp21_);
#line 370 "../src/reversi-view.vala"
	_tmp23_ = _tmp22_;
#line 370 "../src/reversi-view.vala"
	_tmp24_ = self->priv->_theme_manager;
#line 370 "../src/reversi-view.vala"
	_tmp25_ = theme_manager_get_border_green (_tmp24_);
#line 370 "../src/reversi-view.vala"
	_tmp26_ = _tmp25_;
#line 370 "../src/reversi-view.vala"
	_tmp27_ = self->priv->_theme_manager;
#line 370 "../src/reversi-view.vala"
	_tmp28_ = theme_manager_get_border_blue (_tmp27_);
#line 370 "../src/reversi-view.vala"
	_tmp29_ = _tmp28_;
#line 370 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, _tmp23_, _tmp26_, _tmp29_, 1.0);
#line 371 "../src/reversi-view.vala"
	_tmp30_ = self->priv->_theme_manager;
#line 371 "../src/reversi-view.vala"
	_tmp31_ = theme_manager_get_border_width (_tmp30_);
#line 371 "../src/reversi-view.vala"
	_tmp32_ = _tmp31_;
#line 371 "../src/reversi-view.vala"
	cairo_set_line_width (cr, (gdouble) _tmp32_);
#line 372 "../src/reversi-view.vala"
	cairo_stroke (cr);
#line 1604 "reversi-view.c"
}

static inline void
reversi_view_draw_tiles_background (ReversiView* self,
                                    cairo_t* cr,
                                    cairo_pattern_t** noise_pattern)
{
	ThemeManager* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	ThemeManager* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 375 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 377 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 377 "../src/reversi-view.vala"
	_tmp1_ = theme_manager_get_border_width (_tmp0_);
#line 377 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 377 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_theme_manager;
#line 377 "../src/reversi-view.vala"
	_tmp4_ = theme_manager_get_border_width (_tmp3_);
#line 377 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 377 "../src/reversi-view.vala"
	cairo_translate (cr, (gdouble) _tmp2_, (gdouble) _tmp5_);
#line 1636 "reversi-view.c"
	{
		guint8 x = 0U;
#line 379 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 1641 "reversi-view.c"
		{
			gboolean _tmp6_ = FALSE;
#line 379 "../src/reversi-view.vala"
			_tmp6_ = TRUE;
#line 379 "../src/reversi-view.vala"
			while (TRUE) {
#line 379 "../src/reversi-view.vala"
				if (!_tmp6_) {
#line 1650 "reversi-view.c"
					guint8 _tmp7_;
#line 379 "../src/reversi-view.vala"
					_tmp7_ = x;
#line 379 "../src/reversi-view.vala"
					x = _tmp7_ + 1;
#line 1656 "reversi-view.c"
				}
#line 379 "../src/reversi-view.vala"
				_tmp6_ = FALSE;
#line 379 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 379 "../src/reversi-view.vala"
					break;
#line 1664 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 380 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 1670 "reversi-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 380 "../src/reversi-view.vala"
						_tmp8_ = TRUE;
#line 380 "../src/reversi-view.vala"
						while (TRUE) {
#line 1677 "reversi-view.c"
							gint* _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							gint _tmp11_;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
#line 380 "../src/reversi-view.vala"
							if (!_tmp8_) {
#line 1688 "reversi-view.c"
								guint8 _tmp9_;
#line 380 "../src/reversi-view.vala"
								_tmp9_ = y;
#line 380 "../src/reversi-view.vala"
								y = _tmp9_ + 1;
#line 1694 "reversi-view.c"
							}
#line 380 "../src/reversi-view.vala"
							_tmp8_ = FALSE;
#line 380 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 380 "../src/reversi-view.vala"
								break;
#line 1702 "reversi-view.c"
							}
#line 381 "../src/reversi-view.vala"
							_tmp10_ = self->priv->tile_xs;
#line 381 "../src/reversi-view.vala"
							_tmp10__length1 = self->priv->tile_xs_length1;
#line 381 "../src/reversi-view.vala"
							_tmp10__length2 = self->priv->tile_xs_length2;
#line 381 "../src/reversi-view.vala"
							_tmp11_ = _tmp10_[(x * _tmp10__length2) + y];
#line 381 "../src/reversi-view.vala"
							_tmp12_ = self->priv->tile_ys;
#line 381 "../src/reversi-view.vala"
							_tmp12__length1 = self->priv->tile_ys_length1;
#line 381 "../src/reversi-view.vala"
							_tmp12__length2 = self->priv->tile_ys_length2;
#line 381 "../src/reversi-view.vala"
							_tmp13_ = _tmp12_[(x * _tmp12__length2) + y];
#line 381 "../src/reversi-view.vala"
							reversi_view_draw_tile_background (self, cr, noise_pattern, _tmp11_, _tmp13_);
#line 1722 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_draw_tile_background (ReversiView* self,
                                   cairo_t* cr,
                                   cairo_pattern_t** noise_pattern,
                                   gint tile_x,
                                   gint tile_y)
{
	ThemeManager* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	ThemeManager* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	ThemeManager* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	ThemeManager* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_ = FALSE;
	ThemeManager* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 383 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 385 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 385 "../src/reversi-view.vala"
	_tmp1_ = theme_manager_get_background_red (_tmp0_);
#line 385 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 385 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_theme_manager;
#line 385 "../src/reversi-view.vala"
	_tmp4_ = theme_manager_get_background_green (_tmp3_);
#line 385 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 385 "../src/reversi-view.vala"
	_tmp6_ = self->priv->_theme_manager;
#line 385 "../src/reversi-view.vala"
	_tmp7_ = theme_manager_get_background_blue (_tmp6_);
#line 385 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 385 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, _tmp2_, _tmp5_, _tmp8_, 1.0);
#line 386 "../src/reversi-view.vala"
	_tmp9_ = self->priv->_theme_manager;
#line 386 "../src/reversi-view.vala"
	_tmp10_ = theme_manager_get_background_radius (_tmp9_);
#line 386 "../src/reversi-view.vala"
	_tmp11_ = _tmp10_;
#line 386 "../src/reversi-view.vala"
	reversi_view_rounded_square (self, cr, (gdouble) tile_x, (gdouble) tile_y, self->priv->tile_size, (gdouble) 0, (gdouble) _tmp11_);
#line 387 "../src/reversi-view.vala"
	_tmp13_ = self->priv->_theme_manager;
#line 387 "../src/reversi-view.vala"
	_tmp14_ = theme_manager_get_apply_texture (_tmp13_);
#line 387 "../src/reversi-view.vala"
	_tmp15_ = _tmp14_;
#line 387 "../src/reversi-view.vala"
	if (_tmp15_) {
#line 387 "../src/reversi-view.vala"
		_tmp12_ = self->priv->noise_pixbuf_loaded;
#line 1796 "reversi-view.c"
	} else {
#line 387 "../src/reversi-view.vala"
		_tmp12_ = FALSE;
#line 1800 "reversi-view.c"
	}
#line 387 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 1804 "reversi-view.c"
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp16_;
#line 389 "../src/reversi-view.vala"
		cairo_fill_preserve (cr);
#line 391 "../src/reversi-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 392 "../src/reversi-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (-tile_x), (gdouble) (-tile_y));
#line 393 "../src/reversi-view.vala"
		_tmp16_ = matrix;
#line 393 "../src/reversi-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) (*noise_pattern), &_tmp16_);
#line 394 "../src/reversi-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) (*noise_pattern));
#line 1819 "reversi-view.c"
	}
#line 396 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 1823 "reversi-view.c"
}

static inline void
reversi_view_draw_overture (ReversiView* self,
                            cairo_t* cr)
{
	guint8 half_game_size = 0U;
	Game* _tmp14_;
	Game* _tmp15_;
	Opening _tmp16_;
	Opening _tmp17_;
#line 399 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 399 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 402 "../src/reversi-view.vala"
	half_game_size = (guint8) (self->priv->game_size / 2);
#line 1841 "reversi-view.c"
	{
		guint8 x = 0U;
#line 403 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 1846 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 403 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 403 "../src/reversi-view.vala"
			while (TRUE) {
#line 403 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 1855 "reversi-view.c"
					guint8 _tmp1_;
#line 403 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 403 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 1861 "reversi-view.c"
				}
#line 403 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 403 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 403 "../src/reversi-view.vala"
					break;
#line 1869 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 404 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 1875 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 404 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 404 "../src/reversi-view.vala"
						while (TRUE) {
#line 1882 "reversi-view.c"
							gboolean _tmp4_ = FALSE;
							gboolean _tmp5_ = FALSE;
							gboolean _tmp7_ = FALSE;
#line 404 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 1888 "reversi-view.c"
								guint8 _tmp3_;
#line 404 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 404 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 1894 "reversi-view.c"
							}
#line 404 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 404 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 404 "../src/reversi-view.vala"
								break;
#line 1902 "reversi-view.c"
							}
#line 407 "../src/reversi-view.vala"
							if (x == half_game_size) {
#line 407 "../src/reversi-view.vala"
								_tmp5_ = TRUE;
#line 1908 "reversi-view.c"
							} else {
#line 407 "../src/reversi-view.vala"
								_tmp5_ = ((gint) x) == (half_game_size - 1);
#line 1912 "reversi-view.c"
							}
#line 407 "../src/reversi-view.vala"
							if (_tmp5_) {
#line 1916 "reversi-view.c"
								gboolean _tmp6_ = FALSE;
#line 408 "../src/reversi-view.vala"
								if (y == half_game_size) {
#line 408 "../src/reversi-view.vala"
									_tmp6_ = TRUE;
#line 1922 "reversi-view.c"
								} else {
#line 408 "../src/reversi-view.vala"
									_tmp6_ = ((gint) y) == (half_game_size - 1);
#line 1926 "reversi-view.c"
								}
#line 408 "../src/reversi-view.vala"
								_tmp4_ = _tmp6_;
#line 1930 "reversi-view.c"
							} else {
#line 407 "../src/reversi-view.vala"
								_tmp4_ = FALSE;
#line 1934 "reversi-view.c"
							}
#line 407 "../src/reversi-view.vala"
							if (_tmp4_) {
#line 409 "../src/reversi-view.vala"
								continue;
#line 1940 "reversi-view.c"
							}
#line 412 "../src/reversi-view.vala"
							if ((self->priv->game_size % 2) != 0) {
#line 1944 "reversi-view.c"
								gboolean _tmp8_ = FALSE;
								gboolean _tmp9_ = FALSE;
#line 413 "../src/reversi-view.vala"
								if (((gint) y) == (half_game_size + 1)) {
#line 1949 "reversi-view.c"
									gboolean _tmp10_ = FALSE;
									gboolean _tmp11_ = FALSE;
#line 413 "../src/reversi-view.vala"
									if (((gint) x) == (half_game_size - 1)) {
#line 413 "../src/reversi-view.vala"
										_tmp11_ = TRUE;
#line 1956 "reversi-view.c"
									} else {
#line 413 "../src/reversi-view.vala"
										_tmp11_ = x == half_game_size;
#line 1960 "reversi-view.c"
									}
#line 413 "../src/reversi-view.vala"
									if (_tmp11_) {
#line 413 "../src/reversi-view.vala"
										_tmp10_ = TRUE;
#line 1966 "reversi-view.c"
									} else {
#line 413 "../src/reversi-view.vala"
										_tmp10_ = ((gint) x) == (half_game_size + 1);
#line 1970 "reversi-view.c"
									}
#line 413 "../src/reversi-view.vala"
									_tmp9_ = _tmp10_;
#line 1974 "reversi-view.c"
								} else {
#line 413 "../src/reversi-view.vala"
									_tmp9_ = FALSE;
#line 1978 "reversi-view.c"
								}
#line 413 "../src/reversi-view.vala"
								if (_tmp9_) {
#line 413 "../src/reversi-view.vala"
									_tmp8_ = TRUE;
#line 1984 "reversi-view.c"
								} else {
									gboolean _tmp12_ = FALSE;
#line 414 "../src/reversi-view.vala"
									if (((gint) x) == (half_game_size + 1)) {
#line 1989 "reversi-view.c"
										gboolean _tmp13_ = FALSE;
#line 414 "../src/reversi-view.vala"
										if (((gint) y) == (half_game_size - 1)) {
#line 414 "../src/reversi-view.vala"
											_tmp13_ = TRUE;
#line 1995 "reversi-view.c"
										} else {
#line 414 "../src/reversi-view.vala"
											_tmp13_ = y == half_game_size;
#line 1999 "reversi-view.c"
										}
#line 414 "../src/reversi-view.vala"
										_tmp12_ = _tmp13_;
#line 2003 "reversi-view.c"
									} else {
#line 414 "../src/reversi-view.vala"
										_tmp12_ = FALSE;
#line 2007 "reversi-view.c"
									}
#line 414 "../src/reversi-view.vala"
									_tmp8_ = _tmp12_;
#line 2011 "reversi-view.c"
								}
#line 413 "../src/reversi-view.vala"
								_tmp7_ = _tmp8_;
#line 2015 "reversi-view.c"
							} else {
#line 412 "../src/reversi-view.vala"
								_tmp7_ = FALSE;
#line 2019 "reversi-view.c"
							}
#line 412 "../src/reversi-view.vala"
							if (_tmp7_) {
#line 415 "../src/reversi-view.vala"
								continue;
#line 2025 "reversi-view.c"
							}
#line 417 "../src/reversi-view.vala"
							reversi_view_darken_tile (self, cr, x, y);
#line 2029 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 420 "../src/reversi-view.vala"
	_tmp14_ = reversi_view_get_game (self);
#line 420 "../src/reversi-view.vala"
	_tmp15_ = _tmp14_;
#line 420 "../src/reversi-view.vala"
	_tmp16_ = game_get_opening (_tmp15_);
#line 420 "../src/reversi-view.vala"
	_tmp17_ = _tmp16_;
#line 420 "../src/reversi-view.vala"
	if (_tmp17_ != OPENING_HUMANS) {
#line 2046 "reversi-view.c"
		guint8 _tmp18_;
#line 422 "../src/reversi-view.vala"
		_tmp18_ = self->priv->humans_opening_intensity;
#line 422 "../src/reversi-view.vala"
		self->priv->humans_opening_intensity = _tmp18_ - 1;
#line 423 "../src/reversi-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 2054 "reversi-view.c"
	}
}

static inline void
reversi_view_draw_highlight (ReversiView* self,
                             cairo_t* cr)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean display_mouse_highlight = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean display_keybd_highlight = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean display_ghost_highlight = FALSE;
#line 427 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 429 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 429 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 429 "../src/reversi-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 429 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 429 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 430 "../src/reversi-view.vala"
		return;
#line 2092 "reversi-view.c"
	}
#line 432 "../src/reversi-view.vala"
	if (!self->priv->show_highlight) {
#line 2096 "reversi-view.c"
		gboolean _tmp6_ = FALSE;
#line 433 "../src/reversi-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 433 "../src/reversi-view.vala"
			_tmp6_ = TRUE;
#line 2102 "reversi-view.c"
		} else {
#line 433 "../src/reversi-view.vala"
			_tmp6_ = ((gint) self->priv->highlight_state) != 0;
#line 2106 "reversi-view.c"
		}
#line 433 "../src/reversi-view.vala"
		_tmp5_ = _tmp6_;
#line 2110 "reversi-view.c"
	} else {
#line 432 "../src/reversi-view.vala"
		_tmp5_ = FALSE;
#line 2114 "reversi-view.c"
	}
#line 432 "../src/reversi-view.vala"
	if (_tmp5_) {
#line 2118 "reversi-view.c"
		gboolean _tmp7_ = FALSE;
		Iagno* _tmp8_;
		Player _tmp9_;
		Player _tmp10_;
		Game* _tmp11_;
		Game* _tmp12_;
		Player _tmp13_;
		Player _tmp14_;
#line 435 "../src/reversi-view.vala"
		_tmp8_ = self->priv->_iagno_instance;
#line 435 "../src/reversi-view.vala"
		_tmp9_ = iagno_get_player_one (_tmp8_);
#line 435 "../src/reversi-view.vala"
		_tmp10_ = _tmp9_;
#line 435 "../src/reversi-view.vala"
		_tmp11_ = reversi_view_get_game (self);
#line 435 "../src/reversi-view.vala"
		_tmp12_ = _tmp11_;
#line 435 "../src/reversi-view.vala"
		_tmp13_ = game_get_current_color (_tmp12_);
#line 435 "../src/reversi-view.vala"
		_tmp14_ = _tmp13_;
#line 435 "../src/reversi-view.vala"
		if (_tmp10_ == _tmp14_) {
#line 435 "../src/reversi-view.vala"
			_tmp7_ = TRUE;
#line 2145 "reversi-view.c"
		} else {
			Iagno* _tmp15_;
			ComputerPlayer* _tmp16_;
			ComputerPlayer* _tmp17_;
#line 435 "../src/reversi-view.vala"
			_tmp15_ = self->priv->_iagno_instance;
#line 435 "../src/reversi-view.vala"
			_tmp16_ = iagno_get_computer (_tmp15_);
#line 435 "../src/reversi-view.vala"
			_tmp17_ = _tmp16_;
#line 435 "../src/reversi-view.vala"
			_tmp7_ = _tmp17_ == NULL;
#line 2158 "reversi-view.c"
		}
#line 435 "../src/reversi-view.vala"
		_tmp4_ = _tmp7_;
#line 2162 "reversi-view.c"
	} else {
#line 432 "../src/reversi-view.vala"
		_tmp4_ = FALSE;
#line 2166 "reversi-view.c"
	}
#line 432 "../src/reversi-view.vala"
	display_mouse_highlight = _tmp4_;
#line 437 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 438 "../src/reversi-view.vala"
		_tmp18_ = !self->priv->show_mouse_highlight;
#line 2174 "reversi-view.c"
	} else {
#line 437 "../src/reversi-view.vala"
		_tmp18_ = FALSE;
#line 2178 "reversi-view.c"
	}
#line 437 "../src/reversi-view.vala"
	display_keybd_highlight = _tmp18_;
#line 441 "../src/reversi-view.vala"
	if (!self->priv->show_highlight) {
#line 442 "../src/reversi-view.vala"
		_tmp22_ = !self->priv->show_mouse_highlight;
#line 2186 "reversi-view.c"
	} else {
#line 441 "../src/reversi-view.vala"
		_tmp22_ = FALSE;
#line 2190 "reversi-view.c"
	}
#line 441 "../src/reversi-view.vala"
	if (_tmp22_) {
#line 443 "../src/reversi-view.vala"
		_tmp21_ = ((gint) self->priv->highlight_state) != 0;
#line 2196 "reversi-view.c"
	} else {
#line 441 "../src/reversi-view.vala"
		_tmp21_ = FALSE;
#line 2200 "reversi-view.c"
	}
#line 441 "../src/reversi-view.vala"
	if (_tmp21_) {
#line 444 "../src/reversi-view.vala"
		_tmp20_ = self->priv->old_highlight_x != G_MAXUINT8;
#line 2206 "reversi-view.c"
	} else {
#line 441 "../src/reversi-view.vala"
		_tmp20_ = FALSE;
#line 2210 "reversi-view.c"
	}
#line 441 "../src/reversi-view.vala"
	if (_tmp20_) {
#line 445 "../src/reversi-view.vala"
		_tmp19_ = self->priv->old_highlight_y != G_MAXUINT8;
#line 2216 "reversi-view.c"
	} else {
#line 441 "../src/reversi-view.vala"
		_tmp19_ = FALSE;
#line 2220 "reversi-view.c"
	}
#line 441 "../src/reversi-view.vala"
	display_ghost_highlight = _tmp19_;
#line 447 "../src/reversi-view.vala"
	if (display_ghost_highlight) {
#line 448 "../src/reversi-view.vala"
		reversi_view_draw_tile_highlight (self, cr, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 2228 "reversi-view.c"
	} else {
#line 449 "../src/reversi-view.vala"
		if (display_mouse_highlight) {
#line 450 "../src/reversi-view.vala"
			reversi_view_draw_tile_highlight (self, cr, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 2234 "reversi-view.c"
		} else {
#line 451 "../src/reversi-view.vala"
			if (display_keybd_highlight) {
#line 452 "../src/reversi-view.vala"
				reversi_view_draw_tile_highlight (self, cr, self->priv->highlight_x, self->priv->highlight_y);
#line 2240 "reversi-view.c"
			}
		}
	}
}

static inline void
reversi_view_draw_tile_highlight (ReversiView* self,
                                  cairo_t* cr,
                                  guint8 x,
                                  guint8 y)
{
	PossibleMove move = {0};
	gboolean test_placing_tile = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean highlight_on = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
#line 454 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 454 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 457 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 457 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 457 "../src/reversi-view.vala"
	_tmp3_ = game_test_placing_tile (_tmp1_, x, y, &_tmp2_);
#line 457 "../src/reversi-view.vala"
	move = _tmp2_;
#line 457 "../src/reversi-view.vala"
	test_placing_tile = _tmp3_;
#line 458 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 458 "../src/reversi-view.vala"
		_tmp4_ = TRUE;
#line 2281 "reversi-view.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 458 "../src/reversi-view.vala"
		if (self->priv->mouse_is_in) {
#line 458 "../src/reversi-view.vala"
			_tmp6_ = self->priv->show_mouse_highlight;
#line 2289 "reversi-view.c"
		} else {
#line 458 "../src/reversi-view.vala"
			_tmp6_ = FALSE;
#line 2293 "reversi-view.c"
		}
#line 458 "../src/reversi-view.vala"
		if (_tmp6_) {
#line 458 "../src/reversi-view.vala"
			_tmp5_ = test_placing_tile;
#line 2299 "reversi-view.c"
		} else {
#line 458 "../src/reversi-view.vala"
			_tmp5_ = FALSE;
#line 2303 "reversi-view.c"
		}
#line 458 "../src/reversi-view.vala"
		_tmp4_ = _tmp5_;
#line 2307 "reversi-view.c"
	}
#line 458 "../src/reversi-view.vala"
	highlight_on = _tmp4_;
#line 461 "../src/reversi-view.vala"
	if (highlight_on) {
#line 461 "../src/reversi-view.vala"
		_tmp7_ = self->priv->highlight_state != REVERSI_VIEW_HIGHLIGHT_MAX;
#line 2315 "reversi-view.c"
	} else {
#line 461 "../src/reversi-view.vala"
		_tmp7_ = FALSE;
#line 2319 "reversi-view.c"
	}
#line 461 "../src/reversi-view.vala"
	if (_tmp7_) {
#line 2323 "reversi-view.c"
		guint8 _tmp8_;
#line 463 "../src/reversi-view.vala"
		_tmp8_ = self->priv->highlight_state;
#line 463 "../src/reversi-view.vala"
		self->priv->highlight_state = _tmp8_ + 1;
#line 464 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, x, y);
#line 2331 "reversi-view.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 466 "../src/reversi-view.vala"
		if (!highlight_on) {
#line 466 "../src/reversi-view.vala"
			_tmp9_ = ((gint) self->priv->highlight_state) != 0;
#line 2338 "reversi-view.c"
		} else {
#line 466 "../src/reversi-view.vala"
			_tmp9_ = FALSE;
#line 2342 "reversi-view.c"
		}
#line 466 "../src/reversi-view.vala"
		if (_tmp9_) {
#line 2346 "reversi-view.c"
			guint8 _tmp10_;
			gboolean _tmp11_ = FALSE;
#line 472 "../src/reversi-view.vala"
			_tmp10_ = self->priv->highlight_state;
#line 472 "../src/reversi-view.vala"
			self->priv->highlight_state = _tmp10_ - 1;
#line 473 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, x, y);
#line 474 "../src/reversi-view.vala"
			if (self->priv->old_highlight_x != x) {
#line 474 "../src/reversi-view.vala"
				_tmp11_ = TRUE;
#line 2359 "reversi-view.c"
			} else {
#line 474 "../src/reversi-view.vala"
				_tmp11_ = self->priv->old_highlight_y != y;
#line 2363 "reversi-view.c"
			}
#line 474 "../src/reversi-view.vala"
			if (_tmp11_) {
#line 476 "../src/reversi-view.vala"
				return;
#line 2369 "reversi-view.c"
			}
		}
	}
#line 478 "../src/reversi-view.vala"
	reversi_view_highlight_tile (self, cr, x, y, self->priv->highlight_state, FALSE);
#line 479 "../src/reversi-view.vala"
	if (test_placing_tile) {
#line 2377 "reversi-view.c"
		gboolean _tmp14_;
#line 480 "../src/reversi-view.vala"
		_tmp14_ = self->priv->_show_turnable_tiles;
#line 480 "../src/reversi-view.vala"
		_tmp13_ = _tmp14_;
#line 2383 "reversi-view.c"
	} else {
#line 479 "../src/reversi-view.vala"
		_tmp13_ = FALSE;
#line 2387 "reversi-view.c"
	}
#line 479 "../src/reversi-view.vala"
	if (_tmp13_) {
#line 2391 "reversi-view.c"
		gboolean _tmp15_ = FALSE;
		Iagno* _tmp16_;
		ComputerPlayer* _tmp17_;
		ComputerPlayer* _tmp18_;
#line 481 "../src/reversi-view.vala"
		_tmp16_ = self->priv->_iagno_instance;
#line 481 "../src/reversi-view.vala"
		_tmp17_ = iagno_get_computer (_tmp16_);
#line 481 "../src/reversi-view.vala"
		_tmp18_ = _tmp17_;
#line 481 "../src/reversi-view.vala"
		if (_tmp18_ != NULL) {
#line 2404 "reversi-view.c"
			Iagno* _tmp19_;
			Player _tmp20_;
			Player _tmp21_;
			Game* _tmp22_;
			Game* _tmp23_;
			Player _tmp24_;
			Player _tmp25_;
#line 481 "../src/reversi-view.vala"
			_tmp19_ = self->priv->_iagno_instance;
#line 481 "../src/reversi-view.vala"
			_tmp20_ = iagno_get_player_one (_tmp19_);
#line 481 "../src/reversi-view.vala"
			_tmp21_ = _tmp20_;
#line 481 "../src/reversi-view.vala"
			_tmp22_ = reversi_view_get_game (self);
#line 481 "../src/reversi-view.vala"
			_tmp23_ = _tmp22_;
#line 481 "../src/reversi-view.vala"
			_tmp24_ = game_get_current_color (_tmp23_);
#line 481 "../src/reversi-view.vala"
			_tmp25_ = _tmp24_;
#line 481 "../src/reversi-view.vala"
			_tmp15_ = _tmp21_ != _tmp25_;
#line 2428 "reversi-view.c"
		} else {
#line 481 "../src/reversi-view.vala"
			_tmp15_ = FALSE;
#line 2432 "reversi-view.c"
		}
#line 481 "../src/reversi-view.vala"
		_tmp12_ = !_tmp15_;
#line 2436 "reversi-view.c"
	} else {
#line 479 "../src/reversi-view.vala"
		_tmp12_ = FALSE;
#line 2440 "reversi-view.c"
	}
#line 479 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 2444 "reversi-view.c"
		PossibleMove _tmp26_;
		PossibleMove _tmp27_;
		PossibleMove _tmp28_;
		PossibleMove _tmp29_;
		PossibleMove _tmp30_;
		PossibleMove _tmp31_;
		PossibleMove _tmp32_;
		PossibleMove _tmp33_;
		PossibleMove _tmp34_;
		PossibleMove _tmp35_;
		PossibleMove _tmp36_;
		PossibleMove _tmp37_;
		PossibleMove _tmp38_;
		PossibleMove _tmp39_;
		PossibleMove _tmp40_;
		PossibleMove _tmp41_;
		PossibleMove _tmp42_;
		PossibleMove _tmp43_;
		PossibleMove _tmp44_;
		PossibleMove _tmp45_;
		PossibleMove _tmp46_;
		PossibleMove _tmp47_;
		PossibleMove _tmp48_;
		PossibleMove _tmp49_;
#line 483 "../src/reversi-view.vala"
		_tmp26_ = move;
#line 483 "../src/reversi-view.vala"
		_tmp27_ = move;
#line 483 "../src/reversi-view.vala"
		_tmp28_ = move;
#line 483 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp26_.x, _tmp27_.y, (gint8) 0, (gint8) -1, _tmp28_.n_tiles_n);
#line 484 "../src/reversi-view.vala"
		_tmp29_ = move;
#line 484 "../src/reversi-view.vala"
		_tmp30_ = move;
#line 484 "../src/reversi-view.vala"
		_tmp31_ = move;
#line 484 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp29_.x, _tmp30_.y, (gint8) 1, (gint8) -1, _tmp31_.n_tiles_ne);
#line 485 "../src/reversi-view.vala"
		_tmp32_ = move;
#line 485 "../src/reversi-view.vala"
		_tmp33_ = move;
#line 485 "../src/reversi-view.vala"
		_tmp34_ = move;
#line 485 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp32_.x, _tmp33_.y, (gint8) 1, (gint8) 0, _tmp34_.n_tiles_e);
#line 486 "../src/reversi-view.vala"
		_tmp35_ = move;
#line 486 "../src/reversi-view.vala"
		_tmp36_ = move;
#line 486 "../src/reversi-view.vala"
		_tmp37_ = move;
#line 486 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp35_.x, _tmp36_.y, (gint8) 1, (gint8) 1, _tmp37_.n_tiles_se);
#line 487 "../src/reversi-view.vala"
		_tmp38_ = move;
#line 487 "../src/reversi-view.vala"
		_tmp39_ = move;
#line 487 "../src/reversi-view.vala"
		_tmp40_ = move;
#line 487 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp38_.x, _tmp39_.y, (gint8) 0, (gint8) 1, _tmp40_.n_tiles_s);
#line 488 "../src/reversi-view.vala"
		_tmp41_ = move;
#line 488 "../src/reversi-view.vala"
		_tmp42_ = move;
#line 488 "../src/reversi-view.vala"
		_tmp43_ = move;
#line 488 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp41_.x, _tmp42_.y, (gint8) -1, (gint8) 1, _tmp43_.n_tiles_so);
#line 489 "../src/reversi-view.vala"
		_tmp44_ = move;
#line 489 "../src/reversi-view.vala"
		_tmp45_ = move;
#line 489 "../src/reversi-view.vala"
		_tmp46_ = move;
#line 489 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp44_.x, _tmp45_.y, (gint8) -1, (gint8) 0, _tmp46_.n_tiles_o);
#line 490 "../src/reversi-view.vala"
		_tmp47_ = move;
#line 490 "../src/reversi-view.vala"
		_tmp48_ = move;
#line 490 "../src/reversi-view.vala"
		_tmp49_ = move;
#line 490 "../src/reversi-view.vala"
		reversi_view_highlight_turnable_tiles (self, cr, _tmp47_.x, _tmp48_.y, (gint8) -1, (gint8) -1, _tmp49_.n_tiles_no);
#line 2533 "reversi-view.c"
	}
}

static inline void
reversi_view_highlight_turnable_tiles (ReversiView* self,
                                       cairo_t* cr,
                                       guint8 x,
                                       guint8 y,
                                       gint8 x_step,
                                       gint8 y_step,
                                       guint8 count)
{
#line 493 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 2550 "reversi-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 495 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 495 "../src/reversi-view.vala"
		while (TRUE) {
#line 2557 "reversi-view.c"
			gint8 _x = 0;
			gint8 _y = 0;
#line 495 "../src/reversi-view.vala"
			if (!_tmp0_) {
#line 2562 "reversi-view.c"
				guint8 _tmp1_;
#line 495 "../src/reversi-view.vala"
				_tmp1_ = count;
#line 495 "../src/reversi-view.vala"
				count = _tmp1_ - 1;
#line 2568 "reversi-view.c"
			}
#line 495 "../src/reversi-view.vala"
			_tmp0_ = FALSE;
#line 495 "../src/reversi-view.vala"
			if (!(((gint) count) > 0)) {
#line 495 "../src/reversi-view.vala"
				break;
#line 2576 "reversi-view.c"
			}
#line 497 "../src/reversi-view.vala"
			_x = ((gint8) x) + (((gint8) count) * x_step);
#line 498 "../src/reversi-view.vala"
			_y = ((gint8) y) + (((gint8) count) * y_step);
#line 499 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, (guint8) _x, (guint8) _y);
#line 500 "../src/reversi-view.vala"
			reversi_view_highlight_tile (self, cr, (guint8) _x, (guint8) _y, self->priv->highlight_state, TRUE);
#line 2586 "reversi-view.c"
		}
	}
}

static inline void
reversi_view_add_highlights (ReversiView* self,
                             cairo_t* cr)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	Iagno* _tmp4_;
	ComputerPlayer* _tmp5_;
	ComputerPlayer* _tmp6_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gboolean decreasing = FALSE;
	guint8 intensity = 0U;
	gboolean _tmp32_ = FALSE;
#line 504 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 504 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 506 "../src/reversi-view.vala"
	_tmp1_ = reversi_view_get_show_playable_tiles (self);
#line 506 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 506 "../src/reversi-view.vala"
	if (!_tmp2_) {
#line 506 "../src/reversi-view.vala"
		_tmp0_ = ((gint) self->priv->playable_tiles_highlight_state) == 0;
#line 2620 "reversi-view.c"
	} else {
#line 506 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 2624 "reversi-view.c"
	}
#line 506 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 507 "../src/reversi-view.vala"
		return;
#line 2630 "reversi-view.c"
	}
#line 508 "../src/reversi-view.vala"
	_tmp4_ = self->priv->_iagno_instance;
#line 508 "../src/reversi-view.vala"
	_tmp5_ = iagno_get_computer (_tmp4_);
#line 508 "../src/reversi-view.vala"
	_tmp6_ = _tmp5_;
#line 508 "../src/reversi-view.vala"
	if (_tmp6_ != NULL) {
#line 2640 "reversi-view.c"
		Iagno* _tmp7_;
		Player _tmp8_;
		Player _tmp9_;
		Game* _tmp10_;
		Game* _tmp11_;
		Player _tmp12_;
		Player _tmp13_;
#line 508 "../src/reversi-view.vala"
		_tmp7_ = self->priv->_iagno_instance;
#line 508 "../src/reversi-view.vala"
		_tmp8_ = iagno_get_player_one (_tmp7_);
#line 508 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_;
#line 508 "../src/reversi-view.vala"
		_tmp10_ = reversi_view_get_game (self);
#line 508 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 508 "../src/reversi-view.vala"
		_tmp12_ = game_get_current_color (_tmp11_);
#line 508 "../src/reversi-view.vala"
		_tmp13_ = _tmp12_;
#line 508 "../src/reversi-view.vala"
		_tmp3_ = _tmp9_ != _tmp13_;
#line 2664 "reversi-view.c"
	} else {
#line 508 "../src/reversi-view.vala"
		_tmp3_ = FALSE;
#line 2668 "reversi-view.c"
	}
#line 508 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 510 "../src/reversi-view.vala"
		reversi_view_init_possible_moves (self);
#line 511 "../src/reversi-view.vala"
		return;
#line 2676 "reversi-view.c"
	}
#line 514 "../src/reversi-view.vala"
	_tmp15_ = reversi_view_get_show_playable_tiles (self);
#line 514 "../src/reversi-view.vala"
	_tmp16_ = _tmp15_;
#line 514 "../src/reversi-view.vala"
	if (_tmp16_) {
#line 2684 "reversi-view.c"
		gboolean _tmp17_;
#line 514 "../src/reversi-view.vala"
		_tmp17_ = self->priv->_show_turnable_tiles;
#line 514 "../src/reversi-view.vala"
		_tmp14_ = _tmp17_;
#line 2690 "reversi-view.c"
	} else {
#line 514 "../src/reversi-view.vala"
		_tmp14_ = FALSE;
#line 2694 "reversi-view.c"
	}
#line 514 "../src/reversi-view.vala"
	if (_tmp14_) {
#line 2698 "reversi-view.c"
		PossibleMove move = {0};
		gboolean _tmp18_ = FALSE;
		gboolean _tmp23_ = FALSE;
#line 517 "../src/reversi-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 2704 "reversi-view.c"
			Game* _tmp19_;
			Game* _tmp20_;
			PossibleMove _tmp21_ = {0};
			gboolean _tmp22_;
#line 517 "../src/reversi-view.vala"
			_tmp19_ = reversi_view_get_game (self);
#line 517 "../src/reversi-view.vala"
			_tmp20_ = _tmp19_;
#line 517 "../src/reversi-view.vala"
			_tmp22_ = game_test_placing_tile (_tmp20_, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y, &_tmp21_);
#line 517 "../src/reversi-view.vala"
			move = _tmp21_;
#line 517 "../src/reversi-view.vala"
			_tmp18_ = _tmp22_;
#line 2719 "reversi-view.c"
		} else {
#line 517 "../src/reversi-view.vala"
			_tmp18_ = FALSE;
#line 2723 "reversi-view.c"
		}
#line 517 "../src/reversi-view.vala"
		if (_tmp18_) {
#line 518 "../src/reversi-view.vala"
			return;
#line 2729 "reversi-view.c"
		}
#line 519 "../src/reversi-view.vala"
		if (self->priv->show_highlight) {
#line 2733 "reversi-view.c"
			Game* _tmp24_;
			Game* _tmp25_;
			PossibleMove _tmp26_ = {0};
			gboolean _tmp27_;
#line 519 "../src/reversi-view.vala"
			_tmp24_ = reversi_view_get_game (self);
#line 519 "../src/reversi-view.vala"
			_tmp25_ = _tmp24_;
#line 519 "../src/reversi-view.vala"
			_tmp27_ = game_test_placing_tile (_tmp25_, self->priv->highlight_x, self->priv->highlight_y, &_tmp26_);
#line 519 "../src/reversi-view.vala"
			move = _tmp26_;
#line 519 "../src/reversi-view.vala"
			_tmp23_ = _tmp27_;
#line 2748 "reversi-view.c"
		} else {
#line 519 "../src/reversi-view.vala"
			_tmp23_ = FALSE;
#line 2752 "reversi-view.c"
		}
#line 519 "../src/reversi-view.vala"
		if (_tmp23_) {
#line 520 "../src/reversi-view.vala"
			return;
#line 2758 "reversi-view.c"
		}
	}
#line 523 "../src/reversi-view.vala"
	decreasing = self->priv->playable_tiles_highlight_state > REVERSI_VIEW_HIGHLIGHT_MAX;
#line 525 "../src/reversi-view.vala"
	if (decreasing) {
#line 526 "../src/reversi-view.vala"
		intensity = (guint8) (((2 * REVERSI_VIEW_HIGHLIGHT_MAX) + 1) - self->priv->playable_tiles_highlight_state);
#line 2767 "reversi-view.c"
	} else {
#line 528 "../src/reversi-view.vala"
		intensity = self->priv->playable_tiles_highlight_state;
#line 2771 "reversi-view.c"
	}
	{
		guint8 x = 0U;
#line 530 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 2777 "reversi-view.c"
		{
			gboolean _tmp28_ = FALSE;
#line 530 "../src/reversi-view.vala"
			_tmp28_ = TRUE;
#line 530 "../src/reversi-view.vala"
			while (TRUE) {
#line 530 "../src/reversi-view.vala"
				if (!_tmp28_) {
#line 2786 "reversi-view.c"
					guint8 _tmp29_;
#line 530 "../src/reversi-view.vala"
					_tmp29_ = x;
#line 530 "../src/reversi-view.vala"
					x = _tmp29_ + 1;
#line 2792 "reversi-view.c"
				}
#line 530 "../src/reversi-view.vala"
				_tmp28_ = FALSE;
#line 530 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 530 "../src/reversi-view.vala"
					break;
#line 2800 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 531 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 2806 "reversi-view.c"
					{
						gboolean _tmp30_ = FALSE;
#line 531 "../src/reversi-view.vala"
						_tmp30_ = TRUE;
#line 531 "../src/reversi-view.vala"
						while (TRUE) {
#line 531 "../src/reversi-view.vala"
							if (!_tmp30_) {
#line 2815 "reversi-view.c"
								guint8 _tmp31_;
#line 531 "../src/reversi-view.vala"
								_tmp31_ = y;
#line 531 "../src/reversi-view.vala"
								y = _tmp31_ + 1;
#line 2821 "reversi-view.c"
							}
#line 531 "../src/reversi-view.vala"
							_tmp30_ = FALSE;
#line 531 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 531 "../src/reversi-view.vala"
								break;
#line 2829 "reversi-view.c"
							}
#line 532 "../src/reversi-view.vala"
							reversi_view_add_highlight (self, cr, x, y, intensity);
#line 2833 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 534 "../src/reversi-view.vala"
	if (decreasing) {
#line 534 "../src/reversi-view.vala"
		_tmp32_ = ((gint) intensity) == 1;
#line 2844 "reversi-view.c"
	} else {
#line 534 "../src/reversi-view.vala"
		_tmp32_ = FALSE;
#line 2848 "reversi-view.c"
	}
#line 534 "../src/reversi-view.vala"
	if (_tmp32_) {
#line 535 "../src/reversi-view.vala"
		reversi_view_init_possible_moves (self);
#line 2854 "reversi-view.c"
	} else {
		gboolean _tmp33_;
		gboolean _tmp34_;
#line 536 "../src/reversi-view.vala"
		_tmp33_ = reversi_view_get_show_playable_tiles (self);
#line 536 "../src/reversi-view.vala"
		_tmp34_ = _tmp33_;
#line 536 "../src/reversi-view.vala"
		if (!_tmp34_) {
#line 2864 "reversi-view.c"
			guint8 _tmp35_;
#line 537 "../src/reversi-view.vala"
			_tmp35_ = self->priv->playable_tiles_highlight_state;
#line 537 "../src/reversi-view.vala"
			self->priv->playable_tiles_highlight_state = _tmp35_ + 1;
#line 2870 "reversi-view.c"
		} else {
#line 538 "../src/reversi-view.vala"
			if (self->priv->playable_tiles_highlight_state < REVERSI_VIEW_HIGHLIGHT_MAX) {
#line 2874 "reversi-view.c"
				guint8 _tmp36_;
#line 539 "../src/reversi-view.vala"
				_tmp36_ = self->priv->playable_tiles_highlight_state;
#line 539 "../src/reversi-view.vala"
				self->priv->playable_tiles_highlight_state = _tmp36_ + 1;
#line 2880 "reversi-view.c"
			}
		}
	}
}

static inline void
reversi_view_add_highlight (ReversiView* self,
                            cairo_t* cr,
                            guint8 x,
                            guint8 y,
                            guint8 intensity)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean _tmp1_;
#line 541 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 543 "../src/reversi-view.vala"
	_tmp0_ = self->priv->possible_moves;
#line 543 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->possible_moves_length1;
#line 543 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->possible_moves_length2;
#line 543 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 543 "../src/reversi-view.vala"
	if (_tmp1_ == FALSE) {
#line 544 "../src/reversi-view.vala"
		return;
#line 2913 "reversi-view.c"
	}
#line 546 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, x, y);
#line 547 "../src/reversi-view.vala"
	reversi_view_highlight_tile (self, cr, x, y, intensity, TRUE);
#line 2919 "reversi-view.c"
}

static inline void
reversi_view_draw_playables (ReversiView* self,
                             cairo_t* cr)
{
#line 550 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 2930 "reversi-view.c"
	{
		guint8 x = 0U;
#line 552 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 2935 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 552 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 552 "../src/reversi-view.vala"
			while (TRUE) {
#line 552 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 2944 "reversi-view.c"
					guint8 _tmp1_;
#line 552 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 552 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 2950 "reversi-view.c"
				}
#line 552 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 552 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 552 "../src/reversi-view.vala"
					break;
#line 2958 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 553 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 2964 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 553 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 553 "../src/reversi-view.vala"
						while (TRUE) {
#line 2971 "reversi-view.c"
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gint* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gint _tmp7_;
							gint* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							gint _tmp9_;
#line 553 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 2986 "reversi-view.c"
								guint8 _tmp3_;
#line 553 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 553 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 2992 "reversi-view.c"
							}
#line 553 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 553 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 553 "../src/reversi-view.vala"
								break;
#line 3000 "reversi-view.c"
							}
#line 554 "../src/reversi-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 554 "../src/reversi-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 554 "../src/reversi-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 554 "../src/reversi-view.vala"
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 554 "../src/reversi-view.vala"
							_tmp6_ = self->priv->tile_xs;
#line 554 "../src/reversi-view.vala"
							_tmp6__length1 = self->priv->tile_xs_length1;
#line 554 "../src/reversi-view.vala"
							_tmp6__length2 = self->priv->tile_xs_length2;
#line 554 "../src/reversi-view.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 554 "../src/reversi-view.vala"
							_tmp8_ = self->priv->tile_ys;
#line 554 "../src/reversi-view.vala"
							_tmp8__length1 = self->priv->tile_ys_length1;
#line 554 "../src/reversi-view.vala"
							_tmp8__length2 = self->priv->tile_ys_length2;
#line 554 "../src/reversi-view.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 554 "../src/reversi-view.vala"
							reversi_view_draw_playable (self, cr, _tmp5_, _tmp7_, _tmp9_);
#line 3028 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_draw_playable (ReversiView* self,
                            cairo_t* cr,
                            gint pixmap,
                            gint tile_x,
                            gint tile_y)
{
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	cairo_pattern_t* _tmp2_;
#line 556 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 558 "../src/reversi-view.vala"
	if (pixmap == 0) {
#line 559 "../src/reversi-view.vala"
		return;
#line 3056 "reversi-view.c"
	}
#line 561 "../src/reversi-view.vala"
	cairo_matrix_init_identity (&matrix);
#line 562 "../src/reversi-view.vala"
	cairo_matrix_translate (&matrix, (gdouble) (((pixmap % 8) * self->priv->tile_size) - tile_x), (gdouble) (((pixmap / 8) * self->priv->tile_size) - tile_y));
#line 564 "../src/reversi-view.vala"
	_tmp0_ = self->priv->tiles_pattern;
#line 564 "../src/reversi-view.vala"
	_tmp1_ = matrix;
#line 564 "../src/reversi-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp0_, &_tmp1_);
#line 565 "../src/reversi-view.vala"
	_tmp2_ = self->priv->tiles_pattern;
#line 565 "../src/reversi-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp2_);
#line 566 "../src/reversi-view.vala"
	cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
#line 570 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3076 "reversi-view.c"
}

static inline void
reversi_view_draw_overture_playables (ReversiView* self,
                                      cairo_t* cr)
{
	gboolean even_board = FALSE;
	gint _tmp0_ = 0;
#line 579 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 579 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 581 "../src/reversi-view.vala"
	even_board = (self->priv->game_size % 2) == 0;
#line 582 "../src/reversi-view.vala"
	if (even_board) {
#line 582 "../src/reversi-view.vala"
		_tmp0_ = 4;
#line 3095 "reversi-view.c"
	} else {
#line 582 "../src/reversi-view.vala"
		_tmp0_ = 6;
#line 3099 "reversi-view.c"
	}
#line 582 "../src/reversi-view.vala"
	if (((gint) self->priv->current_overture_playable) < _tmp0_) {
#line 583 "../src/reversi-view.vala"
		reversi_view_draw_overture_indicator (self, cr);
#line 3105 "reversi-view.c"
	}
	{
		guint8 i = 0U;
#line 585 "../src/reversi-view.vala"
		i = (guint8) 0;
#line 3111 "reversi-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 585 "../src/reversi-view.vala"
			_tmp1_ = TRUE;
#line 585 "../src/reversi-view.vala"
			while (TRUE) {
#line 3118 "reversi-view.c"
				gint _tmp3_ = 0;
#line 585 "../src/reversi-view.vala"
				if (!_tmp1_) {
#line 3122 "reversi-view.c"
					guint8 _tmp2_;
#line 585 "../src/reversi-view.vala"
					_tmp2_ = i;
#line 585 "../src/reversi-view.vala"
					i = _tmp2_ + 1;
#line 3128 "reversi-view.c"
				}
#line 585 "../src/reversi-view.vala"
				_tmp1_ = FALSE;
#line 585 "../src/reversi-view.vala"
				if (even_board) {
#line 585 "../src/reversi-view.vala"
					_tmp3_ = 4;
#line 3136 "reversi-view.c"
				} else {
#line 585 "../src/reversi-view.vala"
					_tmp3_ = 6;
#line 3140 "reversi-view.c"
				}
#line 585 "../src/reversi-view.vala"
				if (!(((gint) i) < _tmp3_)) {
#line 585 "../src/reversi-view.vala"
					break;
#line 3146 "reversi-view.c"
				}
#line 586 "../src/reversi-view.vala"
				reversi_view_draw_overture_playable (self, cr, i);
#line 3150 "reversi-view.c"
			}
		}
	}
#line 588 "../src/reversi-view.vala"
	if (!even_board) {
#line 3156 "reversi-view.c"
		guint8 half_game_size = 0U;
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp7_;
		gint* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		gint _tmp9_;
#line 590 "../src/reversi-view.vala"
		half_game_size = (guint8) (self->priv->game_size / 2);
#line 591 "../src/reversi-view.vala"
		_tmp4_ = self->priv->pixmaps;
#line 591 "../src/reversi-view.vala"
		_tmp4__length1 = self->priv->pixmaps_length1;
#line 591 "../src/reversi-view.vala"
		_tmp4__length2 = self->priv->pixmaps_length2;
#line 591 "../src/reversi-view.vala"
		_tmp5_ = _tmp4_[(half_game_size * _tmp4__length2) + half_game_size];
#line 591 "../src/reversi-view.vala"
		_tmp6_ = self->priv->tile_xs;
#line 591 "../src/reversi-view.vala"
		_tmp6__length1 = self->priv->tile_xs_length1;
#line 591 "../src/reversi-view.vala"
		_tmp6__length2 = self->priv->tile_xs_length2;
#line 591 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_[(half_game_size * _tmp6__length2) + half_game_size];
#line 591 "../src/reversi-view.vala"
		_tmp8_ = self->priv->tile_ys;
#line 591 "../src/reversi-view.vala"
		_tmp8__length1 = self->priv->tile_ys_length1;
#line 591 "../src/reversi-view.vala"
		_tmp8__length2 = self->priv->tile_ys_length2;
#line 591 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_[(half_game_size * _tmp8__length2) + half_game_size];
#line 591 "../src/reversi-view.vala"
		reversi_view_draw_playable (self, cr, _tmp5_, _tmp7_, _tmp9_);
#line 3198 "reversi-view.c"
	}
}

static inline void
reversi_view_draw_overture_indicator (ReversiView* self,
                                      cairo_t* cr)
{
	gdouble _tmp0_ = 0.0;
	gdouble diameter_factor = 0.0;
	ThemeManager* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	ThemeManager* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	ThemeManager* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp11_;
#line 596 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 596 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 598 "../src/reversi-view.vala"
	if (((gint) self->priv->game_size) == 4) {
#line 598 "../src/reversi-view.vala"
		_tmp0_ = 1.95;
#line 3228 "reversi-view.c"
	} else {
#line 598 "../src/reversi-view.vala"
		_tmp0_ = 1.8;
#line 3232 "reversi-view.c"
	}
#line 598 "../src/reversi-view.vala"
	diameter_factor = _tmp0_;
#line 599 "../src/reversi-view.vala"
	_tmp1_ = self->priv->_theme_manager;
#line 599 "../src/reversi-view.vala"
	_tmp2_ = theme_manager_get_background_red (_tmp1_);
#line 599 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 599 "../src/reversi-view.vala"
	_tmp4_ = self->priv->_theme_manager;
#line 599 "../src/reversi-view.vala"
	_tmp5_ = theme_manager_get_background_green (_tmp4_);
#line 599 "../src/reversi-view.vala"
	_tmp6_ = _tmp5_;
#line 599 "../src/reversi-view.vala"
	_tmp7_ = self->priv->_theme_manager;
#line 599 "../src/reversi-view.vala"
	_tmp8_ = theme_manager_get_background_blue (_tmp7_);
#line 599 "../src/reversi-view.vala"
	_tmp9_ = _tmp8_;
#line 599 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, _tmp3_, _tmp6_, _tmp9_, 1.0);
#line 600 "../src/reversi-view.vala"
	_tmp10_ = self->priv->overture_origin_xs;
#line 600 "../src/reversi-view.vala"
	_tmp10__length1 = self->priv->overture_origin_xs_length1;
#line 600 "../src/reversi-view.vala"
	_tmp11_ = _tmp10_[self->priv->current_overture_playable];
#line 600 "../src/reversi-view.vala"
	cairo_arc (cr, ((gdouble) _tmp11_) + (((gdouble) self->priv->tile_size) / 2.0), ((gdouble) self->priv->overture_origin_y) + (((gdouble) self->priv->tile_size) / 2.0), ((gdouble) self->priv->tile_size) / diameter_factor, 0.0, G_PI * 2.0);
#line 605 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3266 "reversi-view.c"
}

static inline void
reversi_view_draw_overture_playable (ReversiView* self,
                                     cairo_t* cr,
                                     guint8 playable_id)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8 _tmp1_;
	gint tile_x = 0;
	gint* _tmp10_;
	gint _tmp10__length1;
	gint _tmp11_;
	gint tile_y = 0;
	guint8* _tmp12_;
	gint _tmp12__length1;
	guint8 _tmp13_;
#line 607 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 607 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 609 "../src/reversi-view.vala"
	_tmp0_ = self->priv->overture_steps;
#line 609 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->overture_steps_length1;
#line 609 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_[playable_id];
#line 609 "../src/reversi-view.vala"
	if (_tmp1_ == REVERSI_VIEW_OVERTURE_STEPS_MAX) {
#line 3297 "reversi-view.c"
		guint8 x = 0U;
		guint8 y = 0U;
		guint8 _tmp2_ = 0U;
		guint8 _tmp3_ = 0U;
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp7_;
		gint* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		gint _tmp9_;
#line 612 "../src/reversi-view.vala"
		reversi_view_get_x_and_y (self, playable_id, &_tmp2_, &_tmp3_);
#line 612 "../src/reversi-view.vala"
		x = _tmp2_;
#line 612 "../src/reversi-view.vala"
		y = _tmp3_;
#line 613 "../src/reversi-view.vala"
		_tmp4_ = self->priv->pixmaps;
#line 613 "../src/reversi-view.vala"
		_tmp4__length1 = self->priv->pixmaps_length1;
#line 613 "../src/reversi-view.vala"
		_tmp4__length2 = self->priv->pixmaps_length2;
#line 613 "../src/reversi-view.vala"
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 613 "../src/reversi-view.vala"
		_tmp6_ = self->priv->tile_xs;
#line 613 "../src/reversi-view.vala"
		_tmp6__length1 = self->priv->tile_xs_length1;
#line 613 "../src/reversi-view.vala"
		_tmp6__length2 = self->priv->tile_xs_length2;
#line 613 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 613 "../src/reversi-view.vala"
		_tmp8_ = self->priv->tile_ys;
#line 613 "../src/reversi-view.vala"
		_tmp8__length1 = self->priv->tile_ys_length1;
#line 613 "../src/reversi-view.vala"
		_tmp8__length2 = self->priv->tile_ys_length2;
#line 613 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 613 "../src/reversi-view.vala"
		reversi_view_draw_playable (self, cr, _tmp5_, _tmp7_, _tmp9_);
#line 614 "../src/reversi-view.vala"
		return;
#line 3348 "reversi-view.c"
	}
#line 617 "../src/reversi-view.vala"
	_tmp10_ = self->priv->overture_origin_xs;
#line 617 "../src/reversi-view.vala"
	_tmp10__length1 = self->priv->overture_origin_xs_length1;
#line 617 "../src/reversi-view.vala"
	_tmp11_ = _tmp10_[playable_id];
#line 617 "../src/reversi-view.vala"
	tile_x = _tmp11_;
#line 618 "../src/reversi-view.vala"
	tile_y = self->priv->overture_origin_y;
#line 620 "../src/reversi-view.vala"
	_tmp12_ = self->priv->overture_target;
#line 620 "../src/reversi-view.vala"
	_tmp12__length1 = self->priv->overture_target_length1;
#line 620 "../src/reversi-view.vala"
	_tmp13_ = _tmp12_[playable_id];
#line 620 "../src/reversi-view.vala"
	if (((gint) _tmp13_) != 0) {
#line 3368 "reversi-view.c"
		guint8 x = 0U;
		guint8 y = 0U;
		guint8 _tmp14_ = 0U;
		guint8 _tmp15_ = 0U;
		gint* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		gint _tmp17_;
		guint8* _tmp18_;
		gint _tmp18__length1;
		guint8 _tmp19_;
		gint* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		gint _tmp21_;
		guint8* _tmp22_;
		gint _tmp22__length1;
		guint8 _tmp23_;
		guint8* _tmp24_;
		gint _tmp24__length1;
		guint8 _tmp25_;
		guint8 _tmp26_;
#line 623 "../src/reversi-view.vala"
		reversi_view_get_x_and_y (self, playable_id, &_tmp14_, &_tmp15_);
#line 623 "../src/reversi-view.vala"
		x = _tmp14_;
#line 623 "../src/reversi-view.vala"
		y = _tmp15_;
#line 624 "../src/reversi-view.vala"
		_tmp16_ = self->priv->tile_xs;
#line 624 "../src/reversi-view.vala"
		_tmp16__length1 = self->priv->tile_xs_length1;
#line 624 "../src/reversi-view.vala"
		_tmp16__length2 = self->priv->tile_xs_length2;
#line 624 "../src/reversi-view.vala"
		_tmp17_ = _tmp16_[(x * _tmp16__length2) + y];
#line 624 "../src/reversi-view.vala"
		_tmp18_ = self->priv->overture_steps;
#line 624 "../src/reversi-view.vala"
		_tmp18__length1 = self->priv->overture_steps_length1;
#line 624 "../src/reversi-view.vala"
		_tmp19_ = _tmp18_[playable_id];
#line 624 "../src/reversi-view.vala"
		tile_x += ((_tmp17_ - tile_x) * _tmp19_) / REVERSI_VIEW_OVERTURE_STEPS_MAX;
#line 625 "../src/reversi-view.vala"
		_tmp20_ = self->priv->tile_ys;
#line 625 "../src/reversi-view.vala"
		_tmp20__length1 = self->priv->tile_ys_length1;
#line 625 "../src/reversi-view.vala"
		_tmp20__length2 = self->priv->tile_ys_length2;
#line 625 "../src/reversi-view.vala"
		_tmp21_ = _tmp20_[(x * _tmp20__length2) + y];
#line 625 "../src/reversi-view.vala"
		_tmp22_ = self->priv->overture_steps;
#line 625 "../src/reversi-view.vala"
		_tmp22__length1 = self->priv->overture_steps_length1;
#line 625 "../src/reversi-view.vala"
		_tmp23_ = _tmp22_[playable_id];
#line 625 "../src/reversi-view.vala"
		tile_y += ((_tmp21_ - tile_y) * _tmp23_) / REVERSI_VIEW_OVERTURE_STEPS_MAX;
#line 627 "../src/reversi-view.vala"
		_tmp24_ = self->priv->overture_steps;
#line 627 "../src/reversi-view.vala"
		_tmp24__length1 = self->priv->overture_steps_length1;
#line 627 "../src/reversi-view.vala"
		_tmp25_ = playable_id;
#line 627 "../src/reversi-view.vala"
		_tmp26_ = _tmp24_[_tmp25_];
#line 627 "../src/reversi-view.vala"
		_tmp24_[_tmp25_] = _tmp26_ + 1;
#line 628 "../src/reversi-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 3441 "reversi-view.c"
	}
#line 630 "../src/reversi-view.vala"
	if ((self->priv->game_size % 2) == 0) {
#line 631 "../src/reversi-view.vala"
		_reversi_view_draw_overture_playable (self, cr, tile_x, tile_y, ((playable_id % 2) * 30) + 1);
#line 3447 "reversi-view.c"
	} else {
#line 633 "../src/reversi-view.vala"
		_reversi_view_draw_overture_playable (self, cr, tile_x, tile_y, ((((playable_id / 2) + 1) % 2) * 30) + 1);
#line 3451 "reversi-view.c"
	}
}

static void
_reversi_view_draw_overture_playable (ReversiView* self,
                                      cairo_t* cr,
                                      gint tile_x,
                                      gint tile_y,
                                      gint pixmap)
{
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp0_;
	cairo_matrix_t _tmp1_;
	cairo_pattern_t* _tmp2_;
#line 635 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 635 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 637 "../src/reversi-view.vala"
	cairo_matrix_init_identity (&matrix);
#line 638 "../src/reversi-view.vala"
	cairo_matrix_translate (&matrix, (gdouble) (((pixmap % 8) * self->priv->tile_size) - tile_x), (gdouble) (((pixmap / 8) * self->priv->tile_size) - tile_y));
#line 640 "../src/reversi-view.vala"
	_tmp0_ = self->priv->tiles_pattern;
#line 640 "../src/reversi-view.vala"
	_tmp1_ = matrix;
#line 640 "../src/reversi-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp0_, &_tmp1_);
#line 641 "../src/reversi-view.vala"
	_tmp2_ = self->priv->tiles_pattern;
#line 641 "../src/reversi-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp2_);
#line 642 "../src/reversi-view.vala"
	cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
#line 646 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3488 "reversi-view.c"
}

static void
reversi_view_get_x_and_y (ReversiView* self,
                          guint8 playable_id,
                          guint8* x,
                          guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	guint8 half_game_size = 0U;
#line 648 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 650 "../src/reversi-view.vala"
	half_game_size = (guint8) (self->priv->game_size / 2);
#line 651 "../src/reversi-view.vala"
	if ((self->priv->game_size % 2) == 0) {
#line 3506 "reversi-view.c"
		guint8* _tmp0_;
		gint _tmp0__length1;
		guint8 _tmp1_;
#line 652 "../src/reversi-view.vala"
		_tmp0_ = self->priv->overture_target;
#line 652 "../src/reversi-view.vala"
		_tmp0__length1 = self->priv->overture_target_length1;
#line 652 "../src/reversi-view.vala"
		_tmp1_ = _tmp0_[playable_id];
#line 652 "../src/reversi-view.vala"
		switch (_tmp1_) {
#line 652 "../src/reversi-view.vala"
			case 1:
#line 3520 "reversi-view.c"
			{
#line 654 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size - 1);
#line 654 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size - 1);
#line 654 "../src/reversi-view.vala"
				break;
#line 3528 "reversi-view.c"
			}
#line 652 "../src/reversi-view.vala"
			case 2:
#line 3532 "reversi-view.c"
			{
#line 655 "../src/reversi-view.vala"
				_vala_x = half_game_size;
#line 655 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size - 1);
#line 655 "../src/reversi-view.vala"
				break;
#line 3540 "reversi-view.c"
			}
#line 652 "../src/reversi-view.vala"
			case 3:
#line 3544 "reversi-view.c"
			{
#line 656 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size - 1);
#line 656 "../src/reversi-view.vala"
				_vala_y = half_game_size;
#line 656 "../src/reversi-view.vala"
				break;
#line 3552 "reversi-view.c"
			}
#line 652 "../src/reversi-view.vala"
			case 4:
#line 3556 "reversi-view.c"
			{
#line 657 "../src/reversi-view.vala"
				_vala_x = half_game_size;
#line 657 "../src/reversi-view.vala"
				_vala_y = half_game_size;
#line 657 "../src/reversi-view.vala"
				break;
#line 3564 "reversi-view.c"
			}
			default:
			{
#line 658 "../src/reversi-view.vala"
				g_assert_not_reached ();
#line 3570 "reversi-view.c"
			}
		}
	} else {
		guint8* _tmp2_;
		gint _tmp2__length1;
		guint8 _tmp3_;
#line 661 "../src/reversi-view.vala"
		_tmp2_ = self->priv->overture_target;
#line 661 "../src/reversi-view.vala"
		_tmp2__length1 = self->priv->overture_target_length1;
#line 661 "../src/reversi-view.vala"
		_tmp3_ = _tmp2_[playable_id];
#line 661 "../src/reversi-view.vala"
		switch (_tmp3_) {
#line 661 "../src/reversi-view.vala"
			case 1:
#line 3587 "reversi-view.c"
			{
#line 663 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size - 1);
#line 663 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size - 1);
#line 663 "../src/reversi-view.vala"
				break;
#line 3595 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 2:
#line 3599 "reversi-view.c"
			{
#line 664 "../src/reversi-view.vala"
				_vala_x = half_game_size;
#line 664 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size - 1);
#line 664 "../src/reversi-view.vala"
				break;
#line 3607 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 3:
#line 3611 "reversi-view.c"
			{
#line 665 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size + 1);
#line 665 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size - 1);
#line 665 "../src/reversi-view.vala"
				break;
#line 3619 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 4:
#line 3623 "reversi-view.c"
			{
#line 666 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size - 1);
#line 666 "../src/reversi-view.vala"
				_vala_y = half_game_size;
#line 666 "../src/reversi-view.vala"
				break;
#line 3631 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 6:
#line 3635 "reversi-view.c"
			{
#line 667 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size + 1);
#line 667 "../src/reversi-view.vala"
				_vala_y = half_game_size;
#line 667 "../src/reversi-view.vala"
				break;
#line 3643 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 7:
#line 3647 "reversi-view.c"
			{
#line 668 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size - 1);
#line 668 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size + 1);
#line 668 "../src/reversi-view.vala"
				break;
#line 3655 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 8:
#line 3659 "reversi-view.c"
			{
#line 669 "../src/reversi-view.vala"
				_vala_x = half_game_size;
#line 669 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size + 1);
#line 669 "../src/reversi-view.vala"
				break;
#line 3667 "reversi-view.c"
			}
#line 661 "../src/reversi-view.vala"
			case 9:
#line 3671 "reversi-view.c"
			{
#line 670 "../src/reversi-view.vala"
				_vala_x = (guint8) (half_game_size + 1);
#line 670 "../src/reversi-view.vala"
				_vala_y = (guint8) (half_game_size + 1);
#line 670 "../src/reversi-view.vala"
				break;
#line 3679 "reversi-view.c"
			}
			default:
			{
#line 671 "../src/reversi-view.vala"
				g_assert_not_reached ();
#line 3685 "reversi-view.c"
			}
		}
	}
#line 648 "../src/reversi-view.vala"
	if (x) {
#line 648 "../src/reversi-view.vala"
		*x = _vala_x;
#line 3693 "reversi-view.c"
	}
#line 648 "../src/reversi-view.vala"
	if (y) {
#line 648 "../src/reversi-view.vala"
		*y = _vala_y;
#line 3699 "reversi-view.c"
	}
}

static void
reversi_view_rounded_square (ReversiView* self,
                             cairo_t* cr,
                             gdouble x,
                             gdouble y,
                             gint size,
                             gdouble width,
                             gdouble radius_percent)
{
	gdouble radius_border = 0.0;
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 680 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 680 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 682 "../src/reversi-view.vala"
	if (radius_percent <= 0.0) {
#line 684 "../src/reversi-view.vala"
		cairo_rectangle (cr, x + (width / 2.0), y + (width / 2.0), size + width, size + width);
#line 688 "../src/reversi-view.vala"
		return;
#line 3728 "reversi-view.c"
	}
#line 691 "../src/reversi-view.vala"
	if (radius_percent > 50.0) {
#line 692 "../src/reversi-view.vala"
		radius_percent = 50.0;
#line 3734 "reversi-view.c"
	}
#line 693 "../src/reversi-view.vala"
	radius_border = (radius_percent * size) / 100.0;
#line 694 "../src/reversi-view.vala"
	radius_arc = radius_border - (width / 2.0);
#line 695 "../src/reversi-view.vala"
	x1 = x + radius_border;
#line 696 "../src/reversi-view.vala"
	y1 = y + radius_border;
#line 697 "../src/reversi-view.vala"
	x2 = (x + size) - radius_border;
#line 698 "../src/reversi-view.vala"
	y2 = (y + size) - radius_border;
#line 700 "../src/reversi-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -REVERSI_VIEW_HALF_PI);
#line 701 "../src/reversi-view.vala"
	cairo_arc (cr, x2, y1, radius_arc, -REVERSI_VIEW_HALF_PI, 0.0);
#line 702 "../src/reversi-view.vala"
	cairo_arc (cr, x2, y2, radius_arc, 0.0, REVERSI_VIEW_HALF_PI);
#line 703 "../src/reversi-view.vala"
	cairo_arc (cr, x1, y2, radius_arc, REVERSI_VIEW_HALF_PI, G_PI);
#line 704 "../src/reversi-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -REVERSI_VIEW_HALF_PI);
#line 3758 "reversi-view.c"
}

static void
reversi_view_highlight_tile (ReversiView* self,
                             cairo_t* cr,
                             guint8 x,
                             guint8 y,
                             guint8 intensity,
                             gboolean soft_highlight)
{
	gint* _tmp24_;
	gint _tmp24__length1;
	gint _tmp24__length2;
	gint _tmp25_;
	gint* _tmp26_;
	gint _tmp26__length1;
	gint _tmp26__length2;
	gint _tmp27_;
	ThemeManager* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
#line 707 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 707 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 709 "../src/reversi-view.vala"
	if (soft_highlight) {
#line 3786 "reversi-view.c"
		ThemeManager* _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
		ThemeManager* _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		ThemeManager* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		ThemeManager* _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 710 "../src/reversi-view.vala"
		_tmp0_ = self->priv->_theme_manager;
#line 710 "../src/reversi-view.vala"
		_tmp1_ = theme_manager_get_highlight_soft_red (_tmp0_);
#line 710 "../src/reversi-view.vala"
		_tmp2_ = _tmp1_;
#line 710 "../src/reversi-view.vala"
		_tmp3_ = self->priv->_theme_manager;
#line 710 "../src/reversi-view.vala"
		_tmp4_ = theme_manager_get_highlight_soft_green (_tmp3_);
#line 710 "../src/reversi-view.vala"
		_tmp5_ = _tmp4_;
#line 710 "../src/reversi-view.vala"
		_tmp6_ = self->priv->_theme_manager;
#line 710 "../src/reversi-view.vala"
		_tmp7_ = theme_manager_get_highlight_soft_blue (_tmp6_);
#line 710 "../src/reversi-view.vala"
		_tmp8_ = _tmp7_;
#line 710 "../src/reversi-view.vala"
		_tmp9_ = self->priv->_theme_manager;
#line 710 "../src/reversi-view.vala"
		_tmp10_ = theme_manager_get_highlight_soft_alpha (_tmp9_);
#line 710 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 710 "../src/reversi-view.vala"
		cairo_set_source_rgba (cr, _tmp2_, _tmp5_, _tmp8_, _tmp11_);
#line 3825 "reversi-view.c"
	} else {
		ThemeManager* _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		ThemeManager* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		ThemeManager* _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		ThemeManager* _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
#line 715 "../src/reversi-view.vala"
		_tmp12_ = self->priv->_theme_manager;
#line 715 "../src/reversi-view.vala"
		_tmp13_ = theme_manager_get_highlight_hard_red (_tmp12_);
#line 715 "../src/reversi-view.vala"
		_tmp14_ = _tmp13_;
#line 715 "../src/reversi-view.vala"
		_tmp15_ = self->priv->_theme_manager;
#line 715 "../src/reversi-view.vala"
		_tmp16_ = theme_manager_get_highlight_hard_green (_tmp15_);
#line 715 "../src/reversi-view.vala"
		_tmp17_ = _tmp16_;
#line 715 "../src/reversi-view.vala"
		_tmp18_ = self->priv->_theme_manager;
#line 715 "../src/reversi-view.vala"
		_tmp19_ = theme_manager_get_highlight_hard_blue (_tmp18_);
#line 715 "../src/reversi-view.vala"
		_tmp20_ = _tmp19_;
#line 715 "../src/reversi-view.vala"
		_tmp21_ = self->priv->_theme_manager;
#line 715 "../src/reversi-view.vala"
		_tmp22_ = theme_manager_get_highlight_hard_alpha (_tmp21_);
#line 715 "../src/reversi-view.vala"
		_tmp23_ = _tmp22_;
#line 715 "../src/reversi-view.vala"
		cairo_set_source_rgba (cr, _tmp14_, _tmp17_, _tmp20_, _tmp23_);
#line 3865 "reversi-view.c"
	}
#line 719 "../src/reversi-view.vala"
	_tmp24_ = self->priv->tile_xs;
#line 719 "../src/reversi-view.vala"
	_tmp24__length1 = self->priv->tile_xs_length1;
#line 719 "../src/reversi-view.vala"
	_tmp24__length2 = self->priv->tile_xs_length2;
#line 719 "../src/reversi-view.vala"
	_tmp25_ = _tmp24_[(x * _tmp24__length2) + y];
#line 719 "../src/reversi-view.vala"
	_tmp26_ = self->priv->tile_ys;
#line 719 "../src/reversi-view.vala"
	_tmp26__length1 = self->priv->tile_ys_length1;
#line 719 "../src/reversi-view.vala"
	_tmp26__length2 = self->priv->tile_ys_length2;
#line 719 "../src/reversi-view.vala"
	_tmp27_ = _tmp26_[(x * _tmp26__length2) + y];
#line 719 "../src/reversi-view.vala"
	_tmp28_ = self->priv->_theme_manager;
#line 719 "../src/reversi-view.vala"
	_tmp29_ = theme_manager_get_background_radius (_tmp28_);
#line 719 "../src/reversi-view.vala"
	_tmp30_ = _tmp29_;
#line 719 "../src/reversi-view.vala"
	reversi_view_rounded_square (self, cr, (gdouble) (_tmp25_ + ((self->priv->tile_size * (REVERSI_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * REVERSI_VIEW_HIGHLIGHT_MAX))), (gdouble) (_tmp27_ + ((self->priv->tile_size * (REVERSI_VIEW_HIGHLIGHT_MAX - intensity)) / (2 * REVERSI_VIEW_HIGHLIGHT_MAX))), (self->priv->tile_size * intensity) / REVERSI_VIEW_HIGHLIGHT_MAX, (gdouble) 0, (gdouble) _tmp30_);
#line 726 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3893 "reversi-view.c"
}

static void
reversi_view_darken_tile (ReversiView* self,
                          cairo_t* cr,
                          guint8 x,
                          guint8 y)
{
	gdouble alpha = 0.0;
	ThemeManager* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	ThemeManager* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	ThemeManager* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	ThemeManager* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint _tmp13_;
	gint* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	gint _tmp15_;
	ThemeManager* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
#line 729 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 729 "../src/reversi-view.vala"
	g_return_if_fail (cr != NULL);
#line 731 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 731 "../src/reversi-view.vala"
	_tmp1_ = theme_manager_get_highlight_hard_alpha (_tmp0_);
#line 731 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 731 "../src/reversi-view.vala"
	alpha = ((_tmp2_ * 1.6) * ((gdouble) self->priv->humans_opening_intensity)) / ((gdouble) REVERSI_VIEW_HUMANS_OPENING_INTENSITY_MAX);
#line 732 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_theme_manager;
#line 732 "../src/reversi-view.vala"
	_tmp4_ = theme_manager_get_highlight_hard_red (_tmp3_);
#line 732 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 732 "../src/reversi-view.vala"
	_tmp6_ = self->priv->_theme_manager;
#line 732 "../src/reversi-view.vala"
	_tmp7_ = theme_manager_get_highlight_hard_green (_tmp6_);
#line 732 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 732 "../src/reversi-view.vala"
	_tmp9_ = self->priv->_theme_manager;
#line 732 "../src/reversi-view.vala"
	_tmp10_ = theme_manager_get_highlight_hard_blue (_tmp9_);
#line 732 "../src/reversi-view.vala"
	_tmp11_ = _tmp10_;
#line 732 "../src/reversi-view.vala"
	cairo_set_source_rgba (cr, _tmp5_, _tmp8_, _tmp11_, alpha);
#line 736 "../src/reversi-view.vala"
	_tmp12_ = self->priv->tile_xs;
#line 736 "../src/reversi-view.vala"
	_tmp12__length1 = self->priv->tile_xs_length1;
#line 736 "../src/reversi-view.vala"
	_tmp12__length2 = self->priv->tile_xs_length2;
#line 736 "../src/reversi-view.vala"
	_tmp13_ = _tmp12_[(x * _tmp12__length2) + y];
#line 736 "../src/reversi-view.vala"
	_tmp14_ = self->priv->tile_ys;
#line 736 "../src/reversi-view.vala"
	_tmp14__length1 = self->priv->tile_ys_length1;
#line 736 "../src/reversi-view.vala"
	_tmp14__length2 = self->priv->tile_ys_length2;
#line 736 "../src/reversi-view.vala"
	_tmp15_ = _tmp14_[(x * _tmp14__length2) + y];
#line 736 "../src/reversi-view.vala"
	_tmp16_ = self->priv->_theme_manager;
#line 736 "../src/reversi-view.vala"
	_tmp17_ = theme_manager_get_background_radius (_tmp16_);
#line 736 "../src/reversi-view.vala"
	_tmp18_ = _tmp17_;
#line 736 "../src/reversi-view.vala"
	reversi_view_rounded_square (self, cr, (gdouble) _tmp13_, (gdouble) _tmp15_, self->priv->tile_size, (gdouble) 0, (gdouble) _tmp18_);
#line 743 "../src/reversi-view.vala"
	cairo_fill (cr);
#line 3984 "reversi-view.c"
}

static void
reversi_view_queue_draw_tile (ReversiView* self,
                              guint8 x,
                              guint8 y)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
#line 746 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 746 "../src/reversi-view.vala"
	_vala_return_if_fail (x < self->priv->game_size, "x < game_size");
#line 746 "../src/reversi-view.vala"
	_vala_return_if_fail (y < self->priv->game_size, "y < game_size");
#line 750 "../src/reversi-view.vala"
	_tmp0_ = self->priv->tile_xs;
#line 750 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->tile_xs_length1;
#line 750 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->tile_xs_length2;
#line 750 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 750 "../src/reversi-view.vala"
	_tmp2_ = self->priv->tile_ys;
#line 750 "../src/reversi-view.vala"
	_tmp2__length1 = self->priv->tile_ys_length1;
#line 750 "../src/reversi-view.vala"
	_tmp2__length2 = self->priv->tile_ys_length2;
#line 750 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 750 "../src/reversi-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, self->priv->board_x + _tmp1_, self->priv->board_y + _tmp3_, self->priv->tile_size, self->priv->tile_size);
#line 4024 "reversi-view.c"
}

static inline void
reversi_view_update_highlight_after_undo (ReversiView* self)
{
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp16_;
	gboolean _tmp17_;
#line 763 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 763 "../src/reversi-view.vala"
	_vala_return_if_fail (self->priv->last_state_set, "last_state_set");
#line 769 "../src/reversi-view.vala"
	reversi_view_get_missing_tile (self, &_tmp0_, &_tmp1_);
#line 769 "../src/reversi-view.vala"
	x = _tmp0_;
#line 769 "../src/reversi-view.vala"
	y = _tmp1_;
#line 772 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 772 "../src/reversi-view.vala"
		_tmp3_ = TRUE;
#line 4052 "reversi-view.c"
	} else {
#line 772 "../src/reversi-view.vala"
		_tmp3_ = self->priv->show_mouse_highlight;
#line 4056 "reversi-view.c"
	}
#line 772 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 772 "../src/reversi-view.vala"
		_tmp2_ = TRUE;
#line 4062 "reversi-view.c"
	} else {
#line 772 "../src/reversi-view.vala"
		_tmp2_ = ((gint) self->priv->highlight_state) != 0;
#line 4066 "reversi-view.c"
	}
#line 772 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 4070 "reversi-view.c"
		Game* _tmp8_;
		Game* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 774 "../src/reversi-view.vala"
		self->priv->highlight_state = (guint8) 0;
#line 775 "../src/reversi-view.vala"
		if (self->priv->show_highlight) {
#line 4079 "reversi-view.c"
			Game* _tmp4_;
			Game* _tmp5_;
#line 776 "../src/reversi-view.vala"
			_tmp4_ = reversi_view_get_game (self);
#line 776 "../src/reversi-view.vala"
			_tmp5_ = _tmp4_;
#line 776 "../src/reversi-view.vala"
			reversi_view_set_square (self, self->priv->highlight_x, self->priv->highlight_y, reversi_view_get_pixmap (game_get_owner (_tmp5_, self->priv->highlight_x, self->priv->highlight_y)), FALSE, TRUE);
#line 4088 "reversi-view.c"
		}
#line 781 "../src/reversi-view.vala"
		if (self->priv->show_mouse_highlight) {
#line 4092 "reversi-view.c"
			Game* _tmp6_;
			Game* _tmp7_;
#line 782 "../src/reversi-view.vala"
			_tmp6_ = reversi_view_get_game (self);
#line 782 "../src/reversi-view.vala"
			_tmp7_ = _tmp6_;
#line 782 "../src/reversi-view.vala"
			reversi_view_set_square (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y, reversi_view_get_pixmap (game_get_owner (_tmp7_, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y)), FALSE, TRUE);
#line 4101 "reversi-view.c"
		}
#line 788 "../src/reversi-view.vala"
		_tmp8_ = reversi_view_get_game (self);
#line 788 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_;
#line 788 "../src/reversi-view.vala"
		_tmp10_ = game_get_is_complete (_tmp9_);
#line 788 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 788 "../src/reversi-view.vala"
		if (!_tmp11_) {
#line 4113 "reversi-view.c"
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 790 "../src/reversi-view.vala"
			if (self->priv->show_highlight) {
#line 791 "../src/reversi-view.vala"
				_tmp13_ = x == self->priv->highlight_x;
#line 4120 "reversi-view.c"
			} else {
#line 790 "../src/reversi-view.vala"
				_tmp13_ = FALSE;
#line 4124 "reversi-view.c"
			}
#line 790 "../src/reversi-view.vala"
			if (_tmp13_) {
#line 792 "../src/reversi-view.vala"
				_tmp12_ = y == self->priv->highlight_y;
#line 4130 "reversi-view.c"
			} else {
#line 790 "../src/reversi-view.vala"
				_tmp12_ = FALSE;
#line 4134 "reversi-view.c"
			}
#line 790 "../src/reversi-view.vala"
			if (_tmp12_) {
#line 793 "../src/reversi-view.vala"
				self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
#line 4140 "reversi-view.c"
			} else {
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
#line 794 "../src/reversi-view.vala"
				if (self->priv->show_mouse_highlight) {
#line 795 "../src/reversi-view.vala"
					_tmp15_ = x == self->priv->mouse_highlight_x;
#line 4148 "reversi-view.c"
				} else {
#line 794 "../src/reversi-view.vala"
					_tmp15_ = FALSE;
#line 4152 "reversi-view.c"
				}
#line 794 "../src/reversi-view.vala"
				if (_tmp15_) {
#line 796 "../src/reversi-view.vala"
					_tmp14_ = y == self->priv->mouse_highlight_y;
#line 4158 "reversi-view.c"
				} else {
#line 794 "../src/reversi-view.vala"
					_tmp14_ = FALSE;
#line 4162 "reversi-view.c"
				}
#line 794 "../src/reversi-view.vala"
				if (_tmp14_) {
#line 797 "../src/reversi-view.vala"
					self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
#line 4168 "reversi-view.c"
				} else {
#line 799 "../src/reversi-view.vala"
					self->priv->highlight_state = (guint8) 1;
#line 4172 "reversi-view.c"
				}
			}
		}
	}
#line 804 "../src/reversi-view.vala"
	self->priv->highlight_set = TRUE;
#line 805 "../src/reversi-view.vala"
	self->priv->highlight_x = x;
#line 806 "../src/reversi-view.vala"
	self->priv->highlight_y = y;
#line 807 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = x;
#line 808 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = y;
#line 809 "../src/reversi-view.vala"
	if (!self->priv->mouse_is_in) {
#line 810 "../src/reversi-view.vala"
		self->priv->show_highlight = TRUE;
#line 4191 "reversi-view.c"
	} else {
#line 811 "../src/reversi-view.vala"
		if (!self->priv->show_highlight) {
#line 812 "../src/reversi-view.vala"
			self->priv->show_mouse_highlight = TRUE;
#line 4197 "reversi-view.c"
		}
	}
#line 815 "../src/reversi-view.vala"
	_tmp16_ = reversi_view_get_show_playable_tiles (self);
#line 815 "../src/reversi-view.vala"
	_tmp17_ = _tmp16_;
#line 815 "../src/reversi-view.vala"
	if (_tmp17_) {
#line 817 "../src/reversi-view.vala"
		reversi_view_init_possible_moves (self);
#line 818 "../src/reversi-view.vala"
		reversi_view_highlight_playable_tiles (self, TRUE);
#line 4210 "reversi-view.c"
	}
}

static void
reversi_view_get_missing_tile (ReversiView* self,
                               guint8* x,
                               guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
#line 821 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 823 "../src/reversi-view.vala"
	_vala_y = (guint8) 0;
#line 4225 "reversi-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 825 "../src/reversi-view.vala"
		_vala_x = (guint8) 0;
#line 825 "../src/reversi-view.vala"
		_tmp0_ = TRUE;
#line 825 "../src/reversi-view.vala"
		while (TRUE) {
#line 825 "../src/reversi-view.vala"
			if (!_tmp0_) {
#line 4236 "reversi-view.c"
				guint8 _tmp1_;
#line 825 "../src/reversi-view.vala"
				_tmp1_ = _vala_x;
#line 825 "../src/reversi-view.vala"
				_vala_x = _tmp1_ + 1;
#line 4242 "reversi-view.c"
			}
#line 825 "../src/reversi-view.vala"
			_tmp0_ = FALSE;
#line 825 "../src/reversi-view.vala"
			if (!(_vala_x < self->priv->game_size)) {
#line 825 "../src/reversi-view.vala"
				break;
#line 4250 "reversi-view.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 827 "../src/reversi-view.vala"
				_vala_y = (guint8) 0;
#line 827 "../src/reversi-view.vala"
				_tmp2_ = TRUE;
#line 827 "../src/reversi-view.vala"
				while (TRUE) {
#line 4260 "reversi-view.c"
					Game* _tmp4_;
					Game* _tmp5_;
					GameStateObject* _tmp6_;
					Game* _tmp7_;
					Game* _tmp8_;
					Player _tmp9_;
					Player _tmp10_;
#line 827 "../src/reversi-view.vala"
					if (!_tmp2_) {
#line 4270 "reversi-view.c"
						guint8 _tmp3_;
#line 827 "../src/reversi-view.vala"
						_tmp3_ = _vala_y;
#line 827 "../src/reversi-view.vala"
						_vala_y = _tmp3_ + 1;
#line 4276 "reversi-view.c"
					}
#line 827 "../src/reversi-view.vala"
					_tmp2_ = FALSE;
#line 827 "../src/reversi-view.vala"
					if (!(_vala_y < self->priv->game_size)) {
#line 827 "../src/reversi-view.vala"
						break;
#line 4284 "reversi-view.c"
					}
#line 829 "../src/reversi-view.vala"
					_tmp4_ = reversi_view_get_game (self);
#line 829 "../src/reversi-view.vala"
					_tmp5_ = _tmp4_;
#line 829 "../src/reversi-view.vala"
					if (game_get_owner (_tmp5_, _vala_x, _vala_y) != PLAYER_NONE) {
#line 830 "../src/reversi-view.vala"
						continue;
#line 4294 "reversi-view.c"
					}
#line 831 "../src/reversi-view.vala"
					_tmp6_ = self->priv->last_state;
#line 831 "../src/reversi-view.vala"
					_tmp7_ = reversi_view_get_game (self);
#line 831 "../src/reversi-view.vala"
					_tmp8_ = _tmp7_;
#line 831 "../src/reversi-view.vala"
					_tmp9_ = game_get_current_color (_tmp8_);
#line 831 "../src/reversi-view.vala"
					_tmp10_ = _tmp9_;
#line 831 "../src/reversi-view.vala"
					if (game_state_object_get_owner (_tmp6_, _vala_x, _vala_y) == _tmp10_) {
#line 832 "../src/reversi-view.vala"
						if (x) {
#line 832 "../src/reversi-view.vala"
							*x = _vala_x;
#line 4312 "reversi-view.c"
						}
#line 832 "../src/reversi-view.vala"
						if (y) {
#line 832 "../src/reversi-view.vala"
							*y = _vala_y;
#line 4318 "reversi-view.c"
						}
#line 832 "../src/reversi-view.vala"
						return;
#line 4322 "reversi-view.c"
					}
				}
			}
		}
	}
#line 835 "../src/reversi-view.vala"
	g_assert_not_reached ();
#line 4330 "reversi-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 896 "../src/reversi-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 4338 "reversi-view.c"
}

static void
reversi_view_turn_ended_cb (ReversiView* self,
                            gboolean undoing,
                            gboolean no_draw)
{
	Game* _tmp92_;
	Game* _tmp93_;
	GameStateObject* _tmp94_;
	GameStateObject* _tmp95_;
	GameStateObject* _tmp96_;
#line 838 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 840 "../src/reversi-view.vala"
	if (((gint) self->priv->humans_opening_intensity) != 0) {
#line 4355 "reversi-view.c"
		gboolean even_board = FALSE;
		guint8 half_game_size = 0U;
		guint8 target = 0U;
#line 842 "../src/reversi-view.vala"
		even_board = (self->priv->game_size % 2) == 0;
#line 843 "../src/reversi-view.vala"
		half_game_size = (guint8) (self->priv->game_size / 2);
#line 845 "../src/reversi-view.vala"
		if (even_board) {
#line 4365 "reversi-view.c"
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
			guint8* _tmp28_;
			gint _tmp28__length1;
			guint8 _tmp29_;
#line 847 "../src/reversi-view.vala"
			if (!self->priv->last_state_set) {
#line 847 "../src/reversi-view.vala"
				_tmp1_ = TRUE;
#line 4375 "reversi-view.c"
			} else {
				GameStateObject* _tmp2_;
#line 847 "../src/reversi-view.vala"
				_tmp2_ = self->priv->last_state;
#line 847 "../src/reversi-view.vala"
				_tmp1_ = game_state_object_get_owner (_tmp2_, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 4382 "reversi-view.c"
			}
#line 847 "../src/reversi-view.vala"
			if (_tmp1_) {
#line 4386 "reversi-view.c"
				Game* _tmp3_;
				Game* _tmp4_;
				GameStateObject* _tmp5_;
				GameStateObject* _tmp6_;
#line 848 "../src/reversi-view.vala"
				_tmp3_ = reversi_view_get_game (self);
#line 848 "../src/reversi-view.vala"
				_tmp4_ = _tmp3_;
#line 848 "../src/reversi-view.vala"
				_tmp5_ = game_get_current_state (_tmp4_);
#line 848 "../src/reversi-view.vala"
				_tmp6_ = _tmp5_;
#line 848 "../src/reversi-view.vala"
				_tmp0_ = game_state_object_get_owner (_tmp6_, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) != PLAYER_NONE;
#line 4401 "reversi-view.c"
			} else {
#line 847 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 4405 "reversi-view.c"
			}
#line 847 "../src/reversi-view.vala"
			if (_tmp0_) {
#line 848 "../src/reversi-view.vala"
				target = (guint8) 1;
#line 4411 "reversi-view.c"
			} else {
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
#line 849 "../src/reversi-view.vala"
				if (!self->priv->last_state_set) {
#line 849 "../src/reversi-view.vala"
					_tmp8_ = TRUE;
#line 4419 "reversi-view.c"
				} else {
					GameStateObject* _tmp9_;
#line 849 "../src/reversi-view.vala"
					_tmp9_ = self->priv->last_state;
#line 849 "../src/reversi-view.vala"
					_tmp8_ = game_state_object_get_owner (_tmp9_, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 4426 "reversi-view.c"
				}
#line 849 "../src/reversi-view.vala"
				if (_tmp8_) {
#line 4430 "reversi-view.c"
					Game* _tmp10_;
					Game* _tmp11_;
					GameStateObject* _tmp12_;
					GameStateObject* _tmp13_;
#line 850 "../src/reversi-view.vala"
					_tmp10_ = reversi_view_get_game (self);
#line 850 "../src/reversi-view.vala"
					_tmp11_ = _tmp10_;
#line 850 "../src/reversi-view.vala"
					_tmp12_ = game_get_current_state (_tmp11_);
#line 850 "../src/reversi-view.vala"
					_tmp13_ = _tmp12_;
#line 850 "../src/reversi-view.vala"
					_tmp7_ = game_state_object_get_owner (_tmp13_, half_game_size, (guint8) (half_game_size - 1)) != PLAYER_NONE;
#line 4445 "reversi-view.c"
				} else {
#line 849 "../src/reversi-view.vala"
					_tmp7_ = FALSE;
#line 4449 "reversi-view.c"
				}
#line 849 "../src/reversi-view.vala"
				if (_tmp7_) {
#line 850 "../src/reversi-view.vala"
					target = (guint8) 2;
#line 4455 "reversi-view.c"
				} else {
					gboolean _tmp14_ = FALSE;
					gboolean _tmp15_ = FALSE;
#line 851 "../src/reversi-view.vala"
					if (!self->priv->last_state_set) {
#line 851 "../src/reversi-view.vala"
						_tmp15_ = TRUE;
#line 4463 "reversi-view.c"
					} else {
						GameStateObject* _tmp16_;
#line 851 "../src/reversi-view.vala"
						_tmp16_ = self->priv->last_state;
#line 851 "../src/reversi-view.vala"
						_tmp15_ = game_state_object_get_owner (_tmp16_, (guint8) (half_game_size - 1), half_game_size) == PLAYER_NONE;
#line 4470 "reversi-view.c"
					}
#line 851 "../src/reversi-view.vala"
					if (_tmp15_) {
#line 4474 "reversi-view.c"
						Game* _tmp17_;
						Game* _tmp18_;
						GameStateObject* _tmp19_;
						GameStateObject* _tmp20_;
#line 852 "../src/reversi-view.vala"
						_tmp17_ = reversi_view_get_game (self);
#line 852 "../src/reversi-view.vala"
						_tmp18_ = _tmp17_;
#line 852 "../src/reversi-view.vala"
						_tmp19_ = game_get_current_state (_tmp18_);
#line 852 "../src/reversi-view.vala"
						_tmp20_ = _tmp19_;
#line 852 "../src/reversi-view.vala"
						_tmp14_ = game_state_object_get_owner (_tmp20_, (guint8) (half_game_size - 1), half_game_size) != PLAYER_NONE;
#line 4489 "reversi-view.c"
					} else {
#line 851 "../src/reversi-view.vala"
						_tmp14_ = FALSE;
#line 4493 "reversi-view.c"
					}
#line 851 "../src/reversi-view.vala"
					if (_tmp14_) {
#line 852 "../src/reversi-view.vala"
						target = (guint8) 3;
#line 4499 "reversi-view.c"
					} else {
						gboolean _tmp21_ = FALSE;
						gboolean _tmp22_ = FALSE;
#line 853 "../src/reversi-view.vala"
						if (!self->priv->last_state_set) {
#line 853 "../src/reversi-view.vala"
							_tmp22_ = TRUE;
#line 4507 "reversi-view.c"
						} else {
							GameStateObject* _tmp23_;
#line 853 "../src/reversi-view.vala"
							_tmp23_ = self->priv->last_state;
#line 853 "../src/reversi-view.vala"
							_tmp22_ = game_state_object_get_owner (_tmp23_, half_game_size, half_game_size) == PLAYER_NONE;
#line 4514 "reversi-view.c"
						}
#line 853 "../src/reversi-view.vala"
						if (_tmp22_) {
#line 4518 "reversi-view.c"
							Game* _tmp24_;
							Game* _tmp25_;
							GameStateObject* _tmp26_;
							GameStateObject* _tmp27_;
#line 854 "../src/reversi-view.vala"
							_tmp24_ = reversi_view_get_game (self);
#line 854 "../src/reversi-view.vala"
							_tmp25_ = _tmp24_;
#line 854 "../src/reversi-view.vala"
							_tmp26_ = game_get_current_state (_tmp25_);
#line 854 "../src/reversi-view.vala"
							_tmp27_ = _tmp26_;
#line 854 "../src/reversi-view.vala"
							_tmp21_ = game_state_object_get_owner (_tmp27_, half_game_size, half_game_size) != PLAYER_NONE;
#line 4533 "reversi-view.c"
						} else {
#line 853 "../src/reversi-view.vala"
							_tmp21_ = FALSE;
#line 4537 "reversi-view.c"
						}
#line 853 "../src/reversi-view.vala"
						if (_tmp21_) {
#line 854 "../src/reversi-view.vala"
							target = (guint8) 4;
#line 4543 "reversi-view.c"
						} else {
#line 855 "../src/reversi-view.vala"
							g_assert_not_reached ();
#line 4547 "reversi-view.c"
						}
					}
				}
			}
#line 857 "../src/reversi-view.vala"
			_tmp28_ = self->priv->overture_target;
#line 857 "../src/reversi-view.vala"
			_tmp28__length1 = self->priv->overture_target_length1;
#line 857 "../src/reversi-view.vala"
			_tmp28_[self->priv->current_overture_playable] = target;
#line 858 "../src/reversi-view.vala"
			_tmp29_ = self->priv->current_overture_playable;
#line 858 "../src/reversi-view.vala"
			self->priv->current_overture_playable = _tmp29_ + 1;
#line 4562 "reversi-view.c"
		} else {
			gboolean _tmp30_ = FALSE;
			gboolean _tmp31_ = FALSE;
			guint8* _tmp86_;
			gint _tmp86__length1;
			guint8 _tmp87_;
			guint8* _tmp88_;
			gint _tmp88__length1;
			guint8 _tmp89_;
#line 862 "../src/reversi-view.vala"
			if (!self->priv->last_state_set) {
#line 862 "../src/reversi-view.vala"
				_tmp31_ = TRUE;
#line 4576 "reversi-view.c"
			} else {
				GameStateObject* _tmp32_;
#line 862 "../src/reversi-view.vala"
				_tmp32_ = self->priv->last_state;
#line 862 "../src/reversi-view.vala"
				_tmp31_ = game_state_object_get_owner (_tmp32_, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 4583 "reversi-view.c"
			}
#line 862 "../src/reversi-view.vala"
			if (_tmp31_) {
#line 4587 "reversi-view.c"
				Game* _tmp33_;
				Game* _tmp34_;
				GameStateObject* _tmp35_;
				GameStateObject* _tmp36_;
#line 863 "../src/reversi-view.vala"
				_tmp33_ = reversi_view_get_game (self);
#line 863 "../src/reversi-view.vala"
				_tmp34_ = _tmp33_;
#line 863 "../src/reversi-view.vala"
				_tmp35_ = game_get_current_state (_tmp34_);
#line 863 "../src/reversi-view.vala"
				_tmp36_ = _tmp35_;
#line 863 "../src/reversi-view.vala"
				_tmp30_ = game_state_object_get_owner (_tmp36_, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) != PLAYER_NONE;
#line 4602 "reversi-view.c"
			} else {
#line 862 "../src/reversi-view.vala"
				_tmp30_ = FALSE;
#line 4606 "reversi-view.c"
			}
#line 862 "../src/reversi-view.vala"
			if (_tmp30_) {
#line 863 "../src/reversi-view.vala"
				target = (guint8) 1;
#line 4612 "reversi-view.c"
			} else {
				gboolean _tmp37_ = FALSE;
				gboolean _tmp38_ = FALSE;
#line 864 "../src/reversi-view.vala"
				if (!self->priv->last_state_set) {
#line 864 "../src/reversi-view.vala"
					_tmp38_ = TRUE;
#line 4620 "reversi-view.c"
				} else {
					GameStateObject* _tmp39_;
#line 864 "../src/reversi-view.vala"
					_tmp39_ = self->priv->last_state;
#line 864 "../src/reversi-view.vala"
					_tmp38_ = game_state_object_get_owner (_tmp39_, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 4627 "reversi-view.c"
				}
#line 864 "../src/reversi-view.vala"
				if (_tmp38_) {
#line 4631 "reversi-view.c"
					Game* _tmp40_;
					Game* _tmp41_;
					GameStateObject* _tmp42_;
					GameStateObject* _tmp43_;
#line 865 "../src/reversi-view.vala"
					_tmp40_ = reversi_view_get_game (self);
#line 865 "../src/reversi-view.vala"
					_tmp41_ = _tmp40_;
#line 865 "../src/reversi-view.vala"
					_tmp42_ = game_get_current_state (_tmp41_);
#line 865 "../src/reversi-view.vala"
					_tmp43_ = _tmp42_;
#line 865 "../src/reversi-view.vala"
					_tmp37_ = game_state_object_get_owner (_tmp43_, half_game_size, (guint8) (half_game_size - 1)) != PLAYER_NONE;
#line 4646 "reversi-view.c"
				} else {
#line 864 "../src/reversi-view.vala"
					_tmp37_ = FALSE;
#line 4650 "reversi-view.c"
				}
#line 864 "../src/reversi-view.vala"
				if (_tmp37_) {
#line 865 "../src/reversi-view.vala"
					target = (guint8) 2;
#line 4656 "reversi-view.c"
				} else {
					gboolean _tmp44_ = FALSE;
					gboolean _tmp45_ = FALSE;
#line 866 "../src/reversi-view.vala"
					if (!self->priv->last_state_set) {
#line 866 "../src/reversi-view.vala"
						_tmp45_ = TRUE;
#line 4664 "reversi-view.c"
					} else {
						GameStateObject* _tmp46_;
#line 866 "../src/reversi-view.vala"
						_tmp46_ = self->priv->last_state;
#line 866 "../src/reversi-view.vala"
						_tmp45_ = game_state_object_get_owner (_tmp46_, (guint8) (half_game_size + 1), (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 4671 "reversi-view.c"
					}
#line 866 "../src/reversi-view.vala"
					if (_tmp45_) {
#line 4675 "reversi-view.c"
						Game* _tmp47_;
						Game* _tmp48_;
						GameStateObject* _tmp49_;
						GameStateObject* _tmp50_;
#line 867 "../src/reversi-view.vala"
						_tmp47_ = reversi_view_get_game (self);
#line 867 "../src/reversi-view.vala"
						_tmp48_ = _tmp47_;
#line 867 "../src/reversi-view.vala"
						_tmp49_ = game_get_current_state (_tmp48_);
#line 867 "../src/reversi-view.vala"
						_tmp50_ = _tmp49_;
#line 867 "../src/reversi-view.vala"
						_tmp44_ = game_state_object_get_owner (_tmp50_, (guint8) (half_game_size + 1), (guint8) (half_game_size - 1)) != PLAYER_NONE;
#line 4690 "reversi-view.c"
					} else {
#line 866 "../src/reversi-view.vala"
						_tmp44_ = FALSE;
#line 4694 "reversi-view.c"
					}
#line 866 "../src/reversi-view.vala"
					if (_tmp44_) {
#line 867 "../src/reversi-view.vala"
						target = (guint8) 3;
#line 4700 "reversi-view.c"
					} else {
						gboolean _tmp51_ = FALSE;
						gboolean _tmp52_ = FALSE;
#line 868 "../src/reversi-view.vala"
						if (!self->priv->last_state_set) {
#line 868 "../src/reversi-view.vala"
							_tmp52_ = TRUE;
#line 4708 "reversi-view.c"
						} else {
							GameStateObject* _tmp53_;
#line 868 "../src/reversi-view.vala"
							_tmp53_ = self->priv->last_state;
#line 868 "../src/reversi-view.vala"
							_tmp52_ = game_state_object_get_owner (_tmp53_, (guint8) (half_game_size - 1), half_game_size) == PLAYER_NONE;
#line 4715 "reversi-view.c"
						}
#line 868 "../src/reversi-view.vala"
						if (_tmp52_) {
#line 4719 "reversi-view.c"
							Game* _tmp54_;
							Game* _tmp55_;
							GameStateObject* _tmp56_;
							GameStateObject* _tmp57_;
#line 869 "../src/reversi-view.vala"
							_tmp54_ = reversi_view_get_game (self);
#line 869 "../src/reversi-view.vala"
							_tmp55_ = _tmp54_;
#line 869 "../src/reversi-view.vala"
							_tmp56_ = game_get_current_state (_tmp55_);
#line 869 "../src/reversi-view.vala"
							_tmp57_ = _tmp56_;
#line 869 "../src/reversi-view.vala"
							_tmp51_ = game_state_object_get_owner (_tmp57_, (guint8) (half_game_size - 1), half_game_size) != PLAYER_NONE;
#line 4734 "reversi-view.c"
						} else {
#line 868 "../src/reversi-view.vala"
							_tmp51_ = FALSE;
#line 4738 "reversi-view.c"
						}
#line 868 "../src/reversi-view.vala"
						if (_tmp51_) {
#line 869 "../src/reversi-view.vala"
							target = (guint8) 4;
#line 4744 "reversi-view.c"
						} else {
							gboolean _tmp58_ = FALSE;
							gboolean _tmp59_ = FALSE;
#line 870 "../src/reversi-view.vala"
							if (!self->priv->last_state_set) {
#line 870 "../src/reversi-view.vala"
								_tmp59_ = TRUE;
#line 4752 "reversi-view.c"
							} else {
								GameStateObject* _tmp60_;
#line 870 "../src/reversi-view.vala"
								_tmp60_ = self->priv->last_state;
#line 870 "../src/reversi-view.vala"
								_tmp59_ = game_state_object_get_owner (_tmp60_, (guint8) (half_game_size + 1), half_game_size) == PLAYER_NONE;
#line 4759 "reversi-view.c"
							}
#line 870 "../src/reversi-view.vala"
							if (_tmp59_) {
#line 4763 "reversi-view.c"
								Game* _tmp61_;
								Game* _tmp62_;
								GameStateObject* _tmp63_;
								GameStateObject* _tmp64_;
#line 871 "../src/reversi-view.vala"
								_tmp61_ = reversi_view_get_game (self);
#line 871 "../src/reversi-view.vala"
								_tmp62_ = _tmp61_;
#line 871 "../src/reversi-view.vala"
								_tmp63_ = game_get_current_state (_tmp62_);
#line 871 "../src/reversi-view.vala"
								_tmp64_ = _tmp63_;
#line 871 "../src/reversi-view.vala"
								_tmp58_ = game_state_object_get_owner (_tmp64_, (guint8) (half_game_size + 1), half_game_size) != PLAYER_NONE;
#line 4778 "reversi-view.c"
							} else {
#line 870 "../src/reversi-view.vala"
								_tmp58_ = FALSE;
#line 4782 "reversi-view.c"
							}
#line 870 "../src/reversi-view.vala"
							if (_tmp58_) {
#line 871 "../src/reversi-view.vala"
								target = (guint8) 6;
#line 4788 "reversi-view.c"
							} else {
								gboolean _tmp65_ = FALSE;
								gboolean _tmp66_ = FALSE;
#line 872 "../src/reversi-view.vala"
								if (!self->priv->last_state_set) {
#line 872 "../src/reversi-view.vala"
									_tmp66_ = TRUE;
#line 4796 "reversi-view.c"
								} else {
									GameStateObject* _tmp67_;
#line 872 "../src/reversi-view.vala"
									_tmp67_ = self->priv->last_state;
#line 872 "../src/reversi-view.vala"
									_tmp66_ = game_state_object_get_owner (_tmp67_, (guint8) (half_game_size - 1), (guint8) (half_game_size + 1)) == PLAYER_NONE;
#line 4803 "reversi-view.c"
								}
#line 872 "../src/reversi-view.vala"
								if (_tmp66_) {
#line 4807 "reversi-view.c"
									Game* _tmp68_;
									Game* _tmp69_;
									GameStateObject* _tmp70_;
									GameStateObject* _tmp71_;
#line 873 "../src/reversi-view.vala"
									_tmp68_ = reversi_view_get_game (self);
#line 873 "../src/reversi-view.vala"
									_tmp69_ = _tmp68_;
#line 873 "../src/reversi-view.vala"
									_tmp70_ = game_get_current_state (_tmp69_);
#line 873 "../src/reversi-view.vala"
									_tmp71_ = _tmp70_;
#line 873 "../src/reversi-view.vala"
									_tmp65_ = game_state_object_get_owner (_tmp71_, (guint8) (half_game_size - 1), (guint8) (half_game_size + 1)) != PLAYER_NONE;
#line 4822 "reversi-view.c"
								} else {
#line 872 "../src/reversi-view.vala"
									_tmp65_ = FALSE;
#line 4826 "reversi-view.c"
								}
#line 872 "../src/reversi-view.vala"
								if (_tmp65_) {
#line 873 "../src/reversi-view.vala"
									target = (guint8) 7;
#line 4832 "reversi-view.c"
								} else {
									gboolean _tmp72_ = FALSE;
									gboolean _tmp73_ = FALSE;
#line 874 "../src/reversi-view.vala"
									if (!self->priv->last_state_set) {
#line 874 "../src/reversi-view.vala"
										_tmp73_ = TRUE;
#line 4840 "reversi-view.c"
									} else {
										GameStateObject* _tmp74_;
#line 874 "../src/reversi-view.vala"
										_tmp74_ = self->priv->last_state;
#line 874 "../src/reversi-view.vala"
										_tmp73_ = game_state_object_get_owner (_tmp74_, half_game_size, (guint8) (half_game_size + 1)) == PLAYER_NONE;
#line 4847 "reversi-view.c"
									}
#line 874 "../src/reversi-view.vala"
									if (_tmp73_) {
#line 4851 "reversi-view.c"
										Game* _tmp75_;
										Game* _tmp76_;
										GameStateObject* _tmp77_;
										GameStateObject* _tmp78_;
#line 875 "../src/reversi-view.vala"
										_tmp75_ = reversi_view_get_game (self);
#line 875 "../src/reversi-view.vala"
										_tmp76_ = _tmp75_;
#line 875 "../src/reversi-view.vala"
										_tmp77_ = game_get_current_state (_tmp76_);
#line 875 "../src/reversi-view.vala"
										_tmp78_ = _tmp77_;
#line 875 "../src/reversi-view.vala"
										_tmp72_ = game_state_object_get_owner (_tmp78_, half_game_size, (guint8) (half_game_size + 1)) != PLAYER_NONE;
#line 4866 "reversi-view.c"
									} else {
#line 874 "../src/reversi-view.vala"
										_tmp72_ = FALSE;
#line 4870 "reversi-view.c"
									}
#line 874 "../src/reversi-view.vala"
									if (_tmp72_) {
#line 875 "../src/reversi-view.vala"
										target = (guint8) 8;
#line 4876 "reversi-view.c"
									} else {
										gboolean _tmp79_ = FALSE;
										gboolean _tmp80_ = FALSE;
#line 876 "../src/reversi-view.vala"
										if (!self->priv->last_state_set) {
#line 876 "../src/reversi-view.vala"
											_tmp80_ = TRUE;
#line 4884 "reversi-view.c"
										} else {
											GameStateObject* _tmp81_;
#line 876 "../src/reversi-view.vala"
											_tmp81_ = self->priv->last_state;
#line 876 "../src/reversi-view.vala"
											_tmp80_ = game_state_object_get_owner (_tmp81_, (guint8) (half_game_size + 1), (guint8) (half_game_size + 1)) == PLAYER_NONE;
#line 4891 "reversi-view.c"
										}
#line 876 "../src/reversi-view.vala"
										if (_tmp80_) {
#line 4895 "reversi-view.c"
											Game* _tmp82_;
											Game* _tmp83_;
											GameStateObject* _tmp84_;
											GameStateObject* _tmp85_;
#line 877 "../src/reversi-view.vala"
											_tmp82_ = reversi_view_get_game (self);
#line 877 "../src/reversi-view.vala"
											_tmp83_ = _tmp82_;
#line 877 "../src/reversi-view.vala"
											_tmp84_ = game_get_current_state (_tmp83_);
#line 877 "../src/reversi-view.vala"
											_tmp85_ = _tmp84_;
#line 877 "../src/reversi-view.vala"
											_tmp79_ = game_state_object_get_owner (_tmp85_, (guint8) (half_game_size + 1), (guint8) (half_game_size + 1)) != PLAYER_NONE;
#line 4910 "reversi-view.c"
										} else {
#line 876 "../src/reversi-view.vala"
											_tmp79_ = FALSE;
#line 4914 "reversi-view.c"
										}
#line 876 "../src/reversi-view.vala"
										if (_tmp79_) {
#line 877 "../src/reversi-view.vala"
											target = (guint8) 9;
#line 4920 "reversi-view.c"
										} else {
#line 878 "../src/reversi-view.vala"
											g_assert_not_reached ();
#line 4924 "reversi-view.c"
										}
									}
								}
							}
						}
					}
				}
			}
#line 880 "../src/reversi-view.vala"
			_tmp86_ = self->priv->overture_target;
#line 880 "../src/reversi-view.vala"
			_tmp86__length1 = self->priv->overture_target_length1;
#line 880 "../src/reversi-view.vala"
			_tmp86_[self->priv->current_overture_playable] = target;
#line 881 "../src/reversi-view.vala"
			_tmp87_ = self->priv->current_overture_playable;
#line 881 "../src/reversi-view.vala"
			self->priv->current_overture_playable = _tmp87_ + 1;
#line 882 "../src/reversi-view.vala"
			_tmp88_ = self->priv->overture_target;
#line 882 "../src/reversi-view.vala"
			_tmp88__length1 = self->priv->overture_target_length1;
#line 882 "../src/reversi-view.vala"
			_tmp88_[self->priv->current_overture_playable] = (guint8) (10 - target);
#line 883 "../src/reversi-view.vala"
			_tmp89_ = self->priv->current_overture_playable;
#line 883 "../src/reversi-view.vala"
			self->priv->current_overture_playable = _tmp89_ + 1;
#line 4953 "reversi-view.c"
		}
	}
#line 886 "../src/reversi-view.vala"
	if (!no_draw) {
#line 888 "../src/reversi-view.vala"
		reversi_view_update_squares (self);
#line 889 "../src/reversi-view.vala"
		self->priv->playable_tiles_highlight_state = (guint8) 0;
#line 890 "../src/reversi-view.vala"
		if (undoing) {
#line 891 "../src/reversi-view.vala"
			reversi_view_update_highlight_after_undo (self);
#line 4966 "reversi-view.c"
		} else {
			gboolean _tmp90_;
			gboolean _tmp91_;
#line 892 "../src/reversi-view.vala"
			_tmp90_ = reversi_view_get_show_playable_tiles (self);
#line 892 "../src/reversi-view.vala"
			_tmp91_ = _tmp90_;
#line 892 "../src/reversi-view.vala"
			if (_tmp91_) {
#line 893 "../src/reversi-view.vala"
				reversi_view_highlight_playable_tiles (self, FALSE);
#line 4978 "reversi-view.c"
			}
		}
	}
#line 896 "../src/reversi-view.vala"
	_tmp92_ = reversi_view_get_game (self);
#line 896 "../src/reversi-view.vala"
	_tmp93_ = _tmp92_;
#line 896 "../src/reversi-view.vala"
	_tmp94_ = game_get_current_state (_tmp93_);
#line 896 "../src/reversi-view.vala"
	_tmp95_ = _tmp94_;
#line 896 "../src/reversi-view.vala"
	_tmp96_ = _g_object_ref0 (_tmp95_);
#line 896 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->last_state);
#line 896 "../src/reversi-view.vala"
	self->priv->last_state = _tmp96_;
#line 897 "../src/reversi-view.vala"
	self->priv->last_state_set = TRUE;
#line 4998 "reversi-view.c"
}

static inline void
reversi_view_update_squares (ReversiView* self)
{
#line 900 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 5006 "reversi-view.c"
	{
		guint8 x = 0U;
#line 902 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 5011 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 902 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 902 "../src/reversi-view.vala"
			while (TRUE) {
#line 902 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 5020 "reversi-view.c"
					guint8 _tmp1_;
#line 902 "../src/reversi-view.vala"
					_tmp1_ = x;
#line 902 "../src/reversi-view.vala"
					x = _tmp1_ + 1;
#line 5026 "reversi-view.c"
				}
#line 902 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 902 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 902 "../src/reversi-view.vala"
					break;
#line 5034 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 903 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 5040 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 903 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 903 "../src/reversi-view.vala"
						while (TRUE) {
#line 903 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 5049 "reversi-view.c"
								guint8 _tmp3_;
#line 903 "../src/reversi-view.vala"
								_tmp3_ = y;
#line 903 "../src/reversi-view.vala"
								y = _tmp3_ + 1;
#line 5055 "reversi-view.c"
							}
#line 903 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 903 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 903 "../src/reversi-view.vala"
								break;
#line 5063 "reversi-view.c"
							}
#line 904 "../src/reversi-view.vala"
							reversi_view_update_square (self, x, y);
#line 5067 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_update_square (ReversiView* self,
                            guint8 x,
                            guint8 y)
{
	Game* _tmp0_;
	Game* _tmp1_;
#line 907 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 907 "../src/reversi-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 910 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 910 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 910 "../src/reversi-view.vala"
	reversi_view_set_square (self, x, y, reversi_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, FALSE);
#line 5093 "reversi-view.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 913 "../src/reversi-view.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 913 "../src/reversi-view.vala"
	return _data7_;
#line 5103 "reversi-view.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 913 "../src/reversi-view.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 5113 "reversi-view.c"
		ReversiView* self;
#line 913 "../src/reversi-view.vala"
		self = _data7_->self;
#line 913 "../src/reversi-view.vala"
		_g_object_unref0 (self);
#line 913 "../src/reversi-view.vala"
		g_slice_free (Block7Data, _data7_);
#line 5121 "reversi-view.c"
	}
}

static gboolean
____lambda17_ (Block7Data* _data7_)
{
	ReversiView* self;
	gboolean animating = FALSE;
	gboolean result;
#line 927 "../src/reversi-view.vala"
	self = _data7_->self;
#line 928 "../src/reversi-view.vala"
	animating = FALSE;
#line 5135 "reversi-view.c"
	{
		guint8 ix = 0U;
#line 930 "../src/reversi-view.vala"
		ix = (guint8) 0;
#line 5140 "reversi-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 930 "../src/reversi-view.vala"
			_tmp0_ = TRUE;
#line 930 "../src/reversi-view.vala"
			while (TRUE) {
#line 930 "../src/reversi-view.vala"
				if (!_tmp0_) {
#line 5149 "reversi-view.c"
					guint8 _tmp1_;
#line 930 "../src/reversi-view.vala"
					_tmp1_ = ix;
#line 930 "../src/reversi-view.vala"
					ix = _tmp1_ + 1;
#line 5155 "reversi-view.c"
				}
#line 930 "../src/reversi-view.vala"
				_tmp0_ = FALSE;
#line 930 "../src/reversi-view.vala"
				if (!(ix < self->priv->game_size)) {
#line 930 "../src/reversi-view.vala"
					break;
#line 5163 "reversi-view.c"
				}
				{
					guint8 iy = 0U;
#line 932 "../src/reversi-view.vala"
					iy = (guint8) 0;
#line 5169 "reversi-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 932 "../src/reversi-view.vala"
						_tmp2_ = TRUE;
#line 932 "../src/reversi-view.vala"
						while (TRUE) {
#line 5176 "reversi-view.c"
							gint old = 0;
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
#line 932 "../src/reversi-view.vala"
							if (!_tmp2_) {
#line 5190 "reversi-view.c"
								guint8 _tmp3_;
#line 932 "../src/reversi-view.vala"
								_tmp3_ = iy;
#line 932 "../src/reversi-view.vala"
								iy = _tmp3_ + 1;
#line 5196 "reversi-view.c"
							}
#line 932 "../src/reversi-view.vala"
							_tmp2_ = FALSE;
#line 932 "../src/reversi-view.vala"
							if (!(iy < self->priv->game_size)) {
#line 932 "../src/reversi-view.vala"
								break;
#line 5204 "reversi-view.c"
							}
#line 934 "../src/reversi-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 934 "../src/reversi-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 934 "../src/reversi-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 934 "../src/reversi-view.vala"
							_tmp5_ = _tmp4_[(ix * _tmp4__length2) + iy];
#line 934 "../src/reversi-view.vala"
							old = _tmp5_;
#line 936 "../src/reversi-view.vala"
							if (_data7_->is_final_animation) {
#line 937 "../src/reversi-view.vala"
								_tmp7_ = self->priv->flip_final_result_now;
#line 5220 "reversi-view.c"
							} else {
#line 936 "../src/reversi-view.vala"
								_tmp7_ = FALSE;
#line 5224 "reversi-view.c"
							}
#line 936 "../src/reversi-view.vala"
							if (_tmp7_) {
#line 5228 "reversi-view.c"
								Game* _tmp8_;
								Game* _tmp9_;
								gboolean _tmp10_;
								gboolean _tmp11_;
#line 938 "../src/reversi-view.vala"
								_tmp8_ = reversi_view_get_game (self);
#line 938 "../src/reversi-view.vala"
								_tmp9_ = _tmp8_;
#line 938 "../src/reversi-view.vala"
								_tmp10_ = game_get_is_complete (_tmp9_);
#line 938 "../src/reversi-view.vala"
								_tmp11_ = _tmp10_;
#line 938 "../src/reversi-view.vala"
								_tmp6_ = _tmp11_;
#line 5243 "reversi-view.c"
							} else {
#line 936 "../src/reversi-view.vala"
								_tmp6_ = FALSE;
#line 5247 "reversi-view.c"
							}
#line 936 "../src/reversi-view.vala"
							if (_tmp6_) {
#line 939 "../src/reversi-view.vala"
								reversi_view_flip_final_result_tile (self, ix, iy);
#line 5253 "reversi-view.c"
							} else {
#line 941 "../src/reversi-view.vala"
								reversi_view_update_square (self, ix, iy);
#line 5257 "reversi-view.c"
							}
#line 943 "../src/reversi-view.vala"
							_tmp12_ = self->priv->pixmaps;
#line 943 "../src/reversi-view.vala"
							_tmp12__length1 = self->priv->pixmaps_length1;
#line 943 "../src/reversi-view.vala"
							_tmp12__length2 = self->priv->pixmaps_length2;
#line 943 "../src/reversi-view.vala"
							_tmp13_ = _tmp12_[(ix * _tmp12__length2) + iy];
#line 943 "../src/reversi-view.vala"
							if (_tmp13_ != old) {
#line 944 "../src/reversi-view.vala"
								animating = TRUE;
#line 5271 "reversi-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 948 "../src/reversi-view.vala"
	if (animating) {
#line 949 "../src/reversi-view.vala"
		result = G_SOURCE_CONTINUE;
#line 949 "../src/reversi-view.vala"
		return result;
#line 5285 "reversi-view.c"
	} else {
#line 952 "../src/reversi-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 953 "../src/reversi-view.vala"
		if (!self->priv->show_highlight) {
#line 954 "../src/reversi-view.vala"
			_reversi_view_on_motion (self, self->priv->mouse_position_x, self->priv->mouse_position_y, TRUE);
#line 5293 "reversi-view.c"
		}
#line 955 "../src/reversi-view.vala"
		result = G_SOURCE_REMOVE;
#line 955 "../src/reversi-view.vala"
		return result;
#line 5299 "reversi-view.c"
	}
}

static gboolean
_____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda17_ (self);
#line 927 "../src/reversi-view.vala"
	return result;
#line 5310 "reversi-view.c"
}

static void
reversi_view_set_square (ReversiView* self,
                         guint8 x,
                         guint8 y,
                         gint pixmap,
                         gboolean is_final_animation,
                         gboolean force_redraw)
{
	Block7Data* _data7_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 913 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 913 "../src/reversi-view.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 913 "../src/reversi-view.vala"
	_data7_->_ref_count_ = 1;
#line 913 "../src/reversi-view.vala"
	_data7_->self = g_object_ref (self);
#line 913 "../src/reversi-view.vala"
	_data7_->is_final_animation = is_final_animation;
#line 915 "../src/reversi-view.vala"
	if (!force_redraw) {
#line 5336 "reversi-view.c"
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		gint _tmp2_;
#line 915 "../src/reversi-view.vala"
		_tmp1_ = self->priv->pixmaps;
#line 915 "../src/reversi-view.vala"
		_tmp1__length1 = self->priv->pixmaps_length1;
#line 915 "../src/reversi-view.vala"
		_tmp1__length2 = self->priv->pixmaps_length2;
#line 915 "../src/reversi-view.vala"
		_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
#line 915 "../src/reversi-view.vala"
		_tmp0_ = _tmp2_ == pixmap;
#line 5351 "reversi-view.c"
	} else {
#line 915 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 5355 "reversi-view.c"
	}
#line 915 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 916 "../src/reversi-view.vala"
		block7_data_unref (_data7_);
#line 916 "../src/reversi-view.vala"
		_data7_ = NULL;
#line 916 "../src/reversi-view.vala"
		return;
#line 5365 "reversi-view.c"
	}
#line 918 "../src/reversi-view.vala"
	if (pixmap == 0) {
#line 918 "../src/reversi-view.vala"
		_tmp3_ = TRUE;
#line 5371 "reversi-view.c"
	} else {
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
#line 918 "../src/reversi-view.vala"
		_tmp4_ = self->priv->pixmaps;
#line 918 "../src/reversi-view.vala"
		_tmp4__length1 = self->priv->pixmaps_length1;
#line 918 "../src/reversi-view.vala"
		_tmp4__length2 = self->priv->pixmaps_length2;
#line 918 "../src/reversi-view.vala"
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 918 "../src/reversi-view.vala"
		_tmp3_ = _tmp5_ == 0;
#line 5387 "reversi-view.c"
	}
#line 918 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 5391 "reversi-view.c"
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
#line 919 "../src/reversi-view.vala"
		_tmp6_ = self->priv->pixmaps;
#line 919 "../src/reversi-view.vala"
		_tmp6__length1 = self->priv->pixmaps_length1;
#line 919 "../src/reversi-view.vala"
		_tmp6__length2 = self->priv->pixmaps_length2;
#line 919 "../src/reversi-view.vala"
		_tmp6_[(x * _tmp6__length2) + y] = pixmap;
#line 5403 "reversi-view.c"
	} else {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp8_;
#line 922 "../src/reversi-view.vala"
		_tmp7_ = self->priv->pixmaps;
#line 922 "../src/reversi-view.vala"
		_tmp7__length1 = self->priv->pixmaps_length1;
#line 922 "../src/reversi-view.vala"
		_tmp7__length2 = self->priv->pixmaps_length2;
#line 922 "../src/reversi-view.vala"
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 922 "../src/reversi-view.vala"
		if (pixmap > _tmp8_) {
#line 5419 "reversi-view.c"
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			guint8 _tmp10_;
			guint8 _tmp11_;
			gint _tmp12_;
#line 923 "../src/reversi-view.vala"
			_tmp9_ = self->priv->pixmaps;
#line 923 "../src/reversi-view.vala"
			_tmp9__length1 = self->priv->pixmaps_length1;
#line 923 "../src/reversi-view.vala"
			_tmp9__length2 = self->priv->pixmaps_length2;
#line 923 "../src/reversi-view.vala"
			_tmp10_ = x;
#line 923 "../src/reversi-view.vala"
			_tmp11_ = y;
#line 923 "../src/reversi-view.vala"
			_tmp12_ = _tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_];
#line 923 "../src/reversi-view.vala"
			_tmp9_[(_tmp10_ * _tmp9__length2) + _tmp11_] = _tmp12_ + 1;
#line 5440 "reversi-view.c"
		} else {
			gint* _tmp13_;
			gint _tmp13__length1;
			gint _tmp13__length2;
			guint8 _tmp14_;
			guint8 _tmp15_;
			gint _tmp16_;
#line 925 "../src/reversi-view.vala"
			_tmp13_ = self->priv->pixmaps;
#line 925 "../src/reversi-view.vala"
			_tmp13__length1 = self->priv->pixmaps_length1;
#line 925 "../src/reversi-view.vala"
			_tmp13__length2 = self->priv->pixmaps_length2;
#line 925 "../src/reversi-view.vala"
			_tmp14_ = x;
#line 925 "../src/reversi-view.vala"
			_tmp15_ = y;
#line 925 "../src/reversi-view.vala"
			_tmp16_ = _tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_];
#line 925 "../src/reversi-view.vala"
			_tmp13_[(_tmp14_ * _tmp13__length2) + _tmp15_] = _tmp16_ - 1;
#line 5462 "reversi-view.c"
		}
#line 926 "../src/reversi-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 927 "../src/reversi-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) REVERSI_VIEW_PIXMAP_FLIP_DELAY, _____lambda17__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 5468 "reversi-view.c"
		}
	}
#line 959 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, x, y);
#line 913 "../src/reversi-view.vala"
	block7_data_unref (_data7_);
#line 913 "../src/reversi-view.vala"
	_data7_ = NULL;
#line 5477 "reversi-view.c"
}

static gint
reversi_view_get_pixmap (Player color)
{
	gint result;
#line 964 "../src/reversi-view.vala"
	switch (color) {
#line 5486 "reversi-view.c"
		default:
#line 964 "../src/reversi-view.vala"
		case PLAYER_NONE:
#line 5490 "reversi-view.c"
		{
#line 968 "../src/reversi-view.vala"
			result = 0;
#line 968 "../src/reversi-view.vala"
			return result;
#line 5496 "reversi-view.c"
		}
#line 964 "../src/reversi-view.vala"
		case PLAYER_DARK:
#line 5500 "reversi-view.c"
		{
#line 970 "../src/reversi-view.vala"
			result = 1;
#line 970 "../src/reversi-view.vala"
			return result;
#line 5506 "reversi-view.c"
		}
#line 964 "../src/reversi-view.vala"
		case PLAYER_LIGHT:
#line 5510 "reversi-view.c"
		{
#line 972 "../src/reversi-view.vala"
			result = 31;
#line 972 "../src/reversi-view.vala"
			return result;
#line 5516 "reversi-view.c"
		}
	}
}

static gboolean
___lambda16_ (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 1004 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 1004 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 1004 "../src/reversi-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 1004 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 1004 "../src/reversi-view.vala"
	if (!_tmp3_) {
#line 1005 "../src/reversi-view.vala"
		result = G_SOURCE_REMOVE;
#line 1005 "../src/reversi-view.vala"
		return result;
#line 5543 "reversi-view.c"
	}
#line 1007 "../src/reversi-view.vala"
	g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL], 0, FALSE);
#line 1008 "../src/reversi-view.vala"
	reversi_view_set_winner_and_loser_variables (self);
#line 1009 "../src/reversi-view.vala"
	self->priv->flip_final_result_now = TRUE;
#line 5551 "reversi-view.c"
	{
		guint8 x = 0U;
#line 1010 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 5556 "reversi-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1010 "../src/reversi-view.vala"
			_tmp4_ = TRUE;
#line 1010 "../src/reversi-view.vala"
			while (TRUE) {
#line 1010 "../src/reversi-view.vala"
				if (!_tmp4_) {
#line 5565 "reversi-view.c"
					guint8 _tmp5_;
#line 1010 "../src/reversi-view.vala"
					_tmp5_ = x;
#line 1010 "../src/reversi-view.vala"
					x = _tmp5_ + 1;
#line 5571 "reversi-view.c"
				}
#line 1010 "../src/reversi-view.vala"
				_tmp4_ = FALSE;
#line 1010 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 1010 "../src/reversi-view.vala"
					break;
#line 5579 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 1011 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 5585 "reversi-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 1011 "../src/reversi-view.vala"
						_tmp6_ = TRUE;
#line 1011 "../src/reversi-view.vala"
						while (TRUE) {
#line 1011 "../src/reversi-view.vala"
							if (!_tmp6_) {
#line 5594 "reversi-view.c"
								guint8 _tmp7_;
#line 1011 "../src/reversi-view.vala"
								_tmp7_ = y;
#line 1011 "../src/reversi-view.vala"
								y = _tmp7_ + 1;
#line 5600 "reversi-view.c"
							}
#line 1011 "../src/reversi-view.vala"
							_tmp6_ = FALSE;
#line 1011 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 1011 "../src/reversi-view.vala"
								break;
#line 5608 "reversi-view.c"
							}
#line 1012 "../src/reversi-view.vala"
							reversi_view_flip_final_result_tile (self, x, y);
#line 5612 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 1014 "../src/reversi-view.vala"
	result = G_SOURCE_REMOVE;
#line 1014 "../src/reversi-view.vala"
	return result;
#line 5623 "reversi-view.c"
}

static gboolean
____lambda16__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda16_ ((ReversiView*) self);
#line 1003 "../src/reversi-view.vala"
	return result;
#line 5633 "reversi-view.c"
}

static void
reversi_view_game_is_complete_cb (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	Game* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
#line 990 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 992 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 992 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 992 "../src/reversi-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 992 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 992 "../src/reversi-view.vala"
	if (!_tmp3_) {
#line 993 "../src/reversi-view.vala"
		return;
#line 5662 "reversi-view.c"
	}
#line 995 "../src/reversi-view.vala"
	_tmp5_ = reversi_view_get_game (self);
#line 995 "../src/reversi-view.vala"
	_tmp6_ = _tmp5_;
#line 995 "../src/reversi-view.vala"
	_tmp7_ = game_get_n_light_tiles (_tmp6_);
#line 995 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 995 "../src/reversi-view.vala"
	if (((gint) _tmp8_) == 0) {
#line 995 "../src/reversi-view.vala"
		_tmp4_ = TRUE;
#line 5676 "reversi-view.c"
	} else {
		Game* _tmp9_;
		Game* _tmp10_;
		guint8 _tmp11_;
		guint8 _tmp12_;
#line 995 "../src/reversi-view.vala"
		_tmp9_ = reversi_view_get_game (self);
#line 995 "../src/reversi-view.vala"
		_tmp10_ = _tmp9_;
#line 995 "../src/reversi-view.vala"
		_tmp11_ = game_get_n_dark_tiles (_tmp10_);
#line 995 "../src/reversi-view.vala"
		_tmp12_ = _tmp11_;
#line 995 "../src/reversi-view.vala"
		_tmp4_ = ((gint) _tmp12_) == 0;
#line 5692 "reversi-view.c"
	}
#line 995 "../src/reversi-view.vala"
	if (_tmp4_) {
#line 996 "../src/reversi-view.vala"
		return;
#line 5698 "reversi-view.c"
	}
#line 1002 "../src/reversi-view.vala"
	if (((gint) self->priv->game_size) >= 6) {
#line 1003 "../src/reversi-view.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ____lambda16__gsource_func, g_object_ref (self), g_object_unref);
#line 5704 "reversi-view.c"
	}
}

static void
reversi_view_flip_final_result_tile (ReversiView* self,
                                     guint8 x,
                                     guint8 y)
{
	gint pixmap = 0;
	guint8 n = 0U;
#line 1018 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1021 "../src/reversi-view.vala"
	n = (y * self->priv->game_size) + x;
#line 1022 "../src/reversi-view.vala"
	if (((gint) n) < self->priv->n_winning_tiles) {
#line 1023 "../src/reversi-view.vala"
		pixmap = reversi_view_get_pixmap (self->priv->winning_color);
#line 5723 "reversi-view.c"
	} else {
#line 1024 "../src/reversi-view.vala"
		if (((gint) n) < (self->priv->n_winning_tiles + self->priv->n_losing_tiles)) {
#line 1025 "../src/reversi-view.vala"
			pixmap = reversi_view_get_pixmap (self->priv->losing_color);
#line 5729 "reversi-view.c"
		} else {
#line 1027 "../src/reversi-view.vala"
			pixmap = reversi_view_get_pixmap (PLAYER_NONE);
#line 5733 "reversi-view.c"
		}
	}
#line 1028 "../src/reversi-view.vala"
	reversi_view_set_square (self, x, y, pixmap, TRUE, FALSE);
#line 5738 "reversi-view.c"
}

static void
reversi_view_set_winner_and_loser_variables (ReversiView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 1031 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1033 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 1033 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 1033 "../src/reversi-view.vala"
	_tmp2_ = game_get_n_light_tiles (_tmp1_);
#line 1033 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 1033 "../src/reversi-view.vala"
	self->priv->n_winning_tiles = (gint) _tmp3_;
#line 1034 "../src/reversi-view.vala"
	_tmp4_ = reversi_view_get_game (self);
#line 1034 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 1034 "../src/reversi-view.vala"
	_tmp6_ = game_get_n_dark_tiles (_tmp5_);
#line 1034 "../src/reversi-view.vala"
	_tmp7_ = _tmp6_;
#line 1034 "../src/reversi-view.vala"
	self->priv->n_losing_tiles = (gint) _tmp7_;
#line 1035 "../src/reversi-view.vala"
	if (self->priv->n_losing_tiles > self->priv->n_winning_tiles) {
#line 5776 "reversi-view.c"
		gint t = 0;
#line 1037 "../src/reversi-view.vala"
		self->priv->winning_color = PLAYER_DARK;
#line 1038 "../src/reversi-view.vala"
		self->priv->losing_color = PLAYER_LIGHT;
#line 1039 "../src/reversi-view.vala"
		t = self->priv->n_winning_tiles;
#line 1040 "../src/reversi-view.vala"
		self->priv->n_winning_tiles = self->priv->n_losing_tiles;
#line 1041 "../src/reversi-view.vala"
		self->priv->n_losing_tiles = t;
#line 5788 "reversi-view.c"
	} else {
#line 1045 "../src/reversi-view.vala"
		self->priv->winning_color = PLAYER_LIGHT;
#line 1046 "../src/reversi-view.vala"
		self->priv->losing_color = PLAYER_DARK;
#line 5794 "reversi-view.c"
	}
}

gboolean
reversi_view_undo_final_animation (ReversiView* self)
{
	gboolean result;
#line 1050 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1052 "../src/reversi-view.vala"
	if (!self->priv->flip_final_result_now) {
#line 1053 "../src/reversi-view.vala"
		result = FALSE;
#line 1053 "../src/reversi-view.vala"
		return result;
#line 5810 "reversi-view.c"
	}
#line 1055 "../src/reversi-view.vala"
	g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL], 0, TRUE);
#line 1056 "../src/reversi-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 1057 "../src/reversi-view.vala"
	reversi_view_update_squares (self);
#line 1058 "../src/reversi-view.vala"
	reversi_view_highlight_playable_tiles (self, FALSE);
#line 1060 "../src/reversi-view.vala"
	result = TRUE;
#line 1060 "../src/reversi-view.vala"
	return result;
#line 5824 "reversi-view.c"
}

static void
_reversi_view_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 1074 "../src/reversi-view.vala"
	reversi_view_on_motion ((ReversiView*) self, _sender, x, y);
#line 5835 "reversi-view.c"
}

static void
_reversi_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                        gint n_press,
                                                        gdouble x,
                                                        gdouble y,
                                                        gpointer self)
{
#line 1080 "../src/reversi-view.vala"
	reversi_view_on_click ((ReversiView*) self, _sender, n_press, x, y);
#line 5847 "reversi-view.c"
}

static void
reversi_view_init_mouse (ReversiView* self)
{
	GtkEventControllerMotion* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
	GtkGestureMultiPress* _tmp3_;
	GtkGestureMultiPress* _tmp4_;
#line 1071 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1073 "../src/reversi-view.vala"
	_tmp0_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) self);
#line 1073 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 1073 "../src/reversi-view.vala"
	self->priv->motion_controller = _tmp0_;
#line 1074 "../src/reversi-view.vala"
	_tmp1_ = self->priv->motion_controller;
#line 1074 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp1_, "motion", (GCallback) _reversi_view_on_motion_gtk_event_controller_motion_motion, self, 0);
#line 1078 "../src/reversi-view.vala"
	_tmp2_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 1078 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 1078 "../src/reversi-view.vala"
	self->priv->click_controller = _tmp2_;
#line 1079 "../src/reversi-view.vala"
	_tmp3_ = self->priv->click_controller;
#line 1079 "../src/reversi-view.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp3_, (guint) 0);
#line 1080 "../src/reversi-view.vala"
	_tmp4_ = self->priv->click_controller;
#line 1080 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp4_, "pressed", (GCallback) _reversi_view_on_click_gtk_gesture_multi_press_pressed, self, 0);
#line 5884 "reversi-view.c"
}

static gboolean
reversi_view_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	ReversiView * self;
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean result;
#line 1084 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 1084 "../src/reversi-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1088 "../src/reversi-view.vala"
	_tmp2_ = reversi_view_pointer_is_in_board (self, event->x, event->y, &_tmp0_, &_tmp1_);
#line 1088 "../src/reversi-view.vala"
	x = _tmp0_;
#line 1088 "../src/reversi-view.vala"
	y = _tmp1_;
#line 1088 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 1090 "../src/reversi-view.vala"
		reversi_view_on_cursor_moving_in (self, x, y);
#line 5912 "reversi-view.c"
	} else {
#line 1091 "../src/reversi-view.vala"
		if (self->priv->mouse_is_in) {
#line 1092 "../src/reversi-view.vala"
			g_assert_not_reached ();
#line 5918 "reversi-view.c"
		}
	}
#line 1093 "../src/reversi-view.vala"
	result = FALSE;
#line 1093 "../src/reversi-view.vala"
	return result;
#line 5925 "reversi-view.c"
}

static void
reversi_view_on_cursor_moving_in (ReversiView* self,
                                  guint8 x,
                                  guint8 y)
{
#line 1096 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1098 "../src/reversi-view.vala"
	self->priv->mouse_position_x = x;
#line 1099 "../src/reversi-view.vala"
	self->priv->mouse_position_y = y;
#line 1100 "../src/reversi-view.vala"
	self->priv->mouse_position_set = TRUE;
#line 1101 "../src/reversi-view.vala"
	self->priv->mouse_is_in = TRUE;
#line 1102 "../src/reversi-view.vala"
	_reversi_view_on_motion (self, x, y, TRUE);
#line 5945 "reversi-view.c"
}

static gboolean
reversi_view_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	ReversiView * self;
	gboolean result;
#line 1106 "../src/reversi-view.vala"
	self = (ReversiView*) base;
#line 1106 "../src/reversi-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1108 "../src/reversi-view.vala"
	self->priv->mouse_is_in = FALSE;
#line 1109 "../src/reversi-view.vala"
	if (self->priv->mouse_position_set) {
#line 1110 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 5964 "reversi-view.c"
	}
#line 1111 "../src/reversi-view.vala"
	result = FALSE;
#line 1111 "../src/reversi-view.vala"
	return result;
#line 5970 "reversi-view.c"
}

static gboolean
reversi_view_pointer_is_in_board (ReversiView* self,
                                  gdouble pos_x,
                                  gdouble pos_y,
                                  guint8* x,
                                  guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	gint _x = 0;
	gint _y = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 1114 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1116 "../src/reversi-view.vala"
	_x = (gint) floor ((pos_x - ((gdouble) self->priv->board_x)) / ((gdouble) self->priv->paving_size));
#line 1117 "../src/reversi-view.vala"
	_y = (gint) floor ((pos_y - ((gdouble) self->priv->board_y)) / ((gdouble) self->priv->paving_size));
#line 1118 "../src/reversi-view.vala"
	if (_x >= 0) {
#line 1118 "../src/reversi-view.vala"
		_tmp2_ = _x < ((gint) self->priv->game_size);
#line 5998 "reversi-view.c"
	} else {
#line 1118 "../src/reversi-view.vala"
		_tmp2_ = FALSE;
#line 6002 "reversi-view.c"
	}
#line 1118 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 1119 "../src/reversi-view.vala"
		_tmp1_ = _y >= 0;
#line 6008 "reversi-view.c"
	} else {
#line 1118 "../src/reversi-view.vala"
		_tmp1_ = FALSE;
#line 6012 "reversi-view.c"
	}
#line 1118 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 1119 "../src/reversi-view.vala"
		_tmp0_ = _y < ((gint) self->priv->game_size);
#line 6018 "reversi-view.c"
	} else {
#line 1118 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 6022 "reversi-view.c"
	}
#line 1118 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1121 "../src/reversi-view.vala"
		_vala_x = (guint8) _x;
#line 1122 "../src/reversi-view.vala"
		_vala_y = (guint8) _y;
#line 1123 "../src/reversi-view.vala"
		result = TRUE;
#line 1123 "../src/reversi-view.vala"
		if (x) {
#line 1123 "../src/reversi-view.vala"
			*x = _vala_x;
#line 6036 "reversi-view.c"
		}
#line 1123 "../src/reversi-view.vala"
		if (y) {
#line 1123 "../src/reversi-view.vala"
			*y = _vala_y;
#line 6042 "reversi-view.c"
		}
#line 1123 "../src/reversi-view.vala"
		return result;
#line 6046 "reversi-view.c"
	} else {
#line 1127 "../src/reversi-view.vala"
		_vala_x = G_MAXUINT8;
#line 1128 "../src/reversi-view.vala"
		_vala_y = G_MAXUINT8;
#line 1129 "../src/reversi-view.vala"
		result = FALSE;
#line 1129 "../src/reversi-view.vala"
		if (x) {
#line 1129 "../src/reversi-view.vala"
			*x = _vala_x;
#line 6058 "reversi-view.c"
		}
#line 1129 "../src/reversi-view.vala"
		if (y) {
#line 1129 "../src/reversi-view.vala"
			*y = _vala_y;
#line 6064 "reversi-view.c"
		}
#line 1129 "../src/reversi-view.vala"
		return result;
#line 6068 "reversi-view.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 1134 "../src/reversi-view.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 1134 "../src/reversi-view.vala"
	return _data8_;
#line 6079 "reversi-view.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 1134 "../src/reversi-view.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 6089 "reversi-view.c"
		ReversiView* self;
#line 1134 "../src/reversi-view.vala"
		self = _data8_->self;
#line 1134 "../src/reversi-view.vala"
		_g_object_unref0 (self);
#line 1134 "../src/reversi-view.vala"
		g_slice_free (Block8Data, _data8_);
#line 6097 "reversi-view.c"
	}
}

static gboolean
______lambda19_ (Block8Data* _data8_)
{
	ReversiView* self;
	gboolean result;
#line 1160 "../src/reversi-view.vala"
	self = _data8_->self;
#line 1161 "../src/reversi-view.vala"
	if (self->priv->mouse_is_in) {
#line 1162 "../src/reversi-view.vala"
		_reversi_view_on_motion (self, _data8_->x, _data8_->y, FALSE);
#line 6112 "reversi-view.c"
	}
#line 1163 "../src/reversi-view.vala"
	self->priv->timeout_id = (guint) 0;
#line 1164 "../src/reversi-view.vala"
	result = G_SOURCE_REMOVE;
#line 1164 "../src/reversi-view.vala"
	return result;
#line 6120 "reversi-view.c"
}

static gboolean
_______lambda19__gsource_func (gpointer self)
{
	gboolean result;
	result = ______lambda19_ (self);
#line 1160 "../src/reversi-view.vala"
	return result;
#line 6130 "reversi-view.c"
}

static void
reversi_view_on_motion (ReversiView* self,
                        GtkEventControllerMotion* _motion_controller,
                        gdouble event_x,
                        gdouble event_y)
{
	Block8Data* _data8_;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
	gboolean _tmp2_;
#line 1134 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1134 "../src/reversi-view.vala"
	g_return_if_fail (_motion_controller != NULL);
#line 1134 "../src/reversi-view.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 1134 "../src/reversi-view.vala"
	_data8_->_ref_count_ = 1;
#line 1134 "../src/reversi-view.vala"
	_data8_->self = g_object_ref (self);
#line 1138 "../src/reversi-view.vala"
	_tmp2_ = reversi_view_pointer_is_in_board (self, event_x, event_y, &_tmp0_, &_tmp1_);
#line 1138 "../src/reversi-view.vala"
	_data8_->x = _tmp0_;
#line 1138 "../src/reversi-view.vala"
	_data8_->y = _tmp1_;
#line 1138 "../src/reversi-view.vala"
	if (_tmp2_) {
#line 1140 "../src/reversi-view.vala"
		if (!self->priv->mouse_is_in) {
#line 1141 "../src/reversi-view.vala"
			reversi_view_on_cursor_moving_in (self, _data8_->x, _data8_->y);
#line 6165 "reversi-view.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 1142 "../src/reversi-view.vala"
			if (_data8_->x != self->priv->mouse_position_x) {
#line 1142 "../src/reversi-view.vala"
				_tmp3_ = TRUE;
#line 6172 "reversi-view.c"
			} else {
#line 1142 "../src/reversi-view.vala"
				_tmp3_ = _data8_->y != self->priv->mouse_position_y;
#line 6176 "reversi-view.c"
			}
#line 1142 "../src/reversi-view.vala"
			if (_tmp3_) {
#line 6180 "reversi-view.c"
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
#line 1144 "../src/reversi-view.vala"
				self->priv->mouse_position_x = _data8_->x;
#line 1145 "../src/reversi-view.vala"
				self->priv->mouse_position_y = _data8_->y;
#line 1146 "../src/reversi-view.vala"
				self->priv->mouse_position_set = TRUE;
#line 1147 "../src/reversi-view.vala"
				if (self->priv->show_highlight) {
#line 1147 "../src/reversi-view.vala"
					_tmp5_ = TRUE;
#line 6193 "reversi-view.c"
				} else {
#line 1148 "../src/reversi-view.vala"
					_tmp5_ = _data8_->x != self->priv->mouse_highlight_x;
#line 6197 "reversi-view.c"
				}
#line 1147 "../src/reversi-view.vala"
				if (_tmp5_) {
#line 1147 "../src/reversi-view.vala"
					_tmp4_ = TRUE;
#line 6203 "reversi-view.c"
				} else {
#line 1149 "../src/reversi-view.vala"
					_tmp4_ = _data8_->y != self->priv->mouse_highlight_y;
#line 6207 "reversi-view.c"
				}
#line 1147 "../src/reversi-view.vala"
				if (_tmp4_) {
#line 6211 "reversi-view.c"
					guint delay = 0U;
					gboolean _tmp6_;
#line 1151 "../src/reversi-view.vala"
					if (self->priv->timeout_id != ((guint) 0)) {
#line 1153 "../src/reversi-view.vala"
						g_source_remove (self->priv->timeout_id);
#line 1154 "../src/reversi-view.vala"
						self->priv->timeout_id = (guint) 0;
#line 6220 "reversi-view.c"
					}
#line 1157 "../src/reversi-view.vala"
					_tmp6_ = self->priv->_show_turnable_tiles;
#line 1157 "../src/reversi-view.vala"
					if (_tmp6_) {
#line 1157 "../src/reversi-view.vala"
						delay = (guint) 120;
#line 6228 "reversi-view.c"
					} else {
						gboolean _tmp7_;
						gboolean _tmp8_;
#line 1158 "../src/reversi-view.vala"
						_tmp7_ = reversi_view_get_show_playable_tiles (self);
#line 1158 "../src/reversi-view.vala"
						_tmp8_ = _tmp7_;
#line 1158 "../src/reversi-view.vala"
						if (_tmp8_) {
#line 1158 "../src/reversi-view.vala"
							delay = (guint) 50;
#line 6240 "reversi-view.c"
						} else {
#line 1159 "../src/reversi-view.vala"
							delay = (guint) 200;
#line 6244 "reversi-view.c"
						}
					}
#line 1160 "../src/reversi-view.vala"
					self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, delay, _______lambda19__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 6249 "reversi-view.c"
				}
			}
		}
	} else {
#line 1171 "../src/reversi-view.vala"
		self->priv->mouse_is_in = FALSE;
#line 1172 "../src/reversi-view.vala"
		self->priv->show_mouse_highlight = FALSE;
#line 1173 "../src/reversi-view.vala"
		if (self->priv->mouse_position_set) {
#line 1174 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 6262 "reversi-view.c"
		}
	}
#line 1134 "../src/reversi-view.vala"
	block8_data_unref (_data8_);
#line 1134 "../src/reversi-view.vala"
	_data8_ = NULL;
#line 6269 "reversi-view.c"
}

static void
_reversi_view_on_motion (ReversiView* self,
                         guint8 x,
                         guint8 y,
                         gboolean force_redraw)
{
	gboolean _tmp0_ = FALSE;
	gboolean old_show_mouse_highlight = FALSE;
	PossibleMove move = {0};
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_ = FALSE;
	guint8 old_mouse_highlight_x = 0U;
	guint8 old_mouse_highlight_y = 0U;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
#line 1177 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1179 "../src/reversi-view.vala"
	if (!force_redraw) {
#line 6293 "reversi-view.c"
		gboolean _tmp1_ = FALSE;
#line 1180 "../src/reversi-view.vala"
		if (x != self->priv->mouse_position_x) {
#line 1180 "../src/reversi-view.vala"
			_tmp1_ = TRUE;
#line 6299 "reversi-view.c"
		} else {
#line 1181 "../src/reversi-view.vala"
			_tmp1_ = y != self->priv->mouse_position_y;
#line 6303 "reversi-view.c"
		}
#line 1180 "../src/reversi-view.vala"
		_tmp0_ = _tmp1_;
#line 6307 "reversi-view.c"
	} else {
#line 1179 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 6311 "reversi-view.c"
	}
#line 1179 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1182 "../src/reversi-view.vala"
		return;
#line 6317 "reversi-view.c"
	}
#line 1184 "../src/reversi-view.vala"
	old_show_mouse_highlight = self->priv->show_mouse_highlight;
#line 1186 "../src/reversi-view.vala"
	if (self->priv->mouse_is_in) {
#line 6323 "reversi-view.c"
		Game* _tmp3_;
		Game* _tmp4_;
		PossibleMove _tmp5_ = {0};
		gboolean _tmp6_;
#line 1186 "../src/reversi-view.vala"
		_tmp3_ = reversi_view_get_game (self);
#line 1186 "../src/reversi-view.vala"
		_tmp4_ = _tmp3_;
#line 1186 "../src/reversi-view.vala"
		_tmp6_ = game_test_placing_tile (_tmp4_, x, y, &_tmp5_);
#line 1186 "../src/reversi-view.vala"
		move = _tmp5_;
#line 1186 "../src/reversi-view.vala"
		_tmp2_ = _tmp6_;
#line 6338 "reversi-view.c"
	} else {
#line 1186 "../src/reversi-view.vala"
		_tmp2_ = FALSE;
#line 6342 "reversi-view.c"
	}
#line 1186 "../src/reversi-view.vala"
	self->priv->show_mouse_highlight = _tmp2_;
#line 1188 "../src/reversi-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1189 "../src/reversi-view.vala"
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
#line 6350 "reversi-view.c"
	}
#line 1191 "../src/reversi-view.vala"
	if (old_show_mouse_highlight) {
#line 1191 "../src/reversi-view.vala"
		_tmp7_ = !self->priv->show_mouse_highlight;
#line 6356 "reversi-view.c"
	} else {
#line 1191 "../src/reversi-view.vala"
		_tmp7_ = FALSE;
#line 6360 "reversi-view.c"
	}
#line 1191 "../src/reversi-view.vala"
	if (_tmp7_) {
#line 1193 "../src/reversi-view.vala"
		self->priv->old_highlight_x = G_MAXUINT8;
#line 1194 "../src/reversi-view.vala"
		self->priv->old_highlight_y = G_MAXUINT8;
#line 6368 "reversi-view.c"
	}
#line 1197 "../src/reversi-view.vala"
	old_mouse_highlight_x = self->priv->mouse_highlight_x;
#line 1198 "../src/reversi-view.vala"
	old_mouse_highlight_y = self->priv->mouse_highlight_y;
#line 1200 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = x;
#line 1201 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = y;
#line 1203 "../src/reversi-view.vala"
	if (old_mouse_highlight_x != G_MAXUINT8) {
#line 1203 "../src/reversi-view.vala"
		_tmp8_ = old_mouse_highlight_y != G_MAXUINT8;
#line 6382 "reversi-view.c"
	} else {
#line 1203 "../src/reversi-view.vala"
		_tmp8_ = FALSE;
#line 6386 "reversi-view.c"
	}
#line 1203 "../src/reversi-view.vala"
	if (_tmp8_) {
#line 1204 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, old_mouse_highlight_x, old_mouse_highlight_y);
#line 6392 "reversi-view.c"
	}
#line 1205 "../src/reversi-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1205 "../src/reversi-view.vala"
		_tmp9_ = self->priv->show_highlight;
#line 6398 "reversi-view.c"
	} else {
#line 1205 "../src/reversi-view.vala"
		_tmp9_ = FALSE;
#line 6402 "reversi-view.c"
	}
#line 1205 "../src/reversi-view.vala"
	if (_tmp9_) {
#line 6406 "reversi-view.c"
		gboolean _tmp10_ = FALSE;
#line 1207 "../src/reversi-view.vala"
		self->priv->show_highlight = FALSE;
#line 1208 "../src/reversi-view.vala"
		if (self->priv->highlight_x != x) {
#line 1208 "../src/reversi-view.vala"
			_tmp10_ = TRUE;
#line 6414 "reversi-view.c"
		} else {
#line 1208 "../src/reversi-view.vala"
			_tmp10_ = self->priv->highlight_y != y;
#line 6418 "reversi-view.c"
		}
#line 1208 "../src/reversi-view.vala"
		if (_tmp10_) {
#line 1209 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 6424 "reversi-view.c"
		}
	}
#line 1211 "../src/reversi-view.vala"
	if (self->priv->show_mouse_highlight) {
#line 1211 "../src/reversi-view.vala"
		_tmp12_ = TRUE;
#line 6431 "reversi-view.c"
	} else {
#line 1211 "../src/reversi-view.vala"
		_tmp12_ = force_redraw;
#line 6435 "reversi-view.c"
	}
#line 1211 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 6439 "reversi-view.c"
		gboolean _tmp13_ = FALSE;
#line 1213 "../src/reversi-view.vala"
		if (self->priv->mouse_highlight_x != G_MAXUINT8) {
#line 1213 "../src/reversi-view.vala"
			_tmp13_ = self->priv->mouse_highlight_y != G_MAXUINT8;
#line 6445 "reversi-view.c"
		} else {
#line 1213 "../src/reversi-view.vala"
			_tmp13_ = FALSE;
#line 6449 "reversi-view.c"
		}
#line 1213 "../src/reversi-view.vala"
		_tmp11_ = _tmp13_;
#line 6453 "reversi-view.c"
	} else {
#line 1211 "../src/reversi-view.vala"
		_tmp11_ = FALSE;
#line 6457 "reversi-view.c"
	}
#line 1211 "../src/reversi-view.vala"
	if (_tmp11_) {
#line 1215 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 6463 "reversi-view.c"
	}
}

static inline void
reversi_view_on_click (ReversiView* self,
                       GtkGestureMultiPress* _click_controller,
                       gint n_press,
                       gdouble event_x,
                       gdouble event_y)
{
	guint button = 0U;
	gboolean _tmp0_ = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp1_ = 0U;
	guint8 _tmp2_ = 0U;
	gboolean _tmp3_;
#line 1219 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1219 "../src/reversi-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 1221 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 1222 "../src/reversi-view.vala"
		return;
#line 6489 "reversi-view.c"
	}
#line 1224 "../src/reversi-view.vala"
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _click_controller);
#line 1225 "../src/reversi-view.vala"
	if (button != ((guint) GDK_BUTTON_PRIMARY)) {
#line 1225 "../src/reversi-view.vala"
		_tmp0_ = button != ((guint) GDK_BUTTON_SECONDARY);
#line 6497 "reversi-view.c"
	} else {
#line 1225 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 6501 "reversi-view.c"
	}
#line 1225 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1226 "../src/reversi-view.vala"
		return;
#line 6507 "reversi-view.c"
	}
#line 1230 "../src/reversi-view.vala"
	_tmp3_ = reversi_view_pointer_is_in_board (self, event_x, event_y, &_tmp1_, &_tmp2_);
#line 1230 "../src/reversi-view.vala"
	x = _tmp1_;
#line 1230 "../src/reversi-view.vala"
	y = _tmp2_;
#line 1230 "../src/reversi-view.vala"
	if (_tmp3_) {
#line 1232 "../src/reversi-view.vala"
		self->priv->mouse_is_in = TRUE;
#line 1233 "../src/reversi-view.vala"
		self->priv->show_highlight = FALSE;
#line 1234 "../src/reversi-view.vala"
		self->priv->old_highlight_x = self->priv->highlight_x;
#line 1235 "../src/reversi-view.vala"
		self->priv->old_highlight_y = self->priv->highlight_y;
#line 1236 "../src/reversi-view.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 1237 "../src/reversi-view.vala"
		self->priv->highlight_set = TRUE;
#line 1238 "../src/reversi-view.vala"
		self->priv->highlight_x = x;
#line 1239 "../src/reversi-view.vala"
		self->priv->highlight_y = y;
#line 1240 "../src/reversi-view.vala"
		reversi_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
#line 6535 "reversi-view.c"
	}
}

static gboolean
_reversi_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                   guint keyval,
                                                                   guint keycode,
                                                                   GdkModifierType state,
                                                                   gpointer self)
{
	gboolean result;
	result = reversi_view_on_key_pressed ((ReversiView*) self, _sender, keyval, keycode, state);
#line 1253 "../src/reversi-view.vala"
	return result;
#line 6550 "reversi-view.c"
}

static void
reversi_view_init_keyboard (ReversiView* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
#line 1250 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1252 "../src/reversi-view.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 1252 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 1252 "../src/reversi-view.vala"
	self->priv->key_controller = _tmp0_;
#line 1253 "../src/reversi-view.vala"
	_tmp1_ = self->priv->key_controller;
#line 1253 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _reversi_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 6570 "reversi-view.c"
}

static inline gboolean
reversi_view_on_key_pressed (ReversiView* self,
                             GtkEventControllerKey* _key_controller,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* key = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	GQuark _tmp66_ = 0U;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label0 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label1 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label2 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label3 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label4 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label5 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label6 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label7 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label8 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label9 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label10 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label11 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label12 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label13 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label14 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label15 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label16 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label17 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label18 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label19 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label20 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label21 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label22 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label23 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label24 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label25 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label26 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label27 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label28 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label29 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label30 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label31 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label32 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label33 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label34 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label35 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label36 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label37 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label38 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label39 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label40 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label41 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label42 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label43 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label44 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label45 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label46 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label47 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label48 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label49 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label50 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label51 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label52 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label53 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label54 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label55 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label56 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label57 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label58 = 0;
#line 1281 "../src/reversi-view.vala"
	static GQuark _tmp65_label59 = 0;
#line 6715 "reversi-view.c"
	gboolean _tmp71_ = FALSE;
	gboolean _tmp72_ = FALSE;
	const gchar* _tmp73_;
	const gchar* _tmp76_;
	gboolean _tmp77_ = FALSE;
	const gchar* _tmp78_;
	gboolean result;
#line 1256 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1256 "../src/reversi-view.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 1258 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 1259 "../src/reversi-view.vala"
		result = FALSE;
#line 1259 "../src/reversi-view.vala"
		return result;
#line 6733 "reversi-view.c"
	}
#line 1261 "../src/reversi-view.vala"
	_tmp1_ = gdk_keyval_name (keyval);
#line 1261 "../src/reversi-view.vala"
	_tmp0_ = _tmp1_;
#line 1261 "../src/reversi-view.vala"
	if (_tmp0_ == NULL) {
#line 1261 "../src/reversi-view.vala"
		_tmp0_ = "";
#line 6743 "reversi-view.c"
	}
#line 1261 "../src/reversi-view.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 1261 "../src/reversi-view.vala"
	key = _tmp2_;
#line 1262 "../src/reversi-view.vala"
	_tmp3_ = key;
#line 1262 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 1263 "../src/reversi-view.vala"
		result = FALSE;
#line 1263 "../src/reversi-view.vala"
		_g_free0 (key);
#line 1263 "../src/reversi-view.vala"
		return result;
#line 6759 "reversi-view.c"
	}
#line 1265 "../src/reversi-view.vala"
	if (self->priv->show_highlight) {
#line 6763 "reversi-view.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
#line 1265 "../src/reversi-view.vala"
		_tmp7_ = key;
#line 1265 "../src/reversi-view.vala"
		if (g_strcmp0 (_tmp7_, "space") == 0) {
#line 1265 "../src/reversi-view.vala"
			_tmp6_ = TRUE;
#line 6773 "reversi-view.c"
		} else {
			const gchar* _tmp8_;
#line 1265 "../src/reversi-view.vala"
			_tmp8_ = key;
#line 1265 "../src/reversi-view.vala"
			_tmp6_ = g_strcmp0 (_tmp8_, "Return") == 0;
#line 6780 "reversi-view.c"
		}
#line 1265 "../src/reversi-view.vala"
		if (_tmp6_) {
#line 1265 "../src/reversi-view.vala"
			_tmp5_ = TRUE;
#line 6786 "reversi-view.c"
		} else {
			const gchar* _tmp9_;
#line 1265 "../src/reversi-view.vala"
			_tmp9_ = key;
#line 1265 "../src/reversi-view.vala"
			_tmp5_ = g_strcmp0 (_tmp9_, "KP_Enter") == 0;
#line 6793 "reversi-view.c"
		}
#line 1265 "../src/reversi-view.vala"
		_tmp4_ = _tmp5_;
#line 6797 "reversi-view.c"
	} else {
#line 1265 "../src/reversi-view.vala"
		_tmp4_ = FALSE;
#line 6801 "reversi-view.c"
	}
#line 1265 "../src/reversi-view.vala"
	if (_tmp4_) {
#line 1267 "../src/reversi-view.vala"
		reversi_view_move_if_possible (self, self->priv->highlight_x, self->priv->highlight_y);
#line 1268 "../src/reversi-view.vala"
		result = TRUE;
#line 1268 "../src/reversi-view.vala"
		_g_free0 (key);
#line 1268 "../src/reversi-view.vala"
		return result;
#line 6813 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (((gint) self->priv->game_size) <= 4) {
#line 6817 "reversi-view.c"
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
#line 1271 "../src/reversi-view.vala"
		_tmp19_ = key;
#line 1271 "../src/reversi-view.vala"
		if (g_strcmp0 (_tmp19_, "e") == 0) {
#line 1271 "../src/reversi-view.vala"
			_tmp18_ = TRUE;
#line 6828 "reversi-view.c"
		} else {
			const gchar* _tmp20_;
#line 1271 "../src/reversi-view.vala"
			_tmp20_ = key;
#line 1271 "../src/reversi-view.vala"
			_tmp18_ = g_strcmp0 (_tmp20_, "E") == 0;
#line 6835 "reversi-view.c"
		}
#line 1271 "../src/reversi-view.vala"
		if (_tmp18_) {
#line 1271 "../src/reversi-view.vala"
			_tmp17_ = TRUE;
#line 6841 "reversi-view.c"
		} else {
			const gchar* _tmp21_;
#line 1271 "../src/reversi-view.vala"
			_tmp21_ = key;
#line 1271 "../src/reversi-view.vala"
			_tmp17_ = g_strcmp0 (_tmp21_, "5") == 0;
#line 6848 "reversi-view.c"
		}
#line 1271 "../src/reversi-view.vala"
		if (_tmp17_) {
#line 1271 "../src/reversi-view.vala"
			_tmp16_ = TRUE;
#line 6854 "reversi-view.c"
		} else {
			const gchar* _tmp22_;
#line 1271 "../src/reversi-view.vala"
			_tmp22_ = key;
#line 1271 "../src/reversi-view.vala"
			_tmp16_ = g_strcmp0 (_tmp22_, "KP_5") == 0;
#line 6861 "reversi-view.c"
		}
#line 1271 "../src/reversi-view.vala"
		_tmp15_ = _tmp16_;
#line 6865 "reversi-view.c"
	} else {
#line 1271 "../src/reversi-view.vala"
		_tmp15_ = FALSE;
#line 6869 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (_tmp15_) {
#line 1271 "../src/reversi-view.vala"
		_tmp14_ = TRUE;
#line 6875 "reversi-view.c"
	} else {
		gboolean _tmp23_ = FALSE;
#line 1272 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 5) {
#line 6880 "reversi-view.c"
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			gboolean _tmp26_ = FALSE;
			const gchar* _tmp27_;
#line 1272 "../src/reversi-view.vala"
			_tmp27_ = key;
#line 1272 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp27_, "f") == 0) {
#line 1272 "../src/reversi-view.vala"
				_tmp26_ = TRUE;
#line 6891 "reversi-view.c"
			} else {
				const gchar* _tmp28_;
#line 1272 "../src/reversi-view.vala"
				_tmp28_ = key;
#line 1272 "../src/reversi-view.vala"
				_tmp26_ = g_strcmp0 (_tmp28_, "F") == 0;
#line 6898 "reversi-view.c"
			}
#line 1272 "../src/reversi-view.vala"
			if (_tmp26_) {
#line 1272 "../src/reversi-view.vala"
				_tmp25_ = TRUE;
#line 6904 "reversi-view.c"
			} else {
				const gchar* _tmp29_;
#line 1272 "../src/reversi-view.vala"
				_tmp29_ = key;
#line 1272 "../src/reversi-view.vala"
				_tmp25_ = g_strcmp0 (_tmp29_, "6") == 0;
#line 6911 "reversi-view.c"
			}
#line 1272 "../src/reversi-view.vala"
			if (_tmp25_) {
#line 1272 "../src/reversi-view.vala"
				_tmp24_ = TRUE;
#line 6917 "reversi-view.c"
			} else {
				const gchar* _tmp30_;
#line 1272 "../src/reversi-view.vala"
				_tmp30_ = key;
#line 1272 "../src/reversi-view.vala"
				_tmp24_ = g_strcmp0 (_tmp30_, "KP_6") == 0;
#line 6924 "reversi-view.c"
			}
#line 1272 "../src/reversi-view.vala"
			_tmp23_ = _tmp24_;
#line 6928 "reversi-view.c"
		} else {
#line 1272 "../src/reversi-view.vala"
			_tmp23_ = FALSE;
#line 6932 "reversi-view.c"
		}
#line 1272 "../src/reversi-view.vala"
		_tmp14_ = _tmp23_;
#line 6936 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (_tmp14_) {
#line 1271 "../src/reversi-view.vala"
		_tmp13_ = TRUE;
#line 6942 "reversi-view.c"
	} else {
		gboolean _tmp31_ = FALSE;
#line 1273 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 6) {
#line 6947 "reversi-view.c"
			gboolean _tmp32_ = FALSE;
			gboolean _tmp33_ = FALSE;
			gboolean _tmp34_ = FALSE;
			const gchar* _tmp35_;
#line 1273 "../src/reversi-view.vala"
			_tmp35_ = key;
#line 1273 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp35_, "g") == 0) {
#line 1273 "../src/reversi-view.vala"
				_tmp34_ = TRUE;
#line 6958 "reversi-view.c"
			} else {
				const gchar* _tmp36_;
#line 1273 "../src/reversi-view.vala"
				_tmp36_ = key;
#line 1273 "../src/reversi-view.vala"
				_tmp34_ = g_strcmp0 (_tmp36_, "G") == 0;
#line 6965 "reversi-view.c"
			}
#line 1273 "../src/reversi-view.vala"
			if (_tmp34_) {
#line 1273 "../src/reversi-view.vala"
				_tmp33_ = TRUE;
#line 6971 "reversi-view.c"
			} else {
				const gchar* _tmp37_;
#line 1273 "../src/reversi-view.vala"
				_tmp37_ = key;
#line 1273 "../src/reversi-view.vala"
				_tmp33_ = g_strcmp0 (_tmp37_, "7") == 0;
#line 6978 "reversi-view.c"
			}
#line 1273 "../src/reversi-view.vala"
			if (_tmp33_) {
#line 1273 "../src/reversi-view.vala"
				_tmp32_ = TRUE;
#line 6984 "reversi-view.c"
			} else {
				const gchar* _tmp38_;
#line 1273 "../src/reversi-view.vala"
				_tmp38_ = key;
#line 1273 "../src/reversi-view.vala"
				_tmp32_ = g_strcmp0 (_tmp38_, "KP_7") == 0;
#line 6991 "reversi-view.c"
			}
#line 1273 "../src/reversi-view.vala"
			_tmp31_ = _tmp32_;
#line 6995 "reversi-view.c"
		} else {
#line 1273 "../src/reversi-view.vala"
			_tmp31_ = FALSE;
#line 6999 "reversi-view.c"
		}
#line 1273 "../src/reversi-view.vala"
		_tmp13_ = _tmp31_;
#line 7003 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (_tmp13_) {
#line 1271 "../src/reversi-view.vala"
		_tmp12_ = TRUE;
#line 7009 "reversi-view.c"
	} else {
		gboolean _tmp39_ = FALSE;
#line 1274 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 7) {
#line 7014 "reversi-view.c"
			gboolean _tmp40_ = FALSE;
			gboolean _tmp41_ = FALSE;
			gboolean _tmp42_ = FALSE;
			const gchar* _tmp43_;
#line 1274 "../src/reversi-view.vala"
			_tmp43_ = key;
#line 1274 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp43_, "h") == 0) {
#line 1274 "../src/reversi-view.vala"
				_tmp42_ = TRUE;
#line 7025 "reversi-view.c"
			} else {
				const gchar* _tmp44_;
#line 1274 "../src/reversi-view.vala"
				_tmp44_ = key;
#line 1274 "../src/reversi-view.vala"
				_tmp42_ = g_strcmp0 (_tmp44_, "H") == 0;
#line 7032 "reversi-view.c"
			}
#line 1274 "../src/reversi-view.vala"
			if (_tmp42_) {
#line 1274 "../src/reversi-view.vala"
				_tmp41_ = TRUE;
#line 7038 "reversi-view.c"
			} else {
				const gchar* _tmp45_;
#line 1274 "../src/reversi-view.vala"
				_tmp45_ = key;
#line 1274 "../src/reversi-view.vala"
				_tmp41_ = g_strcmp0 (_tmp45_, "8") == 0;
#line 7045 "reversi-view.c"
			}
#line 1274 "../src/reversi-view.vala"
			if (_tmp41_) {
#line 1274 "../src/reversi-view.vala"
				_tmp40_ = TRUE;
#line 7051 "reversi-view.c"
			} else {
				const gchar* _tmp46_;
#line 1274 "../src/reversi-view.vala"
				_tmp46_ = key;
#line 1274 "../src/reversi-view.vala"
				_tmp40_ = g_strcmp0 (_tmp46_, "KP_8") == 0;
#line 7058 "reversi-view.c"
			}
#line 1274 "../src/reversi-view.vala"
			_tmp39_ = _tmp40_;
#line 7062 "reversi-view.c"
		} else {
#line 1274 "../src/reversi-view.vala"
			_tmp39_ = FALSE;
#line 7066 "reversi-view.c"
		}
#line 1274 "../src/reversi-view.vala"
		_tmp12_ = _tmp39_;
#line 7070 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (_tmp12_) {
#line 1271 "../src/reversi-view.vala"
		_tmp11_ = TRUE;
#line 7076 "reversi-view.c"
	} else {
		gboolean _tmp47_ = FALSE;
#line 1275 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 8) {
#line 7081 "reversi-view.c"
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			gboolean _tmp50_ = FALSE;
			const gchar* _tmp51_;
#line 1275 "../src/reversi-view.vala"
			_tmp51_ = key;
#line 1275 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp51_, "i") == 0) {
#line 1275 "../src/reversi-view.vala"
				_tmp50_ = TRUE;
#line 7092 "reversi-view.c"
			} else {
				const gchar* _tmp52_;
#line 1275 "../src/reversi-view.vala"
				_tmp52_ = key;
#line 1275 "../src/reversi-view.vala"
				_tmp50_ = g_strcmp0 (_tmp52_, "I") == 0;
#line 7099 "reversi-view.c"
			}
#line 1275 "../src/reversi-view.vala"
			if (_tmp50_) {
#line 1275 "../src/reversi-view.vala"
				_tmp49_ = TRUE;
#line 7105 "reversi-view.c"
			} else {
				const gchar* _tmp53_;
#line 1275 "../src/reversi-view.vala"
				_tmp53_ = key;
#line 1275 "../src/reversi-view.vala"
				_tmp49_ = g_strcmp0 (_tmp53_, "9") == 0;
#line 7112 "reversi-view.c"
			}
#line 1275 "../src/reversi-view.vala"
			if (_tmp49_) {
#line 1275 "../src/reversi-view.vala"
				_tmp48_ = TRUE;
#line 7118 "reversi-view.c"
			} else {
				const gchar* _tmp54_;
#line 1275 "../src/reversi-view.vala"
				_tmp54_ = key;
#line 1275 "../src/reversi-view.vala"
				_tmp48_ = g_strcmp0 (_tmp54_, "KP_9") == 0;
#line 7125 "reversi-view.c"
			}
#line 1275 "../src/reversi-view.vala"
			_tmp47_ = _tmp48_;
#line 7129 "reversi-view.c"
		} else {
#line 1275 "../src/reversi-view.vala"
			_tmp47_ = FALSE;
#line 7133 "reversi-view.c"
		}
#line 1275 "../src/reversi-view.vala"
		_tmp11_ = _tmp47_;
#line 7137 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (_tmp11_) {
#line 1271 "../src/reversi-view.vala"
		_tmp10_ = TRUE;
#line 7143 "reversi-view.c"
	} else {
		gboolean _tmp55_ = FALSE;
#line 1276 "../src/reversi-view.vala"
		if (((gint) self->priv->game_size) <= 9) {
#line 7148 "reversi-view.c"
			gboolean _tmp56_ = FALSE;
			gboolean _tmp57_ = FALSE;
			gboolean _tmp58_ = FALSE;
			const gchar* _tmp59_;
#line 1276 "../src/reversi-view.vala"
			_tmp59_ = key;
#line 1276 "../src/reversi-view.vala"
			if (g_strcmp0 (_tmp59_, "j") == 0) {
#line 1276 "../src/reversi-view.vala"
				_tmp58_ = TRUE;
#line 7159 "reversi-view.c"
			} else {
				const gchar* _tmp60_;
#line 1276 "../src/reversi-view.vala"
				_tmp60_ = key;
#line 1276 "../src/reversi-view.vala"
				_tmp58_ = g_strcmp0 (_tmp60_, "J") == 0;
#line 7166 "reversi-view.c"
			}
#line 1276 "../src/reversi-view.vala"
			if (_tmp58_) {
#line 1276 "../src/reversi-view.vala"
				_tmp57_ = TRUE;
#line 7172 "reversi-view.c"
			} else {
				const gchar* _tmp61_;
#line 1276 "../src/reversi-view.vala"
				_tmp61_ = key;
#line 1276 "../src/reversi-view.vala"
				_tmp57_ = g_strcmp0 (_tmp61_, "0") == 0;
#line 7179 "reversi-view.c"
			}
#line 1276 "../src/reversi-view.vala"
			if (_tmp57_) {
#line 1276 "../src/reversi-view.vala"
				_tmp56_ = TRUE;
#line 7185 "reversi-view.c"
			} else {
				const gchar* _tmp62_;
#line 1276 "../src/reversi-view.vala"
				_tmp62_ = key;
#line 1276 "../src/reversi-view.vala"
				_tmp56_ = g_strcmp0 (_tmp62_, "KP_0") == 0;
#line 7192 "reversi-view.c"
			}
#line 1276 "../src/reversi-view.vala"
			_tmp55_ = _tmp56_;
#line 7196 "reversi-view.c"
		} else {
#line 1276 "../src/reversi-view.vala"
			_tmp55_ = FALSE;
#line 7200 "reversi-view.c"
		}
#line 1276 "../src/reversi-view.vala"
		_tmp10_ = _tmp55_;
#line 7204 "reversi-view.c"
	}
#line 1271 "../src/reversi-view.vala"
	if (_tmp10_) {
#line 1277 "../src/reversi-view.vala"
		result = FALSE;
#line 1277 "../src/reversi-view.vala"
		_g_free0 (key);
#line 1277 "../src/reversi-view.vala"
		return result;
#line 7214 "reversi-view.c"
	}
#line 1279 "../src/reversi-view.vala"
	self->priv->old_highlight_x = self->priv->highlight_x;
#line 1280 "../src/reversi-view.vala"
	self->priv->old_highlight_y = self->priv->highlight_y;
#line 1281 "../src/reversi-view.vala"
	_tmp63_ = key;
#line 1281 "../src/reversi-view.vala"
	_tmp64_ = _tmp63_;
#line 1281 "../src/reversi-view.vala"
	_tmp66_ = (NULL == _tmp64_) ? 0 : g_quark_from_string (_tmp64_);
#line 1281 "../src/reversi-view.vala"
	if ((_tmp66_ == ((0 != _tmp65_label0) ? _tmp65_label0 : (_tmp65_label0 = g_quark_from_static_string ("Up")))) || (_tmp66_ == ((0 != _tmp65_label1) ? _tmp65_label1 : (_tmp65_label1 = g_quark_from_static_string ("KP_Up"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7230 "reversi-view.c"
			default:
			{
#line 1285 "../src/reversi-view.vala"
				reversi_view_set_highlight_position_if_needed (self, REVERSI_VIEW_DIRECTION_TOP);
#line 1286 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_y) > 0) {
#line 7237 "reversi-view.c"
					guint8 _tmp67_;
#line 1286 "../src/reversi-view.vala"
					_tmp67_ = self->priv->highlight_y;
#line 1286 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp67_ - 1;
#line 7243 "reversi-view.c"
				}
#line 1287 "../src/reversi-view.vala"
				break;
#line 7247 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label2) ? _tmp65_label2 : (_tmp65_label2 = g_quark_from_static_string ("Left")))) || (_tmp66_ == ((0 != _tmp65_label3) ? _tmp65_label3 : (_tmp65_label3 = g_quark_from_static_string ("KP_Left"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7253 "reversi-view.c"
			default:
			{
#line 1290 "../src/reversi-view.vala"
				reversi_view_set_highlight_position_if_needed (self, REVERSI_VIEW_DIRECTION_LEFT);
#line 1291 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_x) > 0) {
#line 7260 "reversi-view.c"
					guint8 _tmp68_;
#line 1291 "../src/reversi-view.vala"
					_tmp68_ = self->priv->highlight_x;
#line 1291 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp68_ - 1;
#line 7266 "reversi-view.c"
				}
#line 1292 "../src/reversi-view.vala"
				break;
#line 7270 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label4) ? _tmp65_label4 : (_tmp65_label4 = g_quark_from_static_string ("Right")))) || (_tmp66_ == ((0 != _tmp65_label5) ? _tmp65_label5 : (_tmp65_label5 = g_quark_from_static_string ("KP_Right"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7276 "reversi-view.c"
			default:
			{
#line 1295 "../src/reversi-view.vala"
				reversi_view_set_highlight_position_if_needed (self, REVERSI_VIEW_DIRECTION_RIGHT);
#line 1296 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_x) < (self->priv->game_size - 1)) {
#line 7283 "reversi-view.c"
					guint8 _tmp69_;
#line 1296 "../src/reversi-view.vala"
					_tmp69_ = self->priv->highlight_x;
#line 1296 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp69_ + 1;
#line 7289 "reversi-view.c"
				}
#line 1297 "../src/reversi-view.vala"
				break;
#line 7293 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label6) ? _tmp65_label6 : (_tmp65_label6 = g_quark_from_static_string ("Down")))) || (_tmp66_ == ((0 != _tmp65_label7) ? _tmp65_label7 : (_tmp65_label7 = g_quark_from_static_string ("KP_Down"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7299 "reversi-view.c"
			default:
			{
#line 1300 "../src/reversi-view.vala"
				reversi_view_set_highlight_position_if_needed (self, REVERSI_VIEW_DIRECTION_BOTTOM);
#line 1301 "../src/reversi-view.vala"
				if (((gint) self->priv->highlight_y) < (self->priv->game_size - 1)) {
#line 7306 "reversi-view.c"
					guint8 _tmp70_;
#line 1301 "../src/reversi-view.vala"
					_tmp70_ = self->priv->highlight_y;
#line 1301 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp70_ + 1;
#line 7312 "reversi-view.c"
				}
#line 1302 "../src/reversi-view.vala"
				break;
#line 7316 "reversi-view.c"
			}
		}
	} else if (((_tmp66_ == ((0 != _tmp65_label8) ? _tmp65_label8 : (_tmp65_label8 = g_quark_from_static_string ("space")))) || (_tmp66_ == ((0 != _tmp65_label9) ? _tmp65_label9 : (_tmp65_label9 = g_quark_from_static_string ("Return"))))) || (_tmp66_ == ((0 != _tmp65_label10) ? _tmp65_label10 : (_tmp65_label10 = g_quark_from_static_string ("KP_Enter"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7322 "reversi-view.c"
			default:
			{
#line 1307 "../src/reversi-view.vala"
				if (self->priv->show_mouse_highlight) {
#line 1309 "../src/reversi-view.vala"
					reversi_view_move_if_possible (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 1310 "../src/reversi-view.vala"
					result = TRUE;
#line 1310 "../src/reversi-view.vala"
					_g_free0 (key);
#line 1310 "../src/reversi-view.vala"
					return result;
#line 7335 "reversi-view.c"
				} else {
#line 1312 "../src/reversi-view.vala"
					if (self->priv->mouse_position_set) {
#line 1314 "../src/reversi-view.vala"
						self->priv->highlight_x = self->priv->mouse_position_x;
#line 1315 "../src/reversi-view.vala"
						self->priv->highlight_y = self->priv->mouse_position_y;
#line 7343 "reversi-view.c"
					} else {
#line 1317 "../src/reversi-view.vala"
						reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 7347 "reversi-view.c"
					}
				}
#line 1318 "../src/reversi-view.vala"
				break;
#line 7352 "reversi-view.c"
			}
		}
	} else if (_tmp66_ == ((0 != _tmp65_label11) ? _tmp65_label11 : (_tmp65_label11 = g_quark_from_static_string ("Escape")))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7358 "reversi-view.c"
			default:
			{
#line 1320 "../src/reversi-view.vala"
				break;
#line 7363 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label12) ? _tmp65_label12 : (_tmp65_label12 = g_quark_from_static_string ("a")))) || (_tmp66_ == ((0 != _tmp65_label13) ? _tmp65_label13 : (_tmp65_label13 = g_quark_from_static_string ("A"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7369 "reversi-view.c"
			default:
			{
#line 1322 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1322 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1322 "../src/reversi-view.vala"
				break;
#line 7378 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label14) ? _tmp65_label14 : (_tmp65_label14 = g_quark_from_static_string ("b")))) || (_tmp66_ == ((0 != _tmp65_label15) ? _tmp65_label15 : (_tmp65_label15 = g_quark_from_static_string ("B"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7384 "reversi-view.c"
			default:
			{
#line 1323 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1323 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 1;
#line 1323 "../src/reversi-view.vala"
				break;
#line 7393 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label16) ? _tmp65_label16 : (_tmp65_label16 = g_quark_from_static_string ("c")))) || (_tmp66_ == ((0 != _tmp65_label17) ? _tmp65_label17 : (_tmp65_label17 = g_quark_from_static_string ("C"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7399 "reversi-view.c"
			default:
			{
#line 1324 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1324 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 2;
#line 1324 "../src/reversi-view.vala"
				break;
#line 7408 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label18) ? _tmp65_label18 : (_tmp65_label18 = g_quark_from_static_string ("d")))) || (_tmp66_ == ((0 != _tmp65_label19) ? _tmp65_label19 : (_tmp65_label19 = g_quark_from_static_string ("D"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7414 "reversi-view.c"
			default:
			{
#line 1325 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1325 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 3;
#line 1325 "../src/reversi-view.vala"
				break;
#line 7423 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label20) ? _tmp65_label20 : (_tmp65_label20 = g_quark_from_static_string ("e")))) || (_tmp66_ == ((0 != _tmp65_label21) ? _tmp65_label21 : (_tmp65_label21 = g_quark_from_static_string ("E"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7429 "reversi-view.c"
			default:
			{
#line 1326 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1326 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 4;
#line 1326 "../src/reversi-view.vala"
				break;
#line 7438 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label22) ? _tmp65_label22 : (_tmp65_label22 = g_quark_from_static_string ("f")))) || (_tmp66_ == ((0 != _tmp65_label23) ? _tmp65_label23 : (_tmp65_label23 = g_quark_from_static_string ("F"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7444 "reversi-view.c"
			default:
			{
#line 1327 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1327 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 5;
#line 1327 "../src/reversi-view.vala"
				break;
#line 7453 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label24) ? _tmp65_label24 : (_tmp65_label24 = g_quark_from_static_string ("g")))) || (_tmp66_ == ((0 != _tmp65_label25) ? _tmp65_label25 : (_tmp65_label25 = g_quark_from_static_string ("G"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7459 "reversi-view.c"
			default:
			{
#line 1328 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1328 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 6;
#line 1328 "../src/reversi-view.vala"
				break;
#line 7468 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label26) ? _tmp65_label26 : (_tmp65_label26 = g_quark_from_static_string ("h")))) || (_tmp66_ == ((0 != _tmp65_label27) ? _tmp65_label27 : (_tmp65_label27 = g_quark_from_static_string ("H"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7474 "reversi-view.c"
			default:
			{
#line 1329 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1329 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 7;
#line 1329 "../src/reversi-view.vala"
				break;
#line 7483 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label28) ? _tmp65_label28 : (_tmp65_label28 = g_quark_from_static_string ("i")))) || (_tmp66_ == ((0 != _tmp65_label29) ? _tmp65_label29 : (_tmp65_label29 = g_quark_from_static_string ("I"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7489 "reversi-view.c"
			default:
			{
#line 1330 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1330 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 8;
#line 1330 "../src/reversi-view.vala"
				break;
#line 7498 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label30) ? _tmp65_label30 : (_tmp65_label30 = g_quark_from_static_string ("j")))) || (_tmp66_ == ((0 != _tmp65_label31) ? _tmp65_label31 : (_tmp65_label31 = g_quark_from_static_string ("J"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7504 "reversi-view.c"
			default:
			{
#line 1331 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1331 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 9;
#line 1331 "../src/reversi-view.vala"
				break;
#line 7513 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label32) ? _tmp65_label32 : (_tmp65_label32 = g_quark_from_static_string ("1")))) || (_tmp66_ == ((0 != _tmp65_label33) ? _tmp65_label33 : (_tmp65_label33 = g_quark_from_static_string ("KP_1"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7519 "reversi-view.c"
			default:
			{
#line 1333 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1333 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1333 "../src/reversi-view.vala"
				break;
#line 7528 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label34) ? _tmp65_label34 : (_tmp65_label34 = g_quark_from_static_string ("2")))) || (_tmp66_ == ((0 != _tmp65_label35) ? _tmp65_label35 : (_tmp65_label35 = g_quark_from_static_string ("KP_2"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7534 "reversi-view.c"
			default:
			{
#line 1334 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1334 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 1;
#line 1334 "../src/reversi-view.vala"
				break;
#line 7543 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label36) ? _tmp65_label36 : (_tmp65_label36 = g_quark_from_static_string ("3")))) || (_tmp66_ == ((0 != _tmp65_label37) ? _tmp65_label37 : (_tmp65_label37 = g_quark_from_static_string ("KP_3"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7549 "reversi-view.c"
			default:
			{
#line 1335 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1335 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 2;
#line 1335 "../src/reversi-view.vala"
				break;
#line 7558 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label38) ? _tmp65_label38 : (_tmp65_label38 = g_quark_from_static_string ("4")))) || (_tmp66_ == ((0 != _tmp65_label39) ? _tmp65_label39 : (_tmp65_label39 = g_quark_from_static_string ("KP_4"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7564 "reversi-view.c"
			default:
			{
#line 1336 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1336 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 3;
#line 1336 "../src/reversi-view.vala"
				break;
#line 7573 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label40) ? _tmp65_label40 : (_tmp65_label40 = g_quark_from_static_string ("5")))) || (_tmp66_ == ((0 != _tmp65_label41) ? _tmp65_label41 : (_tmp65_label41 = g_quark_from_static_string ("KP_5"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7579 "reversi-view.c"
			default:
			{
#line 1337 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1337 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 4;
#line 1337 "../src/reversi-view.vala"
				break;
#line 7588 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label42) ? _tmp65_label42 : (_tmp65_label42 = g_quark_from_static_string ("6")))) || (_tmp66_ == ((0 != _tmp65_label43) ? _tmp65_label43 : (_tmp65_label43 = g_quark_from_static_string ("KP_6"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7594 "reversi-view.c"
			default:
			{
#line 1338 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1338 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 5;
#line 1338 "../src/reversi-view.vala"
				break;
#line 7603 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label44) ? _tmp65_label44 : (_tmp65_label44 = g_quark_from_static_string ("7")))) || (_tmp66_ == ((0 != _tmp65_label45) ? _tmp65_label45 : (_tmp65_label45 = g_quark_from_static_string ("KP_7"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7609 "reversi-view.c"
			default:
			{
#line 1339 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1339 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 6;
#line 1339 "../src/reversi-view.vala"
				break;
#line 7618 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label46) ? _tmp65_label46 : (_tmp65_label46 = g_quark_from_static_string ("8")))) || (_tmp66_ == ((0 != _tmp65_label47) ? _tmp65_label47 : (_tmp65_label47 = g_quark_from_static_string ("KP_8"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7624 "reversi-view.c"
			default:
			{
#line 1340 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1340 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 7;
#line 1340 "../src/reversi-view.vala"
				break;
#line 7633 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label48) ? _tmp65_label48 : (_tmp65_label48 = g_quark_from_static_string ("9")))) || (_tmp66_ == ((0 != _tmp65_label49) ? _tmp65_label49 : (_tmp65_label49 = g_quark_from_static_string ("KP_9"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7639 "reversi-view.c"
			default:
			{
#line 1341 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1341 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 8;
#line 1341 "../src/reversi-view.vala"
				break;
#line 7648 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label50) ? _tmp65_label50 : (_tmp65_label50 = g_quark_from_static_string ("0")))) || (_tmp66_ == ((0 != _tmp65_label51) ? _tmp65_label51 : (_tmp65_label51 = g_quark_from_static_string ("KP_0"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7654 "reversi-view.c"
			default:
			{
#line 1342 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1342 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 9;
#line 1342 "../src/reversi-view.vala"
				break;
#line 7663 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label52) ? _tmp65_label52 : (_tmp65_label52 = g_quark_from_static_string ("Home")))) || (_tmp66_ == ((0 != _tmp65_label53) ? _tmp65_label53 : (_tmp65_label53 = g_quark_from_static_string ("KP_Home"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7669 "reversi-view.c"
			default:
			{
#line 1346 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1347 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 1348 "../src/reversi-view.vala"
				break;
#line 7678 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label54) ? _tmp65_label54 : (_tmp65_label54 = g_quark_from_static_string ("End")))) || (_tmp66_ == ((0 != _tmp65_label55) ? _tmp65_label55 : (_tmp65_label55 = g_quark_from_static_string ("KP_End"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7684 "reversi-view.c"
			default:
			{
#line 1351 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1352 "../src/reversi-view.vala"
				self->priv->highlight_x = (guint8) (self->priv->game_size - 1);
#line 1353 "../src/reversi-view.vala"
				break;
#line 7693 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label56) ? _tmp65_label56 : (_tmp65_label56 = g_quark_from_static_string ("Page_Up")))) || (_tmp66_ == ((0 != _tmp65_label57) ? _tmp65_label57 : (_tmp65_label57 = g_quark_from_static_string ("KP_Page_Up"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7699 "reversi-view.c"
			default:
			{
#line 1356 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1357 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 1358 "../src/reversi-view.vala"
				break;
#line 7708 "reversi-view.c"
			}
		}
	} else if ((_tmp66_ == ((0 != _tmp65_label58) ? _tmp65_label58 : (_tmp65_label58 = g_quark_from_static_string ("Page_Down")))) || (_tmp66_ == ((0 != _tmp65_label59) ? _tmp65_label59 : (_tmp65_label59 = g_quark_from_static_string ("KP_Next"))))) {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7714 "reversi-view.c"
			default:
			{
#line 1361 "../src/reversi-view.vala"
				reversi_view_init_highlight_on_light_tile_if_needed (self);
#line 1362 "../src/reversi-view.vala"
				self->priv->highlight_y = (guint8) (self->priv->game_size - 1);
#line 1363 "../src/reversi-view.vala"
				break;
#line 7723 "reversi-view.c"
			}
		}
	} else {
#line 1281 "../src/reversi-view.vala"
		switch (0) {
#line 7729 "reversi-view.c"
			default:
			{
#line 1367 "../src/reversi-view.vala"
				result = FALSE;
#line 1367 "../src/reversi-view.vala"
				_g_free0 (key);
#line 1367 "../src/reversi-view.vala"
				return result;
#line 7738 "reversi-view.c"
			}
		}
	}
#line 1370 "../src/reversi-view.vala"
	self->priv->highlight_set = TRUE;
#line 1372 "../src/reversi-view.vala"
	_tmp73_ = key;
#line 1372 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp73_, "space") != 0) {
#line 7748 "reversi-view.c"
		const gchar* _tmp74_;
#line 1372 "../src/reversi-view.vala"
		_tmp74_ = key;
#line 1372 "../src/reversi-view.vala"
		_tmp72_ = g_strcmp0 (_tmp74_, "Return") != 0;
#line 7754 "reversi-view.c"
	} else {
#line 1372 "../src/reversi-view.vala"
		_tmp72_ = FALSE;
#line 7758 "reversi-view.c"
	}
#line 1372 "../src/reversi-view.vala"
	if (_tmp72_) {
#line 7762 "reversi-view.c"
		const gchar* _tmp75_;
#line 1372 "../src/reversi-view.vala"
		_tmp75_ = key;
#line 1372 "../src/reversi-view.vala"
		_tmp71_ = g_strcmp0 (_tmp75_, "KP_Enter") != 0;
#line 7768 "reversi-view.c"
	} else {
#line 1372 "../src/reversi-view.vala"
		_tmp71_ = FALSE;
#line 7772 "reversi-view.c"
	}
#line 1372 "../src/reversi-view.vala"
	if (_tmp71_) {
#line 1373 "../src/reversi-view.vala"
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL], 0);
#line 7778 "reversi-view.c"
	}
#line 1375 "../src/reversi-view.vala"
	_tmp76_ = key;
#line 1375 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp76_, "Escape") == 0) {
#line 1376 "../src/reversi-view.vala"
		self->priv->show_highlight = FALSE;
#line 7786 "reversi-view.c"
	} else {
#line 1377 "../src/reversi-view.vala"
		if (self->priv->show_highlight) {
#line 1378 "../src/reversi-view.vala"
			self->priv->highlight_state = REVERSI_VIEW_HIGHLIGHT_MAX;
#line 7792 "reversi-view.c"
		} else {
#line 1380 "../src/reversi-view.vala"
			self->priv->show_highlight = TRUE;
#line 7796 "reversi-view.c"
		}
	}
#line 1382 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, self->priv->old_highlight_x, self->priv->old_highlight_y);
#line 1383 "../src/reversi-view.vala"
	if (self->priv->old_highlight_x != self->priv->highlight_x) {
#line 1383 "../src/reversi-view.vala"
		_tmp77_ = TRUE;
#line 7805 "reversi-view.c"
	} else {
#line 1384 "../src/reversi-view.vala"
		_tmp77_ = self->priv->old_highlight_y != self->priv->highlight_y;
#line 7809 "reversi-view.c"
	}
#line 1383 "../src/reversi-view.vala"
	if (_tmp77_) {
#line 1385 "../src/reversi-view.vala"
		reversi_view_queue_draw_tile (self, self->priv->highlight_x, self->priv->highlight_y);
#line 7815 "reversi-view.c"
	}
#line 1386 "../src/reversi-view.vala"
	_tmp78_ = key;
#line 1386 "../src/reversi-view.vala"
	if (g_strcmp0 (_tmp78_, "Escape") != 0) {
#line 1388 "../src/reversi-view.vala"
		self->priv->show_mouse_highlight = FALSE;
#line 1389 "../src/reversi-view.vala"
		if (self->priv->mouse_position_set) {
#line 1390 "../src/reversi-view.vala"
			reversi_view_queue_draw_tile (self, self->priv->mouse_highlight_x, self->priv->mouse_highlight_y);
#line 7827 "reversi-view.c"
		}
	} else {
		gboolean _tmp79_ = FALSE;
#line 1392 "../src/reversi-view.vala"
		if (self->priv->mouse_position_set) {
#line 1392 "../src/reversi-view.vala"
			_tmp79_ = self->priv->mouse_is_in;
#line 7835 "reversi-view.c"
		} else {
#line 1392 "../src/reversi-view.vala"
			_tmp79_ = FALSE;
#line 7839 "reversi-view.c"
		}
#line 1392 "../src/reversi-view.vala"
		if (_tmp79_) {
#line 1394 "../src/reversi-view.vala"
			self->priv->highlight_x = self->priv->mouse_position_x;
#line 1395 "../src/reversi-view.vala"
			self->priv->highlight_y = self->priv->mouse_position_y;
#line 1396 "../src/reversi-view.vala"
			_reversi_view_on_motion (self, self->priv->highlight_x, self->priv->highlight_y, TRUE);
#line 7849 "reversi-view.c"
		}
	}
#line 1398 "../src/reversi-view.vala"
	result = TRUE;
#line 1398 "../src/reversi-view.vala"
	_g_free0 (key);
#line 1398 "../src/reversi-view.vala"
	return result;
#line 7858 "reversi-view.c"
}

static void
reversi_view_set_highlight_position_if_needed (ReversiView* self,
                                               ReversiViewDirection direction)
{
	gboolean _tmp0_ = FALSE;
	Game* _tmp1_;
	Game* _tmp2_;
	Player _tmp3_;
	Player _tmp4_;
	gboolean _tmp5_ = FALSE;
	Iagno* _tmp6_;
	ComputerPlayer* _tmp7_;
	ComputerPlayer* _tmp8_;
	Game* _tmp20_;
	Game* _tmp21_;
	Opening _tmp22_;
	Opening _tmp23_;
#line 1401 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1403 "../src/reversi-view.vala"
	if (self->priv->mouse_position_set) {
#line 1403 "../src/reversi-view.vala"
		_tmp0_ = self->priv->show_mouse_highlight;
#line 7884 "reversi-view.c"
	} else {
#line 1403 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 7888 "reversi-view.c"
	}
#line 1403 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1407 "../src/reversi-view.vala"
		self->priv->highlight_x = self->priv->mouse_highlight_x;
#line 1408 "../src/reversi-view.vala"
		self->priv->highlight_y = self->priv->mouse_highlight_y;
#line 1409 "../src/reversi-view.vala"
		return;
#line 7898 "reversi-view.c"
	}
#line 1412 "../src/reversi-view.vala"
	if (self->priv->highlight_set) {
#line 1414 "../src/reversi-view.vala"
		return;
#line 7904 "reversi-view.c"
	}
#line 1416 "../src/reversi-view.vala"
	_tmp1_ = reversi_view_get_game (self);
#line 1416 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 1416 "../src/reversi-view.vala"
	_tmp3_ = game_get_current_color (_tmp2_);
#line 1416 "../src/reversi-view.vala"
	_tmp4_ = _tmp3_;
#line 1416 "../src/reversi-view.vala"
	if (_tmp4_ == PLAYER_LIGHT) {
#line 1420 "../src/reversi-view.vala"
		reversi_view_init_highlight_on_light_tile (self);
#line 1421 "../src/reversi-view.vala"
		return;
#line 7920 "reversi-view.c"
	}
#line 1424 "../src/reversi-view.vala"
	_tmp6_ = self->priv->_iagno_instance;
#line 1424 "../src/reversi-view.vala"
	_tmp7_ = iagno_get_computer (_tmp6_);
#line 1424 "../src/reversi-view.vala"
	_tmp8_ = _tmp7_;
#line 1424 "../src/reversi-view.vala"
	if (_tmp8_ != NULL) {
#line 7930 "reversi-view.c"
		Iagno* _tmp9_;
		Player _tmp10_;
		Player _tmp11_;
#line 1424 "../src/reversi-view.vala"
		_tmp9_ = self->priv->_iagno_instance;
#line 1424 "../src/reversi-view.vala"
		_tmp10_ = iagno_get_player_one (_tmp9_);
#line 1424 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 1424 "../src/reversi-view.vala"
		_tmp5_ = _tmp11_ == PLAYER_LIGHT;
#line 7942 "reversi-view.c"
	} else {
#line 1424 "../src/reversi-view.vala"
		_tmp5_ = FALSE;
#line 7946 "reversi-view.c"
	}
#line 1424 "../src/reversi-view.vala"
	if (_tmp5_) {
#line 1432 "../src/reversi-view.vala"
		if (gtk_get_locale_direction () == GTK_TEXT_DIR_LTR) {
#line 1433 "../src/reversi-view.vala"
			switch (direction) {
#line 1433 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 7956 "reversi-view.c"
				{
					guint8 _tmp12_;
#line 1435 "../src/reversi-view.vala"
					_tmp12_ = self->priv->highlight_y;
#line 1435 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp12_ + 1;
#line 1435 "../src/reversi-view.vala"
					break;
#line 7965 "reversi-view.c"
				}
#line 1433 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 7969 "reversi-view.c"
				{
					guint8 _tmp13_;
					guint8 _tmp14_;
#line 1436 "../src/reversi-view.vala"
					_tmp13_ = self->priv->highlight_x;
#line 1436 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp13_ + 1;
#line 1436 "../src/reversi-view.vala"
					_tmp14_ = self->priv->highlight_y;
#line 1436 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp14_ + 1;
#line 1436 "../src/reversi-view.vala"
					break;
#line 7983 "reversi-view.c"
				}
#line 1433 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 7987 "reversi-view.c"
				{
#line 1437 "../src/reversi-view.vala"
					break;
#line 7991 "reversi-view.c"
				}
#line 1433 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 7995 "reversi-view.c"
				{
					guint8 _tmp15_;
#line 1438 "../src/reversi-view.vala"
					_tmp15_ = self->priv->highlight_x;
#line 1438 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp15_ + 1;
#line 1438 "../src/reversi-view.vala"
					break;
#line 8004 "reversi-view.c"
				}
				default:
#line 1433 "../src/reversi-view.vala"
				break;
#line 8009 "reversi-view.c"
			}
		} else {
#line 1441 "../src/reversi-view.vala"
			switch (direction) {
#line 1441 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8016 "reversi-view.c"
				{
					guint8 _tmp16_;
					guint8 _tmp17_;
#line 1443 "../src/reversi-view.vala"
					_tmp16_ = self->priv->highlight_x;
#line 1443 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp16_ + 1;
#line 1443 "../src/reversi-view.vala"
					_tmp17_ = self->priv->highlight_y;
#line 1443 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp17_ + 1;
#line 1443 "../src/reversi-view.vala"
					break;
#line 8030 "reversi-view.c"
				}
#line 1441 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8034 "reversi-view.c"
				{
					guint8 _tmp18_;
#line 1444 "../src/reversi-view.vala"
					_tmp18_ = self->priv->highlight_x;
#line 1444 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp18_ + 1;
#line 1444 "../src/reversi-view.vala"
					break;
#line 8043 "reversi-view.c"
				}
#line 1441 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8047 "reversi-view.c"
				{
					guint8 _tmp19_;
#line 1445 "../src/reversi-view.vala"
					_tmp19_ = self->priv->highlight_y;
#line 1445 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp19_ + 1;
#line 1445 "../src/reversi-view.vala"
					break;
#line 8056 "reversi-view.c"
				}
#line 1441 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8060 "reversi-view.c"
				{
#line 1446 "../src/reversi-view.vala"
					break;
#line 8064 "reversi-view.c"
				}
				default:
#line 1441 "../src/reversi-view.vala"
				break;
#line 8069 "reversi-view.c"
			}
		}
#line 1448 "../src/reversi-view.vala"
		return;
#line 8074 "reversi-view.c"
	}
#line 1451 "../src/reversi-view.vala"
	_tmp20_ = reversi_view_get_game (self);
#line 1451 "../src/reversi-view.vala"
	_tmp21_ = _tmp20_;
#line 1451 "../src/reversi-view.vala"
	_tmp22_ = game_get_opening (_tmp21_);
#line 1451 "../src/reversi-view.vala"
	_tmp23_ = _tmp22_;
#line 1451 "../src/reversi-view.vala"
	switch (_tmp23_) {
#line 1451 "../src/reversi-view.vala"
		case OPENING_HUMANS:
#line 8088 "reversi-view.c"
		{
#line 1459 "../src/reversi-view.vala"
			if (gtk_get_locale_direction () == GTK_TEXT_DIR_LTR) {
#line 1460 "../src/reversi-view.vala"
				switch (direction) {
#line 1460 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_TOP:
#line 8096 "reversi-view.c"
					{
						guint8 _tmp24_;
#line 1462 "../src/reversi-view.vala"
						_tmp24_ = self->priv->highlight_y;
#line 1462 "../src/reversi-view.vala"
						self->priv->highlight_y = _tmp24_ + 1;
#line 1462 "../src/reversi-view.vala"
						break;
#line 8105 "reversi-view.c"
					}
#line 1460 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_LEFT:
#line 8109 "reversi-view.c"
					{
						guint8 _tmp25_;
						guint8 _tmp26_;
#line 1463 "../src/reversi-view.vala"
						_tmp25_ = self->priv->highlight_x;
#line 1463 "../src/reversi-view.vala"
						self->priv->highlight_x = _tmp25_ + 1;
#line 1463 "../src/reversi-view.vala"
						_tmp26_ = self->priv->highlight_y;
#line 1463 "../src/reversi-view.vala"
						self->priv->highlight_y = _tmp26_ + 1;
#line 1463 "../src/reversi-view.vala"
						break;
#line 8123 "reversi-view.c"
					}
#line 1460 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8127 "reversi-view.c"
					{
#line 1464 "../src/reversi-view.vala"
						break;
#line 8131 "reversi-view.c"
					}
#line 1460 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8135 "reversi-view.c"
					{
						guint8 _tmp27_;
#line 1465 "../src/reversi-view.vala"
						_tmp27_ = self->priv->highlight_x;
#line 1465 "../src/reversi-view.vala"
						self->priv->highlight_x = _tmp27_ + 1;
#line 1465 "../src/reversi-view.vala"
						break;
#line 8144 "reversi-view.c"
					}
					default:
#line 1460 "../src/reversi-view.vala"
					break;
#line 8149 "reversi-view.c"
				}
			} else {
#line 1468 "../src/reversi-view.vala"
				switch (direction) {
#line 1468 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_TOP:
#line 8156 "reversi-view.c"
					{
						guint8 _tmp28_;
						guint8 _tmp29_;
#line 1470 "../src/reversi-view.vala"
						_tmp28_ = self->priv->highlight_x;
#line 1470 "../src/reversi-view.vala"
						self->priv->highlight_x = _tmp28_ + 1;
#line 1470 "../src/reversi-view.vala"
						_tmp29_ = self->priv->highlight_y;
#line 1470 "../src/reversi-view.vala"
						self->priv->highlight_y = _tmp29_ + 1;
#line 1470 "../src/reversi-view.vala"
						break;
#line 8170 "reversi-view.c"
					}
#line 1468 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_LEFT:
#line 8174 "reversi-view.c"
					{
						guint8 _tmp30_;
#line 1471 "../src/reversi-view.vala"
						_tmp30_ = self->priv->highlight_x;
#line 1471 "../src/reversi-view.vala"
						self->priv->highlight_x = _tmp30_ + 1;
#line 1471 "../src/reversi-view.vala"
						break;
#line 8183 "reversi-view.c"
					}
#line 1468 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8187 "reversi-view.c"
					{
						guint8 _tmp31_;
#line 1472 "../src/reversi-view.vala"
						_tmp31_ = self->priv->highlight_y;
#line 1472 "../src/reversi-view.vala"
						self->priv->highlight_y = _tmp31_ + 1;
#line 1472 "../src/reversi-view.vala"
						break;
#line 8196 "reversi-view.c"
					}
#line 1468 "../src/reversi-view.vala"
					case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8200 "reversi-view.c"
					{
#line 1473 "../src/reversi-view.vala"
						break;
#line 8204 "reversi-view.c"
					}
					default:
#line 1468 "../src/reversi-view.vala"
					break;
#line 8209 "reversi-view.c"
				}
			}
#line 1475 "../src/reversi-view.vala"
			return;
#line 8214 "reversi-view.c"
		}
#line 1451 "../src/reversi-view.vala"
		case OPENING_REVERSI:
#line 8218 "reversi-view.c"
		{
#line 1478 "../src/reversi-view.vala"
			switch (direction) {
#line 1478 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8224 "reversi-view.c"
				{
#line 1480 "../src/reversi-view.vala"
					break;
#line 8228 "reversi-view.c"
				}
#line 1478 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8232 "reversi-view.c"
				{
#line 1481 "../src/reversi-view.vala"
					break;
#line 8236 "reversi-view.c"
				}
#line 1478 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8240 "reversi-view.c"
				{
					guint8 _tmp32_;
					guint8 _tmp33_;
#line 1482 "../src/reversi-view.vala"
					_tmp32_ = self->priv->highlight_x;
#line 1482 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp32_ + 1;
#line 1482 "../src/reversi-view.vala"
					_tmp33_ = self->priv->highlight_y;
#line 1482 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp33_ + 1;
#line 1482 "../src/reversi-view.vala"
					break;
#line 8254 "reversi-view.c"
				}
#line 1478 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8258 "reversi-view.c"
				{
					guint8 _tmp34_;
					guint8 _tmp35_;
#line 1483 "../src/reversi-view.vala"
					_tmp34_ = self->priv->highlight_x;
#line 1483 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp34_ + 1;
#line 1483 "../src/reversi-view.vala"
					_tmp35_ = self->priv->highlight_y;
#line 1483 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp35_ + 1;
#line 1483 "../src/reversi-view.vala"
					break;
#line 8272 "reversi-view.c"
				}
				default:
#line 1478 "../src/reversi-view.vala"
				break;
#line 8277 "reversi-view.c"
			}
#line 1485 "../src/reversi-view.vala"
			return;
#line 8281 "reversi-view.c"
		}
#line 1451 "../src/reversi-view.vala"
		case OPENING_INVERTED:
#line 8285 "reversi-view.c"
		{
#line 1488 "../src/reversi-view.vala"
			switch (direction) {
#line 1488 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8291 "reversi-view.c"
				{
					guint8 _tmp36_;
#line 1490 "../src/reversi-view.vala"
					_tmp36_ = self->priv->highlight_x;
#line 1490 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp36_ + 1;
#line 1490 "../src/reversi-view.vala"
					break;
#line 8300 "reversi-view.c"
				}
#line 1488 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8304 "reversi-view.c"
				{
					guint8 _tmp37_;
#line 1491 "../src/reversi-view.vala"
					_tmp37_ = self->priv->highlight_y;
#line 1491 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp37_ + 1;
#line 1491 "../src/reversi-view.vala"
					break;
#line 8313 "reversi-view.c"
				}
#line 1488 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8317 "reversi-view.c"
				{
					guint8 _tmp38_;
#line 1492 "../src/reversi-view.vala"
					_tmp38_ = self->priv->highlight_x;
#line 1492 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp38_ + 1;
#line 1492 "../src/reversi-view.vala"
					break;
#line 8326 "reversi-view.c"
				}
#line 1488 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8330 "reversi-view.c"
				{
					guint8 _tmp39_;
#line 1493 "../src/reversi-view.vala"
					_tmp39_ = self->priv->highlight_y;
#line 1493 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp39_ + 1;
#line 1493 "../src/reversi-view.vala"
					break;
#line 8339 "reversi-view.c"
				}
				default:
#line 1488 "../src/reversi-view.vala"
				break;
#line 8344 "reversi-view.c"
			}
#line 1495 "../src/reversi-view.vala"
			return;
#line 8348 "reversi-view.c"
		}
#line 1451 "../src/reversi-view.vala"
		case OPENING_ALTER_TOP:
#line 8352 "reversi-view.c"
		{
#line 1498 "../src/reversi-view.vala"
			switch (direction) {
#line 1498 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8358 "reversi-view.c"
				{
					guint8 _tmp40_;
#line 1500 "../src/reversi-view.vala"
					_tmp40_ = self->priv->highlight_x;
#line 1500 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp40_ + 1;
#line 1500 "../src/reversi-view.vala"
					self->priv->highlight_y = (guint8) (self->priv->highlight_y + 3);
#line 1500 "../src/reversi-view.vala"
					break;
#line 8369 "reversi-view.c"
				}
#line 1498 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8373 "reversi-view.c"
				{
#line 1501 "../src/reversi-view.vala"
					self->priv->highlight_y = (guint8) (self->priv->highlight_y + 2);
#line 1501 "../src/reversi-view.vala"
					break;
#line 8379 "reversi-view.c"
				}
#line 1498 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8383 "reversi-view.c"
				{
					guint8 _tmp41_;
#line 1502 "../src/reversi-view.vala"
					_tmp41_ = self->priv->highlight_x;
#line 1502 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp41_ + 1;
#line 1502 "../src/reversi-view.vala"
					self->priv->highlight_y = (guint8) (self->priv->highlight_y + 2);
#line 1502 "../src/reversi-view.vala"
					break;
#line 8394 "reversi-view.c"
				}
#line 1498 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8398 "reversi-view.c"
				{
					guint8 _tmp42_;
#line 1503 "../src/reversi-view.vala"
					_tmp42_ = self->priv->highlight_y;
#line 1503 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp42_ + 1;
#line 1503 "../src/reversi-view.vala"
					break;
#line 8407 "reversi-view.c"
				}
				default:
#line 1498 "../src/reversi-view.vala"
				break;
#line 8412 "reversi-view.c"
			}
#line 1505 "../src/reversi-view.vala"
			return;
#line 8416 "reversi-view.c"
		}
#line 1451 "../src/reversi-view.vala"
		case OPENING_ALTER_LEFT:
#line 8420 "reversi-view.c"
		{
#line 1508 "../src/reversi-view.vala"
			switch (direction) {
#line 1508 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8426 "reversi-view.c"
				{
#line 1510 "../src/reversi-view.vala"
					self->priv->highlight_x = (guint8) (self->priv->highlight_x + 2);
#line 1510 "../src/reversi-view.vala"
					break;
#line 8432 "reversi-view.c"
				}
#line 1508 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8436 "reversi-view.c"
				{
					guint8 _tmp43_;
#line 1511 "../src/reversi-view.vala"
					self->priv->highlight_x = (guint8) (self->priv->highlight_x + 3);
#line 1511 "../src/reversi-view.vala"
					_tmp43_ = self->priv->highlight_y;
#line 1511 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp43_ + 1;
#line 1511 "../src/reversi-view.vala"
					break;
#line 8447 "reversi-view.c"
				}
#line 1508 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8451 "reversi-view.c"
				{
					guint8 _tmp44_;
#line 1512 "../src/reversi-view.vala"
					_tmp44_ = self->priv->highlight_x;
#line 1512 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp44_ + 1;
#line 1512 "../src/reversi-view.vala"
					break;
#line 8460 "reversi-view.c"
				}
#line 1508 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8464 "reversi-view.c"
				{
					guint8 _tmp45_;
#line 1513 "../src/reversi-view.vala"
					self->priv->highlight_x = (guint8) (self->priv->highlight_x + 2);
#line 1513 "../src/reversi-view.vala"
					_tmp45_ = self->priv->highlight_y;
#line 1513 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp45_ + 1;
#line 1513 "../src/reversi-view.vala"
					break;
#line 8475 "reversi-view.c"
				}
				default:
#line 1508 "../src/reversi-view.vala"
				break;
#line 8480 "reversi-view.c"
			}
#line 1515 "../src/reversi-view.vala"
			return;
#line 8484 "reversi-view.c"
		}
#line 1451 "../src/reversi-view.vala"
		case OPENING_ALTER_RIGHT:
#line 8488 "reversi-view.c"
		{
#line 1518 "../src/reversi-view.vala"
			switch (direction) {
#line 1518 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8494 "reversi-view.c"
				{
					guint8 _tmp46_;
#line 1520 "../src/reversi-view.vala"
					_tmp46_ = self->priv->highlight_x;
#line 1520 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp46_ - 1;
#line 1520 "../src/reversi-view.vala"
					break;
#line 8503 "reversi-view.c"
				}
#line 1518 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8507 "reversi-view.c"
				{
#line 1521 "../src/reversi-view.vala"
					break;
#line 8511 "reversi-view.c"
				}
#line 1518 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8515 "reversi-view.c"
				{
					guint8 _tmp47_;
#line 1522 "../src/reversi-view.vala"
					self->priv->highlight_x = (guint8) (self->priv->highlight_x - 2);
#line 1522 "../src/reversi-view.vala"
					_tmp47_ = self->priv->highlight_y;
#line 1522 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp47_ + 1;
#line 1522 "../src/reversi-view.vala"
					break;
#line 8526 "reversi-view.c"
				}
#line 1518 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8530 "reversi-view.c"
				{
					guint8 _tmp48_;
					guint8 _tmp49_;
#line 1523 "../src/reversi-view.vala"
					_tmp48_ = self->priv->highlight_x;
#line 1523 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp48_ - 1;
#line 1523 "../src/reversi-view.vala"
					_tmp49_ = self->priv->highlight_y;
#line 1523 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp49_ + 1;
#line 1523 "../src/reversi-view.vala"
					break;
#line 8544 "reversi-view.c"
				}
				default:
#line 1518 "../src/reversi-view.vala"
				break;
#line 8549 "reversi-view.c"
			}
#line 1525 "../src/reversi-view.vala"
			return;
#line 8553 "reversi-view.c"
		}
#line 1451 "../src/reversi-view.vala"
		case OPENING_ALTER_BOTTOM:
#line 8557 "reversi-view.c"
		{
#line 1528 "../src/reversi-view.vala"
			switch (direction) {
#line 1528 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_TOP:
#line 8563 "reversi-view.c"
				{
#line 1530 "../src/reversi-view.vala"
					break;
#line 8567 "reversi-view.c"
				}
#line 1528 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_LEFT:
#line 8571 "reversi-view.c"
				{
					guint8 _tmp50_;
#line 1531 "../src/reversi-view.vala"
					_tmp50_ = self->priv->highlight_y;
#line 1531 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp50_ - 1;
#line 1531 "../src/reversi-view.vala"
					break;
#line 8580 "reversi-view.c"
				}
#line 1528 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_RIGHT:
#line 8584 "reversi-view.c"
				{
					guint8 _tmp51_;
					guint8 _tmp52_;
#line 1532 "../src/reversi-view.vala"
					_tmp51_ = self->priv->highlight_x;
#line 1532 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp51_ + 1;
#line 1532 "../src/reversi-view.vala"
					_tmp52_ = self->priv->highlight_y;
#line 1532 "../src/reversi-view.vala"
					self->priv->highlight_y = _tmp52_ - 1;
#line 1532 "../src/reversi-view.vala"
					break;
#line 8598 "reversi-view.c"
				}
#line 1528 "../src/reversi-view.vala"
				case REVERSI_VIEW_DIRECTION_BOTTOM:
#line 8602 "reversi-view.c"
				{
					guint8 _tmp53_;
#line 1533 "../src/reversi-view.vala"
					_tmp53_ = self->priv->highlight_x;
#line 1533 "../src/reversi-view.vala"
					self->priv->highlight_x = _tmp53_ + 1;
#line 1533 "../src/reversi-view.vala"
					self->priv->highlight_y = (guint8) (self->priv->highlight_y - 2);
#line 1533 "../src/reversi-view.vala"
					break;
#line 8613 "reversi-view.c"
				}
				default:
#line 1528 "../src/reversi-view.vala"
				break;
#line 8618 "reversi-view.c"
			}
#line 1535 "../src/reversi-view.vala"
			return;
#line 8622 "reversi-view.c"
		}
		default:
#line 1451 "../src/reversi-view.vala"
		break;
#line 8627 "reversi-view.c"
	}
#line 1537 "../src/reversi-view.vala"
	g_assert_not_reached ();
#line 8631 "reversi-view.c"
}

static void
reversi_view_init_highlight_on_light_tile_if_needed (ReversiView* self)
{
	gboolean _tmp0_ = FALSE;
#line 1540 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1542 "../src/reversi-view.vala"
	if (!self->priv->highlight_set) {
#line 8642 "reversi-view.c"
		Game* _tmp1_;
		Game* _tmp2_;
		Player _tmp3_;
		Player _tmp4_;
#line 1542 "../src/reversi-view.vala"
		_tmp1_ = reversi_view_get_game (self);
#line 1542 "../src/reversi-view.vala"
		_tmp2_ = _tmp1_;
#line 1542 "../src/reversi-view.vala"
		_tmp3_ = game_get_current_color (_tmp2_);
#line 1542 "../src/reversi-view.vala"
		_tmp4_ = _tmp3_;
#line 1542 "../src/reversi-view.vala"
		_tmp0_ = _tmp4_ == PLAYER_LIGHT;
#line 8657 "reversi-view.c"
	} else {
#line 1542 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 8661 "reversi-view.c"
	}
#line 1542 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1543 "../src/reversi-view.vala"
		reversi_view_init_highlight_on_light_tile (self);
#line 8667 "reversi-view.c"
	}
}

static void
reversi_view_init_highlight_on_light_tile (ReversiView* self)
{
	guint8 half_size = 0U;
	Game* _tmp0_;
	Game* _tmp1_;
	Game* _tmp2_;
	Game* _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	Game* _tmp6_;
	Game* _tmp7_;
#line 1546 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1550 "../src/reversi-view.vala"
	half_size = (guint8) (self->priv->game_size / 2);
#line 1551 "../src/reversi-view.vala"
	_tmp0_ = reversi_view_get_game (self);
#line 1551 "../src/reversi-view.vala"
	_tmp1_ = _tmp0_;
#line 1551 "../src/reversi-view.vala"
	if (game_get_owner (_tmp1_, (guint8) (half_size - 1), (guint8) (half_size - 1)) == PLAYER_LIGHT) {
#line 1553 "../src/reversi-view.vala"
		self->priv->highlight_x = (guint8) (half_size - 1);
#line 1554 "../src/reversi-view.vala"
		self->priv->highlight_y = self->priv->highlight_x;
#line 1555 "../src/reversi-view.vala"
		return;
#line 8699 "reversi-view.c"
	}
#line 1557 "../src/reversi-view.vala"
	_tmp2_ = reversi_view_get_game (self);
#line 1557 "../src/reversi-view.vala"
	_tmp3_ = _tmp2_;
#line 1557 "../src/reversi-view.vala"
	if (game_get_owner (_tmp3_, half_size, half_size) == PLAYER_LIGHT) {
#line 1559 "../src/reversi-view.vala"
		self->priv->highlight_x = half_size;
#line 1560 "../src/reversi-view.vala"
		self->priv->highlight_y = half_size;
#line 1561 "../src/reversi-view.vala"
		return;
#line 8713 "reversi-view.c"
	}
#line 1563 "../src/reversi-view.vala"
	_tmp4_ = reversi_view_get_game (self);
#line 1563 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 1563 "../src/reversi-view.vala"
	if (game_get_owner (_tmp5_, (guint8) (half_size - 1), half_size) == PLAYER_LIGHT) {
#line 1565 "../src/reversi-view.vala"
		self->priv->highlight_x = (guint8) (half_size - 1);
#line 1566 "../src/reversi-view.vala"
		self->priv->highlight_y = half_size;
#line 1567 "../src/reversi-view.vala"
		return;
#line 8727 "reversi-view.c"
	}
#line 1569 "../src/reversi-view.vala"
	_tmp6_ = reversi_view_get_game (self);
#line 1569 "../src/reversi-view.vala"
	_tmp7_ = _tmp6_;
#line 1569 "../src/reversi-view.vala"
	if (game_get_owner (_tmp7_, half_size, (guint8) (half_size - 1)) == PLAYER_LIGHT) {
#line 1571 "../src/reversi-view.vala"
		self->priv->highlight_x = half_size;
#line 1572 "../src/reversi-view.vala"
		self->priv->highlight_y = (guint8) (half_size - 1);
#line 1573 "../src/reversi-view.vala"
		return;
#line 8741 "reversi-view.c"
	}
#line 1575 "../src/reversi-view.vala"
	g_assert_not_reached ();
#line 8745 "reversi-view.c"
}

static void
reversi_view_init_possible_moves (ReversiView* self)
{
	gboolean* _tmp0_;
#line 1592 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1594 "../src/reversi-view.vala"
	self->priv->playable_tiles_highlight_state = (guint8) 0;
#line 1595 "../src/reversi-view.vala"
	_tmp0_ = g_new0 (gboolean, self->priv->game_size * self->priv->game_size);
#line 1595 "../src/reversi-view.vala"
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
#line 1595 "../src/reversi-view.vala"
	self->priv->possible_moves = _tmp0_;
#line 1595 "../src/reversi-view.vala"
	self->priv->possible_moves_length1 = self->priv->game_size;
#line 1595 "../src/reversi-view.vala"
	self->priv->possible_moves_length2 = self->priv->game_size;
#line 8766 "reversi-view.c"
	{
		guint8 x = 0U;
#line 1597 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 8771 "reversi-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1597 "../src/reversi-view.vala"
			_tmp1_ = TRUE;
#line 1597 "../src/reversi-view.vala"
			while (TRUE) {
#line 1597 "../src/reversi-view.vala"
				if (!_tmp1_) {
#line 8780 "reversi-view.c"
					guint8 _tmp2_;
#line 1597 "../src/reversi-view.vala"
					_tmp2_ = x;
#line 1597 "../src/reversi-view.vala"
					x = _tmp2_ + 1;
#line 8786 "reversi-view.c"
				}
#line 1597 "../src/reversi-view.vala"
				_tmp1_ = FALSE;
#line 1597 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 1597 "../src/reversi-view.vala"
					break;
#line 8794 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 1598 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 8800 "reversi-view.c"
					{
						gboolean _tmp3_ = FALSE;
#line 1598 "../src/reversi-view.vala"
						_tmp3_ = TRUE;
#line 1598 "../src/reversi-view.vala"
						while (TRUE) {
#line 8807 "reversi-view.c"
							gboolean* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 1598 "../src/reversi-view.vala"
							if (!_tmp3_) {
#line 8813 "reversi-view.c"
								guint8 _tmp4_;
#line 1598 "../src/reversi-view.vala"
								_tmp4_ = y;
#line 1598 "../src/reversi-view.vala"
								y = _tmp4_ + 1;
#line 8819 "reversi-view.c"
							}
#line 1598 "../src/reversi-view.vala"
							_tmp3_ = FALSE;
#line 1598 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 1598 "../src/reversi-view.vala"
								break;
#line 8827 "reversi-view.c"
							}
#line 1599 "../src/reversi-view.vala"
							_tmp5_ = self->priv->possible_moves;
#line 1599 "../src/reversi-view.vala"
							_tmp5__length1 = self->priv->possible_moves_length1;
#line 1599 "../src/reversi-view.vala"
							_tmp5__length2 = self->priv->possible_moves_length2;
#line 1599 "../src/reversi-view.vala"
							_tmp5_[(x * _tmp5__length2) + y] = FALSE;
#line 8837 "reversi-view.c"
						}
					}
				}
			}
		}
	}
}

static inline void
reversi_view_move_if_possible (ReversiView* self,
                               guint8 x,
                               guint8 y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Iagno* _tmp2_;
	ComputerPlayer* _tmp3_;
	ComputerPlayer* _tmp4_;
#line 1602 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1604 "../src/reversi-view.vala"
	_tmp2_ = self->priv->_iagno_instance;
#line 1604 "../src/reversi-view.vala"
	_tmp3_ = iagno_get_computer (_tmp2_);
#line 1604 "../src/reversi-view.vala"
	_tmp4_ = _tmp3_;
#line 1604 "../src/reversi-view.vala"
	if (_tmp4_ == NULL) {
#line 1604 "../src/reversi-view.vala"
		_tmp1_ = TRUE;
#line 8868 "reversi-view.c"
	} else {
		Iagno* _tmp5_;
		Player _tmp6_;
		Player _tmp7_;
		Game* _tmp8_;
		Game* _tmp9_;
		Player _tmp10_;
		Player _tmp11_;
#line 1604 "../src/reversi-view.vala"
		_tmp5_ = self->priv->_iagno_instance;
#line 1604 "../src/reversi-view.vala"
		_tmp6_ = iagno_get_player_one (_tmp5_);
#line 1604 "../src/reversi-view.vala"
		_tmp7_ = _tmp6_;
#line 1604 "../src/reversi-view.vala"
		_tmp8_ = reversi_view_get_game (self);
#line 1604 "../src/reversi-view.vala"
		_tmp9_ = _tmp8_;
#line 1604 "../src/reversi-view.vala"
		_tmp10_ = game_get_current_color (_tmp9_);
#line 1604 "../src/reversi-view.vala"
		_tmp11_ = _tmp10_;
#line 1604 "../src/reversi-view.vala"
		_tmp1_ = _tmp7_ == _tmp11_;
#line 8893 "reversi-view.c"
	}
#line 1604 "../src/reversi-view.vala"
	if (_tmp1_) {
#line 8897 "reversi-view.c"
		Game* _tmp12_;
		Game* _tmp13_;
#line 1605 "../src/reversi-view.vala"
		_tmp12_ = reversi_view_get_game (self);
#line 1605 "../src/reversi-view.vala"
		_tmp13_ = _tmp12_;
#line 1605 "../src/reversi-view.vala"
		_tmp0_ = game_get_owner (_tmp13_, x, y) != PLAYER_NONE;
#line 8906 "reversi-view.c"
	} else {
#line 1604 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 8910 "reversi-view.c"
	}
#line 1604 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1606 "../src/reversi-view.vala"
		reversi_view_highlight_playable_tiles (self, FALSE);
#line 8916 "reversi-view.c"
	} else {
#line 1608 "../src/reversi-view.vala"
		g_signal_emit (self, reversi_view_signals[REVERSI_VIEW_MOVE_SIGNAL], 0, x, y);
#line 8920 "reversi-view.c"
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 1617 "../src/reversi-view.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 8929 "reversi-view.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 1617 "../src/reversi-view.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 8937 "reversi-view.c"
}

static void
__lambda18_ (ReversiView* self,
             PossibleMove* move)
{
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 1620 "../src/reversi-view.vala"
	x = ((PossibleMove) (*move)).x;
#line 1621 "../src/reversi-view.vala"
	y = ((PossibleMove) (*move)).y;
#line 1622 "../src/reversi-view.vala"
	_tmp0_ = self->priv->possible_moves;
#line 1622 "../src/reversi-view.vala"
	_tmp0__length1 = self->priv->possible_moves_length1;
#line 1622 "../src/reversi-view.vala"
	_tmp0__length2 = self->priv->possible_moves_length2;
#line 1622 "../src/reversi-view.vala"
	_tmp0_[(x * _tmp0__length2) + y] = TRUE;
#line 1623 "../src/reversi-view.vala"
	reversi_view_queue_draw_tile (self, x, y);
#line 8963 "reversi-view.c"
}

static void
___lambda18__gfunc (gconstpointer data,
                    gpointer self)
{
#line 1619 "../src/reversi-view.vala"
	__lambda18_ ((ReversiView*) self, (PossibleMove*) data);
#line 8972 "reversi-view.c"
}

static inline void
reversi_view_highlight_playable_tiles (ReversiView* self,
                                       gboolean force_reload)
{
	gboolean _tmp0_ = FALSE;
	GSList* moves = NULL;
	Game* _tmp1_;
	Game* _tmp2_;
	GSList* _tmp3_ = NULL;
	GSList* _tmp4_;
#line 1611 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 1613 "../src/reversi-view.vala"
	if (!force_reload) {
#line 1613 "../src/reversi-view.vala"
		_tmp0_ = ((gint) self->priv->playable_tiles_highlight_state) != 0;
#line 8991 "reversi-view.c"
	} else {
#line 1613 "../src/reversi-view.vala"
		_tmp0_ = FALSE;
#line 8995 "reversi-view.c"
	}
#line 1613 "../src/reversi-view.vala"
	if (_tmp0_) {
#line 1614 "../src/reversi-view.vala"
		return;
#line 9001 "reversi-view.c"
	}
#line 1617 "../src/reversi-view.vala"
	_tmp1_ = reversi_view_get_game (self);
#line 1617 "../src/reversi-view.vala"
	_tmp2_ = _tmp1_;
#line 1617 "../src/reversi-view.vala"
	game_get_possible_moves (_tmp2_, &_tmp3_);
#line 1617 "../src/reversi-view.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 1617 "../src/reversi-view.vala"
	moves = _tmp3_;
#line 1618 "../src/reversi-view.vala"
	self->priv->playable_tiles_highlight_state = (guint8) 1;
#line 1619 "../src/reversi-view.vala"
	_tmp4_ = moves;
#line 1619 "../src/reversi-view.vala"
	g_slist_foreach (_tmp4_, ___lambda18__gfunc, self);
#line 1611 "../src/reversi-view.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 9021 "reversi-view.c"
}

static gboolean
reversi_view_get_show_playable_tiles (ReversiView* self)
{
	gboolean result;
#line 28 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/reversi-view.vala"
	result = self->priv->_show_playable_tiles;
#line 28 "../src/reversi-view.vala"
	return result;
#line 9034 "reversi-view.c"
}

void
reversi_view_set_show_playable_tiles (ReversiView* self,
                                      gboolean value)
{
#line 29 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/reversi-view.vala"
	self->priv->_show_playable_tiles = value;
#line 29 "../src/reversi-view.vala"
	if (self->priv->game_is_set) {
#line 29 "../src/reversi-view.vala"
		reversi_view_highlight_playable_tiles (self, FALSE);
#line 9049 "reversi-view.c"
	}
}

static gboolean
reversi_view_get_show_turnable_tiles (ReversiView* self)
{
	gboolean result;
#line 31 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/reversi-view.vala"
	result = self->priv->_show_turnable_tiles;
#line 31 "../src/reversi-view.vala"
	return result;
#line 9063 "reversi-view.c"
}

void
reversi_view_set_show_turnable_tiles (ReversiView* self,
                                      gboolean value)
{
#line 31 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/reversi-view.vala"
	self->priv->_show_turnable_tiles = value;
#line 9074 "reversi-view.c"
}

Game*
reversi_view_get_game (ReversiView* self)
{
	Game* result;
	Game* _tmp0_;
#line 82 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 85 "../src/reversi-view.vala"
		g_assert_not_reached ();
#line 9088 "reversi-view.c"
	}
#line 86 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_game;
#line 86 "../src/reversi-view.vala"
	result = _tmp0_;
#line 86 "../src/reversi-view.vala"
	return result;
#line 9096 "reversi-view.c"
}

static void
_reversi_view_game_is_complete_cb_game_completeness_updated (Game* _sender,
                                                             gboolean completeness,
                                                             gpointer self)
{
#line 110 "../src/reversi-view.vala"
	reversi_view_game_is_complete_cb ((ReversiView*) self);
#line 9106 "reversi-view.c"
}

static void
_reversi_view_turn_ended_cb_game_turn_ended (Game* _sender,
                                             gboolean undoing,
                                             gboolean no_draw,
                                             gpointer self)
{
#line 111 "../src/reversi-view.vala"
	reversi_view_turn_ended_cb ((ReversiView*) self, undoing, no_draw);
#line 9117 "reversi-view.c"
}

void
reversi_view_set_game (ReversiView* self,
                       Game* value)
{
	Game* test = NULL;
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	Game* _tmp15_;
	Game* _tmp16_;
	gboolean even_board = FALSE;
	Game* _tmp17_;
	Opening _tmp18_;
	Opening _tmp19_;
	gboolean _tmp24_;
	gboolean _tmp25_;
#line 88 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/reversi-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 90 "../src/reversi-view.vala"
	test = _tmp0_;
#line 91 "../src/reversi-view.vala"
	if (test == NULL) {
#line 92 "../src/reversi-view.vala"
		g_assert_not_reached ();
#line 9148 "reversi-view.c"
	}
#line 94 "../src/reversi-view.vala"
	if (self->priv->game_is_set) {
#line 9152 "reversi-view.c"
		Game* _tmp1_;
#line 95 "../src/reversi-view.vala"
		_tmp1_ = self->priv->_game;
#line 95 "../src/reversi-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 9158 "reversi-view.c"
	}
#line 97 "../src/reversi-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 97 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 97 "../src/reversi-view.vala"
	self->priv->_game = _tmp2_;
#line 98 "../src/reversi-view.vala"
	_tmp3_ = self->priv->_game;
#line 98 "../src/reversi-view.vala"
	_tmp4_ = game_get_size (_tmp3_);
#line 98 "../src/reversi-view.vala"
	_tmp5_ = _tmp4_;
#line 98 "../src/reversi-view.vala"
	self->priv->game_size = _tmp5_;
#line 99 "../src/reversi-view.vala"
	if (!self->priv->game_is_set) {
#line 9176 "reversi-view.c"
		gint* _tmp6_;
		gint* _tmp7_;
		gint* _tmp8_;
#line 101 "../src/reversi-view.vala"
		_tmp6_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 101 "../src/reversi-view.vala"
		self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 101 "../src/reversi-view.vala"
		self->priv->pixmaps = _tmp6_;
#line 101 "../src/reversi-view.vala"
		self->priv->pixmaps_length1 = self->priv->game_size;
#line 101 "../src/reversi-view.vala"
		self->priv->pixmaps_length2 = self->priv->game_size;
#line 102 "../src/reversi-view.vala"
		_tmp7_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 102 "../src/reversi-view.vala"
		self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
#line 102 "../src/reversi-view.vala"
		self->priv->tile_xs = _tmp7_;
#line 102 "../src/reversi-view.vala"
		self->priv->tile_xs_length1 = self->priv->game_size;
#line 102 "../src/reversi-view.vala"
		self->priv->tile_xs_length2 = self->priv->game_size;
#line 103 "../src/reversi-view.vala"
		_tmp8_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 103 "../src/reversi-view.vala"
		self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
#line 103 "../src/reversi-view.vala"
		self->priv->tile_ys = _tmp8_;
#line 103 "../src/reversi-view.vala"
		self->priv->tile_ys_length1 = self->priv->game_size;
#line 103 "../src/reversi-view.vala"
		self->priv->tile_ys_length2 = self->priv->game_size;
#line 104 "../src/reversi-view.vala"
		self->priv->game_is_set = TRUE;
#line 9212 "reversi-view.c"
	}
#line 106 "../src/reversi-view.vala"
	reversi_view_init_possible_moves (self);
#line 9216 "reversi-view.c"
	{
		guint8 x = 0U;
#line 107 "../src/reversi-view.vala"
		x = (guint8) 0;
#line 9221 "reversi-view.c"
		{
			gboolean _tmp9_ = FALSE;
#line 107 "../src/reversi-view.vala"
			_tmp9_ = TRUE;
#line 107 "../src/reversi-view.vala"
			while (TRUE) {
#line 107 "../src/reversi-view.vala"
				if (!_tmp9_) {
#line 9230 "reversi-view.c"
					guint8 _tmp10_;
#line 107 "../src/reversi-view.vala"
					_tmp10_ = x;
#line 107 "../src/reversi-view.vala"
					x = _tmp10_ + 1;
#line 9236 "reversi-view.c"
				}
#line 107 "../src/reversi-view.vala"
				_tmp9_ = FALSE;
#line 107 "../src/reversi-view.vala"
				if (!(x < self->priv->game_size)) {
#line 107 "../src/reversi-view.vala"
					break;
#line 9244 "reversi-view.c"
				}
				{
					guint8 y = 0U;
#line 108 "../src/reversi-view.vala"
					y = (guint8) 0;
#line 9250 "reversi-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 108 "../src/reversi-view.vala"
						_tmp11_ = TRUE;
#line 108 "../src/reversi-view.vala"
						while (TRUE) {
#line 9257 "reversi-view.c"
							gint* _tmp13_;
							gint _tmp13__length1;
							gint _tmp13__length2;
							Game* _tmp14_;
#line 108 "../src/reversi-view.vala"
							if (!_tmp11_) {
#line 9264 "reversi-view.c"
								guint8 _tmp12_;
#line 108 "../src/reversi-view.vala"
								_tmp12_ = y;
#line 108 "../src/reversi-view.vala"
								y = _tmp12_ + 1;
#line 9270 "reversi-view.c"
							}
#line 108 "../src/reversi-view.vala"
							_tmp11_ = FALSE;
#line 108 "../src/reversi-view.vala"
							if (!(y < self->priv->game_size)) {
#line 108 "../src/reversi-view.vala"
								break;
#line 9278 "reversi-view.c"
							}
#line 109 "../src/reversi-view.vala"
							_tmp13_ = self->priv->pixmaps;
#line 109 "../src/reversi-view.vala"
							_tmp13__length1 = self->priv->pixmaps_length1;
#line 109 "../src/reversi-view.vala"
							_tmp13__length2 = self->priv->pixmaps_length2;
#line 109 "../src/reversi-view.vala"
							_tmp14_ = self->priv->_game;
#line 109 "../src/reversi-view.vala"
							_tmp13_[(x * _tmp13__length2) + y] = reversi_view_get_pixmap (game_get_owner (_tmp14_, x, y));
#line 9290 "reversi-view.c"
						}
					}
				}
			}
		}
	}
#line 110 "../src/reversi-view.vala"
	_tmp15_ = self->priv->_game;
#line 110 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp15_, "completeness-updated", (GCallback) _reversi_view_game_is_complete_cb_game_completeness_updated, self, 0);
#line 111 "../src/reversi-view.vala"
	_tmp16_ = self->priv->_game;
#line 111 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp16_, "turn-ended", (GCallback) _reversi_view_turn_ended_cb_game_turn_ended, self, 0);
#line 113 "../src/reversi-view.vala"
	self->priv->show_highlight = FALSE;
#line 114 "../src/reversi-view.vala"
	even_board = (self->priv->game_size % 2) == 0;
#line 115 "../src/reversi-view.vala"
	if (even_board) {
#line 117 "../src/reversi-view.vala"
		self->priv->highlight_set = FALSE;
#line 118 "../src/reversi-view.vala"
		self->priv->highlight_x = (guint8) ((self->priv->game_size / 2) - 1);
#line 9315 "reversi-view.c"
	} else {
#line 122 "../src/reversi-view.vala"
		self->priv->highlight_set = TRUE;
#line 123 "../src/reversi-view.vala"
		self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 9321 "reversi-view.c"
	}
#line 125 "../src/reversi-view.vala"
	self->priv->highlight_y = self->priv->highlight_x;
#line 126 "../src/reversi-view.vala"
	self->priv->old_highlight_x = G_MAXUINT8;
#line 127 "../src/reversi-view.vala"
	self->priv->old_highlight_y = G_MAXUINT8;
#line 128 "../src/reversi-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 130 "../src/reversi-view.vala"
	self->priv->show_mouse_highlight = FALSE;
#line 131 "../src/reversi-view.vala"
	self->priv->mouse_position_set = FALSE;
#line 132 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = G_MAXUINT8;
#line 133 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = G_MAXUINT8;
#line 134 "../src/reversi-view.vala"
	self->priv->mouse_position_x = G_MAXUINT8;
#line 135 "../src/reversi-view.vala"
	self->priv->mouse_position_y = G_MAXUINT8;
#line 137 "../src/reversi-view.vala"
	self->priv->last_state_set = FALSE;
#line 138 "../src/reversi-view.vala"
	_tmp17_ = self->priv->_game;
#line 138 "../src/reversi-view.vala"
	_tmp18_ = game_get_opening (_tmp17_);
#line 138 "../src/reversi-view.vala"
	_tmp19_ = _tmp18_;
#line 138 "../src/reversi-view.vala"
	if (_tmp19_ == OPENING_HUMANS) {
#line 140 "../src/reversi-view.vala"
		if (even_board) {
#line 9355 "reversi-view.c"
			guint8* _tmp20_;
			guint8* _tmp21_;
#line 142 "../src/reversi-view.vala"
			_tmp20_ = g_new0 (guint8, 4);
#line 142 "../src/reversi-view.vala"
			_tmp20_[0] = (guint8) 0;
#line 142 "../src/reversi-view.vala"
			_tmp20_[1] = (guint8) 0;
#line 142 "../src/reversi-view.vala"
			_tmp20_[2] = (guint8) 0;
#line 142 "../src/reversi-view.vala"
			_tmp20_[3] = (guint8) 0;
#line 142 "../src/reversi-view.vala"
			self->priv->overture_steps = (g_free (self->priv->overture_steps), NULL);
#line 142 "../src/reversi-view.vala"
			self->priv->overture_steps = _tmp20_;
#line 142 "../src/reversi-view.vala"
			self->priv->overture_steps_length1 = 4;
#line 142 "../src/reversi-view.vala"
			self->priv->_overture_steps_size_ = self->priv->overture_steps_length1;
#line 143 "../src/reversi-view.vala"
			_tmp21_ = g_new0 (guint8, 4);
#line 143 "../src/reversi-view.vala"
			_tmp21_[0] = (guint8) 0;
#line 143 "../src/reversi-view.vala"
			_tmp21_[1] = (guint8) 0;
#line 143 "../src/reversi-view.vala"
			_tmp21_[2] = (guint8) 0;
#line 143 "../src/reversi-view.vala"
			_tmp21_[3] = (guint8) 0;
#line 143 "../src/reversi-view.vala"
			self->priv->overture_target = (g_free (self->priv->overture_target), NULL);
#line 143 "../src/reversi-view.vala"
			self->priv->overture_target = _tmp21_;
#line 143 "../src/reversi-view.vala"
			self->priv->overture_target_length1 = 4;
#line 143 "../src/reversi-view.vala"
			self->priv->_overture_target_size_ = self->priv->overture_target_length1;
#line 9394 "reversi-view.c"
		} else {
			guint8* _tmp22_;
			guint8* _tmp23_;
#line 147 "../src/reversi-view.vala"
			_tmp22_ = g_new0 (guint8, 6);
#line 147 "../src/reversi-view.vala"
			_tmp22_[0] = (guint8) 0;
#line 147 "../src/reversi-view.vala"
			_tmp22_[1] = (guint8) 0;
#line 147 "../src/reversi-view.vala"
			_tmp22_[2] = (guint8) 0;
#line 147 "../src/reversi-view.vala"
			_tmp22_[3] = (guint8) 0;
#line 147 "../src/reversi-view.vala"
			_tmp22_[4] = (guint8) 0;
#line 147 "../src/reversi-view.vala"
			_tmp22_[5] = (guint8) 0;
#line 147 "../src/reversi-view.vala"
			self->priv->overture_steps = (g_free (self->priv->overture_steps), NULL);
#line 147 "../src/reversi-view.vala"
			self->priv->overture_steps = _tmp22_;
#line 147 "../src/reversi-view.vala"
			self->priv->overture_steps_length1 = 6;
#line 147 "../src/reversi-view.vala"
			self->priv->_overture_steps_size_ = self->priv->overture_steps_length1;
#line 148 "../src/reversi-view.vala"
			_tmp23_ = g_new0 (guint8, 6);
#line 148 "../src/reversi-view.vala"
			_tmp23_[0] = (guint8) 0;
#line 148 "../src/reversi-view.vala"
			_tmp23_[1] = (guint8) 0;
#line 148 "../src/reversi-view.vala"
			_tmp23_[2] = (guint8) 0;
#line 148 "../src/reversi-view.vala"
			_tmp23_[3] = (guint8) 0;
#line 148 "../src/reversi-view.vala"
			_tmp23_[4] = (guint8) 0;
#line 148 "../src/reversi-view.vala"
			_tmp23_[5] = (guint8) 0;
#line 148 "../src/reversi-view.vala"
			self->priv->overture_target = (g_free (self->priv->overture_target), NULL);
#line 148 "../src/reversi-view.vala"
			self->priv->overture_target = _tmp23_;
#line 148 "../src/reversi-view.vala"
			self->priv->overture_target_length1 = 6;
#line 148 "../src/reversi-view.vala"
			self->priv->_overture_target_size_ = self->priv->overture_target_length1;
#line 9442 "reversi-view.c"
		}
#line 150 "../src/reversi-view.vala"
		self->priv->current_overture_playable = (guint8) 0;
#line 151 "../src/reversi-view.vala"
		if (self->priv->configuration_done) {
#line 152 "../src/reversi-view.vala"
			reversi_view_configure_overture_origin (self);
#line 9450 "reversi-view.c"
		}
#line 154 "../src/reversi-view.vala"
		self->priv->humans_opening_intensity = REVERSI_VIEW_HUMANS_OPENING_INTENSITY_MAX;
#line 9454 "reversi-view.c"
	} else {
#line 157 "../src/reversi-view.vala"
		self->priv->humans_opening_intensity = (guint8) 0;
#line 9458 "reversi-view.c"
	}
#line 159 "../src/reversi-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 161 "../src/reversi-view.vala"
	_tmp24_ = reversi_view_get_show_playable_tiles (self);
#line 161 "../src/reversi-view.vala"
	_tmp25_ = _tmp24_;
#line 161 "../src/reversi-view.vala"
	if (_tmp25_) {
#line 162 "../src/reversi-view.vala"
		reversi_view_highlight_playable_tiles (self, FALSE);
#line 9470 "reversi-view.c"
	}
#line 88 "../src/reversi-view.vala"
	_g_object_unref0 (test);
#line 9474 "reversi-view.c"
}

static Iagno*
reversi_view_get_iagno_instance (ReversiView* self)
{
	Iagno* result;
	Iagno* _tmp0_;
#line 189 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_iagno_instance;
#line 189 "../src/reversi-view.vala"
	result = _tmp0_;
#line 189 "../src/reversi-view.vala"
	return result;
#line 9490 "reversi-view.c"
}

static void
reversi_view_set_iagno_instance (ReversiView* self,
                                 Iagno* value)
{
	Iagno* _tmp0_;
#line 189 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/reversi-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 189 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_iagno_instance);
#line 189 "../src/reversi-view.vala"
	self->priv->_iagno_instance = _tmp0_;
#line 9506 "reversi-view.c"
}

static ThemeManager*
reversi_view_get_theme_manager (ReversiView* self)
{
	ThemeManager* result;
	ThemeManager* _tmp0_;
#line 190 "../src/reversi-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 190 "../src/reversi-view.vala"
	result = _tmp0_;
#line 190 "../src/reversi-view.vala"
	return result;
#line 9522 "reversi-view.c"
}

static void
reversi_view_set_theme_manager (ReversiView* self,
                                ThemeManager* value)
{
	ThemeManager* _tmp0_;
#line 190 "../src/reversi-view.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/reversi-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 190 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_theme_manager);
#line 190 "../src/reversi-view.vala"
	self->priv->_theme_manager = _tmp0_;
#line 9538 "reversi-view.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/reversi-view.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/reversi-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/reversi-view.vala"
		data1 = closure->data;
#line 23 "../src/reversi-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 9563 "reversi-view.c"
	} else {
#line 23 "../src/reversi-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/reversi-view.vala"
		data2 = closure->data;
#line 9569 "reversi-view.c"
	}
#line 23 "../src/reversi-view.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/reversi-view.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 9575 "reversi-view.c"
}

static void
_reversi_view___lambda20_ (ReversiView* self)
{
#line 182 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 182 "../src/reversi-view.vala"
	self->priv->tiles_pattern = NULL;
#line 183 "../src/reversi-view.vala"
	if (self->priv->configuration_done) {
#line 184 "../src/reversi-view.vala"
		reversi_view_configure_theme (self);
#line 9589 "reversi-view.c"
	}
#line 185 "../src/reversi-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 9593 "reversi-view.c"
}

static void
__reversi_view___lambda20__theme_manager_theme_changed (ThemeManager* _sender,
                                                        gpointer self)
{
#line 181 "../src/reversi-view.vala"
	_reversi_view___lambda20_ ((ReversiView*) self);
#line 9602 "reversi-view.c"
}

static GObject *
reversi_view_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ReversiView * self;
	ThemeManager* _tmp0_;
#line 166 "../src/reversi-view.vala"
	parent_class = G_OBJECT_CLASS (reversi_view_parent_class);
#line 166 "../src/reversi-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 166 "../src/reversi-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REVERSI_VIEW, ReversiView);
#line 168 "../src/reversi-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 169 "../src/reversi-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 171 "../src/reversi-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) ((((((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_POINTER_MOTION_MASK) | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK) | GDK_STRUCTURE_MASK));
#line 178 "../src/reversi-view.vala"
	reversi_view_init_mouse (self);
#line 179 "../src/reversi-view.vala"
	reversi_view_init_keyboard (self);
#line 181 "../src/reversi-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 181 "../src/reversi-view.vala"
	g_signal_connect_object (_tmp0_, "theme-changed", (GCallback) __reversi_view___lambda20__theme_manager_theme_changed, self, 0);
#line 166 "../src/reversi-view.vala"
	return obj;
#line 9636 "reversi-view.c"
}

static void
reversi_view_class_init (ReversiViewClass * klass,
                         gpointer klass_data)
{
#line 23 "../src/reversi-view.vala"
	reversi_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/reversi-view.vala"
	g_type_class_adjust_private_offset (klass, &ReversiView_private_offset);
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) reversi_view_real_configure_event;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) reversi_view_real_draw;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) reversi_view_real_enter_notify_event;
#line 23 "../src/reversi-view.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) reversi_view_real_leave_notify_event;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_reversi_view_get_property;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_reversi_view_set_property;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->constructor = reversi_view_constructor;
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (klass)->finalize = reversi_view_finalize;
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SHOW_PLAYABLE_TILES_PROPERTY, reversi_view_properties[REVERSI_VIEW_SHOW_PLAYABLE_TILES_PROPERTY] = g_param_spec_boolean ("show-playable-tiles", "show-playable-tiles", "show-playable-tiles", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY, reversi_view_properties[REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY] = g_param_spec_boolean ("show-turnable-tiles", "show-turnable-tiles", "show-turnable-tiles", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_GAME_PROPERTY, reversi_view_properties[REVERSI_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_IAGNO_INSTANCE_PROPERTY, reversi_view_properties[REVERSI_VIEW_IAGNO_INSTANCE_PROPERTY] = g_param_spec_object ("iagno-instance", "iagno-instance", "iagno-instance", TYPE_IAGNO, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), REVERSI_VIEW_THEME_MANAGER_PROPERTY, reversi_view_properties[REVERSI_VIEW_THEME_MANAGER_PROPERTY] = g_param_spec_object ("theme-manager", "theme-manager", "theme-manager", TYPE_THEME_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/reversi-view.vala"
	reversi_view_signals[REVERSI_VIEW_MOVE_SIGNAL] = g_signal_new ("move", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 23 "../src/reversi-view.vala"
	reversi_view_signals[REVERSI_VIEW_CLEAR_IMPOSSIBLE_TO_MOVE_HERE_WARNING_SIGNAL] = g_signal_new ("clear-impossible-to-move-here-warning", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/reversi-view.vala"
	reversi_view_signals[REVERSI_VIEW_NOTIFY_FINAL_ANIMATION_SIGNAL] = g_signal_new ("notify-final-animation", TYPE_REVERSI_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 9679 "reversi-view.c"
}

static void
reversi_view_instance_init (ReversiView * self,
                            gpointer klass)
{
	gint* _tmp0_;
	guint8* _tmp1_;
	guint8* _tmp2_;
#line 23 "../src/reversi-view.vala"
	self->priv = reversi_view_get_instance_private (self);
#line 25 "../src/reversi-view.vala"
	self->priv->_show_playable_tiles = FALSE;
#line 31 "../src/reversi-view.vala"
	self->priv->_show_turnable_tiles = FALSE;
#line 37 "../src/reversi-view.vala"
	self->priv->show_highlight = FALSE;
#line 38 "../src/reversi-view.vala"
	self->priv->highlight_set = FALSE;
#line 39 "../src/reversi-view.vala"
	self->priv->highlight_x = G_MAXUINT8;
#line 40 "../src/reversi-view.vala"
	self->priv->highlight_y = G_MAXUINT8;
#line 41 "../src/reversi-view.vala"
	self->priv->old_highlight_x = G_MAXUINT8;
#line 42 "../src/reversi-view.vala"
	self->priv->old_highlight_y = G_MAXUINT8;
#line 43 "../src/reversi-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 47 "../src/reversi-view.vala"
	self->priv->show_mouse_highlight = FALSE;
#line 48 "../src/reversi-view.vala"
	self->priv->mouse_position_set = FALSE;
#line 49 "../src/reversi-view.vala"
	self->priv->mouse_highlight_x = G_MAXUINT8;
#line 50 "../src/reversi-view.vala"
	self->priv->mouse_highlight_y = G_MAXUINT8;
#line 51 "../src/reversi-view.vala"
	self->priv->mouse_position_x = G_MAXUINT8;
#line 52 "../src/reversi-view.vala"
	self->priv->mouse_position_y = G_MAXUINT8;
#line 58 "../src/reversi-view.vala"
	self->priv->render_size = (guint) 0;
#line 59 "../src/reversi-view.vala"
	self->priv->tiles_pattern = NULL;
#line 60 "../src/reversi-view.vala"
	self->priv->board_pattern = NULL;
#line 62 "../src/reversi-view.vala"
	self->priv->noise_pixbuf_loaded = FALSE;
#line 68 "../src/reversi-view.vala"
	self->priv->animate_timeout = (guint) 0;
#line 72 "../src/reversi-view.vala"
	self->priv->humans_opening_intensity = (guint8) 0;
#line 77 "../src/reversi-view.vala"
	self->priv->game_is_set = FALSE;
#line 200 "../src/reversi-view.vala"
	self->priv->configuration_done = FALSE;
#line 574 "../src/reversi-view.vala"
	_tmp0_ = g_new0 (gint, 6);
#line 574 "../src/reversi-view.vala"
	self->priv->overture_origin_xs = _tmp0_;
#line 574 "../src/reversi-view.vala"
	self->priv->overture_origin_xs_length1 = 6;
#line 574 "../src/reversi-view.vala"
	self->priv->_overture_origin_xs_size_ = self->priv->overture_origin_xs_length1;
#line 575 "../src/reversi-view.vala"
	self->priv->overture_origin_y = 0;
#line 576 "../src/reversi-view.vala"
	_tmp1_ = g_new0 (guint8, 6);
#line 576 "../src/reversi-view.vala"
	_tmp1_[0] = (guint8) 0;
#line 576 "../src/reversi-view.vala"
	_tmp1_[1] = (guint8) 0;
#line 576 "../src/reversi-view.vala"
	_tmp1_[2] = (guint8) 0;
#line 576 "../src/reversi-view.vala"
	_tmp1_[3] = (guint8) 0;
#line 576 "../src/reversi-view.vala"
	_tmp1_[4] = (guint8) 0;
#line 576 "../src/reversi-view.vala"
	_tmp1_[5] = (guint8) 0;
#line 576 "../src/reversi-view.vala"
	self->priv->overture_steps = _tmp1_;
#line 576 "../src/reversi-view.vala"
	self->priv->overture_steps_length1 = 6;
#line 576 "../src/reversi-view.vala"
	self->priv->_overture_steps_size_ = self->priv->overture_steps_length1;
#line 577 "../src/reversi-view.vala"
	_tmp2_ = g_new0 (guint8, 6);
#line 577 "../src/reversi-view.vala"
	_tmp2_[0] = (guint8) 0;
#line 577 "../src/reversi-view.vala"
	_tmp2_[1] = (guint8) 0;
#line 577 "../src/reversi-view.vala"
	_tmp2_[2] = (guint8) 0;
#line 577 "../src/reversi-view.vala"
	_tmp2_[3] = (guint8) 0;
#line 577 "../src/reversi-view.vala"
	_tmp2_[4] = (guint8) 0;
#line 577 "../src/reversi-view.vala"
	_tmp2_[5] = (guint8) 0;
#line 577 "../src/reversi-view.vala"
	self->priv->overture_target = _tmp2_;
#line 577 "../src/reversi-view.vala"
	self->priv->overture_target_length1 = 6;
#line 577 "../src/reversi-view.vala"
	self->priv->_overture_target_size_ = self->priv->overture_target_length1;
#line 578 "../src/reversi-view.vala"
	self->priv->current_overture_playable = (guint8) 0;
#line 760 "../src/reversi-view.vala"
	self->priv->last_state_set = FALSE;
#line 982 "../src/reversi-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 1069 "../src/reversi-view.vala"
	self->priv->mouse_is_in = FALSE;
#line 1133 "../src/reversi-view.vala"
	self->priv->timeout_id = (guint) 0;
#line 9797 "reversi-view.c"
}

static void
reversi_view_finalize (GObject * obj)
{
	ReversiView * self;
#line 23 "../src/reversi-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REVERSI_VIEW, ReversiView);
#line 59 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 60 "../src/reversi-view.vala"
	_cairo_pattern_destroy0 (self->priv->board_pattern);
#line 65 "../src/reversi-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 79 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 189 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_iagno_instance);
#line 190 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->_theme_manager);
#line 204 "../src/reversi-view.vala"
	self->priv->tile_xs = (g_free (self->priv->tile_xs), NULL);
#line 205 "../src/reversi-view.vala"
	self->priv->tile_ys = (g_free (self->priv->tile_ys), NULL);
#line 574 "../src/reversi-view.vala"
	self->priv->overture_origin_xs = (g_free (self->priv->overture_origin_xs), NULL);
#line 576 "../src/reversi-view.vala"
	self->priv->overture_steps = (g_free (self->priv->overture_steps), NULL);
#line 577 "../src/reversi-view.vala"
	self->priv->overture_target = (g_free (self->priv->overture_target), NULL);
#line 761 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->last_state);
#line 1067 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 1068 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 1248 "../src/reversi-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 1590 "../src/reversi-view.vala"
	self->priv->possible_moves = (g_free (self->priv->possible_moves), NULL);
#line 23 "../src/reversi-view.vala"
	G_OBJECT_CLASS (reversi_view_parent_class)->finalize (obj);
#line 9840 "reversi-view.c"
}

static GType
reversi_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ReversiViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) reversi_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ReversiView), 0, (GInstanceInitFunc) reversi_view_instance_init, NULL };
	GType reversi_view_type_id;
	reversi_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ReversiView", &g_define_type_info, 0);
	ReversiView_private_offset = g_type_add_instance_private (reversi_view_type_id, sizeof (ReversiViewPrivate));
	return reversi_view_type_id;
}

GType
reversi_view_get_type (void)
{
	static volatile gsize reversi_view_type_id__once = 0;
	if (g_once_init_enter (&reversi_view_type_id__once)) {
		GType reversi_view_type_id;
		reversi_view_type_id = reversi_view_get_type_once ();
		g_once_init_leave (&reversi_view_type_id__once, reversi_view_type_id);
	}
	return reversi_view_type_id__once;
}

static void
_vala_reversi_view_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_REVERSI_VIEW, ReversiView);
#line 23 "../src/reversi-view.vala"
	switch (property_id) {
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SHOW_PLAYABLE_TILES_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_boolean (value, reversi_view_get_show_playable_tiles (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_boolean (value, reversi_view_get_show_turnable_tiles (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_GAME_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_object (value, reversi_view_get_game (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_IAGNO_INSTANCE_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_object (value, reversi_view_get_iagno_instance (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_THEME_MANAGER_PROPERTY:
#line 23 "../src/reversi-view.vala"
		g_value_set_object (value, reversi_view_get_theme_manager (self));
#line 23 "../src/reversi-view.vala"
		break;
#line 9905 "reversi-view.c"
		default:
#line 23 "../src/reversi-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/reversi-view.vala"
		break;
#line 9911 "reversi-view.c"
	}
}

static void
_vala_reversi_view_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ReversiView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_REVERSI_VIEW, ReversiView);
#line 23 "../src/reversi-view.vala"
	switch (property_id) {
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SHOW_PLAYABLE_TILES_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_show_playable_tiles (self, g_value_get_boolean (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_SHOW_TURNABLE_TILES_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_show_turnable_tiles (self, g_value_get_boolean (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_GAME_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_game (self, g_value_get_object (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_IAGNO_INSTANCE_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_iagno_instance (self, g_value_get_object (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 23 "../src/reversi-view.vala"
		case REVERSI_VIEW_THEME_MANAGER_PROPERTY:
#line 23 "../src/reversi-view.vala"
		reversi_view_set_theme_manager (self, g_value_get_object (value));
#line 23 "../src/reversi-view.vala"
		break;
#line 9955 "reversi-view.c"
		default:
#line 23 "../src/reversi-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/reversi-view.vala"
		break;
#line 9961 "reversi-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

